
CM.Atomic=function(){};
CM.Atomic.prototype.isNumber=true;
CM.Atomic.prototype.isAtomic=true;
CM.Atomic.prototype.isPolynomial=true;
CM.Atomic.prototype.isRationalFunction=true;
CM.Atomic.prototype.real=function(){
return this;};
CM.Atomic.prototype.imaginary=function(){
return CM.Integer.zero;};
CM.Atomic.prototype.simplify=function(){
return this;};
CM.Atomic.prototype.simplifyInClass=function(){
return this;};
CM.Atomic.AddExact=function(){
var temparray=arguments[0];
var temparraylength=temparray.length;
var integerarray=[];
var floatingarray=[];
var rationalarray=[];
var complexarray=[];
var otherarray=[];
for(var i=0;i<temparraylength;i++){
var type=temparray[i].cm_instanceof;
if(type==="Integer")
integerarray.push(temparray[i]);
else if(type==="Rational")
rationalarray.push(temparray[i]);
else if(type==="Floating")
floatingarray.push(temparray[i]);
else if(type==="Complex")
complexarray.push(temparray[i]);
else
otherarray.push(temparray[i]);}
floatingarray.push(CM.Integer.Add(integerarray));
var tempsum=CM.Floating.Add(floatingarray);
if(rationalarray.length>0)
tempsum=CM.Rational.Add(rationalarray.concat(tempsum));
if(complexarray.length>0)
tempsum=CM.Complex.Add(complexarray.concat(tempsum));
if(otherarray.length==0)
return tempsum.simplify();
else
return new CM.Sum([tempsum].concat(otherarray));}
CM.Atomic.AddRounded=function(){
var temparray=arguments[0];
var precision=arguments[1];
if(precision===null)
precision=CM.Floating.precision;
var type=arguments[2];
if(type===null)
type=CM.Floating.precisionType;var temparraylength=temparray.length;
var integerarray=[];
var floatingarray=[];
var rationalarray=[];
var complexarray=[];
var otherarray=[];
for(var i=0;i<temparraylength;i++){
var type=temparray[i].cm_instanceof;
if(type==="Integer")
integerarray.push(temparray[i]);
else if(type==="Rational")
rationalarray.push(temparray[i]);
else if(type==="Floating")
floatingarray.push(temparray[i]);
else if(type==="Complex")
complexarray.push(temparray[i]);
else
otherarray.push(temparray[i]);}
if(floatingarray.length==0){
rationalarray.push(CM.Integer.Add(integerarray,precision,type));
var rationalsum=CM.Rational.Add(rationalarray,precision,type);
if(complexarray.length>0)
rationalsum=CM.Complex.Add(complexarray.concat(rationalsum),precision,type);
if(otherarray.length==0)
return rationalsum.round(precision,type);
else
return new CM.Sum([rationalsum].concat(otherarray));}
else{
floatingarray.push(CM.Integer.Add(integerarray,precision,type));
var floatingsum=CM.Floating.Add(floatingarray.concat(rationalarray),precision,type);
if(rationalarray.length>0)
floatingsum=CM.Rational.Add(rationalarray.concat(floatingsum),precision,type);
if(complexarray.length>0)
floatingsum=CM.Complex.Add(complexarray.concat(floatingsum),precision,type);
if(otherarray.length==0)
return floatingsum;
else
return new CM.Sum([floatingsum].concat(otherarray));}}
CM.Atomic.Add=CM.Atomic.AddExact;
CM.Atomic.MultiplyExact=function(){
var temparray=arguments[0];
var temparraylength=temparray.length;
var integerarray=[];
var floatingarray=[];
var rationalarray=[];
var complexarray=[];
var otherarray=[];
for(var i=0;i<temparraylength;i++){
var type=temparray[i].cm_instanceof;
if(type==="Integer")
integerarray.push(temparray[i]);
else if(type==="Rational")
rationalarray.push(temparray[i]);
else if(type==="Floating")
floatingarray.push(temparray[i]);
else if(type==="Complex")
complexarray.push(temparray[i]);
else
otherarray.push(temparray[i]);}
if(1==2&&floatingarray.length>0){
var floatingnumberspresent=true;
var precision=CM.Floating.Precision;}
else{
var floatingnumberspresent=false;}
floatingarray.push(CM.Integer.Multiply(integerarray));
var tempproduct=CM.Floating.Multiply(floatingarray);
if(rationalarray.length>0){
if(floatingnumberspresent!==true){
var tempproduct=CM.Rational.Multiply(rationalarray.concat(tempproduct));}
else{
var tempproduct=CM.Rational.Multiply(rationalarray).round(precision).multiply(tempproduct);}}
if(complexarray.length>0)
var tempproduct=CM.Complex.Multiply(complexarray.concat(tempproduct));
if(otherarray.length==0)
return tempproduct;
else
return new CM.Factor([tempproduct].concat(otherarray));}
CM.Atomic.MultiplyTwoNumbers=function(){
var left=arguments[0];
var right=arguments[1];
var modulus=arguments[2];
if(modulus==null){
if(left.cm_instanceof=="Integer"){
return right.multiply(left);}
else if(left.cm_instanceof=="Rational"){
if(right.cm_instanceof=="Integer"){
return left.multiply(right);}
else{
return right.multiply(left);}}
else if(right.cm_instanceof=="Complex"){
return right.multiply(left);}
return left.multiply(right);}
else{
return left.multiplyM(right,modulus);}}
CM.Atomic.MultiplyRounded=function(){
var temparray=arguments[0];
var temparraylength=temparray.length;
var precision=arguments[1];
if(precision===null)
precision=CM.Floating.precision;
var type=arguments[2];
if(type===null)
type=CM.Floating.precisionType;
var integerarray=[];
var floatingarray=[];
var rationalarray=[];
var complexarray=[];
var otherarray=[];
for(var i=0;i<temparraylength;i++){
var type=temparray[i].cm_instanceof;
if(type==="Integer")
integerarray.push(temparray[i]);
else if(type==="Rational")
rationalarray.push(temparray[i]);
else if(type==="Floating")
floatingarray.push(temparray[i]);
else if(type==="Complex")
complexarray.push(temparray[i]);
else
otherarray.push(temparray[i]);}
floatingarray.push(CM.Integer.Multiply(integerarray));
rationalarray.push(CM.Floating.Multiply(floatingarray,precision,type));
var rationalproduct=(CM.Rational.Multiply(rationalarray)).round(precision,type);
var rationalproduct=(CM.Complex.Multiply(complexarray.concat(rationalproduct))).round(precision,type);
if(otherarray.length==0)
return rationalproduct;
else
return new CM.Factor([rationalproduct.round(precision,type)].concat(otherarray));};
CM.Atomic.prototype.mod=function(){
var errorstring="You are trying to determine the value of "+this+" mod "+arguments[0]+". However, this is undefined.";
alert(errorstring);
throw new Error(errorstring);};
CM.Atomic.Multiply=CM.Atomic.MultiplyExact;
CM.Atomic.prototype.replacePolynomialVariables=function(){
return this;}
CM.Atomic.prototype.structure=function(){
return this.toString();}
CM.Atomic.prototype.getDependentVariables=function(){
return[];}
CM.Atomic.prototype.replaceExpressionReferences=function(){
return this;}
CM.Atomic.prototype.useCurrentExpressionValues=function(){
return this;}
CM.Atomic.prototype.executeInterfaceFunctions=function(){
return this;}
CM.Atomic.prototype.sort=function(){
return this;}
CM.Atomic.prototype.substitute=function(){
return this;}
CM.Atomic.prototype.expand=function(){
return this;};
CM.Atomic.prototype.expandAux=CM.Atomic.prototype.expand;
CM.Atomic.prototype.expandWithoutSimplification=function(){
return this;}
CM.Atomic.prototype.fastExpand=function(){
return this;}
CM.Atomic.prototype.fastExpandAux=function(){
return this;}
CM.Atomic.prototype.unreplaceStandardFunctions=function(){
return this;};
CM.Atomic.prototype.replaceStandardFunctions=function(){
return this;};
CM.Atomic.prototype.getTerms=function(){
return this;}
CM.Atomic.prototype.reduceConstants=function(){
return this;}
CM.Atomic.prototype.isVariable=function(){
return false;}
CM.Atomic.prototype.taylorSeries=function(){
return this;};
CM.Atomic.prototype.collect=function(){
return this;};
CM.Atomic.prototype.simplifyPowers=function(){
return this;};
CM.Atomic.prototype.multivariateDivide=function(){
var args0=arguments[0].simplify();
if(args0.isNumber===true){
var tempobject=new Object();
tempobject.quotient=new CM.Quotient([this,args0]).simplify();
tempobject.remainder=CM.Integer.zero;
return tempobject;}
else if(args0.cm_instanceof==="Polynomial"){
return new CM.PolynomialNativeExponents(this).multivariateDivide(args0,arguments[1]);}
else{
args0=args0.expand();
if(args0.isNumber===true){
var tempobject=new Object();
tempobject.quotient=new CM.Quotient([this,args0]).simplify();
tempobject.remainder=CM.Integer.zero;
return tempobject;}
else if(args0.cm_instanceof==="Polynomial"){
return new CM.PolynomialNativeExponents(this).multivariateDivide(args0,arguments[1]);}
else{
var errorstring=" You are invoking CM.Atomic.prototype.multivariateDivide on "+this+" with an argument that cannot be converted to a number or a polynomial. The argument is "+arguments[0]+".";
alert(errorstring);
throw new Error(errorstring);}}};
CM.Atomic.prototype.maxDegree=function(){
return CM.Integer.zero;};
CM.Atomic.prototype.minDegree=function(){
return CM.Integer.zero;};
CM.Atomic.prototype.coeff=function(){
if(arguments[1]!=null){
if(arguments[1].equalTo(CM.Integer.zero)){
return this;}
else{
return CM.Integer.zero;}}
return[this];};
CM.Atomic.prototype.lCoeff=function(){
return this;};
CM.Atomic.prototype.tCoeff=function(){
return this;};
CM.Atomic.prototype.constantTerm=function(){
return this;};
CM.Atomic.prototype.substituteOneKeyTerm=function(){
return this;};
CM.Atomic.Max=function(){
var inputarray=arguments[0];
var inputarraylength=inputarray.length;
var integerarray=new Array();
var rationalarray=new Array();
var floatingarray=new Array();
for(var i=0;i<inputarraylength;i++){
var inputarrayi=inputarray[i].simplify();
if(inputarrayi.cm_instanceof=="Integer"){
integerarray.push(inputarrayi);}
else if(inputarrayi.cm_instanceof=="Rational"){
rationalarray.push(inputarrayi);}
else if(inputarrayi.cm_instanceof=="Floating"){
floatingarray.push(inputarrayi);}}
if(integerarray.length>0){
var integermax=CM.Integer.Max(integerarray);}
if(rationalarray.length>0){
var rationalmax=CM.Rational.Max(rationalarray);}
if(floatingarray.length>0){
var floatingmax=CM.Floating.Max(floatingarray);}
var finalarray=new Array();
if(integermax!=null){
finalarray.push(new CM.Rational(integermax));}
if(rationalmax!=null){
finalarray.push(rationalmax);}
if(finalarray.length==0){
return floatingmax;}
else if(floatingarray.length==0){
return CM.Rational.Max(finalarray).simplify();}
else{
var integerandrationalmax=CM.Rational.Max(finalarray);
var newfloatingmax=new CM.Rational(floatingmax);
if(integerandrationalmax.greaterThan(newfloatingmax)){
return integerandrationalmax.simplify();}
else{
return floatingmax;}}};
CM.Atomic.Min=function(){
var inputarray=arguments[0];
var inputarraylength=inputarray.length;
var integerarray=new Array();
var rationalarray=new Array();
var floatingarray=new Array();
for(var i=0;i<inputarraylength;i++){
var inputarrayi=inputarray[i].simplify();
if(inputarrayi.cm_instanceof=="Integer"){
integerarray.push(inputarrayi);}
else if(inputarrayi.cm_instanceof=="Rational"){
rationalarray.push(inputarrayi);}
else if(inputarrayi.cm_instanceof=="Floating"){
floatingarray.push(inputarrayi);}}
if(integerarray.length>0){
var integermin=CM.Integer.Min(integerarray);}
if(rationalarray.length>0){
var rationalmin=CM.Rational.Min(rationalarray);}
if(floatingarray.length>0){
var floatingmin=CM.Floating.Min(floatingarray);}
var finalarray=new Array();
if(integermin!=null){
finalarray.push(new CM.Rational(integermin));}
if(rationalmin!=null){
finalarray.push(rationalmin);}
if(finalarray.length==0){
return floatingmin;}
else if(floatingarray.length==0){
return CM.Rational.Min(finalarray).simplify();}
else{
var integerandrationalmin=CM.Rational.Min(finalarray);
var newfloatingmin=new CM.Rational(floatingmin);
if(integerandrationalmin.lessThan(newfloatingmin)){
return integerandrationalmin.simplify();}
else{
return floatingmin;}}};
CM.Atomic.prototype.rationalize=function(){
return[this,CM.Integer.one];};
CM.Atomic.prototype.rationalizeAux=CM.Atomic.prototype.rationalize;
CM.Atomic.prototype.rationalizeWithoutCanceling=function(){
return[this,CM.Integer.one];};
CM.Atomic.prototype.reduceCommonFactors=function(){
return this;};
CM.Atomic.prototype.horner=function(){
return this;};
CM.Atomic.prototype.rationalCoefficientDenominator=function(){
return CM.Integer.one;};
CM.Atomic.prototype.isInteger=function(){
if(this.simplify().cm_instanceof=="Integer"){
return true;}
else{
return false;}};
CM.Atomic.prototype.numeratorAndDenominator=function(){
return this;};
CM.Atomic.prototype.maximizePolynomials=function(){
return this;};
CM.Atomic.prototype.isMultipliedOutPolynomial=function(){
return true;};
CM.Atomic.prototype.containsPowers=function(){
return false;};
CM.Atomic.prototype.hasIntegerCoefficients=CM.Atomic.prototype.isInteger;
CM.Atomic.prototype.structurallyEquivalent=function(){
var args0=arguments[0];
if(args0.isAtomic===true){
return this.equalTo(args0);}
if(args0.cm_instanceof=="Polynomial"&&args0.key.length==0&&args0.terms.length==1){
return this.equalTo(args0.terms[0][0]);}};
CM.Atomic.prototype.isNonconstantPolynomial=function(){
return false;};
CM.Atomic.prototype.containsQuotientsOrNegativeExponents=function(){
return false;};
CM.Atomic.prototype.containsQuotientsOrNegativeExponentsAux=CM.Atomic.prototype.containsQuotientsOrNegativeExponents;
CM.Atomic.prototype.evaluateAsFunction=function(){
return this;};
CM.Atomic.prototype.convertToRoots=function(){
return this;};
CM.Atomic.prototype.reduceFractionalExponents=function(){
return this.simplify();};
CM.Atomic.prototype.reduceFractionalExponentsAndSimplify=function(){
return this.simplify();};
CM.Atomic.prototype.convertRootsToFractionalExponents=function(){
return this;};
CM.Atomic.prototype.containsNegativeExponents=function(){
return false;};
CM.Atomic.prototype.containsFractionalExponents=function(){
return false;};
CM.Atomic.prototype.containsRoots=function(){
return false;};
CM.Atomic.prototype.containsUnsimplifiedFractionalExponents=function(){
return false;};
