
CM.Integer.prototype.modSymmetric=function(){
var Integer=CM.Integer;
var two=Integer.two;
var minusOne=Integer.minusOne;
var divisor=arguments[0];
if(divisor!=null){
var tempreturn=this.divide(divisor).mod;
if(tempreturn.multiply(two).greaterThan(divisor.add(minusOne))){
return tempreturn.minus(divisor);}
else{
return tempreturn;}}
else{
return this;}};
CM.PolynomialNativeExponents.prototype.modSymmetric=function(){
var modulus=arguments[0];
var temppoly=new CM.PolynomialNativeExponents(this.simplify(modulus));
var tempterms=CM.PolynomialNativeExponents._CopyTerms(temppoly.terms);
var tempkey=CM.PolynomialNativeExponents._CopyKey(temppoly.key);
var temptermslength=tempterms.length;
for(var i=0;i<temptermslength;i++){
tempterms[i][0]=tempterms[i][0].modSymmetric(modulus);}
return new CM.PolynomialNativeExponents(tempterms,tempkey);};
CM.PolynomialNativeExponents.prototype.BigPrimeGCD=function(){
var Integer=CM.Integer;
var Polynomial=CM.PolynomialNativeExponents;
var b=new Polynomial(arguments[0]);
if(b.key.length>1||b.key.length>1){
return Integer.one;
throw new Error("Polynomial A has "+this.key.length+" variables while polynomial B has "+b.key.length+"variables.\n This function was written for polynomials of one variable.");}
var acontent=this.content();
var bcontent=b.content();
var contentgcd=Integer.gcd(acontent,bcontent);
if(this.key.length==0||b.key.length==0){
return contentgcd;}
if(this.key[0]!=b.key[0]){
return contentgcd;}
var a=this.primitive();
var b=b.primitive();
var n=a.maxDegree(1);
var b1=b.maxDegree(1);
var whosA="a";
if(n<b1){
n=b1;
var temp=a;
a=b;
b=temp;
whosA="b";}
var A=a.linfinity(0);
var bLinfinity=b.linfinity(0);
if(A.lessThan(bLinfinity)){
A=bLinfinity;}
var gcdB=Integer.gcd(a.terms[0][0],b.terms[0][0]);
var m=Math.ceil(Math.pow(1*n+1,1/2));
m=new Integer(m);
var o=Integer.two.power(n);
var B=m.multiply(o).multiply(A).multiply(gcdB);
var twoB=B.multiply(Integer.two);
var fourB=B.multiply(Integer.four);
do{
var randomP=Integer.random(twoB,fourB);
var nextP=randomP.nextPrime();
var f=a.mod(nextP);
var g=b.mod(nextP);
var zeroPolynomial=CM.PolynomialNativeExponents.zero;
var onePolynomial=CM.PolynomialNativeExponents.one;
var r1,r2,r3;
r1=(f.divide(g,nextP)).remainder.mod(nextP);
if(r1.notEqualTo(zeroPolynomial)){
r2=(g.divide(r1,nextP)).remainder.mod(nextP);
r3=r2;}
else if(r1.equalTo(zeroPolynomial)){
r1=g;
r3=zeroPolynomial;}
while(r3.notEqualTo(zeroPolynomial)){
r3=(r1.divide(r2,nextP)).remainder.mod(nextP);
r1=r2;
r2=r3;}
if(r1.cm_instanceof=="Integer"){
return contentgcd;}
var v=r1.monic(nextP);
var w=v.multiply(gcdB,nextP).modSymmetric(nextP);
var tmp1=a.multiply(gcdB,nextP);
var fStar=tmp1.divide(w,nextP).quotient.modSymmetric(nextP);
tmp1=b.multiply(gcdB,nextP);
var gStar=tmp1.divide(w,nextP).quotient;
gStar=gStar.modSymmetric(nextP);
var wL1=w.linfinity(1);
var fStarL1W=wL1.multiply(fStar.linfinity(1));
var gStarL1W=wL1.multiply(gStar.linfinity(1));}while(fStarL1W.greaterThan(B)||gStarL1W.greaterThan(B))
return w.primitive().multiply(contentgcd);};
CM.PolynomialNativeExponents.prototype.contentOLD=function(){
var Integer=CM.Integer;
var one=Integer.one;
var minusOne=Integer.minusOne;
if(arguments[0]==null){
var terms=this.terms;
var tLength=terms.length;
if(tLength<2){
var tempreturn=terms[0][0].abs();
return tempreturn;}
for(var i=0;i<tLength;i++){
if(terms[i][0].equalTo(one)||terms[i][0].equalTo(minusOne)){
return one;}}
var d=Integer.gcd(terms[0][0],terms[1][0]);
for(var i=2;i<tLength;i++){
d=Integer.gcd(terms[i][0],d);
if(d.equalTo(one)){
return one;}}}
else{
var variable=arguments[0];
var terms=this.coeff(variable);
var termslength=terms.length;
if(termslength<2){
var tempreturn=terms[0];
return tempreturn;}
for(var i=0;i<termslength;i++){
if(terms[i].equalTo(one)||terms[i].equalTo(minusOne)){
return one;}
else{
terms[i]=new CM.PolynomialNativeExponents(terms[i]);}}
var d=terms[0].multivariateGcd(terms[1]);
for(var i=2;i<termslength;i++){
d=terms[i].multivariateGcd(d);
if(d.equalTo(one)){
return one;}}}
return d;};
CM.PolynomialNativeExponents.prototype.monic=function(){
var Integer=CM.Integer;
var Polynomial=CM.PolynomialNativeExponents
var one=Integer.one;
var vTerms=Polynomial._CopyTerms(this.terms);
var vKey=Polynomial._CopyKey(this.key);
var vLength=vTerms.length;
var vLeadingCoeff=vTerms[0][0];
var nextP=new Integer(arguments[0]);
if(vLeadingCoeff.notEqualTo(one)){
var vLCInverse=vLeadingCoeff.inverseM(nextP);
for(var i=0;i<vTerms.length;i++){
vTerms[i][0]=vTerms[i][0].multiply(vLCInverse).mod(nextP);}}
return new CM.PolynomialNativeExponents(vTerms,vKey);};

