
CM.DensePolynomial=function(){
if(arguments[0]==undefined){
return CM.DensePolynomial.zero;}
var type=arguments[0].cm_instanceof;
if(type=="Array"){
this.terms=arguments[0];
this.key=arguments[1];
if(this.key==null)
this.isNumber=arguments[0].isNumber;}
else if(type=="DensePolynomial"){
return this;}
else if(type=="Polynomial"){
var temppoly=arguments[0].expand();
var key=temppoly.getKey();
var keylength=key.length;
var zero=CM.Integer.zero;
if(keylength==0){
this.terms=arguments[0].simplify();
this.key=[];}
else if(keylength==1){
var coeff=temppoly.coeff(key[0]);
var coefflength=coeff.length;
for(var i=0;i<coefflength;i++){
if(coeff[i].equalTo(zero)){
coeff[i]=null;}}
this.terms=coeff;
this.key=key;}
else{
var coeff=temppoly.coeff(key[key.length-1]);
coefflength=coeff.length;
for(var i=0;i<coefflength;i++){
if(coeff[i]!=null){
if(coeff[i].isNumber!==true){
coeff[i]=new CM.DensePolynomial(coeff[i]);}
else if(coeff[i].equalTo(zero)){
coeff[i]=null;}}}
this.terms=coeff;
this.key=[key[key.length-1]];}}
else if(type=="Integer"){
this.key=[];
this.terms=[arguments[0]];
this.isNumber=true;}
else if(type=="Rational"){
this.key=[];
this.terms=[arguments[0]];
this.isNumber=true;}
else if(type=="Floating"){
this.key=[];
this.terms=[arguments[0]];
this.isNumber=true;}
else if(type=="Complex"){
this.key=[]
this.terms=[arguments[0]];
this.isNumber=true;}
else if(arguments[0].simplify!=null){
var tempthis=arguments[0].simplify();
if(tempthis.cm_instanceof=="DensePolynomial"||tempthis.cm_instanceof=="Polynomial"||tempthis.cm_instanceof=="Integer"||tempthis.cm_instanceof=="Rational"||tempthis.cm_instanceof=="Floating"||tempthis.cm_instanceof=="Complex"){
return new CM.DensePolynomial(tempthis,arguments[1]);}
else
throw new Error("DensePolynomial constructor was not passed an appropriate type. It was passed the arguments:"+arguments[0]+".");}
else
throw new Error("DensePolynomial constructor could not construct a polynomial from the "+arguments[0].cm_instanceof+", "+arguments[0]);}
CM.DensePolynomial.prototype.cm_instanceof="DensePolynomial";
CM.DensePolynomial.prototype.isNumber=false;
CM.DensePolynomial.prototype.isPolynomial=true;
CM.DensePolynomial.prototype.isRationalFunction=true;
CM.DensePolynomial.prototype.toString=function(){
var thisstring=this.string;
if(thisstring!=null){
return thisstring;};
var terms=this.terms;
var key=this.key[0];
var tLength=terms.length;
var zero=CM.Integer.zero;
var one=CM.Integer.one;
var returnarray=new Array();
for(var i=tLength-1;i>1;i--){
if(terms[i]!=null){
if(terms[i].isNumber===false||terms[i].cm_instanceof=="Rational"||(terms[i].cm_instanceof=="Complex"&&!terms[i].real().equalTo(zero))){
returnarray.push("("+terms[i].toString()+")*"+key+"^"+i);}
else if(terms[i].equalTo(one)){
returnarray.push(""+key+"^"+i);}
else if(!terms[i].equalTo(zero)){
returnarray.push(""+terms[i].toString()+"*"+key+"^"+i);}}}
if(terms[1]!=null){
if(terms[1].isNumber===false||terms[1].cm_instanceof=="Rational"||(terms[1].cm_instanceof=="Complex"&&!terms[1].real().equalTo(zero))){
returnarray.push("("+terms[1].toString()+")*"+key);}
else if(terms[1].equalTo(one)){
returnarray.push(""+key);}
else if(!terms[1].equalTo(zero)){
returnarray.push(""+terms[1].toString()+"*"+key);}}
if(terms[0]!=null){
returnarray.push(""+terms[0].toString()+"");}
return returnarray.join("+").replace(/\+\-/g,"-");};
CM.DensePolynomial.prototype.getTerms=function(){
return this.terms.slice(0);};
CM.DensePolynomial.prototype.getKey=function(){
return this.key.slice(0);};
CM.DensePolynomial.prototype.multiply=function(){
var AtomicMultiply=CM.Atomic.Multiply;
var Add=CM.DensePolynomial.Add;
var zero=CM.Integer.zero;
args0=arguments[0];
if(args0.cm_instanceof==="DensePolynomial"&&args0.key.length==0){
args0=args0.terms[0];}
if(args0.isNumber===true){
var terms=this.getTerms();
var termslength=terms.length;
var args0=args0.simplify();
for(var i=0;i<termslength;i++){
if(terms[i]!=null){
if(terms[i].isNumber){
terms[i]=AtomicMultiply([terms[i],args0]);}
else{
terms[i]=terms[i].multiply(args0);}}}
return new CM.DensePolynomial(terms,this.getKey());}
if(this.key[0]==args0.key[0]){
if(this.terms.length<args0.terms.length){
var left=this;
var leftterms=left.terms;
var lefttermslength=leftterms.length;
var right=args0;
var rightterms=right.terms;
var righttermslength=rightterms.length;}
else{
var left=args0;
var leftterms=left.terms;
var lefttermslength=leftterms.length;
var right=this;
var rightterms=right.terms;
var righttermslength=rightterms.length;}
var returnarray=new Array();
var combinedlength=lefttermslength+righttermslength;
var lengthminusone=combinedlength-1;
for(var i=0;i<lengthminusone;i++){
var thisterm=new Array();
var stopat=Math.min(lefttermslength,i+1);
var beginat=Math.max(0,i-righttermslength+1);
for(var j=beginat;j<stopat;j++){
if(leftterms[j]!=null&&rightterms[i-j]!=null){
var tempij;
leftterms[j].key!=null?tempij=leftterms[j].multiply(rightterms[i-j]):tempij=rightterms[i-j].multiply(leftterms[j]);
thisterm.push(tempij);}};
if(thisterm.length>0){
returnarray[i]=Add(thisterm);}};
return new CM.DensePolynomial(returnarray,left.getKey());}
else if(this.key[0]<args0.key[0]){
var left=this;
var right=args0;}
else if(this.key[0]>args0.key[0]){
var left=args0;
var right=this;}
var terms=right.getTerms();
var termslength=terms.length;
for(var i=0;i<termslength;i++){
if(terms[i]!=null){
if(terms[i].key==null){
if(left.key==null){
terms[i]=AtomicMultiply([terms[i][0],left]);}
else{
terms[i]=left.multiply(terms[i]);}}
else{
terms[i]=terms[i].multiply(left);}}}
return new CM.DensePolynomial(terms,right.getKey());};
CM.DensePolynomial.Add=function(){
var inputarray=arguments[0];
if(inputarray.length==0){
return CM.Integer.zero;};
var inputarraylength=inputarray.length;
var zero=CM.Integer.zero;
var numberarray=new Array();
var polynomialarray=new Array();
var biggestarray=new Array();
var biggestkey;
for(var i=0;i<inputarraylength;i++){
inputarrayi=inputarray[i];
if(inputarrayi!=null){
if(inputarrayi.key==null){
numberarray.push(inputarrayi);}
else if(inputarrayi.key.length===0){
numberarray.push(inputarrayi.terms[0]);}
else{
var keyi=inputarrayi.key;
if(biggestkey==null){
biggestarray.push(inputarrayi);
biggestkey=keyi[keyi.length-1];}
else if(keyi[keyi.length-1]>biggestkey){
biggestkey=keyi[keyi.length-1];
polynomialarray=polynomialarray.concat(biggestarray);
biggestarray=[inputarrayi];}
else if(keyi[keyi.length-1]==biggestkey){
biggestarray.push(inputarrayi);}
else{
polynomialarray.push(inputarrayi);}}}}
var numberreturn=CM.Atomic.Add(numberarray);
if(biggestarray.length==0){
return numberreturn;}
else if(biggestarray.length==1){
if(!numberreturn.equalTo(zero)){
polynomialarray.push(numberreturn);}
if(polynomialarray.length==0){
return biggestarray[0];}
else{
var biggestterms=biggestarray[0].getTerms();
if(biggestterms[0]!=null){
polynomialarray.push(biggestterms[0]);}
biggestterms[0]=CM.DensePolynomial.Add(polynomialarray);
return new CM.DensePolynomial(biggestterms,biggestarray[0].getKey());}}
else{
var biggestlength=biggestarray.length;
var passthiskey=biggestarray[0].getKey();
var maxdegree=0;
for(var j=0;j<biggestlength;j++){
maxdegree=Math.max(maxdegree,biggestarray[j].terms.length);}
var returnterms=new Array();
for(var t=0;t<maxdegree;t++){
returnterms[t]=new Array();
for(var j=0;j<biggestlength;j++){
if(biggestarray[j].terms[t]!=null){
returnterms[t].push(biggestarray[j].terms[t]);}}
if(returnterms[t].length>0){
returnterms[t]=CM.DensePolynomial.Add(returnterms[t]);}
else{
returnterms[t]=null;}}
if(!numberreturn.equalTo(zero)){
polynomialarray.push(numberreturn);}
if(polynomialarray.length>0){
returnterms[0]=CM.DensePolynomial.Add(polynomialarray.concat(returnterms[0]));}
return new CM.DensePolynomial(returnterms,passthiskey);}};
CM.DensePolynomial.prototype.simplify=function(){
if(this.key==null){
return temp[0];}
else{
return this;}};
CM.DensePolynomial.prototype.equalTo=function(){
if(this.key.length==0&&this.key.length==0){
return temp[0].equalTo(arguments[0]);}
else{
if(arguments[0].key==null||this.key[0]!=arguments[0].key[0]){
return false;}}};
CM.DensePolynomial.prototype.repeatedSquaringPower=function(){
var exponent=arguments[0];
if(exponent.cm_instanceof!="Integer")
return new CM.Power(this,exponent);
if(exponent.equalTo(CM.Integer.zero))
return new CM.Integer(1);
if(exponent.equalTo(CM.Integer.one))
return this;
if(exponent.sign=="-")
return new CM.Power([this.power(exponent.abs()),CM.Integer.minusOne]);
retInt=this;
var binaryString=exponent.toBaseTwo();
var bLength=binaryString.length;
for(var i=1;i<bLength;i++)
if(binaryString.charAt(i)=="1"){
retInt=retInt.multiply(retInt).simplify();
retInt=retInt.multiply(this).simplify();}
else
retInt=retInt.multiply(retInt).simplify();
return retInt;}
CM.DensePolynomial.prototype.convertToPolynomialNativeExponents=function(){
var one=CM.Integer.one;
var terms=this.getTerms();
var key=this.getKey();
var termslength=terms.length;
var tempreturn=new Array();
for(var i=0;i<termslength;i++){
if(terms[i]!=null){
if(terms[i].key==null){
tempreturn.push(new CM.PolynomialNativeExponents([[terms[i],i]],key));}
else{
tempreturn.push(CM.PolynomialNativeExponents.Multiply([terms[i].convertToPolynomialNativeExponents(),new CM.PolynomialNativeExponents([[one,i]],key)]));}}}
return CM.PolynomialNativeExponents.Add(tempreturn);}

