
CM.Exp=function(){
this.terms=arguments[0];
this.hasDerivative=new Object();};
CM.Exp.prototype=new CM.StandardFunction("exp",["x"]);
CM.Exp.prototype.constructor=CM.Exp;
CM.Exp.prototype.name="exp";
CM.Exp.prototype.constructorName="Exp";
CM.Exp.prototype.argumentsLength=1;
CM.Exp.prototype.toString=function(){
if(this.terms[0].cm_instanceof=="NativeString"){
return "exp";}
var exp=this.terms;
return "exp("+exp+")";
if(exp.isNumber)
return "e^"+exp.toString();
var exponentstring=exp.toString();
if(exponentstring.length==1)
return "e^"+exponentstring;
else
return "e^("+exponentstring+")";}
CM.Exp.prototype.round=function(){
var tempexponent=this.terms[0].round(arguments[0],arguments[1]);
var EValue=CM.RealConstant.EValue;
var sixtyfourth=new CM.Floating(new CM.Integer(15625),-6);
var extraprecision=20;
var two=CM.Floating.two;
var one=CM.Floating.one;
var log=Math.log;
var E=Math.E;
minusOne=CM.Floating.minusOne;
if(tempexponent.equalTo(CM.Integer.zero)){
return CM.Floating.one;}
if(tempexponent.isNumber===true){
if(tempexponent.sign=="-"){
var positiveexponentexponential=new CM.Exp([new CM.Floating(this.terms[0]).multiply(minusOne,extraprecision+1*arguments[0],arguments[1])]);
return CM.Floating.one.divide(positiveexponentexponential.round(extraprecision+1*arguments[0],arguments[1]),extraprecision+1*arguments[0],arguments[1]).round(arguments[0],arguments[1]);}
if(tempexponent.cm_instanceof=="Integer"){
return EValue.power(tempexponent,arguments[0],arguments[1]);}
var integermultiple=tempexponent.truncate(0);
tempexponent=tempexponent.subtract(integermultiple,extraprecision+1*arguments[0],arguments[1]);
var integerpart=EValue.power(integermultiple,extraprecision+1*arguments[0],arguments[1]);
var k=0;
while(tempexponent.greaterThan(sixtyfourth)){
tempexponent=tempexponent.divide(two,extraprecision+1*arguments[0],arguments[1]);
k++;}
smallexponential=new CM.Exp([tempexponent]);
var n=10;
while((n+1)*(log(n+1)-log(tempexponent)-1)/log(10)<=extraprecision+1*arguments[0]){
n++;}
smallexponential=smallexponential.evaluateTaylorSeries(n,extraprecision+1*arguments[0],arguments[1]);
smallexponential=smallexponential.power(CM.Integer.two.power(new CM.Integer(k)),extraprecision+1*arguments[0],arguments[1]);
smallexponential=smallexponential.multiply(integerpart,extraprecision+1*arguments[0],arguments[1]);
return smallexponential.round(arguments[0],arguments[1]);}
else{
return new CM.Power([EValue,tempexponent.round(arguments[0],arguments[1])]).round(arguments[0],arguments[1]);}};
CM.Exp.prototype.simplify=function(){
var thissimplified=this.simplified;
if(thissimplified!=null){
return thissimplified;}
var terms=this.terms[0];
var termssimplified=terms.simplify();
if(termssimplified.isNumber===true){
if(termssimplified.equalTo(CM.Integer.zero)){
var tempreturn=CM.Integer.one;
this.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=new CM.Exp([termssimplified]);
tempreturn.simplified=tempreturn;
this.simplified=tempreturn;
return tempreturn;}}
if(termssimplified.cm_instanceof=="StandardFunction"&&termssimplified.name=="ln"){
var tempreturn=termssimplified.terms[0];
this.simplified=tempreturn;
return tempreturn;}
else if(termssimplified.cm_instanceof=="Factor"){
var factorterms=termssimplified.getTerms();
var factortermslength=factorterms.length;
for(var i=0;i<factortermslength;i++){
if(factorterms[i].cm_instanceof=="StandardFunction"&&factorterms[i].name=="ln"){
var base=factorterms[i].terms[0];
factorterms.splice(i,1);
if(factorterms.length>1){
var tempreturn=new CM.Power([base,new CM.Factor(factorterms)]).simplify();}
else if(factorterms.length==1){
var tempreturn=new CM.Power([base,factorterms[0]]).simplify();}
else{
var tempreturn=base.simplify();}
tempreturn.simplified=tempreturn;
this.simplified=tempreturn;
return tempreturn;}}
var tempreturn=new CM.Exp([termssimplified]);
tempreturn.simplified=tempreturn;
this.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=new CM.Exp([termssimplified]);
tempreturn.simplified=tempreturn;
this.simplified=tempreturn;
return tempreturn;}};
CM.Exp.prototype.evaluateTaylorSeries=function(){
var Floating=CM.Floating;
var tempreturn=Floating.one;
var previousterm=tempreturn;
var numberofterms=1*arguments[0].toString();
var precision=arguments[1];
var type=arguments[2];
if(precision==null){
precision=Floating.precision;}
precision=1*precision.toString();
if(type==null){
type="s";}
var exponent=this.terms[0].round(precision,type);
for(var i=1;i<numberofterms;i++){
previousterm=previousterm.multiply(exponent,precision,type).divide(new CM.Floating(new CM.Integer(i)),precision,type);
tempreturn=tempreturn.add(previousterm,precision,type);}
return tempreturn;};
CM.Exp.prototype.rationalize=function(){
var terms=this.terms;
if(terms[0].isNumber===true&&terms[0].sign=="-"){
return[CM.Integer.one,new CM.Exp([new CM.Factor([CM.Integer.minusOne,terms[0]])]).simplify()];}
else{
return[this,CM.Integer.one];}};
CM.Exp.prototype.rationalizeAux=CM.Exp.prototype.rationalize;
CM.Exp.prototype.replaceStandardFunctions=function(){
var originalarray=CM.Composite.originalStandardFunctionsArray;
var replacementobject=CM.Composite.replacementObject;
var originallength=originalarray.length;
if(arguments[0]!="DoNotSimplify"){
var tempthis=this.simplify();}
else{
var tempthis=this;}
if(tempthis.cm_instanceof!=this.cm_instanceof||tempthis.constructorName!=this.constructorName){
return tempthis.replaceStandardFunctions(arguments[0]);}
var terms=tempthis.getTerms();
if(terms[0].cm_instanceof!=="Polynomial"&&terms[0].isNumber===false){
terms[0]=terms[0].replaceStandardFunctions(arguments[0]);}
var terms0=terms[0];
if(terms0.cm_instanceof=="Integer"){
var exponent=terms0;
var terms0=CM.Integer.one;}
else if(terms0.cm_instanceof=="Rational"){
var exponent=terms0.numerator;
var terms0=new CM.Rational(CM.Integer.one,terms0.denominator);}
else if(terms0.cm_instanceof=="Polynomial"){
var content=terms0.content();
if(content.cm_instanceof=="Integer"){
var exponent=content;}
if(content.cm_instanceof=="Rational"){
var exponent=content.numerator;}
var terms0=terms0.multiply(exponent.reciprocal());}
else if(terms0.cm_instanceof=="Factor"){
if(terms0.isPolynomial===true){
alert(["In exp expanding polynomial exponent",terms0,terms0.expand()]);
return new CM.Exp([terms0.expand()]).replaceStandardFunctions(arguments[0]);}
else{
var factorterms=terms0.getTerms();
var factortermslength=factorterms.length;
if(factorterms[0].cm_instanceof=="Integer"){
alert(["In exp with integer coefficient of factor",factorterms[0],factorterms.cm_toString()]);
var exponent=factorterms[0];
if(factortermslength==2){
return new CM.Exp([factorterms[1]]).replaceStandardFunctions(arguments[0]).power(exponent);}
else{
return new CM.Exp(factorterms.splice(0,1)).replaceStandardFunctions(arguments[0]).power(exponent);}}}}
var tempthis=new CM.Exp([terms0]);
var matchfound=false;
for(var j=0;j<originallength;j++){
if(tempthis.equalTo(originalarray[j][0])){
var newtempthis=originalarray[j][1];
matchfound=true;}}
if(matchfound===false){
var replaceby="_b"+CM.Composite.uniqueId();
var newtempthis=CM.Composite.CreateVariable([replaceby]);
originalarray.push([tempthis,newtempthis]);
CM.Composite.replacementObject[replaceby]=tempthis;}
if(exponent==null){
return newtempthis;}
else{
return newtempthis.power(exponent);}};

