
CM.Polynomial=function(){
this.hasDerivative=new Object();
if(arguments[0]==undefined){
return CM.Polynomial.zero;}
var type=arguments[0].cm_instanceof;
if(type=="Array"&&arguments[1]!=undefined&&arguments[1].cm_instanceof=="Array"){
if(arguments[0].length!=0){
this.terms=arguments[0];
this.key=arguments[1];
var key=this.key;
var keylength=key.length;
ispolynomialloop:
for(var i=0;i<keylength;i++){
if(key[i].match(/^\_\_/)){
var constantlist=CM.Definitions.Constants.AllConstantsObject;
if(constantlist!=null){
var tempconstant=constantlist[key[i]];
if(tempconstant!=null&&tempconstant.simplificationArray!=null){
if(tempconstant.simplificationArray[1].isPolynomial===true&&tempconstant.simplificationArray[1].isNumber===false){
this.isPolynomial=false;
this.isNumber=false;
this.isRationalFunction=false;
break ispolynomialloop;}}}}}
if(this.key.length==0){
this.isNumber=arguments[0][0].isNumber;}}
else{
return CM.Polynomial.zero;}}
else if(type=="Polynomial"){
return arguments[0];}
else if(type=="Integer"){
this.key=new Array();
this.terms=new Array([arguments[0]]);
this.isNumber=true;}
else if(type=="Rational"){
this.key=new Array();
this.terms=new Array([arguments[0]]);
this.isNumber=true;}
else if(type=="Floating"){
this.key=new Array();
this.terms=new Array([arguments[0]]);
this.isNumber=true;}
else if(type=="Complex"){
this.key=new Array();
this.terms=new Array([arguments[0]]);
this.isNumber=true;}
else if(arguments[0].simplify!=null){
var tempthis=arguments[0].simplify();
if(tempthis.cm_instanceof=="Polynomial"||tempthis.cm_instanceof=="Integer"||tempthis.cm_instanceof=="Rational"||tempthis.cm_instanceof=="Floating"||tempthis.cm_instanceof=="Complex"){
return new CM.Polynomial(tempthis,arguments[1]);}
else
throw new Error("Polynomial constructor was not passed an appropriate type. It was passed the arguments:"+arguments[0]+".");}
else
throw new Error("Polynomial constructor could not construct a polynomial from the "+arguments[0].cm_instanceof+", "+arguments[0]);}
CM.Polynomial.prototype.cm_instanceof="Polynomial";
CM.Polynomial.prototype.type="Polynomial";
CM.Polynomial.prototype.isNumber=false;
CM.Polynomial.prototype.isPolynomial=true;
CM.Polynomial.prototype.isRationalFunction=true;
CM.Polynomial.prototype.toString=function(){
var thisstring=this.string;
if(thisstring!=null){
return thisstring;};
var terms=this.terms;
var key=this.getKey();
var tLength=terms.length;
var kLength=key.length;
if(CM.DisplayLocalVariables===true){
for(var i=0;i<kLength;i++){
if(CM.Definitions.Constants.AllConstantsObject[key[i]]!=null)
key[i]=CM.Definitions.Constants.AllConstantsObject[key[i]].toString();}}
else{
for(var i=0;i<kLength;i++){
if(CM.Definitions.Constants.AllConstantsObject[key[i]]!=null)
key[i]=CM.Definitions.Constants.AllConstantsObject[key[i]].toString();
else
key[i]=key[i].replace(/[\_]*/,"").replace(/()\_.*/,"$1")}}
var inLength=0;
var outString="";
var tString="";
for(var x=0;x<tLength;x++){
var termsx0=terms[x][0];
if(termsx0.cm_instanceof=="Rational"||termsx0.cm_instanceof=="Complex"||termsx0.cm_instanceof=="Sum"||termsx0.cm_instanceof=="Power"||termsx0.cm_instanceof=="Polynomial")
tString=tString+"("+terms[x][0].toString()+")";
else
tString=tString+terms[x][0].toString();
for(var y=0;y<kLength;y++){
if(!terms[x][y+1].equalTo(CM.Integer.zero))
if(terms[x][y+1].equalTo(CM.Integer.one))
tString=tString+"*"+key[y];
else{
if(terms[x][y+1].sign=="+")
tString=tString+"*"+key[y]+"^"+terms[x][y+1].toString()+"";
else
tString=tString+"*"+key[y]+"^("+terms[x][y+1].toString()+")";}}
tString=tString.replace(/^\s*1\s*\*/,"").replace(/^\s*\-\s*1\s*\*/,"-");
if(terms[x+1]!=undefined)
outString=outString+tString+" + ";
else
outString=outString+tString;
tString="";}
return this.string=outString.replace(/\+\s*\-/g,"- ");}
CM.Polynomial.prototype.getPolynomialTerms=function(){
if(arguments[0]!=null)
var modulus=new CM.Integer(arguments[0]);
if(modulus==null){
var terms=this.terms;
var termslength=terms.length;
var returnterms=new Array(termslength);
for(var i=0;i<termslength;i++){
returnterms[i]=terms[i].slice(0);}}
else{
var zero=CM.Integer.zero;
var terms=this.terms;
var termslength=terms.length;
var returnterms=new Array();
for(var i=0;i<termslength;i++){
var reducedcoefficient=terms[i][0].mod(modulus);
if(!reducedcoefficient.equalTo(zero)){
returnterms.push([reducedcoefficient].concat(terms[i].slice(1)));}}}
return returnterms;}
CM.Polynomial.prototype.getDependentVariables=function(){
var key=this.getKey();
var keylength=key.length;
var returnarray=new Array();
if(arguments[0]==null){
for(var i=0;i<keylength;i++){
if(key[i].match(/^\_/)==null){
returnarray.push(key[i]);}}}
else{
for(var i=0;i<keylength;i++){
returnarray.push(key[i]);}}
return returnarray;};
CM.Polynomial.prototype.getKey=function(){
return this.key.slice(0);}
CM.Polynomial.prototype.equalTo=function(){
var left=new CM.Polynomial(this.simplify());
var right=arguments[0].simplify();
try{
var right=new CM.Polynomial(arguments[0]);}
catch(e){
if(arguments[1]!=null&&right.cm_instanceof=="Power"&&right.terms[0].cm_instanceof=="Polynomial"&&right.terms[1].cm_instanceof=="Integer"){
return this.equalTo(right.terms[0],"ignorefirst");}
else{
return false;}}
var lKey=left.key;
var lkLength=lKey.length;
var rKey=right.key;
var rkLength=rKey.length;
var lTerms=left.terms;
var ltLength=lTerms.length;
var rTerms=right.terms;
var rtLength=rTerms.length;
if(lkLength!=rkLength)
return false;
for(var i=0;i<lkLength;i++)
if(lKey[i]!=rKey[i])
return false;
if(ltLength!=rtLength)
return false;
if(arguments[1]!="allowmultiples"){
for(var i=0;i<ltLength;i++){
var lTermiI=lTerms[i];
var rTermsI=rTerms[i];
for(var j=0;j<lkLength+1;j++){
if(!lTermiI[j].equalTo(rTermsI[j]))
return false;}}}
else{
var multiple=new CM.Factor([lTerms[0][0],new CM.Power([rTerms[0][0],CM.Integer.minusOne])]).simplify();
for(var i=0;i<ltLength;i++){
var lTermiI=lTerms[i];
var rTermsI=rTerms[i];
if(!lTermiI[0].equalTo(new CM.Factor([multiple,rTermsI[0]]).simplify())){
return false;}
for(var j=1;j<lkLength+1;j++){
if(!lTermiI[j].equalTo(rTermsI[j])){
return false;}}}}
return true;}
CM.Polynomial.prototype.notEqualTo=function(){
return !this.equalTo(arguments[0]);}
CM.Polynomial.prototype.sort=function(key,termCompareCB){
if(this.terms.length<=1&&this.key.length<=1&&key==undefined)
return this;
if(key==undefined)
key=this.getKey().sort();
var terms=this.getPolynomialTerms();
var oldKey=this.getKey();
if(key.length!=oldKey.length){
alert("Your argument in sort must be an array that is a reordering of all the variables in the polynomial");
throw new Error("Your argument in sort must be an array that is a reordering of all the variables in the polynomial");}
if(key.length>1)
terms=CM.Polynomial._ExpandKey(terms,oldKey,key);
if(termCompareCB==undefined)
termCompareCB=CM.Polynomial._compare;
else
termCompareCB=CM.Polynomial["_"+termCompareCB];
var tempObject=CM.Polynomial._Sort(terms,key,termCompareCB,key);
return CM.Polynomial._Simplify(tempObject.terms,tempObject.key);}
CM.Polynomial.prototype.simplifyWithoutConstants=function(){
if(arguments[0]!=null)
var modulus=new CM.Integer(arguments[0]);
if(modulus==null){
if(this.simplified!=null)
return this.simplified;
else{
var newthis=this.sort();
return CM.Polynomial._Simplify(newthis.getPolynomialTerms(),newthis.getKey());}}
else{
var newthis=this.sort();
return CM.Polynomial._Simplify(newthis.getPolynomialTerms(),newthis.getKey(),null,modulus);}}
CM.Polynomial.prototype.simplify=function(){
if(arguments[0]!=null){
var modulus=new CM.Integer(arguments[0]);}
if(modulus==null){
if(this.simplified!=null){
return this.simplified;}
else{
var newthis=new CM.Polynomial(this.sort());
var tempreturn=CM.Polynomial._Simplify(newthis.getPolynomialTerms(),newthis.getKey());
if(tempreturn.reduceConstants!=null){
var tempreturn=tempreturn.reduceConstants();}
this.simplified=tempreturn;
tempreturn.simplified=tempreturn;
return tempreturn;}}
else{
var newthis=this.sort();
return CM.Polynomial._Simplify(newthis.getPolynomialTerms(),newthis.getKey(),null,modulus);}}
CM.Polynomial.prototype.reduceConstants=function(){
var tempreturn=this;
var key=tempreturn.getKey();
var keylength=key.length;
var constantarray=CM.Definitions.Constants.AllConstantsObject;
constantnumberloop:
for(var i=0;i<keylength;i++){
if(key[i].match(/^\_\_/)!=null&&constantarray[key[i]]!=null&&constantarray[key[i]].simplificationArray!=null){
var simplifypower=constantarray[key[i]].simplificationArray[0];
var maxpower=tempreturn.maxDegree(key[i]);
if(!maxpower.lessThan(simplifypower)){
break constantnumberloop;}}}
if(i>=keylength){
return this;}
else{
var simplifyindex=i;
var simplifyreplacement=constantarray[key[simplifyindex]].simplificationArray[1];
if(!maxpower.lessThan(simplifypower)){
var tempdivide=maxpower.divide(simplifypower);
var quotient=tempdivide.quotient;
var remainder=tempdivide.remainder;
if(simplifyreplacement.cm_instanceof=="Polynomial"){
var replacement=tempreturn.coeff(key[simplifyindex],maxpower).multiply(simplifyreplacement.power(quotient).multiply(new CM.Polynomial([[CM.Integer.one,remainder]],[key[simplifyindex]])));
return new CM.Polynomial(tempreturn.subtract(tempreturn.coeff(key[simplifyindex],maxpower).multiply(new CM.Polynomial([[CM.Integer.one,maxpower]],[key[simplifyindex]])))).add(replacement).simplify();}
else{
var replacement=new CM.Factor([tempreturn.coeff(key[simplifyindex],maxpower),new CM.Power([simplifyreplacement,quotient]),new CM.Polynomial([[CM.Integer.one,remainder]],[key[simplifyindex]])]).simplify();
return(new CM.Sum([this.subtract(tempreturn.coeff(key[simplifyindex],maxpower).multiply(new CM.Polynomial([[CM.Integer.one,maxpower]],[key[simplifyindex]]))),replacement])).simplify();}}
return tempreturn;}}
CM.Polynomial.zero=new CM.Polynomial([[CM.Integer.zero]],[]);
CM.Polynomial.one=new CM.Polynomial([[CM.Integer.one]],[]);
CM.Polynomial.prototype.maxDegree=function(){
var variable=arguments[0];
if(variable.cm_instanceof=="Variable")
variable=variable.symbol;
else if(variable.cm_instanceof=="Polynomial"&&variable.key.length==1)
variable=variable.key[0];
var key=this.key;
var kLength=key.length;
var terms=this.terms;
var tLength=terms.length;
var index=0;
var i=0;
if(variable.cm_instanceof=="NativeString")
while(i<kLength&&key[i++]!=variable);
else
i=variable;
if(i>kLength)
return CM.Integer.zero;
var max=terms[0][i];
for(var j=1;j<tLength;j++)
if(terms[j][i].greaterThan(max))
max=terms[j][i];
return max;}
CM.Polynomial.prototype.minDegree=function(){
var variable=arguments[0];
if(variable==null)
return CM.Integer.zero;
else if(variable.cm_instanceof=="Variable")
variable=variable.symbol;
else if(variable.cm_instanceof=="Polynomial"&&variable.key.length==1)
variable=key[0];
var key=this.key;
var kLength=key.length;
var terms=this.terms;
var tLength=terms.length;
var index=0;
var i=0;
if(variable.cm_instanceof=="NativeString")
while(i<kLength&&key[i++]!=variable);
else
i=variable;
if(i>kLength)
return CM.Integer.zero;
var min=terms[0][i];
for(var j=1;j<tLength;j++)
if(terms[j][i].lessThan(min))
min=terms[j][i];
return min;}
CM.Polynomial.prototype.coeff=function(){
var variable=arguments[0];
var exponent=arguments[1];
if(variable==null)
return this;
else{
if(variable.cm_instanceof=="Variable")
variable=variable.symbol;
else if(variable.cm_instanceof=="Polynomial"&&variable.key.length==1)
variable=variable.key[0];}
var newTerms=new Array();
var terms=this.terms;
var tLength=terms.length;
var key=this.key;
var kLength=key.length;
var copyOf=CM.Polynomial._CopyTerm;
var j=0;
while(key[j++]!=variable){
if(j>kLength){
return this;}}
if(exponent==undefined){
var totalArray=new Array();
for(var i=0;i<tLength;i++){
var termsI=terms[i];
var temp=copyOf(termsI);
temp.splice(j,1);
var thisindex=1*termsI[j].toString();
if(totalArray[thisindex]==null)
totalArray[thisindex]=[temp];
else
totalArray[thisindex].push(temp);}
var nKey=this.getKey();
nKey.splice(j-1,1);
var totalArraylength=totalArray.length;
for(var j=0;j<totalArraylength;j++){
totalArray[j]=new CM.Polynomial(totalArray[j],nKey).simplify();}
return new CM.Vector(totalArray);}
else{
for(var i=0;i<tLength;i++){
var termsI=terms[i];
if(termsI[j].equalTo(exponent)){
var temp=copyOf(termsI);
temp.splice(j,1);
newTerms.push(temp);}}
var nKey=this.getKey();
nKey.splice(j-1,1);
return new CM.Polynomial(newTerms,nKey);}}
CM.Polynomial.prototype.lCoeff=function(){
var variable=arguments[0];
if(variable==null)
return CM.Integer.zero;
var maxDegree=this.maxDegree(variable);
return this.coeff(variable,maxDegree);}
CM.Polynomial.prototype.tCoeff=function(){
var variable=arguments[0];
var zero=CM.Integer.zero;
if(variable!=null){
return this.coeff(variable,zero);}
else
return this;}
CM.Polynomial.prototype.constantTerm=function(){
var zero=CM.Integer.zero;
var onePlusKeyLength=this.key.length+1;
var terms=this.terms;
var termsLength=terms.length;
var returnTerms=new Array();
for(var i=0;i<termsLength;i++){
var addTerm=-1;
exponentloop:
for(var j=1;j<onePlusKeyLength;j++){
if(!terms[i][j].equalTo(zero)){
addTerm=1;
break exponentloop;}}
if(addTerm==-1)
returnTerms=returnTerms.concat(terms[i].slice(0,1));}
if(returnTerms.length>0)
return(new CM.Sum(returnTerms)).simplify();
else
return zero;}
CM.Polynomial._totalDegreeDescending=function(){
var lTerm=arguments[0];
var rTerm=arguments[1];
var length=lTerm.length;
var lSum=CM.Integer.zero;
var rSum=CM.Integer.zero;
for(var i=1;i<length;i++){
lSum=lSum.plus(lTerm[i]);
rSum=rSum.plus(rTerm[i]);}
if(lSum.greaterThan(rSum))
return -1;
if(lSum.lessThan(rSum))
return 1;
for(var i=1;i<length;i++){
if(lTerm[i].greaterThan(rTerm[i]))
return -1;
else if(lTerm[i].lessThan(rTerm[i]))
return 1;}
return 0;}
CM.Polynomial._totalDegreeAscending=function(){
var lTerm=arguments[0];
var rTerm=arguments[1];
var length=lTerm.length;
var lSum=CM.Integer.zero;
var rSum=CM.Integer.zero;
for(var i=1;i<length;i++){
lSum=lSum.plus(lTerm[i]);
rSum=rSum.plus(rTerm[i]);}
if(lSum.greaterThan(rSum))
return 1;
if(lSum.lessThan(rSum))
return -1;
for(var i=1;i<length;i++){
if(lTerm[i].greaterThan(rTerm[i]))
return -1;
else if(lTerm[i].lessThan(rTerm[i]))
return 1;}
return 0;}
CM.Polynomial._ascending=function(){
var lTerm=arguments[0];
var rTerm=arguments[1];
var length=lTerm.length;
for(var i=1;i<length;i++){
if(lTerm[i].lessThan(rTerm[i]))
return -1;
else if(lTerm[i].greaterThan(rTerm[i]))
return 1;}
return 0;}
CM.Polynomial._descending=function(){
var lTerm=arguments[0];
var rTerm=arguments[1];
var length=lTerm.length;
for(var i=1;i<length;i++){
if(lTerm[i].greaterThan(rTerm[i]))
return -1;
else if(lTerm[i].lessThan(rTerm[i]))
return 1;}
return 0;}
CM.Polynomial._compare=CM.Polynomial._totalDegreeDescending;
CM.Polynomial._CopyTerms=function(terms){
var termslength=terms.length;
var returnterms=new Array(termslength);
for(var i=0;i<termslength;i++){
returnterms[i]=terms[i].slice(0);}
return returnterms;}
CM.Polynomial._CopyKey=function(key){
return key.slice(0);}
CM.Polynomial._CopyTerm=function(){
return arguments[0].slice(0);}
CM.Polynomial._mergeKeys=function(){
var lKey=arguments[0].slice(0).sort();
var lkLength=lKey.length;
var rKey=arguments[1].slice(0).sort();
var rkLength=rKey.length;
var nKey=new Array();
var i=0;
var j=0;
var n=0;
while(i<lkLength&&j<rkLength){
if(lKey[i]==rKey[j]){
nKey[n]=lKey[i];
i++;
j++;}
else if(lKey[i]<rKey[j]){
nKey[n]=lKey[i];
i++;}
else{
nKey[n]=rKey[j];
j++;}
n++;}
while(i<lkLength)
nKey[n++]=lKey[i++];
while(j<rkLength)
nKey[n++]=rKey[j++];
return nKey;}
CM.Polynomial._ExpandKey=function(terms,oldKey,newKey){
var nkLength=newKey.length;
var okLength=oldKey.length;
var kMap=new Array(nkLength);
var nTerm=new Array(nkLength+1);
var found=false;
var tLength=terms.length;
var zero=CM.Integer.zero;
var Int=CM.Integer;
var i=0;
if(nkLength==okLength)
for(i;i<okLength;i++)
if(newKey[i]!=oldKey[i])
break;
if(i>okLength)
return terms;
for(var i=0;i<nkLength;i++){
found=false;
for(var j=0;j<okLength;j++){
if(newKey[i]==oldKey[j]){
kMap[i]=j;
found=true;
break;}}
if(!found)
kMap[i]=-1;}
for(var i=0;i<tLength;i++){
var oTerm=terms[i];
nTerm[0]=oTerm[0];
for(var j=1;j<nkLength+1;j++){
var mapIndex=kMap[j-1];
if(mapIndex>=0)
nTerm[j]=oTerm[mapIndex+1];
else
nTerm[j]=new Int(zero);}
terms[i]=nTerm.slice(0);}
return terms;}
CM.Polynomial._CondenseKey=function(terms,key){
var tLength=terms.length;
var kLength=key.length;
var map=new Array(kLength);
for(var i=0;i<kLength;i++)
map[i]=i+1;
var j=0;
var c=kLength;
while(c>0&&j<tLength){
var cTerm=terms[j];
for(var i=0;i<c;i++){
var mapIndex=map[i];
if(!cTerm[mapIndex].isZero()){
map.splice(i,1);
c--;
i--;}}
j++;}
if(c==0)
return{terms:terms,key:key};
for(var i=c-1;i>=0;i--)
key.splice(map[i]-1,1);
for(var i=0;i<tLength;i++){
var cTerm=terms[i];
for(var j=c-1;j>=0;j--){
cTerm.splice(map[j],1);}}
return{terms:terms,key:key};}
CM.Polynomial._Sort=function(terms,key,termCompareCB,keySortCB){
if(terms.length<=1&&key.length<=1&&keySortCB==undefined)
return{terms:terms,key:key};
var oldKey=key;
if(keySortCB==undefined)
key=key.slice(0).sort();
else
if(keySortCB.cm_instanceof=="Array")
var key=keySortCB;
else if(keySortCB.cm_instanceof=="NativeFunction"){
keySortCB.call(key);}
else
var key=key.sort();
if(key.length>1){
CM.Polynomial._ExpandKey(terms,oldKey,key);}
if(termCompareCB==undefined||termCompareCB.cm_instanceof!="NativeFunction")
termCompareCB=CM.Polynomial._compare;
terms.sort(termCompareCB);
return{terms:terms,key:key};}
CM.Polynomial._Simplify=function(terms,key){
if(terms.length==0||(terms.length==1&&terms[0].cm_instanceof=="Array"&&terms[0][0]==null))
return CM.Integer.zero;
if(arguments[3]!=null)
var modulus=new CM.Integer(arguments[3]);
var lTerms=terms;
var ltLength=lTerms.length;
var compare=CM.Polynomial._compare;
var copyTerm=CM.Polynomial._CopyTerm;
var returnterms=new Array();
var i=0;
if(modulus==null){
while(i<ltLength){
var j=1;
var temparray=[lTerms[i][0]];
if(lTerms[i+j]==null)
var result=10;
else
var result=compare(lTerms[i],lTerms[i+j]);
while(result==0){
temparray.push(lTerms[i+j][0]);
j++;
if(i+j<ltLength)
result=compare(lTerms[i],lTerms[i+j]);
else
result=10;};
if(temparray.length==1){
var singleTermCopy=copyTerm(lTerms[i]);
singleTermCopy[0]=singleTermCopy[0].simplify();
if(!(singleTermCopy[0].cm_instanceof=="Integer")||!singleTermCopy[0].equalTo(CM.Integer.zero))
returnterms.push(singleTermCopy);
i=i+j;}
else{
var tempcopy=copyTerm(lTerms[i]);
tempcopy[0]=new CM.Sum(temparray).simplify();
if(!(tempcopy[0].cm_instanceof=="Integer")||!tempcopy[0].equalTo(CM.Integer.zero)){
returnterms.push(tempcopy);};
i=i+j;};}}
else{
while(i<ltLength){
var j=1;
var temparray=[lTerms[i][0]];
if(lTerms[i+j]==null)
var result=10;
else
var result=compare(lTerms[i],lTerms[i+j]);
while(result==0){
temparray.push(lTerms[i+j][0]);
j++;
if(i+j<ltLength)
result=compare(lTerms[i],lTerms[i+j]);
else
result=10;};
if(temparray.length==1){
var singleTermCopy=copyTerm(lTerms[i]);
singleTermCopy[0]=singleTermCopy[0].simplify().mod(modulus);
if(!(singleTermCopy[0].cm_instanceof=="Integer")||!singleTermCopy[0].equalTo(CM.Integer.zero))
returnterms.push(singleTermCopy);
i=i+j;}
else{
var tempcopy=copyTerm(lTerms[i]);
tempcopy[0]=CM.Integer.AddM(temparray,modulus);
if(!(tempcopy[0].cm_instanceof=="Integer")||!tempcopy[0].equalTo(CM.Integer.zero)){
returnterms.push(tempcopy);};
i=i+j;};}}
var condenseObject=CM.Polynomial._CondenseKey(CM.Polynomial._CopyTerms(returnterms),CM.Polynomial._CopyKey(key));
returnterms=condenseObject.terms;
key=condenseObject.key;
if(arguments[2]!=true){
if(returnterms.length==0)
return CM.Integer.zero
else{
if(key.length>0)
return new CM.Polynomial(returnterms,key);
else
return returnterms[0][0];}}
else{
return returnterms;};}
CM.Polynomial.Add=function(){
var inputArray=arguments[0];
if(arguments[1]!=null)
var modulus=new CM.Integer(arguments[1]);
var inputArrayLength=inputArray.length;
if(inputArrayLength==0)
return CM.Integer.zero;
inputArray[0]=new CM.Polynomial(inputArray[0]);
var totalKey=inputArray[0].getKey();
for(var i=1;i<inputArrayLength;i++){
inputArray[i]=new CM.Polynomial(inputArray[i]);
totalKey=CM.Polynomial._mergeKeys(totalKey,inputArray[i].getKey());}
var totalArray=new Array();
for(var i=0;i<inputArrayLength;i++){
var tempExpand=CM.Polynomial._ExpandKey(inputArray[i].getPolynomialTerms(modulus),inputArray[i].getKey(),totalKey);
totalArray=totalArray.concat(tempExpand);}
var tempObject=CM.Polynomial._Sort(totalArray,totalKey,null,totalKey);
return CM.Polynomial._Simplify(tempObject.terms,tempObject.key,null,modulus).reduceConstants();}
CM.Polynomial.prototype.add=function(){
var left=this;
var right=arguments[0];
if(arguments[1]!=null)
var modulus=new CM.Integer(arguments[1]);
var leftTerms=left.getPolynomialTerms(modulus);
var rightTerms=right.getPolynomialTerms(modulus);
var nKey=CM.Polynomial._mergeKeys(left.key,right.key);
CM.Polynomial._ExpandKey(leftTerms,left.getKey(),nKey);
CM.Polynomial._ExpandKey(rightTerms,right.getKey(),nKey);
var leftTerms=leftTerms.concat(rightTerms);
var tempObject=CM.Polynomial._Sort(leftTerms,nKey,null,nKey);
return CM.Polynomial._Simplify(tempObject.terms,tempObject.key,null,modulus);}
CM.Polynomial.prototype.subtract=function(){
var Poly=CM.Polynomial;
var left=this;
var right=arguments[0];
if(arguments[1]!=null)
var modulus=new CM.Integer(arguments[1]);
var leftTerms=left.getPolynomialTerms(modulus);
var rightTerms=right.getPolynomialTerms(modulus);
var rtLength=rightTerms.length;
var minusOne=CM.Integer.minusOne
if(modulus==null){
for(var i=0;i<rtLength;i++){
rightTerms[i][0]=new CM.Factor([minusOne,rightTerms[i][0]]).simplify()}}
else{
for(var i=0;i<rtLength;i++){
rightTerms[i][0]=minusOne.multiply(rightTerms[i][0],modulus);}}
var nKey=Poly._mergeKeys(left.key,right.key);
Poly._ExpandKey(leftTerms,left.key,nKey);
Poly._ExpandKey(rightTerms,right.key,nKey);
var newTerms=leftTerms.concat(rightTerms);
var tempObject=Poly._Sort(newTerms,nKey,null,nKey);
return Poly._Simplify(tempObject.terms,tempObject.key,null,modulus);}
CM.Polynomial.Multiply=function(){
var inputArray=arguments[0];
var inputArrayLength=inputArray.length;
if(inputArrayLength==0)
return CM.Integer.zero;
if(arguments[1]!=null)
var modulus=new CM.Integer(arguments[1]);
inputArray[0]=new CM.Polynomial(inputArray[0]);
var totalKey=inputArray[0].getKey();
for(var i=1;i<inputArrayLength;i++){
inputArray[i]=new CM.Polynomial(inputArray[i]);
totalKey=CM.Polynomial._mergeKeys(totalKey,inputArray[i].getKey());}
var totalKeyLength=totalKey.length;
var totalArray=new Array();
for(var i=0;i<inputArrayLength;i++){
totalArray[i]=CM.Polynomial._ExpandKey(inputArray[i].getPolynomialTerms(),inputArray[i].getKey(),totalKey);}
var totalArrayLength=totalArray.length;
var leftTerms=totalArray[0];
var leftLength=leftTerms.length;
if(modulus==null){
for(var s=1;s<totalArrayLength;s++){
var rightTerms=totalArray[s];
var rightLength=rightTerms.length;
tempTerms=new Array();
for(var i=0;i<leftLength;i++){
for(var j=0;j<rightLength;j++){
var oneTerm=new Array(totalKeyLength);
oneTerm[0]=new CM.Factor([leftTerms[i][0],rightTerms[j][0]]).simplify();
for(var t=0;t<totalKeyLength;t++){
oneTerm[1+t]=leftTerms[i][1+t].add(rightTerms[j][1+t]);}
tempTerms.push(oneTerm);}}
var leftTerms=CM.Polynomial._Simplify(tempTerms,totalKey);
leftTerms=new CM.Polynomial(leftTerms);
leftTerms=CM.Polynomial._ExpandKey(leftTerms.getPolynomialTerms(),leftTerms.getKey(),totalKey);
var leftLength=leftTerms.length;}}
else{
for(var s=1;s<totalArrayLength;s++){
var rightTerms=totalArray[s];
var rightLength=rightTerms.length;
tempTerms=new Array();
for(var i=0;i<leftLength;i++){
for(var j=0;j<rightLength;j++){
var oneTerm=new Array(totalKeyLength);
oneTerm[0]=new CM.Integer(leftTerms[i][0]).multiplyM(rightTerms[j][0],modulus);
for(var t=1;t<=totalKeyLength;t++){
oneTerm[t]=leftTerms[i][t].add(rightTerms[j][t]);}
tempTerms.push(oneTerm);}}
var leftTerms=CM.Polynomial._Simplify(tempTerms,totalKey,true,modulus);
var leftLength=leftTerms.length;}}
var tempObject=CM.Polynomial._Sort(leftTerms,totalKey,null,totalKey);
return CM.Polynomial._Simplify(tempObject.terms,tempObject.key,null,modulus).reduceConstants();};
CM.Polynomial.prototype.multiply=function(){
var right=new CM.Polynomial(arguments[0]);
if(arguments[1]!=null)
var modulus=new CM.Integer(arguments[1]);
var leftTerms=this.getPolynomialTerms(modulus);
var rightTerms=right.getPolynomialTerms(modulus);
var leftKey=this.key;
var rightKey=right.key;
var tempTerms=new Array();
var nKey=CM.Polynomial._mergeKeys(leftKey,rightKey);
var nKeyLength=nKey.length;
CM.Polynomial._ExpandKey(leftTerms,leftKey,nKey);
CM.Polynomial._ExpandKey(rightTerms,rightKey,nKey);
var rightLength=rightTerms.length;
var leftLength=leftTerms.length;
if(modulus==null){
for(var i=0;i<leftLength;i++){
for(var j=0;j<rightLength;j++){
var oneTerm=new Array(nKeyLength);
oneTerm[0]=new CM.Factor([leftTerms[i][0],rightTerms[j][0]]).simplify();
for(var t=1;t<=nKeyLength;t++){
oneTerm[t]=leftTerms[i][t].add(rightTerms[j][t]);}
tempTerms.push(oneTerm);}}}
else{
for(var i=0;i<leftLength;i++){
for(var j=0;j<rightLength;j++){
var oneTerm=new Array(nKeyLength);
oneTerm[0]=new CM.Integer(leftTerms[i][0]).multiplyM(rightTerms[j][0],modulus);
for(var t=1;t<=nKeyLength;t++){
oneTerm[t]=leftTerms[i][t].add(rightTerms[j][t]);}
tempTerms.push(oneTerm);}}}
var tempObject=CM.Polynomial._Sort(tempTerms,nKey,null,nKey);
return CM.Polynomial._Simplify(tempObject.terms,tempObject.key,null,modulus);}
CM.Polynomial.prototype.divide=function(){
var right=new CM.Polynomial(arguments[0].simplify());
if(right.equalTo(CM.Polynomial.zero)){
alert("You are dividing the polynomial "+left.toString()+" by zero");
throw new Error("You are dividing the polynomial "+left.toString()+" by zero");}
if(arguments[1]!=null){
var modulus=new CM.Integer(arguments[1]);
var left=this.simplify(modulus);
right=new CM.Polynomial(right.mod(modulus));}
else{
var left=this.simplify();}
if(left.cm_instanceof!="Polynomial"){
left=new CM.Polynomial(left,[]);}
var lTerms=left.getPolynomialTerms();
var lKey=left.getKey();
var ltLength=lTerms.length;
var lkLength=lKey.length;
var rTerms=right.getPolynomialTerms();
var rtLength=rTerms.length;
var rKey=right.getKey();
var rkLength=rKey.length;
var qTerms=new Array();
var qKey=lKey;
var termLength=lTerms[0].length;
var copyOf=CM.Polynomial._CopyTerm;
if(modulus==null){
if(rtLength==1&&(rTerms[0].length==1||rTerms[0][1].isZero())){
for(var i=0;i<ltLength;i++)
lTerms[i][0]=new CM.Factor([lTerms[i][0],new CM.Power([rTerms[0][0],CM.Integer.minusOne])]).simplify();
var retObj=new Object();
retObj.quotient=new CM.Polynomial(lTerms,lKey);
retObj.remainder=CM.Integer.zero
return retObj;}}
else{
if(rtLength==1&&(rTerms[0].length==1||rTerms[0][1].isZero())){
for(var i=0;i<ltLength;i++)
lTerms[i][0]=lTerms[i][0].multiplyM(rTerms[0][0].inverseM(modulus),modulus);
var retObj=new Object();
retObj.quotient=new CM.Polynomial(lTerms,lKey);
retObj.remainder=CM.Integer.zero
return retObj;}}
if(ltLength==1&&(lTerms[0].length==1||lTerms[0][1].isZero())){
var retObj=new Object();
retObj.quotient=CM.Integer.zero;
retObj.remainder=left.simplify();
return retObj;}
var rightLeadingCoeff=rTerms[0][0];
var rightLeadingExpon=rTerms[0][1];
var quotientTerms=new Array();
var maxLeftDegree=left.maxDegree(1);
var maxRightDegree=right.maxDegree(1);
if(modulus==null){
divisionloop:
while(!maxRightDegree.greaterThan(maxLeftDegree)){
var multiplier=new CM.Factor([lTerms[0][0],new CM.Power([rTerms[0][0],CM.Integer.minusOne])]).simplify();
var degreeDifference=maxLeftDegree.subtract(maxRightDegree);
var newRightTerms=new Array();
for(var j=0;j<rtLength;j++)
newRightTerms[j]=[new CM.Factor([CM.Integer.minusOne,rTerms[j][0],multiplier]).simplify(),rTerms[j][1].add(degreeDifference)];
lTerms=lTerms.concat(newRightTerms);
var tempObject=CM.Polynomial._Sort(lTerms,lKey,null,lKey);
left=CM.Polynomial._Simplify(tempObject.terms,tempObject.key);
quotientTerms.push([multiplier,degreeDifference]);
if(left.cm_instanceof!="Polynomial")
break divisionloop;
lTerms=left.getPolynomialTerms();
maxLeftDegree=left.maxDegree(1);}}
else{
divisionloop1:
while(!maxRightDegree.greaterThan(maxLeftDegree)){
var multiplier=lTerms[0][0].multiplyM(rTerms[0][0].inverseM(modulus),modulus);
var degreeDifference=maxLeftDegree.subtract(maxRightDegree);
var newRightTerms=new Array();
for(var j=0;j<rtLength;j++){
newRightTerms[j]=[CM.Integer.minusOne.multiply(rTerms[j][0]).multiplyM(multiplier,modulus),rTerms[j][1].add(degreeDifference)];}
lTerms=lTerms.concat(newRightTerms);
var tempObject=CM.Polynomial._Sort(lTerms,lKey,null,lKey);
left=CM.Polynomial._Simplify(tempObject.terms,tempObject.key,null,modulus);
quotientTerms.push([multiplier,degreeDifference]);
if(left.cm_instanceof!="Polynomial")
break divisionloop1;
lTerms=left.getPolynomialTerms(modulus);
maxLeftDegree=left.maxDegree(1);}}
var retObj=new Object();
if(quotientTerms.length>0)
retObj.quotient=new CM.Polynomial(quotientTerms,lKey);
else
retObj.quotient=CM.Integer.zero;
if(modulus==null)
retObj.remainder=left;
else
retObj.remainder=left.simplify(modulus);
return retObj;}
CM.Polynomial.prototype.repeatedSquaringPower=function(){
var exponent=arguments[0];
if(exponent.cm_instanceof!="Integer")
return new CM.Power(this,exponent);
if(exponent.equalTo(CM.Integer.zero))
return new CM.Integer(1);
if(exponent.equalTo(CM.Integer.one))
return this;
if(exponent.sign=="-")
return new CM.Power([this.power(exponent.abs()),CM.Integer.minusOne]);
retInt=this;
var binaryString=exponent.toBaseTwo();
var bLength=binaryString.length;
for(var i=1;i<bLength;i++)
if(binaryString.charAt(i)=="1"){
retInt=retInt.multiply(retInt).simplify();
retInt=retInt.multiply(this).simplify();}
else
retInt=retInt.multiply(retInt).simplify();
return retInt;}
CM.Polynomial.prototype.binomialPower=function(){
if(arguments[0].sign=="-"){
if(this.terms.length>1){
return new CM.Power([this.binomialPower(arguments[0].abs()),CM.Integer.minusOne]);}
else{
var terms=this.getPolynomialTerms()[0];
var key=this.getKey();
var keylength=key.length;
var power=arguments[0];
var one=CM.Integer.one;
var tempcoeff=terms[0].power(power).simplify();
if(!tempcoeff.equalTo(one)){
var returnterms=[tempcoeff];}
else{
var returnterms=[];}
for(var i=0;i<keylength;i++){
var thisterm=new CM.Power([new CM.Polynomial([[one,one]],[key[i]]),terms[i+1].multiply(power)]);
thisterm.simplified=thisterm;
returnterms.push(thisterm);}
if(returnterms.length==1){
return returnterms[0];}
else{
var tempreturn=new CM.Factor(returnterms);
return tempreturn;}}}
var terms=this.getPolynomialTerms();
var key=this.getKey();
var CombinatorialArray=CM.Definitions.Expressions.Standard["CombinatorialArray"];
var keylength=key.length;
var power=arguments[0];
var onepluspower=1+(1*power.toString());
newterms=new Array();
if(terms.length==1){
newterms[0]=new Array();
var numberi=new CM.Integer(power);
newterms[0][0]=terms[0][0].power(numberi);
for(var j=0;j<keylength;j++){
newterms[0][j+1]=new CM.Factor([terms[0][j+1],numberi]).simplify();}
return new CM.Polynomial(newterms,key);}
var hundred=new CM.Integer(100);
if(arguments[0].greaterThan(hundred)){
return this.binomialPower(hundred).multiply(this.binomialPower(arguments[0].subtract(hundred)));}
if(terms.length==2){
var firstcoeff=terms[0][0];
var secondcoeff=terms[1][0];
var firstpowers=new Array();
var secondpowers=new Array();
if(CombinatorialArray[power]!=null){
for(var i=0;i<onepluspower;i++){
newterms[i]=new Array();
var numberi=new CM.Integer(i);
var otheri=new CM.Integer(power-i);
newterms[i][0]=new CM.Factor([firstcoeff.power(numberi),secondcoeff.power(otheri),CombinatorialArray[power][Math.min(i,power-i)]]).simplify();
for(var j=0;j<keylength;j++){if(newterms[i]==null){alert(["In binomial Powers newterms[i] is null",terms.cm_toString(),newterms.cm_toString(),newterms.length,i,newterms[i],this,arguments[0]]);};
newterms[i][j+1]=new CM.Sum([new CM.Factor([terms[0][j+1],numberi]),new CM.Factor([terms[1][j+1],otheri])]).simplify();}}}
else{
CombinatorialArray[power]=new Array();
var NativeCombinatorialArray=CM.Definitions.Expressions.Standard["NativeCombinatorialArray"];
for(var i=0;i<onepluspower;i++){
newterms[i]=new Array();
var numberi=new CM.Integer(i);
CombinatorialArray[power][Math.min(i,power-i)]=new CM.Integer(NativeCombinatorialArray[power][Math.min(i,power-i)]);
var otheri=new CM.Integer(power-i);
newterms[i][0]=new CM.Factor([firstcoeff.power(numberi),secondcoeff.power(otheri),CombinatorialArray[power][Math.min(i,power-i)]]).simplify();
for(var j=0;j<keylength;j++){
newterms[i][j+1]=new CM.Sum([new CM.Factor([terms[0][j+1],numberi]),new CM.Factor([terms[1][j+1],otheri])]).simplify();}}}
return new CM.Polynomial(newterms,key);}
else{
if(CombinatorialArray[power]!=null){
var firstpoly=new CM.Polynomial(terms.slice(0,terms.length-1),key);
var secondpoly=new CM.Polynomial([terms[terms.length-1]],key);
var polysumarray=new Array();
for(var i=0;i<onepluspower;i++){
polysumarray.push(new CM.Polynomial(firstpoly.binomialPower(new CM.Integer(i)).multiply(secondpoly.binomialPower(new CM.Integer(power-i))).multiply(CombinatorialArray[power][Math.min(i,power-i)])));}}
else{
CombinatorialArray[power]=new Array();
var NativeCombinatorialArray=CM.Definitions.Expressions.Standard["NativeCombinatorialArray"];
var firstpoly=new CM.Polynomial(terms.slice(0,terms.length-1),key);
var secondpoly=new CM.Polynomial([terms[terms.length-1]],key);
var polysumarray=new Array();
for(var i=0;i<onepluspower;i++){
CombinatorialArray[power][Math.min(i,power-i)]=new CM.Integer(NativeCombinatorialArray[power][Math.min(i,power-i)]);
polysumarray.push(new CM.Polynomial(firstpoly.binomialPower(new CM.Integer(i)).multiply(secondpoly.binomialPower(new CM.Integer(power-i))).multiply(CombinatorialArray[power][Math.min(i,power-i)])));}}
return new CM.Polynomial(CM.Polynomial.Add(polysumarray));}};
CM.Polynomial.prototype.power=function(){
if(this.terms.length<this.key.length+2){
var tempreturn=this.binomialPower(arguments[0]);}
else{
var tempreturn=this.repeatedSquaringPower(arguments[0]).reduceConstants();}
if(tempreturn.cm_instanceof=="Polynomial"){
return tempreturn.reduceConstants();}
else{
return tempreturn;}};
CM.Polynomial.prototype.expand=function(){
var terms=this.getPolynomialTerms();
var termsLength=terms.length;
var key=this.getKey();
for(var i=0;i<termsLength;i++){
terms[i][0]=terms[i][0].expand();}
return new CM.Polynomial(terms,key);}
CM.Polynomial.prototype.fastExpand=CM.Polynomial.prototype.expand;
CM.Polynomial.prototype.fastExpandAux=CM.Polynomial.prototype.expand;
CM.Polynomial.prototype.substituteOneKeyTerm=function(){
var original=arguments[0];
var replacement=arguments[1];
var terms=this.getPolynomialTerms();
var termslength=terms.length;
var key=this.getKey();
var keylength=key.length;
if(original.cm_instanceof=="NativeString")
var originalsymbol=original;
else if(original.cm_instanceof=="Polynomial"&&original.key.length==1&&original.terms.length==1&&original.terms[0][0].equalTo(CM.Integer.one)&&original.terms[0][1].equalTo(CM.Integer.one))
var originalsymbol=original.key[0];
if(replacement.cm_instanceof=="Polynomial"&&replacement.key.length==1&&replacement.terms.length==1&&replacement.terms[0][0].equalTo(CM.Integer.one)&&replacement.terms[0][1].equalTo(CM.Integer.one)){
var replacementsymbol=replacement.key[0];
if(originalsymbol===replacementsymbol){
return this;}}
else{
var notkeysubstitution=true;}
if(keylength==1&&termslength==1&&terms[0][0].equalTo(CM.Integer.one)&&terms[0][1].equalTo(CM.Integer.one)){
if(key[0]==originalsymbol)
return replacement;}
matchkeyloop:
for(var i=0;i<keylength;i++)
if(key[i]==originalsymbol){
var matchindex=i;
break matchkeyloop;}
if(matchindex!=null){
matchduplicatekeyloop:
for(var i=0;i<keylength;i++){
if(key[i]==replacementsymbol){
var willcauseduplicateindex=i;
break matchduplicatekeyloop;}}}
if(matchindex==null){
return this;}
if(matchindex!=null&&notkeysubstitution){
if(replacement.isNumber===true){
key.splice(matchindex,1);
for(var i=0;i<termslength;i++){
if(!terms[i][matchindex+1].equalTo(CM.Integer.zero)){
if(!terms[i][0].equalTo(CM.Integer.one)){
terms[i][0]=new CM.Factor([terms[i][0],new CM.Power([replacement,terms[i][matchindex+1]])]);}
else{
terms[i][0]=new CM.Power([replacement,terms[i][matchindex+1]]);}}
terms[i].splice(matchindex+1,1);}}
else{
var returnsum=new Array();
var oldkey=this.getKey();
key.splice(matchindex,1);
var sumterms=new Array();
var remainingpolyterms=new Array();
for(var i=0;i<termslength;i++){
if(!terms[i][matchindex+1].equalTo(CM.Integer.zero)){
var exponent=terms[i][matchindex+1];
terms[i].splice(matchindex+1,1);
var condensed=CM.Polynomial._CondenseKey([terms[i]],key.slice(0));
if(!terms[i][0].equalTo(CM.Integer.one)){
sumterms.push(new CM.Factor([new CM.Power([replacement,exponent]),new CM.Polynomial(condensed.terms,condensed.key).simplify()]));}
else{
sumterms.push(new CM.Factor([new CM.Power([replacement,exponent]),new CM.Polynomial(condensed.terms,condensed.key)]).simplify());}}
else{
terms[i].splice(matchindex+1,1);
remainingpolyterms.push(terms[i]);}}
if(remainingpolyterms.length>0){
var condensed=CM.Polynomial._CondenseKey(remainingpolyterms,key.slice(0));
sumterms.push(new CM.Polynomial(condensed.terms,condensed.key).simplify());}
return new CM.Sum(sumterms);}}
else if(matchindex!=null&&willcauseduplicateindex==null){
key[matchindex]=replacementsymbol;}
else{
for(var i=0;i<termslength;i++){
terms[i][matchindex+1]=terms[i][matchindex+1].add(terms[i][willcauseduplicateindex+1]);
terms[i].splice(willcauseduplicateindex+1,1);}
key[matchindex]=replacementsymbol;
key.splice(willcauseduplicateindex,1);}
if(key.length>0)
return new CM.Polynomial(terms,key);
else{
var termslength=terms.length;
var newterms=new Array(termslength);
for(var i=0;i<termslength;i++){
newterms[i]=terms[i][0];}
if(newterms.length>1)
return new CM.Sum(newterms);
else{
return newterms[0];};}}
CM.Polynomial.prototype.substituteKeyTerms=function(){
var originalarray=arguments[0];
var replacementarray=arguments[1];
var type=arguments[2];
var originalarraylength=originalarray.length;
var replacementarraylength=replacementarray.length;
if(originalarraylength!=replacementarraylength){
alert("The number of elements you are replacing in substituteKeyTerms does not equal the number of elements you provided");
throw new Error("The number of elements you are replacing in substituteKeyTerms does not equal the number of elements you provided");}
var temppoly=this;
for(var i=0;i<originalarraylength;i++){
if(temppoly.cm_instanceof=="Polynomial"&&replacementarray[i]!=null){
temppoly=temppoly.substituteOneKeyTerm(originalarray[i],replacementarray[i]);}
else{
temppoly=temppoly.substitute([originalarray[i]],[replacementarray[i]],type);}};
return temppoly;}
CM.Polynomial.prototype.replacePolynomialVariables=function(){
var tempreturn=this.substituteKeyTerms(arguments[0],arguments[1],arguments[2]);
return tempreturn;}
CM.Polynomial.prototype.substitute=function(){
var type;
arguments[2]==null?type="simultaneous":type=arguments[2];
if(type=="recursive"){
var originalarray=arguments[0];
var originalarraylength=originalarray.length;
var tempthis=this.simplify();
var originalarray=arguments[0];
var originalarraylength=originalarray.length;
for(var i=0;i<originalarraylength;i++){
originalarray[i]=originalarray[i].simplify()
if(tempthis.equalTo(originalarray[i])){
tempthis=arguments[1][i];}
else{
tempthis=tempthis.replacePolynomialVariables([originalarray[i]],[arguments[1][i]],"recursive");}}
return tempthis;}
else{
var originalarray=arguments[0];
var originalarraylength=originalarray.length;
for(var i=0;i<originalarraylength;i++){
if(this.equalTo(originalarray[i])){
return arguments[1][i];}}
var replacementarray=new Array();
for(var i=0;i<originalarraylength;i++){
var replaceby="_c"+CM.Composite.uniqueId();
var replacementvariable=new CM.Polynomial([[CM.Integer.one,CM.Integer.one]],[replaceby]);
replacementarray.push(replacementvariable);}
return this.replacePolynomialVariables(originalarray.slice(0),replacementarray,"recursive").replacePolynomialVariables(replacementarray,arguments[1],"recursive");}}
CM.Polynomial.prototype.mod=function(){
return this.simplify(arguments[0]);}
CM.Polynomial.prototype.replaceExpressionReferences=function(){
return this;}
CM.Polynomial.prototype.useCurrentExpressionValues=CM.Composite.prototype.useCurrentExpressionValues;
CM.Polynomial.prototype.structure=function(){
return "Polynomial: ["+this.toString()+"]";};
CM.Polynomial.prototype.executeInterfaceFunctions=function(){
return this;}
CM.Polynomial.prototype.breakUpPolynomial=function(){
var terms=this.getPolynomialTerms();
var termslength=terms.length;
var key=this.getKey();
var keylength=key.length;
var newterms=[];
for(var i=0;i<termslength;i++){
var thisterm=terms[i];
var oneterm=[thisterm[0]];
var onekey=[];
for(var j=0;j<keylength;j++){
if(thisterm[j+1]!=CM.Integer.zero){
oneterm.push(thisterm[j+1]);
onekey.push(key[j]);}}
newterms.push(new CM.Polynomial([oneterm],onekey));}
return new CM.Sum(newterms);};
CM.Polynomial.prototype.unreplaceStandardFunctions=function(){
var dependentvariables=this.getKey();
var dependentvariableslength=dependentvariables.length;
var originalarray=new Array();
var replacementarray=new Array();
var replacementobject=CM.Composite.replacementObject;
originalloop:
for(var i=0;i<dependentvariableslength;i++){
if(dependentvariables[i].match(/^\_b/)){
originalarray.push(new CM.Polynomial([[CM.Integer.one,CM.Integer.one]],[dependentvariables[i]]));
replacementarray.push(replacementobject[dependentvariables[i]]);}}
if(originalarray.length==0){
return this;}
else{
var originalarray=originalarray.slice(0).reverse();
var replacementarray=replacementarray.slice(0).reverse();
return this.substitute(originalarray,replacementarray,"recursive").unreplaceStandardFunctions();}}
CM.Polynomial.prototype.round=function(){
var precision=arguments[0];
if(precision==null)
precision=CM.Floating.precision;
var type=arguments[1];
if(type==null)
type=CM.Floating.precisionType;
var terms=this.getPolynomialTerms();
var termslength=terms.length;
for(var i=0;i<termslength;i++)
terms[i][0]=terms[i][0].round(precision,type);
var tempreturn=new CM.Polynomial(terms,this.key);
var key=tempreturn.getKey();
var keylength=key.length;
var replacethis=new Array();
var withthis=new Array();
for(var i=0;i<keylength;i++){
if(key[i].match(/^\_\_/)){
keyname=key[i].replace(/^\_\_/,"");
var constantreference=CM.Definitions.Constants.Standard[keyname];
if(constantreference!=null&&constantreference.constant!=null&&constantreference.constant.round!=null){
replacethis.push(key[i]);
withthis.push(constantreference.constant.round(precision,type));}}}
return tempreturn.replacePolynomialVariables(replacethis,withthis);}
CM.Polynomial.prototype.derivative=function(){
if(arguments[1]!=null){
var derivativenumber=new CM.Integer(arguments[1]);
if(derivativenumber.equalTo(CM.Integer.zero))
return this.simplify();}
if(arguments[2]!=null)
var modulus=new CM.Integer(arguments[2]);
var left=new CM.Polynomial(this.simplify());
var derivativevariable=arguments[0].toString();
var key=this.getKey();
var keylength=key.length;
var variableindex;
indexloop:
for(var i=0;i<keylength;i++){
if(derivativevariable==key[i]){
variableindex=i+1;
break indexloop;}}
if(variableindex==null)
return CM.Integer.zero;
var leftTerms=left.getPolynomialTerms(modulus);
var leftTermsLength=leftTerms.length;
var newLeftTerms=new Array();
for(var i=0;i<leftTermsLength;i++){
if(leftTerms[i][variableindex].greaterThan(CM.Integer.zero))
newLeftTerms.push([new CM.Factor([leftTerms[i][0],leftTerms[i][variableindex]])].concat(leftTerms[i].slice(1,variableindex)).concat([leftTerms[i][variableindex].add(CM.Integer.minusOne)]).concat(leftTerms[i].slice(variableindex+1)));}
var tempreturn=CM.Polynomial._Simplify(newLeftTerms,key,null,modulus);
if(derivativenumber==null||derivativenumber.equalTo(CM.Integer.one))
return tempreturn;
else
return tempreturn.derivative(derivativevariable,derivativenumber.add(CM.Integer.minusOne),modulus);}
CM.Polynomial.prototype.squarefree=function(){
if(arguments[0]!=null)
var modulus=new CM.Integer(arguments[0]);
var left=new CM.Polynomial(this.simplify(modulus));
var derivative=left.derivative(left.key[0],CM.Integer.one,modulus);
if(derivative.equalTo(CM.Integer.zero)){
alert("The derivative of the polynomial "+left+" is zero. Therefore you cannot use squarefree on this polynomial.");
throw new Error("The derivative of the polynomial "+left+" is zero. Therefore you cannot use squarefree on this polynomial.");}
var gcd=CM.Polynomial.gcd(left,derivative,modulus);
var tempreturn=left.divide(gcd,modulus).quotient;
return new CM.Polynomial(tempreturn).monic(tempreturn.key[0],modulus);}
CM.Polynomial.gcd=function(){
if(arguments[2]!=null)
var modulus=new CM.Integer(arguments[2]);
var a=new CM.Polynomial(arguments[0].simplify(modulus));
var b=new CM.Polynomial(arguments[1].simplify(modulus))
while(b!=undefined&&b.notEqualTo(CM.Integer.zero)){
var temp=b;
var dividesObj=a.divide(b,modulus);
b=dividesObj.remainder;
a=temp;};
return new CM.Polynomial(a).monic(a.key,modulus);};
CM.Polynomial.prototype.monic=function(){
if(arguments[1]!=null)
var modulus=new CM.Integer(arguments[1]);
var left=this.simplify();
var left=new CM.Polynomial(this.simplify(modulus));
if(left.equalTo(CM.Polynomial.zero)){
alert("You are trying to make the 0 polynomial monic. This is causing an error.");
throw new Error("You are trying to make the 0 polynomial monic. This is causing an error.");}
else if(left.simplify().cm_instanceof=="Integer")
return CM.Integer.one;
var leftTerms=left.getPolynomialTerms(modulus);
var leftTermsLength=leftTerms.length;
var key=left.getKey();
var leadingcoeff=left.lCoeff(key[0]).simplify();
if(leadingcoeff.equalTo(CM.Integer.one)){
return left;}
if(modulus==null){
var leadingcoeffreciprocal=new CM.Power([leadingcoeff,CM.Integer.minusOne]);
for(var i=0;i<leftTermsLength;i++){
leftTerms[i][0]=new CM.Factor([leftTerms[i][0],leadingcoeffreciprocal]);}}
else{
var leadingcoeffreciprocal=leadingcoeff.inverseM(modulus);
for(var i=0;i<leftTermsLength;i++){
leftTerms[i][0]=leftTerms[i][0].multiplyM(leadingcoeffreciprocal,modulus);}}
return CM.Polynomial._Simplify(leftTerms,key,null,modulus);}
CM.Polynomial.prototype.getTerms=function(){
alert(["You are calling getTerms on Polynomial. We need to know why this is being called. This is ",this]);
return[this];}
CM.Polynomial.prototype.isVariable=function(){
var tempTerms=this.getPolynomialTerms();
var tempKey=this.getKey();
if(tempKey.length==1&&tempTerms.length==1&&tempTerms[0][0].equalTo(CM.Integer.one)&&tempTerms[0][1].equalTo(CM.Integer.one)){
return true;}
else{
return false;}};
CM.Polynomial.simplifySingleTermExpressions=function(){
var polyarray=new Array();
var powerarray=new Array();
var exponentarray=new Array();
var argsarray=arguments[0];
var argsarraylength=argsarray.length;
for(var i=0;i<argsarraylength;i++){
if(argsarray[i].cm_instanceof=="Polynomial"){
polyarray.push(argsarray[i]);}
else{
powerarray.push(argsarray[i].terms[0]);
exponentarray.push(argsarray[i].terms[1]);}}
var powerarraylength=powerarray.length;
var polyarraylength=polyarray.length;
if(powerarraylength==0||polyarraylength==0){
return argsarray;}
else{
var mergedkey=polyarray[0].getKey();
for(var i=1;i<polyarraylength;i++){
mergedkey=CM.Polynomial._mergeKeys(mergedkey,polyarray[i].getKey());}
for(var i=0;i<powerarraylength;i++){if(powerarray[i].getKey==null){alert(["Cannot get key in ",powerarray[i],powerarray[i].cm_instanceof]);}
mergedkey=CM.Polynomial._mergeKeys(mergedkey,powerarray[i].getKey());}
for(var i=0;i<polyarraylength;i++){
polyarray[i]=CM.Polynomial._ExpandKey(polyarray[i].getPolynomialTerms(),polyarray[i].getKey(),mergedkey)[0];}
for(var i=0;i<powerarraylength;i++){
powerarray[i]=CM.Polynomial._ExpandKey(powerarray[i].getPolynomialTerms(),powerarray[i].getKey(),mergedkey)[0];}}
var mergedkeylength=mergedkey.length;
var zero=CM.Integer.zero;
var coefficientarray=[CM.Integer.one];
var combinedexponentarray=new Array();
for(var i=0;i<mergedkeylength;i++){
combinedexponentarray.push(zero);}
for(var i=0;i<polyarraylength;i++){
coefficientarray.push(polyarray[i][0]);
for(var j=0;j<mergedkeylength;j++){
combinedexponentarray[j]=(new CM.Sum([combinedexponentarray[j],polyarray[i][j+1]])).simplify();}}
for(var i=0;i<powerarraylength;i++){
for(var j=0;j<mergedkeylength;j++){
combinedexponentarray[j]=(new CM.Sum([combinedexponentarray[j],new CM.Factor([exponentarray[i],powerarray[i][j+1]])])).simplify();}}
var finalpolykey=new Array();
var finalpowerkey=new Array();
var finalpolyterms=new Array();
var finalpowerterms=new Array();
for(var i=0;i<mergedkeylength;i++){
if(combinedexponentarray[i].greaterThan(zero)){
finalpolykey.push(mergedkey[i]);
finalpolyterms.push(combinedexponentarray[i]);}
else if(combinedexponentarray[i].lessThan(zero)){
finalpowerkey.push(mergedkey[i]);
finalpowerterms.push(combinedexponentarray[i].abs());}}
if(finalpowerkey.length>0){
var finalpowerobjects=new Array();
for(var i=0;i<finalpowerkey.length;i++){
finalpowerobjects.push(new CM.Power([new CM.Polynomial([[CM.Integer.one,CM.Integer.one]],[finalpowerkey[i]]),finalpowerterms[i].multiply(CM.Integer.minusOne)]));}}
if(finalpolykey.length>0){
var finalpolyobject=new CM.Polynomial([[(new CM.Factor(coefficientarray)).simplify()].concat(finalpolyterms)],finalpolykey);
if(finalpowerkey.length>0){
return[finalpolyobject].concat(finalpowerobjects);}
else{
return[finalpolyobject];}}
else{
if(finalpowerkey.length>0){
var finalcoeff=(new CM.Factor(coefficientarray)).simplify();
if(!finalcoeff.equalTo(CM.Integer.one)){
return[finalcoeff].concat(finalpowerobjects);}
else{
return finalpowerobjects;}}
else{
if(coefficientarray.length==1){
return[coefficientarray.simplify()];}
else{
return[(new CM.Factor(coefficientarray)).simplify()];}}}};
CM.Polynomial.prototype.taylorSeries=function(){
var derivativeRespectTo=arguments[0];
var value=arguments[1];
var numbersOfDerivative=arguments[2];
var zero=CM.Integer.zero;
var tempArray=new Array();
var temppoly=new CM.Polynomial([[(new CM.Factor([CM.Integer.minusOne,value])).simplify(),zero],[CM.Integer.one,CM.Integer.one]],['x']);
temppoly=temppoly.sort(['x'],"descending");
for(var i=0;i<numbersOfDerivative;i++){
if(i==0){
tempArray[i]=
this.derivative(derivativeRespectTo,i).substitute([derivativeRespectTo],[value]);}
else{
var thisTermsDerivative=this.derivative(derivativeRespectTo,i).substitute([derivativeRespectTo],[value]);
if(thisTermsDerivative.equalTo(zero)){}
else{
tempArray.push(new CM.Factor([thisTermsDerivative,(new CM.Power([new CM.Factorial([new CM.Integer(i)]),CM.Integer.minusOne])).simplify(),new CM.Power([temppoly,new CM.Integer(i)])]));}}}
return new CM.Sum(tempArray);};

