
CM.Rational=function(){
var args0=arguments[0];
var args1=arguments[1];
var args2=arguments[2];
var args3=arguments[3];
var args0type=args0.cm_instanceof;
if(args0type=="Rational"){
if(arguments[1]==null||args0.sign==arguments[1])
return args0;
else{
this.numerator=new CM.Integer(args0.numerator,arguments[1]);
this.denominator=args0.denominator.abs();
this.sign=args0.sign;}}
else if(args0type=="Integer"){
this.numerator=args0;
if(args1==undefined){
this.denominator=CM.Integer.one;
this.sign=args0.sign;}
else{
this.denominator=args1;
if(args1.equalTo(CM.Integer.zero))
throw new Error(args0+"/0 is undefined.");}
if(args2==null)
this.sign=(args0.sign==this.denominator.sign?"+":"-");
else{
this.numerator=new CM.Integer(args0,args2);
this.denominator=this.denominator.abs();
this.sign=args2;}
if(args2!=null&&args3===true){
this.simplified=this;
this.simplifiedInClass=this;}}
else if(args0type=="Floating"){
var sign=args1||args0.sign;
if(args0.shift<0)
return new CM.Rational(args0.value,CM.Integer.ten.power(new CM.Integer(-1*args0.shift)),sign);
else
return new CM.Rational(args0.value.multiply(CM.Integer.ten.power(new CM.Integer(args0.shift))),CM.Integer.one,sign);}
else if(args0.simplify!=null){
var tempthis=args0.simplify();
if(tempthis.cm_instanceof=="Integer"||tempthis.cm_instanceof=="Rational"||tempthis.cm_instanceof=="Floating"){
return new CM.Rational(tempthis,args1,args2,args3);}
else
throw new Error("Rational constructor was not passed an appropriate type. It was passed the arguments:"+arguments[0]+".");}
else
throw new Error("Rational constructor was not passed an appropriate type. It was passed the arguments:"+arguments[0]+".");};
CM.Rational.prototype=new CM.Atomic();
CM.Rational.prototype.constructor=CM.Rational;
CM.Rational.prototype.cm_instanceof="Rational";
CM.Rational.half=new CM.Rational(CM.Integer.one,CM.Integer.two);
CM.Rational.third=new CM.Rational(CM.Integer.one,CM.Integer.three);
CM.Rational.fourth=new CM.Rational(CM.Integer.one,CM.Integer.four);
CM.Rational.fifth=new CM.Rational(CM.Integer.one,CM.Integer.five);
CM.Rational.sixth=new CM.Rational(CM.Integer.one,CM.Integer.six);
CM.Rational.prototype.toString=function(){
var thisstring=this.string;
if(thisstring!=null){
return thisstring;};
var denominator=this.denominator;
if(denominator.sign!="-")
return this.string=this.numerator+"/"+denominator;
else{
return this.string=this.numerator+"/("+denominator+")";};};
CM.Rational.prototype.simplify=function(){
var simplified=this.simplified;
if(simplified!=null)
return simplified;
var tempsimplified=this.simplifyInClass();
if(tempsimplified.denominator.equalTo(CM.Integer.one))
tempsimplified=new CM.Integer(tempsimplified.numerator);
this.simplified=tempsimplified;
return tempsimplified;}
CM.Rational.prototype.simplifyInClass=function(){
var simplifiedInClass=this.simplifiedInClass;
if(simplifiedInClass!=null)
return simplifiedInClass;
var sign=this.sign;
var numerator=this.numerator;
var denominator=this.denominator
var Integer=CM.Integer;
var one=Integer.one;
var gcd=Integer.gcd(numerator,denominator);
if(gcd.equalTo(one)){
var tempreturn=new CM.Rational(numerator,denominator,sign);}
else{
numerator=numerator.divide(gcd).quotient;
denominator=denominator.divide(gcd).quotient;
var tempreturn=new CM.Rational(numerator,denominator,sign);}
this. simplifiedInClass=tempreturn;
return tempreturn;};
CM.Rational.prototype.equalTo=function(){
var left=this.simplifyInClass();
try{
var right=new CM.Rational(arguments[0].simplify());}
catch(e){
return false;}
var leftsign=left.sign;
var rightsign=right.sign;
if(leftsign!=rightsign)
return false;
var a=left.numerator;
var b=left.denominator;
var c=right.numerator;
var d=right.denominator;
return a.times(d).equalTo(b.times(c));};
CM.Rational.prototype.notEqualTo=function(){
return !this.equalTo(arguments[0]);};
CM.Rational.prototype.greaterThan=function(){
var left=this.simplifyInClass();
var right=new CM.Rational(arguments[0]);
var leftsign=left.sign;
var rightsign=right.sign;
if(leftsign=="+"&&rightsign=="-")
return true;
if(leftsign=="-"&&rightsign=="+")
return false;
return left.numerator.times(right.denominator).greaterThan(left.denominator.times(right.numerator));}
CM.Rational.prototype.lessThan=function(){
var left=this.simplifyInClass();
var right=new CM.Rational(arguments[0]);var leftsign=left.sign;
var rightsign=right.sign;
if(leftsign=="+"&&rightsign=="-")
return false;
if(leftsign=="-"&&rightsign=="+")
return true;
return left.numerator.times(right.denominator).lessThan(left.denominator.times(right.numerator));};
CM.Rational.prototype.abs=function(){
return new CM.Rational(this.numerator.abs(),this.denominator.abs(),"+");};
CM.Rational.prototype.add=function(){
var left=this.simplifyInClass();
var right=new CM.Rational(arguments[0]);
var leftsign=left.sign;
var rightsign=right.sign;
var a=left.numerator;
var b=left.denominator;
var c=right.numerator;
var d=right.denominator;
var gcd=CM.Integer.gcd(b,d);
var reducedd=d.divide(gcd).quotient;
return new CM.Rational((reducedd.multiply(a)).add(b.divide(gcd).quotient.multiply(c)),reducedd.multiply(b)).simplify();};
CM.Rational.Add=function(){
var args0=arguments[0];
var args0length=args0.length;
if(args0length==0)
return CM.Integer.zero
if(args0length==1)
return args0[0].simplify();
var tempsum=new CM.Rational(args0[0]);
for(var i=1;i<args0length;i++)
tempsum=new CM.Rational(tempsum.add(args0[i]));
return tempsum;}
CM.Rational.prototype.subtract=function(){
var left=this.simplifyInClass();
var right=new CM.Rational(arguments[0]);
var a=left.numerator;
var b=left.denominator;
var c=right.numerator;
var d=right.denominator;
var gcd=CM.Integer.gcd(b,d);
var reducedd=d.divide(gcd).quotient;
return new CM.Rational((reducedd.multiply(a)).subtract(b.divide(gcd).quotient.multiply(c)),reducedd.multiply(b)).simplify();}
CM.Rational.prototype.multiply=function(){
var left=this.simplifyInClass();
var right=new CM.Rational(arguments[0]).simplifyInClass();
var a=left.numerator;
var b=left.denominator;
var c=right.numerator;
var d=right.denominator;
var gcd=CM.Integer.gcd;
var gcdad=gcd(a,d);
var gcdbc=gcd(b,c);
var newa=a.divide(gcdad).quotient;
var newb=b.divide(gcdbc).quotient;
var newc=c.divide(gcdbc).quotient;
var newd=d.divide(gcdad).quotient;
var sign=(left.sign==right.sign?"+":"-");
var denominator=newb.multiply(newd).abs();
if(denominator.notEqualTo(CM.Integer.one))
return new CM.Rational(newa.multiply(newc),denominator,sign,true);
else
return new CM.Integer(newa.multiply(newc),sign);}
CM.Rational.Multiply=function(){
var args0=arguments[0];
var args0length=args0.length;
if(args0length==0)
return CM.Integer.one;
if(args0length==1)
return new CM.Rational(args0[0]).simplify();
var tempproduct=new CM.Rational(args0[0]);
for(var i=1;i<args0length;i++){
tempproduct=tempproduct.multiply(args0[i]);
tempproduct=new CM.Rational(tempproduct);};
return tempproduct.simplify();}
CM.Rational.prototype.divide=function(){
var left=this.simplifyInClass();
var right=new CM.Rational(arguments[0]);
var a=left.numerator;
var b=left.denominator;
var c=right.numerator;
var d=right.denominator;
var gcd=CM.Integer.gcd;
var gcdac=gcd(a,c);
var gcdbd=gcd(b,d);
var newa=a.divide(gcdac).quotient;
var newb=b.divide(gcdbd).quotient;
var newc=c.divide(gcdac).quotient;
var newd=d.divide(gcdbd).quotient;
var sign=(left.sign==right.sign?"+":"-");
return new CM.Rational(newa.multiply(newd),newb.multiply(newc),sign,true);}
CM.Rational.prototype.power=function(){
var exp=new CM.Integer(arguments[0]);
if(exp.cm_instanceof=="Integer"){
if(exp.sign=="+")
return new CM.Rational(this.numerator.power(exp),this.denominator.power(exp)).simplify();
else
return new CM.Rational(this.denominator.power(exp.abs()),this.numerator.power(exp.abs())).simplify();}
else
return alert("Error: The rational number "+this+" is raised to the noninteger exponent "+exp+".");}
CM.Rational.prototype.reciprocal=function(){
var sign=this.sign;
return new CM.Rational(new CM.Integer(this.denominator,sign),this.numerator.abs(),sign).simplify();};
CM.Rational.prototype.floor=function(){
var tempthis=this.simplifyInClass();
if(this.sign=="+")
return tempthis.numerator.divide(tempthis.denominator).quotient
else{
var quotientobject=tempthis.numerator.divide(tempthis.denominator);
if(!quotientobject.remainder.equalTo(CM.Integer.zero))
return quotientobject.quotient.subtract(CM.Integer.one)
else
return quotientobject.quotient;}}
CM.Rational.prototype.fractionalPart=function(){
return this.subtract(this.floor());};
CM.Rational.prototype.ceiling=function(){
var tempthis=this.simplifyInClass();
var quotientobject=tempthis.numerator.divide(tempthis.denominator);
if(quotientobject.remainder.equalTo(CM.Integer.zero))
return quotientobject.quotient;
else{
if(this.sign=="+")
return quotientobject.quotient.add(CM.Integer.one)
else
return quotientobject.quotient;}}
CM.Rational.prototype.round=function(){
return new CM.Floating(this,arguments[0],arguments[1]);};
CM.Rational.prototype.mod=function(){
if(arguments[0]!=null)
return this.denominator.inverseM(arguments[0]).multiplyM(this.numerator,arguments[0]);
else
return this;};
CM.Rational.prototype.isZero=function(){
return this.numerator.isZero();};
CM.Rational.prototype.atomicSortIndex=20;
CM.Rational.Max=function(){
var inputarray=arguments[0];
var inputarraylength=inputarray.length;
var tempreturn=inputarray[0];
for(var i=1;i<inputarraylength;i++){
if(inputarray[i].greaterThan(tempreturn)){
tempreturn=inputarray[i];}}
return tempreturn;};
CM.Rational.Min=function(){
var inputarray=arguments[0];
var inputarraylength=inputarray.length;
var tempreturn=inputarray[0];
for(var i=1;i<inputarraylength;i++){
if(inputarray[i].lessThan(tempreturn)){
tempreturn=inputarray[i];}}
return tempreturn;};
CM.Rational.prototype.content=function(){
return this.abs();};
CM.Rational.prototype.rationalize=function(){
return[this.numerator,this.denominator];};
CM.Rational.prototype.rationalizeWithoutCanceling=function(){
var thissimplified=this.simplifyInClass();
return[thissimplified.numerator,thissimplified.denominator];};
CM.Rational.prototype.rationalizeUnsimplified=function(){
return[this.numerator,this.denominator];};
CM.Rational.prototype.rationalCoefficientDenominator=function(){
return this.simplify().denominator;};
CM.Rational.prototype.hasIntegerFractionalPower=function(){
var thissimplified=this.simplify();
if(thissimplified.cm_instanceof=="Integer"){
return thissimplified.hasIntegerFractionalPower(arguments[0]);}
var numerator=thissimplified.numerator;
var denominator=thissimplified.denominator;
if(arguments[0].sign=="-"){
var exponentisnegative=true;
exponent=arguments[0].abs();}
else{
exponent=arguments[0];
exponentisnegative=false;}
var top=numerator.hasIntegerFractionalPower(exponent);
if(top!==false){
var bottom=denominator.hasIntegerFractionalPower(exponent);
if(bottom!==false){
if(exponentisnegative===false){
return new CM.Rational(top,bottom).simplify();}
else{
return new CM.Rational(bottom,top).simplify();}}}
return false;};

