
CM.SmallPrimePolynomial=function(){
this.terms=arguments[0];
this.prime=1*arguments[1];
this.variable=arguments[2];};
CM.SmallPrimePolynomial.prototype.cm_instanceof="SmallPrimePolynomial";
CM.SmallPrimePolynomial.prototype.isNumber=false;
CM.SmallPrimePolynomial.prototype.isPolynomial=true;
CM.SmallPrimePolynomial.prototype.isRationalFunction=true;
CM.SmallPrimePolynomial.ZeroArray=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];
CM.SmallPrimePolynomial.prototype.add=function(){
var right=arguments[0];
var rightterms=right.terms;
var righttermslength=rightterms.length;
var thisterms=this.terms;
var thistermslength=thisterms.length;
if(righttermslength>=thistermslength){
var maxlength=righttermslength;
var minlength=thistermslength;
var largerterms=rightterms;}
else{
var minlength=righttermslength;
var maxlength=thistermslength;
var largerterms=thisterms;}
var ZeroArray=CM.SmallPrimePolynomial.ZeroArray;
var prime=this.prime;
var variable=this.variable;
if(maxlength<100){
var terms=CM.SmallPrimePolynomial.ZeroArray.slice(0,maxlength);}
else{
var remainder=(maxlength%100);
var multiple=Math.round((maxlength-remainder)/100);
terms=ZeroArray.slice(0);
for(var j=0;j<multiple;j++){
terms=terms.concat(ZeroArray.slice(0));}
terms=terms.concat(ZeroArray.slice(0,remainder));}
var termsi;
for(var i=0;i<minlength;i++){
termsi=(thisterms[i]+rightterms[i])%prime;
if(termsi<0){
termsi=termsi+prime;}
terms[i]=termsi;}
for(var i=minlength;i<maxlength;i++){
terms=largerterms[i]%prime;
if(termsi<0){
termsi=termsi+prime;}
terms[i]=termsi;}
return new CM.SmallPrimePolynomial(terms,prime,variable);};
CM.SmallPrimePolynomial.prototype.toString=function(){
var thisstring=this.string;
if(thisstring!=null){
return thisstring;};
var terms=this.terms;
var termslength=terms.length;
var variable=this.variable;
var terms0=terms[0];
if(terms0!=0){
var returnstring=""+terms0;}
else{
var returnstring="";}
var terms1=terms[1];
if(terms1>0){
returnstring=returnstring+"+"+terms1+"*"+variable;}
else if(terms1<0){
returnstring=returnstring+terms1+"*"+variable;}
for(var i=2;i<termslength;i++){
var termsi=terms[i];
if(termsi>0){
returnstring=returnstring+"+"+termsi+"*"+variable+"^"+i;}
else if(termsi<0){
returnstring=returnstring+termsi+"*"+variable+"^"+i;}}
returnstring=returnstring.replace(/^\+/,"");
this.string=returnstring;
return returnstring;};
CM.SmallPrimePolynomial.prototype.getPolynomialTerms=function(){
return this.terms.slice(0);};
CM.SmallPrimePolynomial.prototype.simplify=function(){
if(this.simplified!=null){
return this.simplified;}
var terms=this.terms;
var termslength=terms.length;
var prime=this.prime;
var leadingterm=terms[termslength-1]%prime;
if(leadingterm!=0){
this.simplified=this;
return this;}
else{
terms=terms.slice(0);
while(terms[terms.length-1]%prime===0){
terms.length=terms.length-1;}
if(terms.length===0){
terms=[0];}
var tempreturn=new CM.SmallPrimePolynomial(terms,prime,this.variable);
this.simplified=tempreturn;
tempreturn.simplified=tempreturn;
return tempreturn;}};
CM.SmallPrimePolynomial.prototype.maxDegree=function(){
var thissimplified=this.simplify();
return thissimplified.terms.length;};
CM.SmallPrimePolynomial.prototype.multiply=function(){
var retArray=new Array();
var prime=this.prime;
var variable=this.variable;
if(this.terms.length<=arguments[0].terms.length){
var first=this.terms;
var second=arguments[0].terms;}
else{
var second=this.terms;
var first=arguments[0].terms;};
var firstLength=first.length;
var secondLength=second.length;
var combinedlength=firstLength+secondLength;
var nextterm=0;
if(firstLength==1){
first=first[0];
for(var i=0;i<secondLength;i++){
retArray[i]=(first*second[i])%prime;}
return new CM.SmallPrimePolynomial(retArray,prime,variable);}
else{
var lengthminusone=combinedlength-1;
for(var i=0;i<lengthminusone;i++){
var stopAt=Math.min(firstLength,i+1);
var beginAt=Math.max(0,i-secondLength+1);
var tempterm=0;
for(var j=beginAt;j<stopAt;j++){
tempterm=(tempterm+(first[j]*second[i-j]%prime))%prime;};
retArray[i]=tempterm;};
return new CM.SmallPrimePolynomial(retArray,prime,variable);}};
CM.SmallPrimePolynomial.prototype.leadingCoefficientInverse=function(){
var thissimplified=this.simplify();
var prime=this.prime;
var terms=thissimplified.terms;
var constant=terms[terms.length-1];
var tempreturn=1*(CM.Integer.smallextended_gcd(constant,prime).x);
if(tempreturn<0){
tempreturn=tempreturn+prime;}
return tempreturn;};
CM.SmallPrimePolynomial.prototype.divide=function(){
var right=arguments[0].simplify();
var rightterms=right.terms;
var righttermslength=rightterms.length;
var prime=this.prime;
var left=this.simplify();
var variable=this.variable;
if(righttermslength===1&&rightterms[0]==0){
alert("You are dividing the small prime polynomial "+left.toString()+" by zero");
throw new Error("You are dividing the polynomial "+left.toString()+" by zero");}
var leftterms=left.getPolynomialTerms();
var lefttermslength=leftterms.length;
if(lefttermslength==1&&leftterms[0]==0){
var retObj=new Object();
retObj.quotient=0;
retObj.remainder=0;
return retObj;}
if(righttermslength==1){
var constantterm=rightterms[0];
var constantterminverse=right.leadingCoefficientInverse();
for(var i=0;i<lefttermslength;i++){
leftterms[i][0]=leftterms[i]*constantterminverse%prime;}
var retObj=new Object();
retObj.quotient=new CM.SmallPrimePolynomial(leftterms,prime,variable);
retObj.remainder=new CM.SmallPrimePolynomial([0],prime,variable);
return retObj;}
if(lefttermslength==1){
var retObj=new Object();
retObj.quotient=0;
retObj.remainder=left.simplify();
return retObj;}
var rightLeadingCoeffInverse=right.leadingCoefficientInverse();
var quotientTerms=new Array();
var maxLeftDegree=lefttermslength-1;
var maxRightDegree=righttermslength-1;
divisionloop1:
while(!(maxRightDegree>maxLeftDegree)){
var multiplier=leftterms[maxLeftDegree]*rightLeadingCoeffInverse%prime;
var degreeDifference=1*maxLeftDegree-1*maxRightDegree;
for(var j=0;j<righttermslength;j++){
var tempresult=(((-1)*rightterms[j]*multiplier%prime)+(1*leftterms[j+degreeDifference]%prime))%prime;
if(tempresult<0){
tempresult=tempresult+prime;}
leftterms[j+degreeDifference]=tempresult;}
quotientTerms[degreeDifference]=multiplier;
leftterms.length=leftterms.length-1;
var maxLeftDegree=leftterms.length-1;}
var retObj=new Object();
if(quotientTerms.length>0){
retObj.quotient=new CM.SmallPrimePolynomial(quotientTerms,prime,variable);}
else{
retObj.quotient=0;}
retObj.remainder=new CM.SmallPrimePolynomial(leftterms,prime,variable).simplify();
return retObj;};
CM.SmallPrimePolynomial.prototype.monic=function(){
var terms=this.getPolynomialTerms();
var termslength=terms.length;
var prime=this.prime;
var LeadingCoeffInverse=this.leadingCoefficientInverse();
for(var i=0;i<termslength;i++){
terms[i]=terms[i]*LeadingCoeffInverse%prime;}
return new CM.SmallPrimePolynomial(terms,prime,this.variable);};
CM.SmallPrimePolynomial.prototype.equalsZero=function(){
var terms=this.terms;
if(terms.length==1&&terms[0]==0){
return true;}
return false;};
CM.SmallPrimePolynomial.prototype.isConstant=function(){
var terms=this.terms;
if(terms.length==1){
return true;}
return false;};
CM.SmallPrimePolynomial.prototype.convertToPolynomialNativeExponents=function(){
var terms=this.terms;
var termslength=terms.length;
var newterms=new Array();
for(var i=0;i<termslength;i++){
if(terms[i]!=0){
newterms.push([new CM.Integer(terms[i]),i]);}}
return new CM.PolynomialNativeExponents(newterms,[this.variable]);};
CM.SmallPrimePolynomial.prototype.multiplyInteger=function(){
var integer=arguments[0];
var prime=this.prime;
if(integer.cm_instanceof=="Integer"){
integer=integer.mod(new CM.Integer(prime));
integer=1*integer;}
var terms=this.getPolynomialTerms();
var termslength=terms.length;
for(var i=0;i<termslength;i++){
if(terms[i]!=0){
terms[i]=(terms[i]*integer)%prime;}}
return new CM.SmallPrimePolynomial(terms,prime,this.variable);};

