
CM.StandardFunction=function(){
this.name=arguments[0];
this.terms=arguments[1];
if(arguments[2]!=null)
this.argumentsLength=arguments[2];};
CM.StandardFunction.prototype=new CM.Composite();
CM.StandardFunction.prototype.constructor=CM.StandardFunction;
CM.StandardFunction.prototype.cm_instanceof="StandardFunction";
CM.StandardFunction.prototype.isNumber=false;
CM.StandardFunction.prototype.isPolynomial=false;
CM.StandardFunction.prototype.isRationalFunction=false;
CM.StandardFunction.prototype.isFunction=true;
CM.StandardFunction.prototype.toString=function(){
var terms=this.terms;
if(terms.cm_instanceof=="Array"&&terms[0]!=null&&terms[0].cm_instanceof!="NativeString"){
return this.name+"("+terms+")";}
else{
return this.name;}};
CM.StandardFunction.prototype.simplify=function(){
if(this.simplified!=undefined){
return this.simplified;}
var terms=this.getTerms();
var termslength=terms.length;
for(var i=0;i<termslength;i++){
terms[i]=terms[i].simplify();}
var tempreturn=new CM[this.constructorName](terms);
this.simplified=tempreturn;
tempreturn.simplified=tempreturn;
return tempreturn;}
CM.StandardFunction.prototype.replacePolynomialVariables=function(){
var terms=this.getTerms();
var termslength=terms.length;
for(var i=0;i<termslength;i++){
terms[i]=terms[i].replacePolynomialVariables(arguments[0],arguments[1]);}
return new CM[this.constructorName](terms);};
CM.StandardFunction.prototype.structure=function(){
return "Standard Function: "+this.name+"("+this.terms[0].structure()+")";}
CM.StandardFunction.prototype.equalTo=function(){
if(arguments[0].cm_instanceof==="Factor"){
return arguments[0].equalTo(this,arguments[1]);}
var left=this;
var right=arguments[0];
if(right.cm_instanceof!="StandardFunction")
return false;
if(left.name!=right.name)
return false;
return left.terms[0].equalTo(right.terms[0]);}
CM.StandardFunction.prototype.substitute=function(){
var originalterms=arguments[0].slice(0);
var originaltermslength=originalterms.length;
var replacementterms=arguments[1];
var type=arguments[2];
if(type==null){
type="simultaneous";}
var tempthis=this.simplify();
if(tempthis.cm_instanceof!="StandardFunction"){
return tempthis.substitute(arguments[0],arguments[1],type);}
if(arguments[2]!="recursive"){
for(var j=0;j<originaltermslength;j++){
originalterms[j]=originalterms[j].simplify();
if(tempthis.equalTo(originalterms[j])){
return arguments[1][j];}}
return new CM[this.constructorName]([this.terms[0].substitute(arguments[0],arguments[1],type)]);}
else{
if(tempthis.equalTo(originalterms[0])){
tempthis=replacementterms[0];}
else{
var thisterms=tempthis.getTerms();
var thisterms0=thisterms[0].simplify();
if(thisterms0.equalTo(originalterms[0])){
thisterms[0]=replacementterms[0];}
else{
thisterms[0]=thisterms0.substitute([originalterms[0]],[replacementterms[0]],type);}
tempthis=new CM[this.constructorName](thisterms);}
if(originaltermslength==1){
return tempthis;}
else{
return tempthis.substitute(originalterms.slice(1),replacementterms.slice(1),"recursive");}}};
CM.StandardFunction.prototype.evaluateAsFunction=function(){
var argumentsarray=arguments[0];
var functionname=this.name;
if(this.argumentsLength==null||this.argumentsLength==argumentsarray.length){
var tempreturn=new CM.Definitions.Functions.Standard[functionname].constructor(argumentsarray);
return tempreturn;}
else{
alert("The function "+functionname+" can only be defined with "+this.argumentsLength+" arguments");
throw new Error("The function "+functionname+" can only be defined with "+this.argumentsLength+" arguments");}};
CM.StandardFunction.prototype.getDependentVariables=function(){
if(this.dependentVariablesArray!=null&&arguments[0]==null){
return this.dependentVariablesArray.slice(0);}
if(this.dependentAllVariablesArray!=null&&arguments[0]!=null){
return this.dependentAllVariablesArray.slice(0);}
var terms=this.terms;
var termslength=terms.length;
if(terms[0].getDependentVariables!=null){
var returnarray=terms[0].getDependentVariables(arguments[0]);}
else{
var returnarray=[];}
for(var i=1;i<termslength;i++){
returnarray=returnarray.cm_union(terms[i].getDependentVariables(arguments[0]));}
if(arguments[0]==null){
return this.dependentVariablesArray=returnarray;}
else{
return this.dependentAllVariablesArray=returnarray;}};

