
var ubound=21;
var lbound=1;
var strubound=49;
var createObject=function(){
var A=new Object();
A.prop1="String";
A.prop2=true;
A.prop3=5;
return A;}
var createArray=function(){
var A=new Array(3);
A[0]="String";
A[1]=true;
A[2]=5;
return A;}
var objectVsArrayTest=function(){
var A;
var B;
var runs=100000;
var begin=new Date();
for(var x=0;x<runs;x++)
A=createObject();
var middle=new Date();
for(var y=0;y<runs;y++)
B=createArray();
var end=new Date();
return("Object versus Array return: "+"\nObject: "+(middle.getTime()-begin.getTime())+"\nArray: "+(end.getTime()-middle.getTime()));}
var concatTest=function(){
var test1="";
var test2="";
var test3="";
var runs=1000000;
var begin=new Date();
for(var x=0;x<runs;x++)
test1=test1+"0";
var test1Time=new Date();
for(var y=0;y<runs;y++)
test2=test2.concat("0");
var test2Time=new Date();
for(var z=0;z<runs;z++)
test3+="0";
var end=new Date();
return(
"+ Versus concat() Versus +="+
"\n+ operator: "+(test1Time.getTime()-begin.getTime())+
"\nconcat(): "+(test2Time.getTime()-test1Time.getTime())+
"\n+=: "+(end.getTime()-test2Time.getTime()));}
var arrayLengthTest=function(){
var runs=arguments[0];
var theArray=new Array(runs);
var setup=new Date();
for(var x=0;x<runs;x++)
theArray[x]=Math.floor(Math.random()*(runs-1));
temp=theArray[Math.random()*(runs-1)];
var begin=new Date();
for(var x=0;x<runs;x++)
temp=theArray[temp];
var middle=new Date();
for(var x=0;x<runs;x++)
temp=theArray[x];
var end=new Date();
return "Array Length Test: \n"+
"Setting up the array took "+(begin.getTime()-setup.getTime())+" milliseconds.\n"+
runs+" random accesses took "+(middle.getTime()-begin.getTime())+" milliseconds.\n"+
runs+" sequential accesses took "+(end.getTime()-middle.getTime())+" milliseconds.";}
var integerQuickTest=function(){
var A=new CM.Integer("123456712345671234567");
var B=new CM.Integer("12345671234567");
var C=A.divide(B);
return(
"Sum: "+A.add(B)+"\n"+
"Difference: "+A.subtract(B)+"\n"+
"Product: "+A.multiply(B)+"\n"+
"Quotient: "+C.quotient+"\n"+
"Remainder: "+C.remainder);}
var randomNumberSpeedTest=function(){
var begin=new Date();
for(var x=0;x<arguments[0];x++)
CM.Integer.randomom(lbound,ubound);
var end=new Date();
return "Random Number Generator Speed Tests\n"+
arguments[0]+" numbers between "+lbound+" and "+ubound+
" digits took "+(end.getTime()-begin.getTime())+
" milliseconds to create.";}
var addSpeedTest=function(){
var left=new Array(arguments[0]);
var right=new Array(arguments[0]);
var temp;
for(var x=0;x<arguments[0];x++){
left[x]=CM.Integer.randomom(lbound,ubound);
right[x]=CM.Integer.randomom(lbound,ubound);}
var begin=new Date();
for(var x=0;x<arguments[0];x++)
left[x].add(right[x]);
var end=new Date();
return "Addition Speed Test: \n"+arguments[0]+" additions took "+(end.getTime()-begin.getTime())+" milliseconds.";}
var subSpeedTest=function(){
var left=new Array(arguments[0]);
var right=new Array(arguments[0]);
var temp;
for(var x=0;x<arguments[0];x++){
left[x]=CM.Integer.randomom(lbound,ubound);
right[x]=CM.Integer.randomom(lbound,ubound);}
var begin=new Date();
for(var x=0;x<arguments[0];x++)
left[x].subtract(right[x]);
var end=new Date();
return "Subtraction Speed Test: \n"+arguments[0]+
" subtractions took "+(end.getTime()-begin.getTime())+
" milliseconds.";}
var divSpeedTest=function(){
var left=new Array(arguments[0]);
var right=new Array(arguments[0]);
var temp;
var runs=arguments[0]*2;
for(var x=0;x<arguments[0];x++){
temp=CM.Integer.random(lbound,ubound);
while(temp.equalTo(CM.Integer.zero))
temp=CM.Integer.random(lbound,ubound);
left[x]=temp;
temp=CM.Integer.random(lbound,ubound);
while(temp.equalTo(CM.Integer.zero))
temp=CM.Integer.randomom(lbound,ubound);
right[x]=temp;}
var summary;
var begin=new Date();
for(var x=0;x<arguments[0];x++)
try{
left[x].divide(right[x]);}
catch(ex){
summary+=ex+" \n___Left: "+left[x]+"\n___Right: "+right[x]+"\n";}
var end=new Date();
return "Division Speed Test: \n"+arguments[0]+" divisions took "+(end.getTime()-begin.getTime())+" milliseconds."+(summary!=undefined?summary:"");}
var multSpeedTest=function(){
var left=new Array(arguments[0]);
var right=new Array(arguments[0]);
for(var x=0;x<arguments[0];x++){
left[x]=CM.Integer.randomom(lbound,ubound);
right[x]=CM.Integer.randomom(lbound,ubound);}
var begin=new Date();
for(x=0;x<arguments[0];x++)
left[x].multiply(right[x]);
var end=new Date();
return "Multiply Speed Test: \n"+arguments[0]+" multiplications took "+(end.getTime()-begin.getTime())+" milliseconds.";}
var arithmeticCombinedSpeedTest=function(){
var left=new Array(arguments[0]);
var right=new Array(arguments[0]);
for(var x=0;x<arguments[0];x++){
left[x]=CM.Integer.randomom(lbound,ubound);
right[x]=CM.Integer.randomom(lbound,ubound);}
var beginAdd=new Date();
for(x=0;x<arguments[0];x++)
left[x].add(right[x]);
var beginSub=new Date();
for(x=0;x<arguments[0];x++)
left[x].subtract(right[x]);
var beginMul=new Date();
for(x=0;x<arguments[0];x++)
left[x].multiply(right[x]);
var beginDiv=new Date();
for(x=0;x<arguments[0];x++)
left[x].divide2(right[x]);
var end=new Date();
return "Combined Arithmetic Operators Speed Test: \n"+
arguments[0]+" operations were requested.\n"+
"Addition took: "+(beginSub.getTime()-beginAdd.getTime())+"\n"+
"Subtraction took: "+(beginMul.getTime()-beginSub.getTime())+"\n"+
"Multiplication took: "+(beginDiv.getTime()-beginMul.getTime())+"\n"+
"Divison took: "+(end.getTime()-beginDiv.getTime());}
var equalitySpeedTest=function(){
var runs=arguments[0];
var left=new Array(runs);
var right=new Array(runs);
var summary="";
for(var x=0;x<runs;x++){
left[x]=CM.Integer.randomom(lbound,ubound);
right[x]=CM.Integer.randomom(lbound,ubound);}
var begin=new Date();
for(var x=0;x<runs;x++)
left[x].equalTo(right[x]);
var end=new Date();
return runs+" equality tests took "+(end.getTime()-begin.getTime())+" milliseconds.\n"+summary;}
var integerCreationTest=function(){
var intString=new Array(arguments[0]);
var intIntegers=new Array(arguments[0]);
var setup=new Date();
for(var x=0;x<arguments[0];x++)
intString[x]=generateRandString(Math.floor(Math.random()*strubound+1));
var begin=new Date();
for(var x=0;x<arguments[0]-1;x++);
intIntegers[x]=new CM.Integer(intString[x]);
var middle=new Date();
for(var x=0;x<arguments[0]-1;x++);
intIntegers[x]=new CM.Integer(intIntegers[x]);
var end=new Date();
return "Integer Creation Speed Test: \n"+"Creation of the strings took "+(begin.getTime()-setup.getTime())+" milliseconds.\n"+arguments[0]+" creations as strings took: "+(middle.getTime()-begin.getTime())+" milliseconds.\n"+arguments[0]+" creations as Integers took: "+(end.getTime()-middle.getTime())+" milliseconds.";}
var generateRandString=function(size){
var temp="";
for(var x=0;x<size;x++)
temp=temp+(Math.floor(Math.random()*10));
return temp;}

