
Array.prototype.cm_constructorname="Array";
Array.prototype.cm_objecttype="Array";
Array.prototype.cm_averageprecision=3;
Array.prototype.calumath={
cm_convertArgumentsWithPlottedPoints:Array.prototype.cm_convertargumentswithplottedpoints,
cm_convertPlottedPointsForDoubleArray:Array.prototype.cm_convertplottedpointsfordoublearray,
cm_addTerms:Array.prototype.cm_addterms,
cm_variable:"",
noComma:""};
Array.prototype.cm_apply=function(){
var thismethod="cm_"+arguments[0];
args=this.slice.apply(arguments,[1]);
return this.calumath[thismethod].apply(this,args);};
Array.prototype.cm_setArrayProperty=function(){
return this[arguments[0]]=arguments[1];};
Array.prototype.cm_maketempobject=CaluMath.Html.GeneralizedPlot.prototype.cm_maketempobject;
Array.prototype.cm_coordinatesToString=function(){
return "("+this.join()+")";};
Array.prototype.cm_display=function(){
try{
return CaluMath.Html.Display(this);}
catch(e){
cm_catch(e,["cm_display",this],arguments);}};
Array.prototype.cm_displaywithquotedstrings=function(){
try{
return CaluMath.Html.DisplayWithQuotedStrings(this);}
catch(e){
cm_catch(e,["cm_displaywithquotedstrings",this],arguments);}};
Array.prototype.cm_round=function(){
try{
if(arguments.length!=0){
var cm_precision=Math.max(0,arguments[0]);}
else{
var cm_precision=0;}
var templength=this.length;
var cm_temparray=new Array();
for(var i=0;i<templength;i++){
var thisi=this[i];
if(thisi!=null){
if(isNaN(thisi)==false){
cm_temparray[i]=CaluMath.Html.Round(thisi,cm_precision);}
else{
if(thisi.cm_constructorname!="Array"){
cm_temparray[i]=thisi;}
else{
cm_temparray[i]=thisi.cm_round(cm_precision);}}}}
return cm_temparray;}
catch(e){
cm_catch(e,["cm_round",this],arguments);}};
Array.prototype.cm_javascript=function(){
try{
var templength=this.length;
var cm_temparray=new Array();
for(var i=0;i<templength;i++){
var thisi=this[i];
if(thisi!=null){
if(thisi.cm_constructorname=="String"){
cm_temparray[i]=thisi.cm_javascript();}
else{
if(thisi.cm_constructorname!="Array"){
cm_temparray[i]=thisi;}
else{
cm_temparray[i]=thisi.cm_javascript();}}}}
return cm_temparray;}
catch(e){
cm_catch(e,["cm_javascript",this],arguments);}};
Array.prototype.cm_tolowercase=function(){
try{
var thislength=this.length;
var returnarray=new Array();
for(var i=0;i<thislength;i++){
var thisi=this[i];
if(thisi!=null){
if(thisi.cm_constructorname=="String"){
returnarray[i]=thisi.toLowerCase().replace(/^\s*/,"").replace(/\s*$/,"");}
else if(thisi.cm_constructorname!="Array"){
returnarray[i]=thisi;}
else{
returnarray[i]=thisi.cm_tolowercase();}}}
return returnarray;}
catch(e){
cm_catch(e,["cm_tolowercase",this],arguments);}};
Array.prototype.cm_roundmath=function(){
try{
if(arguments.length!=0){
var cm_precision=Math.max(0,arguments[0]);}
else{
var cm_precision=0;}
var templength=this.length;
var cm_temparray=new Array();
for(var i=0;i<templength;i++){
var thisi=this[i];
if(thisi!=null){
if(thisi.cm_constructorname=="Number"){
cm_temparray[i]=CaluMath.Html.Round(thisi,cm_precision);}
else if(thisi.cm_constructorname=="String"){
cm_temparray[i]=CaluMath.Html.Round(thisi,cm_precision);}
else if(thisi.cm_constructorname=="Array"){
cm_temparray[i]=thisi.cm_roundmath(cm_precision);}
else{
cm_temparray[i]=thisi;}}}
return cm_temparray;}
catch(e){
cm_catch(e,["cm_roundmath",this],arguments,"In cm_roundmath, each entry of the Array that is a String is assumed to be a mathematical expression and is evaluated as such.");}};
Array.prototype.cm_contains=function(){
var match=arguments[0];
var IsEqual=CaluMath.Html.IsEqual;
try{
var thislength=this.length;
var tempreturn=false;
if(arguments.length==1){
loop:
for(var i=0;i<thislength;i++){
if(IsEqual(this[i],match)){
tempreturn=true;
break loop;}}
return tempreturn;}
else{
var cm_precision=1*arguments[1];
newloop:
for(var i=0;i<thislength;i++){
if(IsEqual(this[i],match,cm_precision)){
tempreturn=true;
break newloop;}}
return tempreturn;}}
catch(e){
cm_catch(e,["cm_contains",this],arguments);}};
Array.prototype.cm_distinctentries=function(){
var thislength=this.length;
if(thislength==0){
return "yes";}
var currentarray=[this[0]];
for(var i=1;i<thislength;i++){
var thiselement=this[i];
if(currentarray.cm_contains(thiselement)===false){
currentarray.push(thiselement);}
else{
return thiselement;}}
return "yes";};
Array.prototype.cm_subset=function(){
var potentialsubset=arguments[0];
var potentialsubsetlength=potentialsubset.length;
thislength=this.length;
bigloop:
for(var i=0;i<potentialsubsetlength;i++){
var thiselement=potentialsubset[i];
var thiselementin="no";
smallloop:
for(var j=0;j<thislength;j++){
if(thiselement==this[j]){
thiselementin="yes";
break smallloop;}}
if(thiselementin!="yes"){
return "no";}}
return "yes";};
Array.prototype.cm_andpoints=function(){
var firstarray=this.cm_convertplottedpointsfordoublearray();
var firstarraylength=firstarray.length;
var secondarray=arguments[0].cm_convertplottedpointsfordoublearray();
var secondarraylength=secondarray.length;
var returnarray=new Array();
for(var i=0;i<secondarraylength;i++){
andpointsjloop:
for(var j=0;j<firstarraylength;j++){
if(secondarray[i][0]==firstarray[j][0]&&secondarray[i][1]==firstarray[j][1]){
var isduplicate="no";
var returnarraylength=returnarray.length;
andtloop:
for(var t=0;t<returnarray.length;t++){
if(secondarray[i][0]==returnarray[t][0]&&secondarray[i][1]==returnarray[t][1]){
isduplicate="yes";
break andtloop;}}
if(isduplicate=="no"){
returnarray.push(secondarray[i]);}
break andpointsjloop;}}}
return returnarray;};
Array.prototype.cm_orpoints=function(){
var firstarray=this.cm_convertplottedpointsfordoublearray();
var firstarraylength=firstarray.length;
var secondarray=arguments[0].cm_convertplottedpointsfordoublearray();
var secondarraylength=secondarray.length;
var returnarray=firstarray;
for(var i=0;i<secondarraylength;i++){
var addpoint="yes";
var returnarraylength=returnarray.length;
orpointsjloop:
for(var j=0;j<returnarraylength;j++){
if(secondarray[i][0]==returnarray[j][0]&&secondarray[i][1]==returnarray[j][1]){
addpoint="no";
break orpointsjloop;}}
if(addpoint=="yes"){
returnarray.push(secondarray[i]);}}
return returnarray;};
Array.prototype.cm_complementpoints=function(){
var firstarray=arguments[0].cm_convertplottedpointsfordoublearray();
var firstarraylength=firstarray.length;
var pointslist=this.cm_convertplottedpointsfordoublearray();;
var pointslistlength=pointslist.length;
var returnarray=new Array();
var precision=arguments[1];
if(precision==null){
for(var i=0;i<pointslistlength;i++){
var addpoint="yes";
var returnarraylength=returnarray.length;
orpointsjloop:
for(var j=0;j<firstarraylength;j++){
if(pointslist[i][0]==firstarray[j][0]&&pointslist[i][1]==firstarray[j][1]){
addpoint="no";
break orpointsjloop;}}
if(addpoint=="yes"){
var isduplicate="no";
var returnarraylength=returnarray.length;
ortloop:
for(var t=0;t<returnarray.length;t++){
if(pointslist[i][0]==returnarray[t][0]&&pointslist[i][1]==returnarray[t][1]){
isduplicate="yes";
break ortloop;}}
if(isduplicate=="no"){
returnarray[returnarray.length]=pointslist[i];}}}
return returnarray;}
else{
for(var i=0;i<pointslistlength;i++){
var addpoint="yes";
var returnarraylength=returnarray.length;
orpointsjloop:
for(var j=0;j<firstarraylength;j++){
if(CaluMath.Html.Round(pointslist[i][0],precision)==CaluMath.Html.Round(firstarray[j][0],precision)&&CaluMath.Html.Round(pointslist[i][1],precision)==CaluMath.Html.Round(firstarray[j][1],precision)){
addpoint="no";
break orpointsjloop;}}
if(addpoint=="yes"){
var isduplicate="no";
var returnarraylength=returnarray.length;
ortloop:
for(var t=0;t<returnarray.length;t++){
if(CaluMath.Html.Round(pointslist[i][0],precision)==CaluMath.Html.Round(returnarray[t][0],precision)&&CaluMath.Html.Round(pointslist[i][1],precision)==CaluMath.Html.Round(returnarray[t][1],2)){
isduplicate="yes";
break ortloop;}}
if(isduplicate=="no"){
returnarray[returnarray.length]=pointslist[i];}}}
return returnarray;}};
Array.prototype.cm_convertgraphstopointsarray=function(){
var thislength=this.length;
var tempreturn=new Array();
for(var i=0;i<thislength;i++){
tempreturn.push([this[i].cm_xcoordinate,this[i].cm_ycoordinate]);}
return tempreturn;};
Array.prototype.cm_removeduplicatepoints=function(){
return this.cm_andpoints(this);};
Array.prototype.cm_removeelements=function(){
try{
var thislength=this.length;
var matchelement=arguments[0];
var matchtype=arguments[1];
var matchindex=arguments[2];
if(matchtype==null){
matchtype="yes";}
var tempreturn=new Array();
if(matchtype=="yes"&&matchindex==null){
loop:
for(var i=0;i<thislength;i++){
if(this[i]==null||this[i]!=matchelement){
tempreturn[tempreturn.length]=this[i];}}
return tempreturn;}
else if(matchtype=="yes"&&matchindex!=null){
loop:
for(var i=0;i<thislength;i++){
if(this[i]==null||this[i].cm_constructorname!="Array"||this[i][matchindex]!=matchelement){
tempreturn[tempreturn.length]=this[i];}}
return tempreturn;}
else if(matchtype=="no"&&matchindex==null){
loop:
for(var i=0;i<thislength;i++){
if(this[i]==null||this[i]!=matchelement){
tempreturn[tempreturn.length]=this[i];}
else{
break loop;}}
for(var j=i+1;j<thislength;j++){
tempreturn[tempreturn.length]=this[j];}
return tempreturn;}
else if(matchtype=="no"&&matchindex!=null){
loop:
for(var i=0;i<thislength;i++){
if(this[i]==null||this[i].cm_constructorname!="Array"||this[i][matchindex]!=matchelement){
tempreturn[tempreturn.length]=this[i];}
else{
break loop;}}
for(var j=i+1;j<thislength;j++){
tempreturn[tempreturn.length]=this[j];}
return tempreturn;}}
catch(e){
cm_catch(e,["cm_removeelements",this],arguments);}};
Array.prototype.cm_delete=function(){
try{
if(arguments[1]!=null){
var limit=arguments[1];}
else{
var limit=Number.POSITIVE_INFINITY;}
var thislength=this.length;
var tempnumber=0;
var match=arguments[0];
var tempreturn=new Array();
for(var i=0;i<thislength;i++){
if(tempnumber<limit){
if(this[i]!=match){
tempreturn=tempreturn.concat(this[i]);}
else{
tempnumber++;}}
else{
tempreturn=tempreturn.concat(this[i]);}}
return tempreturn;}
catch(e){
cm_catch(e,["cm_delete",arguments]);}};
Array.prototype.cm_arraytostring=function(){
try{
var thislengthminus1=this.length-1;
var evaluatestring="(";
if(thislengthminus1==-1){
evaluatestring=evaluatestring+")";}
else{
for(var i=0;i<thislengthminus1;i++){
var thisi=this[i];
if(thisi.cm_constructorname!="String"&&thisi.cm_constructorname!="Number"){
return alert("You have called arraytostring(). However entry "+i+" in "+this.cm_display()+" is not a string or number. This is causing an error.");}
else{
if(thisi.cm_constructorname=="String"){
thisi=thisi.toString().replace(/'/g,"\\\'")
evaluatestring+="'"+thisi+"' ,";}
else{
evaluatestring+=thisi+" ,";}}}
var thisi=this[thislengthminus1];
if(thisi.cm_constructorname!="String"&&thisi.cm_constructorname!="Number"){
return alert("You have called arraytostring(). However entry "+i+" in "+this.cm_display()+" is not a string or number. This is causing an error.");}
else{
if(thisi.cm_constructorname=="String"){
thisi=thisi.toString().replace(/'/g,"\\\'")
evaluatestring+="'"+thisi+"')";}
else{
evaluatestring+=thisi+")";}}}
return evaluatestring;}
catch(e){
cm_catch(e,["cm_arraytostring",this],arguments);}};
Array.prototype.cm_and=function(){
var firstarray=this;
if(arguments[0]==null){
return[];}
else{
if(arguments[0].cm_constructorname!="Array"){
return alert("The first argument in Array.prototype.cm_and must be an Array");}
var newarray=new Array();
var secondarray=arguments[0];
var secondarraylength=secondarray.length;
var args1=arguments[1];
if(args1==null){
for(var i=0;i<secondarraylength;i++){
if(firstarray.cm_contains(secondarray[i])&&!newarray.cm_contains(secondarray[i])){
newarray=newarray.concat(secondarray[i]);}}
return newarray;}
else{
for(var i=0;i<secondarraylength;i++){
if(firstarray.cm_contains(secondarray[i],args1)&&!newarray.cm_contains(secondarray[i],args1)){
newarray=newarray.concat(secondarray[i]);}}
return newarray;}}};
Array.prototype.cm_or=function(){
var firstarray=this.cm_and(this);
if(arguments[0]==null){
return firstarray;}
else{
if(arguments[0].cm_constructorname!="Array"){
return alert("The first argument in Array.prototype.cm_and must be an Array");}
var returnarray=firstarray.slice(0);
var secondarray=arguments[0];
var secondarraylength=secondarray.length;
var args1=arguments[1];
if(args1==null){
for(var i=0;i<secondarraylength;i++){
if(!returnarray.cm_contains(secondarray[i])){
returnarray=returnarray.concat(secondarray[i]);}}
return returnarray;}
else{
for(var i=0;i<secondarraylength;i++){
if(!returnarray.cm_contains(secondarray[i],args1)){
returnarray=returnarray.concat(secondarray[i]);}}
return returnarray;}}};
Array.prototype.cm_removeduplicates=function(){
var thisarray=this;
args0=arguments[0];
if(args0==null){
return thisarray.cm_and(thisarray);}
else{
return thisarray.cm_and(thisarray,args0);}};
Array.prototype.cm_addterms=function(){
var args=arguments;
var argslength=args.length;
for(var i=0;i<argslength;i++){
this[this.length]=args[i];}
return this;};
Array.prototype.cm_parsemath=function(){
try{
var ParseMath=CaluMath.Html.ParseMath;
var tempreturnarray=new Array();
var thislength=this.length;
for(var i=0;i<thislength;i++){
tempreturnarray[i]=ParseMath(this[i]);}
return tempreturnarray;}
catch(e){
cm_catch(e,["cm_parsemath",this],arguments);}};
Array.prototype.cm_multiply=function(){
try{
var returnarray=new Array();
var multiplyby=arguments[0].cm_parsemath();
var thislength=this.length;
for(var i=0;i<thislength;i++){
var thisi=this[i];
if(thisi!=null){
returnarray[i]=multiplyby*thisi;}}
return returnarray;}
catch(e){
cm_catch(e,["cm_parsemath",this],arguments);}};
Array.prototype.cm_evalmath=function(){
try{
var EvalMath=CaluMath.Html.EvalMath;
var tempreturn=new Array;
var arraylength=this.length;
for(var i=0;i<arraylength;i++){
tempreturn[i]=EvalMath(this[i]);}
return tempreturn;}
catch(e){
cm_catch(e,["cm_evalmath",this],arguments);}};
Array.prototype.cm_unicode=function(type){
var tempreturn=new Array();
var thislength=this.length;
var type=arguments[0];
if(type!="remove"){
for(var i=0;i<thislength;i++){
if(this[i].cm_unicode==null){
tempreturn[i]=this[i];}
else{
tempreturn[i]=(" "+this[i]).cm_unicode().slice(1);}}}
else{
for(var i=0;i<thislength;i++){
if(this[i].cm_unicode==null){
tempreturn[i]=this[i];}
else{
tempreturn[i]=(" "+this[i]).cm_unicode("remove").slice(1);}}}
return tempreturn;};
Array.prototype.cm_add=function(){
var addarray=arguments[0];
var cm_precision=arguments[1];
var length=this.length;
if(addarray.cm_constructorname!="Array"||length!=addarray.length){
return alert("You are trying to invoke cm_add on non-arrays or arrays of two different lengths: "+this+" and "+addarray+".");}
var returnarray=new Array();
if(cm_precision==null){
for(var i=0;i<length;i++){
var thisi=this[i];
var addarrayi=addarray[i];
if(thisi.cm_evalmath==null||addarrayi.cm_evalmath==null){
return alert("You are calling cm_add on Arrays with elements that cannot be evaluated mathematically");}
else if(thisi.cm_constructorname=="Array"){
returnarray[i]=thisi.cm_add(addarrayi);}
else{
if(addarrayi.cm_constructorname=="Array"){
return alert(["You are calling cm_add simultaneously on array and non-array elements: ",thisi," and",addarrayi]);}
else{
returnarray[i]=this[i].cm_evalmath()+addarray[i].cm_evalmath();}}}}
else{
var Round=CaluMath.Html.Round;
for(var i=0;i<length;i++){
var thisi=this[i];
var addarrayi=addarray[i];
if(thisi.cm_evalmath==null||addarrayi.cm_evalmath==null){
return alert("You are calling cm_add on Arrays with elements that cannot be evaluated mathematically");}
else if(thisi.cm_constructorname=="Array"){
returnarray[i]=thisi.cm_add(addarrayi,cm_precision);}
else{
if(addarrayi.cm_constructorname=="Array"){
return alert(["You are calling cm_add simultaneously on array and non-array elements: ",thisi," and",addarrayi]);}
else{
returnarray[i]=Round(this[i].cm_evalmath()+addarray[i].cm_evalmath(),cm_precision);}}}}
return returnarray;};
Array.prototype.cm_subtract=function(){
var addarray=arguments[0];
var cm_precision=arguments[1];
var length=this.length;
if(addarray.cm_constructorname!="Array"||length!=addarray.length){
return alert("You are trying to invoke cm_subtract on non-arrays or arrays of two different lengths: "+this+" and "+addarray+".");}
var returnarray=new Array();
if(cm_precision==null){
for(var i=0;i<length;i++){
var thisi=this[i];
var addarrayi=addarray[i];
if(thisi.cm_evalmath==null||addarrayi.cm_evalmath==null){
return alert("You are calling cm_subtract on Arrays with elements that cannot be evaluated mathematically");}
else if(thisi.cm_constructorname=="Array"){
returnarray[i]=thisi.cm_subtract(addarrayi);}
else{
if(addarrayi.cm_constructorname=="Array"){
return alert(["You are calling cm_subtract simultaneously on array and non-array elements: ",thisi," and",addarrayi]);}
else{
returnarray[i]=this[i].cm_evalmath()-addarray[i].cm_evalmath();}}}}
else{
var Round=CaluMath.Html.Round;
for(var i=0;i<length;i++){
var thisi=this[i];
var addarrayi=addarray[i];
if(thisi.cm_evalmath==null||addarrayi.cm_evalmath==null){
return alert("You are calling cm_subtract on Arrays with elements that cannot be evaluated mathematically");}
else if(thisi.cm_constructorname=="Array"){
returnarray[i]=thisi.cm_subtract(addarrayi,cm_precision);}
else{
if(addarrayi.cm_constructorname=="Array"){
return alert(["You are calling cm_subtract simultaneously on array and non-array elements: ",thisi," and",addarrayi]);}
else{
returnarray[i]=Round(this[i].cm_evalmath()-addarray[i].cm_evalmath(),cm_precision);}}}}
return returnarray;};
Array.prototype.cm_removenullentries=function(){
var cm_temparray=this.slice(0);
for(var i=0;i<cm_temparray.length;i++){
if(cm_temparray[i]==null){
cm_temparray.splice(i,1);
i--;}
else if(cm_temparray[i].cm_constructorname=="Array"){
cm_temparray[i]=cm_temparray[i].cm_removenullentries();}}
return cm_temparray;};
Array.prototype.cm_concat=function(){
var argslength=arguments.length;
for(var i=0;i<argslength;i++){
if(arguments[i].cm_constructorname=="Array"){
arguments[i]=[arguments[i]];};};
var temparguments=CaluMath.Html.ArgumentsToArray(arguments);
return Array.prototype.concat.apply(this,temparguments);};
Array.prototype.cm_converttopoints=function(){
var tempreturn=new Array();
var thislength=this.length;
for(var i=0;i<thislength;i++){
var thisi=this[i];
if(thisi!=null){
if(thisi.cm_constructorname=="Array"){
tempreturn[i]=[thisi[0],thisi[1]];}
else if(thisi.cm_coordinates!=null&&thisi.cm_coordinates.cm_constructorname=="Array"){
tempreturn[i]=thisi.cm_coordinates;}
else if(thisi.cm_xcoordinate!=null&&thisi.cm_ycoordinate!=null){
tempreturn[i]=[thisi.cm_xcoordinate,thisi.cm_ycoordinate];}
else if(thisi.cm_coordinates!=null&&thisi.cm_coordinates.cm_constructorname=="Function"){
tempreturn[i]=thisi.cm_coordinates();}
else{
return alert(["In cm_converttopoints, the following element cannot be interpreted as yielding the coordinates of a point. ",thisi]);}}}
return tempreturn;};
Array.prototype.cm_searchand=function(){
var args=arguments;
var argslength=args.length;
var thislength=this.length;
var args0=args[0];
if(args0[0].cm_constructorname!="Array"){
args0=[args0];}
var args0length=args0.length;
var returnarray=new Array();
for(var i=0;i<thislength;i++){
if(this[i]!=null&&typeof(this[i])=="object"){
var result="yes";
andloop:
for(var j=0;j<args0length;j++){
if(args0[j][1].cm_constructorname=="String"){
args0[j][1]=args0[j][1].replace(/\s*/g,"");}
var cm_comparison=args0[j][1];
var tempmatch=args0[j][0].match(/\./);
if(tempmatch!=null){
var tempmatch=args0[j][0].replace(/\s*/g,"").split(/\./);
var tempobjectlhs=this[i];
var tempmatchlengthminus1=tempmatch.length-1
smallloop:
for(var t=0;t<tempmatchlengthminus1;t++){
tempobjectlhs=tempobjectlhs[tempmatch[t]];
if(tempobjectlhs==null){
break smallloop;}}
if(tempobjectlhs==null){
result="no";
break andloop;}
else{
tempobjectlhs=tempobjectlhs[tempmatch[tempmatch.length-1]];}}
else{
var tempobjectlhs=this[i][args0[j][0].replace(/\s*/g,"")];}
var tempobjectrhs=args0[j][2];
if(args0[j][3]!=null){
result=CaluMath.Html.ComparisonOneTerm(tempobjectlhs,cm_comparison,tempobjectrhs,args0[j][3]);
if(result=="no"){
break andloop;}}
else{
result=CaluMath.Html.ComparisonOneTerm(tempobjectlhs,cm_comparison,tempobjectrhs);
if(result=="no"){
break andloop;}}}}
if(result=="yes"){
returnarray=returnarray.concat([this[i]]);}}
return returnarray;};
Array.prototype.cm_searchor=function(){
var args=arguments;
var argslength=args.length;
var thislength=this.length;
var args0=args[0];
if(args0[0].cm_constructorname!="Array"){
args0=[args0];}
var args0length=args0.length;
var returnarray=new Array();
for(var i=0;i<thislength;i++){
if(this[i]!=null&&typeof(this[i])=="object"){
var result="no";
orloop:
for(var j=0;j<args0length;j++){
if(args0[j][1].cm_constructorname=="String"){
args0[j][1]=args0[j][1].replace(/\s*/g,"");}
var cm_comparison=args0[j][1];
var tempmatch=args0[j][0].match(/\./);
if(tempmatch!=null){
var tempmatch=args0[j][0].replace(/\s*/g,"").split(/\./);
var tempobjectlhs=this[i];
var tempmatchlengthminus1=tempmatch.length-1
smallloop:
for(var t=0;t<tempmatchlengthminus1;t++){
tempobjectlhs=tempobjectlhs[tempmatch[t]];
if(tempobjectlhs==null){
break smallloop;}}
if(tempobjectlhs==null){
result="no";
break orloop;}
else{
tempobjectlhs=tempobjectlhs[tempmatch[tempmatch.length-1]];}}
else{
var tempobjectlhs=this[i][args0[j][0].replace(/\s*/g,"")];}
var tempobjectrhs=args0[j][2];
if(args0[j][3]!=null){
result=CaluMath.Html.ComparisonOneTerm(tempobjectlhs,cm_comparison,tempobjectrhs,args0[j][3]);
if(result=="yes"){
break orloop;}}
else{
result=CaluMath.Html.ComparisonOneTerm(tempobjectlhs,cm_comparison,tempobjectrhs);
if(result=="yes"){
break orloop;}}}}
if(result=="yes"){
returnarray=returnarray.concat([this[i]]);}}
return returnarray;};
Array.prototype.cm_search=function(){
var args=arguments;
if(args[1]==null){
var andor="and";}
else{
var andor=args[1].replace(/\s*/g,"");}
if(andor=="and"){
return this.cm_searchand(args[0],args[1]);}
else{
return this.cm_searchor(args[0],args[1]);}};
Array.prototype.cm_execute=function(){
var tempreturn=new Array();
var args=arguments[0];
var args1=arguments[1];
if(args1==undefined){
args1=null;}
var thislength=this.length;
for(var i=0;i<thislength;i++){if(this[i]==null){alert(["In Array.prototype.cm_execute the array ",this.cm_display()," has a null entry in position ",+i]);}
if(this[i].cm_constructorname=="String"){
tempreturn[i]=eval(this[i]);}
else if(this[i].cm_constructorname=="Function"){
tempreturn[i]=this[i].apply(args1,args);}
else if(this[i].cm_constructorname=="Array"){
tempreturn[i]=this[i].cm_execute(args,args1);}}
return tempreturn;};
Array.prototype.cm_remove=function(){
var cm_components=this;
var thislength=this.length;
for(var i=0;i<thislength;i++){
var thisi=this[i];
if(thisi!=null){
if(thisi.parentNode!=null||thisi.tagName!=null){
if(thisi.parentNode!=null){
thisi.parentNode.removeChild(thisi);}}
else if(thisi.remove!=null){
thisi.remove();}
else if(thisi.close!=null){
thisi.close();}}}
return this;};
Array.prototype.cm_hide=function(){
var thislength=this.length;
if(arguments[0]!="yes"){
for(var i=0;i<thislength;i++){
if(this[i]!=null){
if(this[i].hide==null){
this[i].style.display="none";}
else{
this[i].hide();}}}}
else{
for(var i=0;i<thislength;i++){
if(this[i]!=null){
if(this[i].hide==null){
this[i].style.display="none";}
else{
this[i].hide("yes");}}}}};
Array.prototype.cm_close=function(){
var thislength=this.length;
for(var i=0;i<thislength;i++){
var thisi=this[i];
if(thisi!=null&&thisi.close!=null){
thisi.close();}}};
Array.prototype.cm_removefirstrow=function(){
return this.slice(1);};
Array.prototype.cm_removerow=function(){
var row=arguments[0];
if(row==0){
return this.slice(1);}
else{
return this.slice(0,row).concat(this.slice(1*row+1));}};
Array.prototype.cm_removecolumn=function(){
var column=arguments[0];
var length=this.length;
var tempreturn=new Array();
if(column==0){
for(var i=0;i<length;i++){
tempreturn[i]=this[i].slice(1);}
return tempreturn;}
else{
for(var i=0;i<length;i++){
tempreturn[i]=this[i].slice(0,column).concat(this[i].slice(1*column+1));}
return tempreturn;}};
Array.prototype.cm_removefirstcolumn=function(){
var length=this.length;
var tempreturn=new Array();
for(var i=0;i<length;i++){
tempreturn[i]=this[i].slice(1);};
return tempreturn;};
Array.prototype.cm_choosecolumns=function(){
var columnarray=CaluMath.Html.ArgumentsToArray(arguments);
var columnarraylength=columnarray.length;
var length=this.length;
var tempreturn=new Array();
for(var i=0;i<length;i++){
tempreturn[i]=this[i].slice(columnarray[0],1*columnarray[0]+1)
for(var j=1;j<columnarraylength;j++){
tempreturn[i]=tempreturn[i].concat(this[i].slice(columnarray[j],1*columnarray[j]+1));}}
return tempreturn;};
Array.prototype.cm_chooserows=function(){
var rowarray=CaluMath.Html.ArgumentsToArray(arguments);
var rowarraylength=rowarray.length;
var tempreturn=new Array();
for(var i=0;i<rowarraylength;i++){
tempreturn.push(this.slice(rowarray[i],1*rowarray[i]+1)[0])}
return tempreturn;};
Array.prototype.cm_removefirstrowandcolumn=function(){
return this.cm_removefirstrow().cm_removefirstcolumn();};
Array.prototype.cm_transposematrix=function(){
var returnarray=new Array();
var thisrowlength=this.length;
var thiscolumnlength=this[0].length;
for(var j=0;j<thiscolumnlength;j++){
returnarray[j]=new Array();
for(var i=0;i<thisrowlength;i++){
returnarray[j][i]=this[i][j];}}
return returnarray;};
Array.prototype.cm_transpose=Array.prototype.cm_transposematrix;
Array.prototype.cm_applyfunction=function(){
var tempfunction=arguments[0];
var n=arguments[1];
if(n==undefined){
var n=0;}
var returnarray=new Array();
var thislength=this.length;
for(var j=0;j<n;j++){
returnarray[j]=this[j];}
for(var j=n;j<thislength;j++){
var thisj=this[j];
if(thisj.cm_constructorname=="String"||thisj.cm_constructorname=="Number"){
returnarray[j]=tempfunction(thisj);}
else if(thisj.cm_constructorname=="Array"){
returnarray[j]=thisj.cm_applyfunction(tempfunction);}}
return returnarray;};
Array.prototype.cm_parsediscretefunction=function(){
var name=arguments[0];
var variablename=arguments[2];
if(variablename==null){
variablename="x";}
var precision=arguments[1];
if(precision==null){
var precision=3;}
var temparray=this.cm_convertplottedpointsfordoublearray();
var temparraywithduplicates=temparray.slice(0);
var temparraylength=temparray.length;
var removeduplicatesarray=temparray.cm_removeduplicatepoints();
if(removeduplicatesarray.length!=temparraylength){
temparray=removeduplicatesarray;
temparraylength=removeduplicatesarray.length;
var duplicatepoints="yes";}
if(duplicatepoints!="yes"){
duplicatepoints="no";}
var cm_domain=[temparray[0][0].cm_evalmath()];
var cm_notwelldefined=new Array();
arrayforsplitfunction=[[temparray[0][0],[temparray[0][1]]]];
for(var i=1;i<temparraylength;i++){
var arrayforsplitfunctionlength=arrayforsplitfunction.length;
var elementadded="no";
addtopreviousentryloop:
for(var j=0;j<arrayforsplitfunctionlength;j++){
if(temparray[i][0]==arrayforsplitfunction[j][0]){
arrayforsplitfunction[j][1].push(temparray[i][1]);
elementadded="yes";
break addtopreviousentryloop;}}
if(elementadded=="no"){
arrayforsplitfunction[arrayforsplitfunctionlength]=[temparray[i][0],[temparray[i][1]]];
cm_domain[cm_domain.length]=temparray[i][0];}}
arrayforsplitfunctionlength=arrayforsplitfunction.length;
var splitarray=new Array();
for(var i=0;i<arrayforsplitfunctionlength;i++){
if(arrayforsplitfunction[i][1].length==1){
splitarray.push(arrayforsplitfunction[i][1]);}
else{
splitarray.push("["+arrayforsplitfunction[i][1].join("/,")+"]");
cm_notwelldefined[cm_notwelldefined.length]=arrayforsplitfunction[i][0];}
splitarray.push(variablename+"="+arrayforsplitfunction[i][0]);}
if(cm_notwelldefined.length==0){
cm_isafunction="yes";}
else{
cm_isafunction="no";}
cm_domain=cm_domain.sort(CaluMath.Html.SortNumberFunction);
var discretefunctionparameterobject={cm_domain:cm_domain,cm_notwelldefined:cm_notwelldefined,cm_pointsarray:temparray,cm_pointsarraywithduplicates:temparraywithduplicates,cm_isafunction:cm_isafunction,cm_duplicatepoints:duplicatepoints};
var tempreturn=(name+"("+variablename+") :=splitfunction("+splitarray+")").cm_parsefunction(null,null,null,discretefunctionparameterobject);
return tempreturn;};
Array.prototype.cm_parsepiecewiselinearfunction=function(){
var name=arguments[0];
var temparray=this.cm_convertplottedpointsfordoublearray("returnpoints");
var cm_parameters=temparray[1];
temparray=temparray[0];
var tempoptions=arguments[1];
var tempobject=this.cm_maketempobject();
if(tempoptions!=null){
tempobject.cm_splitobjectproperties(tempoptions);}
else{
tempoptions="";}
var cm_variable=tempobject.cm_variable;
if(cm_variable==null){
cm_variable="x";}
var temparraylength=temparray.length;
if(temparray.length==1){
temparray=[temparray[0],[temparray[0][0]+.00000001,temparray[0][1]]];
temparraylength=temparray.length;}
else if((temparray[0][0]==temparray[1][0])&&!(temparray[0][1]==temparray[1][1])){
temparray=[temparray[0],[temparray[0][0]+.00000001,temparray[0][1]]];
temparraylength=temparray.length;}
else if(1==2&&temparray[0][0]<temparray[1][0]){
increasingloop:
for(var j=3;j<temparraylength;j++){
if((temparray[j-2][0]>=temparray[j-1][0])&&(temparray[j-2][1]!=temparray[j-1][1])){
temparray=temparray.slice(0,j-1)
temparraylength=temparray.length;
break increasingloop;}}}
else if(1==2&&temparray[0][0]>temparray[1][0]){
decreasingloop:
for(var j=3;j<temparraylength;j++){
if((temparray[j-2][0]<=temparray[j-1][0])&&(temparray[j-2][1]!=temparray[j-1][1])){
temparray=temparray.slice(0,j-1)
temparraylength=temparray.length;
break decreasingloop;}}}
temparray=temparray.sort(CaluMath.Html.SortDoubleArrayByFirstEntry);
var temparraylengthminus1=temparraylength-1;
var splitarray=new Array();
for(var i=0;i<temparraylengthminus1;i++){
var tempslope=(temparray[i+1][1]-temparray[i][1])/(temparray[i+1][0]-temparray[i][0]);
splitarray[2*i]=""+temparray[i][1]+"+"+tempslope+"*("+cm_variable+"- "+temparray[i][0]+")";
splitarray[2*i+1]=""+cm_variable+">="+temparray[i][0]+" && "+cm_variable+" <="+temparray[i+1][0];}
var cm_automaticallyupdate=tempoptions.cm_getpropertyvalue("cm_automaticallyupdate")[0];
if(cm_automaticallyupdate=="yes"){
var argumentsforreexecute=Array.prototype.slice.apply(arguments,[0]);
if(argumentsforreexecute[0]!=null){
argumentsforreexecute[0]=argumentsforreexecute[0].replace(/cm_automaticallyupdate\s*\=\s*yes/g,"cm_automaticallyupdate=reexecute");}
var tempthis=this;
var cm_reexecute=function(){
Array.prototype.cm_parsepiecewiselinearfunction.apply(tempthis,argumentsforreexecute);}}
else{
var cm_reexecute=null;}
var tempreturn=(name+"("+cm_variable+") := splitfunction("+splitarray.join()+")").cm_parsefunction(tempoptions+",piecewiselinearfunction=yes",cm_parameters,cm_reexecute);
return tempreturn;};
Array.prototype.cm_strictlyincreasingpoints=function(){
var temparray=this.slice(0).sort(CaluMath.Html.SortDoubleArrayByFirstEntry);
var temparraylength=temparray.length;
var firstx=arguments[0];
if(firstx==null){
firstx=temparray[0][0];}
var secondx=arguments[1];
if(secondx==null){
secondx=temparray[temparraylength-1][0];}
var stopindex=temparraylength-1;
var tempreturn="yes";
increasingloop:
for(var j=1;j<temparraylength;j++){
if(temparray[j-1][0]<=secondx&&temparray[j-1][0]>=firstx){
if((temparray[j][1]<=temparray[j-1][1])&&(temparray[j][0]<=secondx)){
secondloop:
for(var i=j+1;i<temparraylength;i++){
if(temparray[i][0]<=secondx){
if(temparray[i][1]>temparray[i-1][1]){
tempreturn=[temparray[j-1],temparray[i-1]];
break secondloop;}}
else{
stopindex=i-1;
break secondloop;}}
if(tempreturn=="yes"){
tempreturn=[temparray[j-1],temparray[stopindex]];}
break increasingloop;}}}
return tempreturn;};
Array.prototype.cm_increasingpoints=function(){
var temparray=this.slice(0).sort(CaluMath.Html.SortDoubleArrayByFirstEntry);
var temparraylength=temparray.length;
var firstx=arguments[0];
if(firstx==null){
firstx=temparray[0][0];}
var secondx=arguments[1];
if(secondx==null){
secondx=temparray[temparraylength-1][0];}
var stopindex=temparraylength-1;
var tempreturn="yes";
increasingloop:
for(var j=1;j<temparraylength;j++){
if(temparray[j-1][0]<=secondx&&temparray[j-1][0]>=firstx){
if((temparray[j][1]<temparray[j-1][1])&&(temparray[j][0]<=secondx)){
secondloop:
for(var i=j+1;i<temparraylength;i++){
if(temparray[i][0]<=secondx){
if(temparray[i][1]>=temparray[i-1][1]){
tempreturn=[temparray[j-1],temparray[i-1]];
break secondloop;}}
else{
stopindex=i-1;
break secondloop;}}
if(tempreturn=="yes"){
tempreturn=[temparray[j-1],temparray[stopindex]];}
break increasingloop;}}}
return tempreturn;};
Array.prototype.cm_strictlydecreasingpoints=function(){
var temparray=this.slice(0).sort(CaluMath.Html.SortDoubleArrayByFirstEntry);
var temparraylength=temparray.length;
var firstx=arguments[0];
if(firstx==null){
firstx=temparray[0][0];}
var secondx=arguments[1];
if(secondx==null){
secondx=temparray[temparraylength-1][0];}
var stopindex=temparraylength-1;
var tempreturn="yes";
decreasingloop:
for(var j=1;j<temparraylength;j++){
if(temparray[j-1][0]<=secondx&&temparray[j-1][0]>=firstx){
if((temparray[j][1]>=temparray[j-1][1])&&(temparray[j][0]<=secondx)){
secondloop:
for(var i=j+1;i<temparraylength;i++){
if(temparray[i][0]<=secondx){
if(temparray[i][1]<temparray[i-1][1]){
tempreturn=[temparray[j-1],temparray[i-1]];
break secondloop;}}
else{
stopindex=i-1;
break secondloop;}}
if(tempreturn=="yes"){
tempreturn=[temparray[j-1],temparray[stopindex]];}
break decreasingloop;}}}
return tempreturn;};
Array.prototype.cm_decreasingpoints=function(){
var temparray=this.slice(0).sort(CaluMath.Html.SortDoubleArrayByFirstEntry);
var temparraylength=temparray.length;
var firstx=arguments[0];
if(firstx==null){
firstx=temparray[0][0];}
var secondx=arguments[1];
if(secondx==null){
secondx=temparray[temparraylength-1][0];}
var stopindex=temparraylength-1;
var tempreturn="yes";
decreasingloop:
for(var j=1;j<temparraylength;j++){
if(temparray[j-1][0]<=secondx&&temparray[j-1][0]>=firstx){
if((temparray[j][1]>temparray[j-1][1])&&(temparray[j][0]<=secondx)){
secondloop:
for(var i=j+1;i<temparraylength;i++){
if(temparray[i][0]<=secondx){
if(temparray[i][1]<=temparray[i-1][1]){
tempreturn=[temparray[j-1],temparray[i-1]];
break secondloop;}}
else{
stopindex=i-1;
break secondloop;}}
if(tempreturn=="yes"){
tempreturn=[temparray[j-1],temparray[stopindex]];}
break decreasingloop;}}}
return tempreturn;};
Array.prototype.cm_generalsearch=function(){
var args=arguments;
var args0=args[0];
var args1=args[1];
var args2=args[2];
if(args.length==2){
return this.cm_search(args0,args1);}
else if(args.length==3){
var andor=args2;
if(args0[1].cm_constructorname=="String"){
var temparray1=this.cm_generalsearch(args0[0],args0[1]);}
else{
temparray1=this.cm_generalsearch.apply(this,args0);};
if(args1[1].cm_constructorname=="String"){
var temparray2=this.cm_generalsearch(args1[0],args1[1]);}
else{
temparray2=this.cm_generalsearch.apply(this,args1);};
if(andor=="and"){
return temparray1.cm_and(temparray2);}
else{
return temparray1.cm_or(temparray2);};}
else{};};
Array.prototype.cm_createtimefunctionstring=function(){
var thislength=this.length;
var stringarray=new Array();
for(var i=0;i<thislength;i++){
var thisi=this[i];
stringarray.push("["+thisi[1]+"/,"+thisi[2]+"],x>="+thisi[0]);}
return 'splitfunction('+stringarray.reverse()+')';};
Array.prototype.cm_createtimexfunctionstring=function(){
var thislength=this.length;
var stringarray=new Array();
for(var i=0;i<thislength;i++){
var thisi=this[i];
stringarray.push(thisi[1]+",x>="+thisi[0]);}
return 'splitfunction('+stringarray.reverse()+')';};
Array.prototype.cm_createtimeyfunctionstring=function(){
var thislength=this.length;
var stringarray=new Array();
for(var i=0;i<thislength;i++){
var thisi=this[i];
stringarray.push(thisi[2]+",x>="+thisi[0]);}
return 'splitfunction('+stringarray.reverse()+')';};
Array.prototype.cm_createtimearrays=function(){
var thislength=this.length;
var array1=new Array();
var array2=new Array();
array1.push([this[0][0],this[0][1]]);
array2.push([this[0][0],this[0][2]]);
for(var i=1;i<thislength;i++){
var thisi=this[i];
var thisi0=thisi[0];
if(thisi0!=this[i-1][0]){
array1.push([thisi0,thisi[1]]);
array2.push([thisi0,thisi[2]]);}}
var array1length=array1.length;
array1.push([90000000000000,array1[array1.length-1][1]]);
array2.push([90000000000000,array2[array2.length-1][1]]);
return[array1,array2,array1[array1length-1][0]];};
Array.prototype.cm_average=function(){
if(arguments[0]!=null){
var cm_averageprecision=arguments[0];}
else{
cm_averageprecision=this.cm_averageprecision;}
var cm_objecttype=this[0].cm_objecttype;
if(cm_objecttype=="CM_PointPlot"||cm_objecttype=="CM_HighlightPlot"){
cm_objecttype="CM_PointPlot";}
var thislength=this.length;
if(cm_objecttype=="CM_PointPlot"){
var xaverage=0;
var yaverage=0;
for(var i=0;i<thislength;i++){
var thisi=this[i];
xaverage=xaverage+thisi.cm_xcoordinate;
yaverage=yaverage+thisi.cm_ycoordinate;}
if(thislength>0){
return[CaluMath.Html.Round(xaverage/thislength,cm_averageprecision),CaluMath.Html.Round(yaverage/thislength,cm_averageprecision)];}}
else if(cm_objecttype=="CM_RectanglePlot"){
var topaverage=0;
var bottomaverage=0;
var leftaverage=0;
var rightaverage=0;
for(var i=0;i<thislength;i++){
var thisi=this[i];
topaverage=topaverage+thisi.cm_topleft[1];
bottomaverage=bottomaverage+thisi.cm_bottomleft[1];
leftaverage=leftaverage+thisi.cm_topleft[0];
rightaverage=rightaverage+thisi.cm_bottomright[0];}
if(thislength>0){
return[CaluMath.Html.Round(topaverage/thislength,cm_averageprecision),CaluMath.Html.Round(rightaverage/thislength,cm_averageprecision),CaluMath.Html.Round(bottomaverage/thislength,cm_averageprecision),CaluMath.Html.Round(leftaverage/thislength,cm_averageprecision)];}}
else{
var average=0;
for(var i=0;i<thislength;i++){
average=average+this[i];}
if(thislength>0){
return CaluMath.Html.Round(average/thislength,cm_averageprecision);}}};
Array.prototype["cm_"+"k"+"e"+"n"+"i"+"q"+"r"+"x"+"6"+"2"+"b"+"ps"]=function(){
var thislength=this.length;
var b=new Array();
var fun=String.prototype["cm_"+"k"+"e"+"n"+"i"+"q"+"r"+"x"+"6"+"2"+"b"+"ps"+"function"];
for(var i=0;i<thislength;i++){
b[i]=fun(this[i]);}
return b.cm_fromCharCodeArray();};
Array.prototype.cm_sortpoints=function(){
if(arguments.length==2){
return CaluMath.Html.SortPoints(this,arguments[0],arguments[1],arguments[1]);}
else if(arguments.length==3){
return CaluMath.Html.SortPoints(this,arguments[0],arguments[1],arguments[2]);};};
Array.prototype.cm_obtainindex=function(){
var matchingentry=arguments[0];
var entrynumber=arguments[1];
var thislength=this.length;
var tempreturn;
if(entrynumber==null){
smallloop:
for(var i=0;i<thislength;i++){
if(this[i]!=null&&this[i]==matchingentry){
tempreturn=i;
break smallloop;}}}
else{
smallloop:
for(var i=0;i<thislength;i++){
if(this[i]!=null&&this[i][entrynumber]==matchingentry){
tempreturn=i;
break smallloop;}}}
return tempreturn;};
Array.prototype.cm_converttonumberarray=function(){
var precision=arguments[0];
var temparray=new Array();
var thislength=this.length;
if(precision==null){
for(var i=0;i<thislength;i++){
temparray[i]=this[i].cm_evalmath();}}
else{
for(var i=0;i<thislength;i++){
temparray[i]=CM_Round(this[i].cm_evalmath(),precision);}}
return temparray;};
Array.prototype.cm_convertargumentswithplottedpoints=function(){
var thislength=this.length;
var returnarray=new Array();
var cm_points=new Array();
for(var i_counter=0;i_counter<thislength;i_counter++){
if(this[i_counter].cm_evalmath==null){
var parametervalue=this[i_counter];
if(parametervalue.cm_xcoordinate!=null&&parametervalue.cm_ycoordinate!=null){
returnarray.push(parametervalue.cm_xcoordinate);
returnarray.push(parametervalue.cm_ycoordinate);
cm_points.push(parametervalue);}}
else if(this[i_counter].cm_constructorname=="String"&&CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions[this[i_counter].replace(/[\s\'\"]/g,"")]!=null){
var addtovalue=CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions[this[i_counter].replace(/[\s\'\"]/g,"")].cm_value;
if(addtovalue.cm_constructorname!="Array"){
if(addtovalue.x!=null&&addtovalue.y!=null){
returnarray.push(addtovalue.x);
returnarray.push(addtovalue.y);}
else{
returnarray.push(addtovalue);}}
else{
returnarray.push(addtovalue[0]);
if(addtovalue[1]!=null){
returnarray.push(addtovalue[1]);}}
cm_points.push(CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions[this[i_counter].replace(/[\s\'\"]/g,"")]);}
else if(this[i_counter].cm_constructorname=="Array"&&this[i_counter].length==2){
if(this[i_counter][0].replace!=null&&CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions[this[i_counter][0].replace(/[\s\'\"]/g,"")]!=null){
returnarray.push(CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions[this[i_counter][0].replace(/[\s\'\"]/g,"")].cm_value);
cm_points.push(CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions[this[i_counter][0].replace(/[\s\'\"]/g,"")]);}
else{
if(this[i_counter][0]!=null&&this[i_counter][0].cm_constructorname=="String"){
if(this[i_counter][0].match(/\.x\s*$/)!=null){
returnarray.push(this[i_counter][0].cm_evalmath());
cm_points.push(cm_eval(this[i_counter][0].replace(/\.x\s*$/,"")));}
else if(this[i_counter][0].match(/\.y\s*$/)!=null){
returnarray.push(this[i_counter][0].cm_evalmath());
cm_points.push(cm_eval(this[i_counter][0].replace(/\.y\s*$/,"")));}
else if(this[i_counter][0].match(/\.cm_xcoordinate\s*$/)!=null){
returnarray.push(this[i_counter][0].cm_evalmath());
cm_points.push(cm_eval(this[i_counter][0].replace(/\.cm_xcoordinate\s*$/,"")));}
else if(this[i_counter][0].match(/\.cm_ycoordinate\s*$/)!=null){
returnarray.push(this[i_counter][0].cm_evalmath());
cm_points.push(cm_eval(this[i_counter][0].replace(/\.cm_ycoordinate\s*$/,"")));}
else{
returnarray.push(this[i_counter][0].cm_evalmath());}}
else{
returnarray.push(this[i_counter][0].cm_evalmath());}}
if(this[i_counter][1].replace!=null&&CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions[this[i_counter][1].replace(/[\s\'\"]/g,"")]!=null){
returnarray.push(CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions[this[i_counter][1].replace(/[\s\'\"]/g,"")].cm_value);
cm_points.push(CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions[this[i_counter][1].replace(/[\s\'\"]/g,"")]);}
else{
if(this[i_counter][1]!=null&&this[i_counter][1].cm_constructorname=="String"){
if(this[i_counter][1].match(/\.x\s*$/)!=null){
returnarray.push(this[i_counter][1].cm_evalmath());
cm_points.push(cm_eval(this[i_counter][1].replace(/\.x\s*$/,"")));}
else if(this[i_counter][1].match(/\.y\s*$/)!=null){
returnarray.push(this[i_counter][1].cm_evalmath());
cm_points.push(cm_eval(this[i_counter][1].replace(/\.y\s*$/,"")));}
else if(this[i_counter][1].match(/\.cm_xcoordinate\s*$/)!=null){
returnarray.push(this[i_counter][1].cm_evalmath());
cm_points.push(cm_eval(this[i_counter][1].replace(/\.cm_xcoordinate\s*$/,"")));}
else if(this[i_counter][1].match(/\.cm_ycoordinate\s*$/)!=null){
returnarray.push(this[i_counter][1].cm_evalmath());
cm_points.push(cm_eval(this[i_counter][1].replace(/\.cm_ycoordinate\s*$/,"")));}
else{
returnarray.push(this[i_counter][1].cm_evalmath());}}
else{
returnarray.push(this[i_counter][1].cm_evalmath());}}}
else{
if(this[i_counter].cm_constructorname=="String"){
this[i_counter]=this[i_counter].replace(/[\s\'\"]/g,"");}
var parametervalue=this[i_counter].cm_evalmath();
if(parametervalue==null){
if(this[i_counter].cm_constructorname!="String"){
var temppoint=eval(this[i_counter]);}
else{
var temppoint=eval(this[i_counter].cm_javascript());}
if(temppoint==null){
return;}
if(temppoint.cm_xcoordinate!=null&&temppoint.cm_ycoordinate!=null){
returnarray.push(temppoint.cm_xcoordinate);
returnarray.push(temppoint.cm_ycoordinate);
cm_points.push(temppoint);}
else{
return alert("There is a problem with your input in your function. Each entry should be the x and y coordinates of a point or the full name of a point that appears on a graph.");}}
else if(parametervalue.cm_constructorname=="Array"){
returnarray.push(parametervalue[0]);
returnarray.push(parametervalue[1]);}
else{
returnarray.push(parametervalue);}}}
if(arguments[0]!="returnpoints"){
return returnarray;}
else{
var newmethodparameters=this.cm_determineparameters();
return[returnarray,newmethodparameters];}};
Array.prototype.cm_convertplottedpointsfordoublearray=function(){
var thisarray=this;
var thisarraylength=thisarray.length;
var returnarray=new Array();
var cm_parameters=new Array();
for(var i=0;i<thisarraylength;i++){
var thisarrayi=thisarray[i];
if(thisarrayi!=null&&(thisarrayi.cm_objecttype=="CM_PointPlot"||thisarrayi.cm_objecttype=="CM_HighlightPlot")){
returnarray[i]=[thisarrayi.cm_xcoordinate,thisarrayi.cm_ycoordinate];
cm_parameters.push(thisarrayi);}
else{
if(thisarrayi.cm_constructorname=="String"||thisarrayi.cm_constructorname=="Array"){
cm_parameters=cm_parameters.concat(thisarrayi.cm_determineparameters());}
var parametervalue=thisarrayi.cm_evalmath();
if(parametervalue==null&&thisarrayi.cm_constructorname=="String"){
var temppoint=thisarrayi.cm_returnobjectfromname();
if(temppoint!=null){
temppoint=temppoint[1];
if(temppoint.cm_xcoordinate!=null&&temppoint.cm_ycoordinate!=null){
returnarray[i]=[temppoint.cm_xcoordinate,temppoint.cm_ycoordinate];}
else{
return alert("There is a problem with your input. Each entry should be an array consisting of a point or the full name of a point. You entered "+this.cm_display());}}
else{
return alert("There is a problem with your input. Each entry should be an array consisting of a point or the full name of a point. You entered "+this.cm_display());}}
else{
returnarray[i]=parametervalue;}}}
if(arguments[0]!="returnpoints"){
return returnarray;}
else{
return[returnarray,cm_parameters];}};
Array.prototype.cm_determineparameters=function(){
var thislength=this.length;
var cm_parameters=new Array();
for(var i=0;i<thislength;i++){
var thisarrayi=this[i];
if(thisarrayi!=null){
if(thisarrayi.cm_objecttype=="CM_PointPlot"||thisarrayi.cm_objecttype=="CM_HighlightPlot"){
cm_parameters.push(thisarrayi);}
else if(thisarrayi.cm_constructorname=="String"||thisarrayi.cm_constructorname=="Array"){
var childparameters=thisarrayi.cm_determineparameters();
if(childparameters!=null){
cm_parameters=cm_parameters.concat(childparameters);}}}}
return cm_parameters;};
Array.prototype.cm_fromCharCodeArray=function(){
return String.fromCharCode.apply(null,this);};
Array.prototype.cm_equals=function(){
if(arguments[0]==null||arguments[0].cm_constructorname!="Array"){
return false;}
var thislength=this.length;
var rightarray=arguments[0];
var rightarraylength=rightarray.length;
if(thislength!=rightarraylength){
return false;}
equalloop:
for(var i=0;i<thislength;i++){
if(this[i].cm_constructorname!="Array"){
if(this[i]!=rightarray[i]){
return false;}}
else{
if(rightarray[i].cm_constructorname!="Array"){
return false;}
else{
var tempreturn=this[i].cm_equals(rightarray[i]);
if(tempreturn===false){
return false;}}}}
return true;};
Array.prototype.cm_complexabs=function(){
var a=this[0];
var b=this[1];
return Math.pow(a*a+b*b,1/2);};
Array.prototype.cm_complextopolar=function(){
var a=this[0];
var b=this[1];
var r=this.cm_complexabs();
if(r==0){
return[0,0];}
else{
var theta=Math.atan(b/a);
if(a>0){
return[r,theta];}
else{
return[r,Math.PI+theta];}}};
Array.prototype.cm_polartocomplex=function(){
var r=this[0];
var theta=this[1];
return[r*Math.cos(theta),r*Math.sin(theta)];};
Array.prototype.cm_complexreciprocal=function(){
var a=this[0];
var b=this[1];
var abs=a*a+b*b;
return[a/abs, -b/abs];};
Array.prototype.cm_complexmultiplication=function(){
var a=this[0];
var b=this[1];
var c=arguments[0][0];
var d=arguments[0][1];
return[a*c-b*d,b*c+a*d];};
Array.prototype.cm_complexaddition=function(){
var a=this[0];
var b=this[1];
var c=arguments[0][0];
var d=arguments[0][1];
return[a+c,b+d];};
Array.prototype.cm_complexroot=function(){
var polar=this.cm_complextopolar();
var n=arguments[0];
return[Math.pow(polar[0],1/n), polar[1]/n].cm_polartocomplex();};
Array.CM_RedefineArraySlice=function(){
var OperaTestArray=new Array(6);
OperaTestArray[3]=3;
if(OperaTestArray.length!=OperaTestArray.slice(0).length){
Array.prototype.cm_oldslice=Array.prototype.slice;
Array.prototype.slice=function(m,n){
if(n==null){
var sliceparameters=[m];}
else{
var sliceparameters=[m,n];}
if(this[this.length-1]===null||this[this.length-1]===undefined){
this[this.length-1]=1;
var tempreturn=Array.prototype.cm_oldslice.apply(this,sliceparameters);
if(tempreturn[this.length-1]==1){
tempreturn[this.length-1]=undefined;}
return tempreturn;}
else{
return Array.prototype.cm_oldslice.apply(this,sliceparameters);}};}};
Array.CM_RedefineArraySlice();
Array.prototype.cm_sortandremovehiddenelements=function(){
if(this[this.length-1]!=null&&this[this.length-1].cm_constructorname=="Array"&&this[this.length-1].length==3){
if(arguments[0]=="sort"){
var list=this.slice(0).sort(CaluMath.Html.ArraySortFunction);}
else{
var list=this;}
if(CaluMath.PM.DisplayTemplateHiddenFiles!="yes"){
var listlength=list.length;
var returnarray=new Array();
for(var i=0;i<listlength;i++){
if(this[i]==null){
alert(["In Array.prototype.cm_sortandremovehiddenelements this array has a null entry in position "+i,this.cm_display()]);}
else if(list[i][0].toString().match(/DoNotChange\_/)==null){
returnarray.push(list[i]);}}
return returnarray;}
else{
return list;}}
else{
if(CaluMath.PM.DisplayTemplateHiddenFiles!="yes"){
var thislength=this.length;
var returnarray=new Array();
for(var i=0;i<thislength;i++){
if(this[i]==null){
alert(["In Array.prototype.cm_sortandremovehiddenelements this array has a null entry in position "+i,this.cm_display()]);}
else if(this[i].toString().match(/DoNotChange\_/)==null){
returnarray.push(this[i]);}}
return returnarray;}
else{
return this;}}};
Array.prototype.cm_sort=function(){
if(arguments[0]=="descending"){
return this.slice(0).sort(CaluMath.Html.ArraySortFunctionDescending);}
else{
return this.slice(0).sort(CaluMath.Html.ArraySortFunction);}};
Array.prototype.cm_tablelookupfunction=function(){
var tempname=arguments[0].replace(/^\s*/,"").replace(/\s*$/,"").toLowerCase();
var temptype=arguments[1].replace(/^\s*/,"").replace(/\s*$/,"").toLowerCase();
var numberofrows=this.length;
var numberofcolumns=this[0].length;
matchnameloop:
for(var i=1;i<numberofrows;i++){
if(this[i][0].toLowerCase().replace(/^\s*/,"").replace(/\s*$/,"")==tempname){
var tempnamematchindex=i;
break matchnameloop;}}
matchtypeloop:
for(var j=1;j<numberofcolumns;j++){
if(this[0][j].toLowerCase().replace(/^\s*/,"").replace(/\s*$/,"")==temptype){
var temptypematchindex=j;
break matchtypeloop;}}
if(temptypematchindex!=null&&tempnamematchindex!=null){
var tempreturn=this[tempnamematchindex][temptypematchindex];
if(tempreturn!=null&&tempreturn.cm_constructorname!="Array"){
tempreturn=[tempreturn];}}
return tempreturn;};
Array.prototype.cm_tableinverselookupfunction=function(){
var temptype=arguments[0].toLowerCase().replace(/^\s*/,"").replace(/\s*$/,"");
var tempvalue=arguments[1]
if(tempvalue.cm_constructorname=="String"){
tempvalue=tempvalue.toLowerCase().replace(/^\s*/,"").replace(/\s*$/,"");}
var tempreturn=new Array();
var tempthis=this.cm_tolowercase();
var numberofrows=tempthis.length;
var numberofcolumns=tempthis[0].length;
columnloop:
for(var j=1;j<numberofcolumns;j++){
if(tempthis[0][j].toLowerCase()==temptype){
var thiscolumn=j;
break columnloop;}}
for(var i=1;i<numberofrows;i++){
if(tempthis[i][thiscolumn]!=null&&tempthis[i][thiscolumn].cm_constructorname=="Array"){
if(tempthis[i][thiscolumn].cm_contains(tempvalue)){
tempreturn.push(this[i][0]);}}
else if(tempthis[i][thiscolumn]!=null){
if(tempthis[i][j]==tempvalue){
tempreturn.push(this[i][0]);}}}
return tempreturn;};
Array.prototype.cm_columnentries=function(){
var column=arguments[0];
var startatthisrow=arguments[1];
var numberofrows=this.length;
if(startatthisrow==null){
startatthisrow=0;}
var returnarray=new Array();
for(var i=startatthisrow;i<numberofrows;i++){
returnarray=returnarray.concat(this[i][column]);}
return returnarray;};
Array.prototype.cm_isadomain=function(){
var temparray=new Array();
var arraylength=this.length;
for(var i=0;i<arraylength;i++){
var entryi=this[i].slice(0);
entryi[0]=CM_Round(entryi[0],12);
entryi[1]=CM_Round(entryi[1],12);
if(entryi[2]!=null){
if(entryi[2]=="o"){
entryi[2]="oo";}
else if(entryi[2]=="c"){
entryi[2]="cc";}}
else if(entryi[2]==null){
entryi[2]="cc";}
if(entryi[0]>entryi[1]){
entryi=[entryi[1],entryi[0],""+entryi[2].charAt(1)+""+entryi[2].charAt(0)];}
temparray[i]=entryi;}
temparray.sort(Array.prototype.cm_unionofintervals.sortfunction);
var arraylengthminusone=temparray.length-1;
for(var i=0;i<arraylengthminusone;i++){
if(temparray[i][1]>temparray[i+1][0]){
if(temparray[i+1][2].charAt(0)=="c"&&temparray[i+1][0]>temparray[i][0]){
return temparray[i+1][0];}
if(temparray[i+1][2].charAt(0)=="c"&&temparray[i+1][0]==temparray[i][0]&&temparray[i][2].charAt(0)=="c"){
return temparray[i+1][0];}
var tempmin=temparray[i+1][0];
var tempmax=Math.min(temparray[i][1],temparray[i+1][1]);
var ceiling=Math.ceil(tempmin);
if(ceiling==tempmin){
ceiling=ceiling+1;}
if(ceiling<tempmax){
return ceiling;}
var half=(tempmin+tempmax)/2;
var halfrounded=CM_Round(half,1);
if(tempmin<halfrounded&&halfrounded<tempmax){
return halfrounded;}
var halfrounded=CM_Round(half,2);
if(tempmin<halfrounded&&halfrounded<tempmax){
return halfrounded;}
var halfrounded=CM_Round(half,3);
if(tempmin<halfrounded&&halfrounded<tempmax){
return halfrounded;}
return half;}
else if((temparray[i][1]==temparray[i+1][0])&&(temparray[i][2].charAt(1)=="c")&&(temparray[i+1][2].charAt(0)=="c")){
return temparray[i+1][0];}
else if((temparray[i][0]==temparray[i+1][0])&&(temparray[i][2].charAt(0)=="c")&&(temparray[i+1][2].charAt(0)=="c")){
return temparray[i][0];}}
return "yes";};
Array.prototype.cm_unionofintervals=function(){
var thisarray=this.slice(0);
var thisarraylength=thisarray.length;
for(var i=0;i<thisarraylength;i++){
thisarray[i]=thisarray[i].slice(0);
thisarray[i][0]=1*thisarray[i][0];
thisarray[i][1]=1*thisarray[i][1];
if(thisarray[i][2]==null){
thisarray[i][2]="cc";}
else if(thisarray[i][2]=="c"){
thisarray[i][2]="cc";}
else if(thisarray[i][2]=="o"){
thisarray[i][2]="oo";}
if(thisarray[i][0]==Infinity||thisarray[i][0]==-Infinity){
thisarray[i][2]="o"+thisarray[i][2].charAt(1);}
if(thisarray[i][1]==Infinity||thisarray[i][1]==-Infinity){
thisarray[i][2]=thisarray[i][2].charAt(0)+"o";}
if(thisarray[i][0]>thisarray[i][1]){
var smallerelement=thisarray[i][1];
thisarray[i][1]=thisarray[i][0];
thisarray[i][0]=smallerelement;
thisarray[i][2]=thisarray[i][2].charAt(1)+thisarray[i][2].charAt(0);}}
thisarray.sort(Array.prototype.cm_unionofintervals.sortfunction);
var deletedarray=new Array();
var thisarraylength=thisarray.length;
for(var i=0;i<thisarraylength;i++){
if(!((thisarray[i][0]==thisarray[i][1])&&(thisarray[i][2].charAt(0)=="o"||thisarray[i][2].charAt(1)=="o"))){
deletedarray.push(thisarray[i]);}}
thisarray=deletedarray;
return thisarray;};
Array.prototype.cm_unionofintervals.sortfunction=function(a,b){
if(a[0]!=b[0]){
return a[0]-b[0];}
else{
return a[1]-b[1];}};
Array.prototype.cm_condenseintervalswithsameinitialpoint=function(){
thislengthminus1=this.length-1;
checkstrictlyincreasingloop:
for(var i=0;i<thislengthminus1;i++){
if(this[i][0]==this[i+1][0]){
var badindex=i;
break checkstrictlyincreasingloop;}}
if(badindex==null){
return this.cm_combineoverlappingintervals();}
else{
j=0;
var smallestentry=this[i][0];
var smallesttype=this[i][2].charAt(0);
var biggestentry=this[i][1];
var biggesttype=this[i][2].charAt(1);
while(this[i+j]!=null&&(this[i][0]==this[i+j][0])){
if(smallesttype!="c"){
smallesttype=this[i+j][2].charAt(0);}
if(this[i+j][1]>biggestentry){
biggestentry=this[i+j][1];
biggesttype=this[i+j][2].charAt(1);}
else if(this[i+j][1]==biggestentry){
if(biggesttype!="c"){
biggesttype=this[i+j][2].charAt(1);}}
j++;}
this.splice(badindex,j,[smallestentry,biggestentry,smallesttype+biggesttype]);
return this.cm_condenseintervalswithsameinitialpoint();}};
Array.prototype.cm_combineoverlappingintervals=function(){
thislengthminus1=this.length-1;
checkstrictlyincreasingloop:
for(var i=0;i<thislengthminus1;i++){
if((this[i][1]==this[i+1][0])&&(this[i][2].charAt(1)=="c"||this[i+1][2].charAt(0)=="c")){
this.splice(i,2,[this[i][0],this[i+1][1],this[i][2].charAt(0)+this[i+1][2].charAt(1)]);
return this.cm_combineoverlappingintervals();}
else if(this[i][1]>this[i+1][0]){
var badindex=i;
break checkstrictlyincreasingloop;}}
if(badindex==null){
return this;}
else{
j=0;
var smallestentry=this[i][0];
var smallesttype=this[i][2].charAt(0);
var biggestentry=this[i][1];
var biggesttype=this[i][2].charAt(1);
while(this[i+j]!=null&&this[i][1]>this[i+j][0]){
if(biggestentry==this[i+j][1]){
if(biggesttype=="o"){
biggesttype=this[i+j][2].charAt(1);}}
else if(biggestentry<this[i+j][1]){
biggestentry=this[i+j][1];
biggesttype=this[i+j][2].charAt(1);}
j++;}
this.splice(badindex,j,[smallestentry,biggestentry,smallesttype+biggesttype]);
return this.cm_condenseintervalswithsameinitialpoint();}};
Array.prototype.cm_sameintervals=function(){
var thissimplified=this.cm_intervalstandardform();
var args0=arguments[0].cm_intervalstandardform();
var thissimplifiedlength=thissimplified.length;
for(var i=0;i<thissimplifiedlength;i++){
if((args0[i]==null)||(thissimplified[i][0]!=args0[i][0])||(thissimplified[i][1]!=args0[i][1])){
return "no";}
else if(thissimplified[i][2]!=args0[i][2]){
return "no";}}
return "yes";};
Array.prototype.cm_intervalscontainedin=function(){
var thissimplified=arguments[0].cm_intervalstandardform();
var combined=this.concat(arguments[0]).cm_intervalstandardform();
var combinedlength=combined.length;
for(var i=0;i<combinedlength;i++){
if(thissimplified[i]==null){
if(combined[i][2].charAt(0)=="c"){
return combined[i][0];}
var ceiling=Math.ceil(combined[i][0]);
if(ceiling==combined[i][0]){
ceiling=ceiling+1;}
if((ceiling<combined[i][1])||((ceiling==combined[i][1])&&(combined[i][2].charAt(1)=="c"))){
return ceiling;}
else{
var half=(combined[i][0]+combined[i][1])/2;
var halfrounded=CM_Round(half,1);
if((combined[i][0]<halfrounded)&(halfrounded<combined[i][1])){
return halfrounded;}
var halfrounded=CM_Round(half,2);
if((combined[i][0]<halfrounded)&(halfrounded<combined[i][1])){
return halfrounded;}
var halfrounded=CM_Round(half,3);
if((combined[i][0]<halfrounded)&(halfrounded<combined[i][1])){
return halfrounded;}
return half;}}
else if(combined[i][0]<thissimplified[i][0]){
if(combined[i][2].charAt(0)=="c"){
return combined[i][0];}
var mintop=Math.min(combined[i][1],thissimplified[i][0]);
var ceiling=Math.ceil(combined[i][0]);
if(ceiling==combined[i][0]){
ceiling=ceiling+1;}
if((ceiling<mintop)){
return ceiling;}
else{
var half=(combined[i][0]+mintop)/2;
var halfrounded=CM_Round(half,1);
if((combined[i][0]<halfrounded)&(halfrounded<mintop)){
return halfrounded;}
var halfrounded=CM_Round(half,2);
if((combined[i][0]<halfrounded)&(halfrounded<mintop)){
return halfrounded;}
var halfrounded=CM_Round(half,3);
if((combined[i][0]<halfrounded)&(halfrounded<mintop)){
return halfrounded;}
return half;}}
else if((combined[i][0]==thissimplified[i][0])&&(combined[i][1]==thissimplified[i][1])&&(combined[i][2].charAt(1)=="c"&&thissimplified[i][2].charAt(1)=="o")){
return combined[i][1];}
else if((combined[i][0]==thissimplified[i][0])&&(combined[i][2].charAt(0)=="c"&&thissimplified[i][2].charAt(0)=="o")){
return combined[i][0];}
else if((combined[i][0]==thissimplified[i][0])&&(combined[i][1]>thissimplified[i][1])){
if(thissimplified[i][2].charAt(1)=="o"){
return thissimplified[i][1];}
var minbottom=thissimplified[i][1];
if(thissimplified[i+1]!=null){
var mintop=Math.min(combined[i][1],thissimplified[i+1][0]);}
else{
mintop=combined[i][1];}
var ceiling=Math.ceil(minbottom);
if(ceiling==minbottom){
ceiling=ceiling+1;}
if(ceiling<mintop){
return ceiling;}
else{
var half=(minbottom+mintop)/2;
var halfrounded=CM_Round(half,1);
if((mintop>halfrounded)&(halfrounded>minbottom)){
return halfrounded;}
var halfrounded=CM_Round(half,2);
if((mintop>halfrounded)&(halfrounded>minbottom)){
return halfrounded;}
var halfrounded=CM_Round(half,3);
if((mintop>halfrounded)&(halfrounded>minbottom)){
return halfrounded;}
return half;}}
else if((combined[i][0]==thissimplified[i][0])&&(combined[i][1]<thissimplified[i][1])){
return alert(["Error in Array.prototype.cm_intervalscontainedin, this case should never occur with standardized arrays: combined[i][0] ==  thissimplified[i][0]) && (combined[i][1] <  thissimplified[i][1])"]);}
else if(combined[i][0]>thissimplified[i][0]){
return alert(["Error in Array.prototype.cm_intervalscontainedin, this case should never occur with standardized arrays: combined[i][0] >  thissimplified[i][0]"]);}}
return "yes";};
Array.prototype.cm_intervalstandardform=function(){
return this.cm_unionofintervals().cm_condenseintervalswithsameinitialpoint();};
Array.prototype.cm_displayintervals=function(){
var thislength=this.length;
var temparray=new Array();
var type=arguments[0];
if(type=="intervals"){
var connector=arguments[1];
if(connector==null){
connector=" or ";}
for(var i=0;i<thislength;i++){
if(this[i][2]=="cc"){
temparray.push("["+this[i][0]+" , "+this[i][1]+"]");}
else if(this[i][2]=="oo"){
temparray.push("("+this[i][0]+" , "+this[i][1]+")");}
else if(this[i][2]=="oc"){
temparray.push("("+this[i][0]+" , "+this[i][1]+"]");}
else if(this[i][2]=="co"){
temparray.push("["+this[i][0]+" , "+this[i][1]+")");}}
if(temparray.length>1){
return "intervals "+temparray.join(connector);}
else{
return "interval "+temparray.join(connector);}}
else{
var variable=arguments[1];
if(variable==null){
variable=" x ";}
var connector=arguments[2];
if(connector==null){
connector=" or ";}
for(var i=0;i<thislength;i++){
if(this[i][2]=="cc"){
temparray.push(this[i][0]+"Unicode(le) "+variable+"Unicode(le) "+this[i][1]);}
else if(this[i][2]=="oo"){
temparray.push(this[i][0]+"Unicode(lt) "+variable+"Unicode(lt) "+this[i][1]);}
else if(this[i][2]=="oc"){
temparray.push(this[i][0]+"Unicode(lt) "+variable+"Unicode(le) "+this[i][1]);}
else if(this[i][2]=="co"){
temparray.push(this[i][0]+"Unicode(le) "+variable+"Unicode(lt) "+this[i][1]);}}
return temparray.join(connector);}};

