
CaluMath.Html.DiscretePlot=function(){
var cm_plot=arguments[0];
var functionobject=arguments[1];
var cm_map=functionobject.cm_getMap();
var name=functionobject.cm_getName();
var EvalMath=CaluMath.Html.EvalMath;
var points=cm_map.cm_getPointsArrayWithDuplicates();
var cm_start=arguments[2];
var cm_finish=arguments[3];
if(cm_start=="default"){
cm_start=cm_plot.cm_getXStart();}
else{
cm_start=EvalMath(cm_start);}
if(cm_finish=="default"){
cm_finish=cm_plot.cm_getXFinish();}
else{
cm_finish=EvalMath(cm_finish);}
var pointslength=points.length;
var options=arguments[4];
if(options==null){
options="";}
var property=options.cm_getpropertyvalue("color");
if(property[0]!=null){
var color=property[0];}
if(color==null){
var colorarray=cm_plot.cm_getColorArray();
var color=colorarray[cm_plot.cm_getDiscretePlotIndex()%colorarray.length];
options=options+",color="+color;}
var cm_alternatename=this.cm_getThis("cm_alternatename");
if(cm_alternatename!=null){
var cm_optionname=cm_alternatename;}
else{
var cm_optionname=name;}
var property=options.cm_getpropertyvalue("cm_equation");
if(property[0]!=null){
var cm_equation=property[0];
options=property[1];}
var property=options.cm_getpropertyvalue("cm_equationreplacement");
if(property[0]!=null){
var cm_equationreplacement=property[0];
options=property[1];}
var property=options.cm_getpropertyvalue("cm_option");
if(property[0]!=null){
var cm_option=property[0];
options=property[1];}
var property=options.cm_getpropertyvalue("cm_dragpointsindividually");
if(property[0]!=null){
var cm_dragpointsindividually=property[0];
options=property[1];}
var cm_components=new Array();
var plotxstart=cm_plot.cm_getXStart();
var plotxfinish=cm_plot.cm_getXFinish();
var plotystart=cm_plot.cm_getYStart();
var plotyfinish=cm_plot.cm_getYFinish();
var cm_clickcoordinatesarray=new Array();
var pointsstring="";
for(var i=0;i<pointslength-1;i++){
var thispoint=points[i];
var pointsstring=pointsstring+"("+thispoint[0]+","+thispoint[1]+"),";
if((thispoint[0].cm_evalmath()>=cm_start)&&(thispoint[0].cm_evalmath()<=cm_finish)){
cm_components.push(cm_plot.cm_pointplot(points[i],options+",cm_equation=no, cm_option=no"));}}
var thispoint=points[pointslength-1];
var pointsstring=pointsstring+"("+thispoint[0]+","+thispoint[1]+")";
if(thispoint[0].cm_evalmath()>=cm_start&&thispoint[0].cm_evalmath()<=cm_finish){
cm_components.push(cm_plot.cm_pointplot(points[pointslength-1],options+",cm_equation=no, cm_option=no"));}
for(var j=0;j<cm_components.length;j++){
cm_components[j].cm_owner=this;};
var cm_compositeobject=cm_plot.cm_compositeobject(cm_components);
cm_plot.cm_setGraphNameAsProperty(this,name);
cm_plot.cm_incrementDiscretePlotIndex();
if(this.cm_getThis("cm_addtopostscriptplotarray")!="no"){
cm_plot.cm_addToPostscriptPlotArray(this);}
cm_plot.cm_appendToChildArray(this);
this.cm_setThis("cm_plot",cm_plot);
this.cm_setThis("functionobject",functionobject);
this.cm_setThis("cm_map",cm_map);
this.cm_setThis("color",color);
this.cm_setThis("cm_optionname",cm_optionname);
this.cm_setThis("cm_option",cm_option);
this.cm_setThis("cm_equation",cm_equation);
this.cm_setThis("cm_equationreplacement",cm_equationreplacement);
this.cm_setThis("cm_dragpointsindividually",cm_dragpointsindividually);
this.cm_setThis("cm_plot",cm_plot);
this.cm_setThis("cm_pointsarray",points);
this.cm_setThis("options",options);
this.cm_setThis("name",name);
this.cm_setThis("cm_compositeobject",cm_compositeobject);
this.cm_setThis("cm_scopechain",[this].concat(cm_plot.cm_getScopeChain()));
this.cm_setThis("cm_clickcoordinatesarray",new Array());
this.cm_setThis("cm_childarray",new Array());
this.cm_makeequationdisplaystring();
var tempdiscreteplot=this;
if(cm_plot.cm_getDelaySetting()=="yes"){
var loadlength=cm_onloadarray.length;
cm_onloadarray[loadlength]=function(){
if(tempdiscreteplot.cm_equation!="no"){
tempdiscreteplot.cm_displayequation();}
if(tempdiscreteplot.cm_option=="yes"){
tempdiscreteplot.cm_displayoption();}
return this;};}
else{
var cm_equation=this.cm_getThis("cm_equation");
if(cm_equation!="no"){
if(cm_plot.cm_getEquationContainerSetting()!="no"){
cm_plot.cm_writeEquationContainer();}
this.cm_displayequation();}
if(this.cm_option=="yes"){
this.cm_displayoption();}}};
CaluMath.Html.DiscretePlot.prototype=new CaluMath.Html.GeneralizedPlot();
CaluMath.Html.DiscretePlot.prototype.cm_trueconstructor=CaluMath.Html.DiscretePlot.prototype.constructor;
CaluMath.Html.DiscretePlot.prototype.constructor=CaluMath.Html.DiscretePlot;
CaluMath.Html.DiscretePlot.prototype.cm_properties={
cm_draggable:["yes"],
cm_objecttype:["CM_DiscretePlot"],
cm_category:["graph"],
cm_fullid:[CaluMath.Html.FunctionPlot.prototype.cm_fullid],
cm_windowofrecordname:["top"],
cm_xprecision:[.1],
cm_yprecision:[.1],
cm_clickpixelprecision:[5],
cm_clickxprecision:[1],
cm_clickyprecision:[.1],
cm_notongraphmessage:["The point is not on the graph"],
cm_clickcoordinates:[CaluMath.Html.FunctionPlot.prototype.cm_clickcoordinates],
cm_clicksetcounter:[CaluMath.Html.FunctionPlot.prototype.cm_clicksetcounter],
cm_createnode:[null],
cm_alternatename:"",
name:"",
cm_addtopostscriptplotarray:"",
cm_equationreplacement:"",
cm_equationdisplaystring:"",
cm_plot:"",
functionobject:"",
color:"",
cm_optionname:"",
cm_equation:"",
cm_hidden:"",
cm_dragpointsindividually:"",
cm_pointsarray:"",
options:"",
cm_compositeobject:"",
cm_scopechain:"",
cm_draggedpoint:"",
cm_clickcoordinatesarray:"",
cm_dragfunction:"This is a function that is executed after an object is dragged (specifically on mouseup). It is set by CaluMath.Html.Plot.cm_draggraphsonmousedownfunction and set to null by CaluMath.Html.Plot.prototype.cm_cancelgraphondragprepfunction.",
cm_dragfunctioncontinuous:"This is a function that is repeatedly executed as the mouse is dragged. It is set by CaluMath.Html.Plot.cm_draggraphsonmousedownfunction set to null by CaluMath.Html.Plot.prototype.cm_cancelgraphondragprepfunction.",
cm_dragfunctiononmousedown:"This is a function that is executed before an object is dragged (specifically on mousedown). It is set by CaluMath.Html.Plot.cm_draggraphsonmousedownfunction set to null by CaluMath.Html.Plot.prototype.cm_cancelgraphondragprepfunction.",
cm_originaloptions:"This is a copy of the options of the PointPlot before it is dragged. It is set by CaluMath.Html.Plot.prototype.cm_graphondragprepfunction and allows the dragging routine to temporarily change the options (for example, the color and size) of the point while it is being dragged. After the drag, the original options are evaluated again and the point is given the options it originally had.",
cm_draggingactive:"",
cm_map:"",
NoCommaHere:"junk"};
CaluMath.Html.DiscretePlot.prototype.cm_makeprototypeproperties();
CaluMath.Html.DiscretePlot.prototype.cm_getDragPointsIndividuallySetting=function(){
return this.cm_getThis("cm_dragpointsindividually");};
CaluMath.Html.DiscretePlot.prototype.cm_getComponents=function(){
return this.cm_getThis("cm_compositeobject").cm_getComponents();};
CaluMath.Html.DiscretePlot.prototype.cm_makeequationdisplaystring=function(){
var name=this.cm_getThis("name");
var cm_equationreplacement=this.cm_getThis("cm_equationreplacement");
var color=this.cm_getThis("color");
if(cm_equationreplacement!=null&&cm_equationreplacement.length>0&&(cm_equationreplacement!="cm_dragging"||CM_DiscreteDraggingAlternateEquation!="")){
if(cm_equationreplacement=="cm_dragging"){
cm_equationreplacement=CM_DiscreteDraggingAlternateEquation;}
if(cm_equationreplacement!="nothing"&&cm_equationreplacement!="none"){
cm_equationreplacement=cm_equationreplacement.replace(/cm_lhs/g,name);
cm_equationreplacement=cm_equationreplacement.replace(/cm_points/g,this.cm_displaypointcoordinates());
cm_equationreplacement=cm_equationreplacement.replace(/cm_name/g,name);
cm_equationreplacement=cm_equationreplacement.replace(/cm_color/g,CaluMath.Html.GetColorName(color));
this.cm_setThis("cm_equationdisplaystring",cm_equationreplacement);}
else{
this.cm_setThis("cm_equationdisplaystring","");}}
else{
this.cm_setThis("cm_equationdisplaystring",name);}
return this.cm_getThis("cm_equationdisplaystring");};
CaluMath.Html.DiscretePlot.prototype.cm_displaypointcoordinates=function(){
var cm_compositeobject=this.cm_getThis("cm_compositeobject");
var cm_components=cm_compositeobject.cm_getComponents();
var cm_componentslength=cm_components.length;
var returnarray=new Array();
for(var i=0;i<cm_componentslength;i++){
returnarray[i]=cm_components[i].cm_coordinates();}
return returnarray.join();};
CaluMath.Html.DiscretePlot.prototype.cm_analyzeclick=function(){
var args0=arguments[0];
var args1=arguments[1];
var cm_compositeobject=this.cm_getThis("cm_compositeobject");
var cm_clickcoordinatesarray=this.cm_getThis("cm_clickcoordinatesarray");
var components=cm_compositeobject.cm_getComponents();
var componentslength=components.length;
for(var i=0;i<componentslength;i++){
var componentsi=components[i];
var tempreturn=componentsi.cm_analyzeclick(args0,args1);
if(componentsi.cm_getClickSuccess()=="yes"){
var thispoint=componentsi;
var returnthis=tempreturn;}
this.cm_setThis("cm_draggedpoint",null);}
if(returnthis!=null){
this.cm_setThis("cm_draggedpoint",thispoint);
this.cm_setThis("cm_clicksuccess","yes");
var tempcoordinates=[thispoint.cm_getXCoordinate(),thispoint.cm_getYCoordinate()];
cm_clickcoordinatesarray.push(tempcoordinates);
return returnthis;}
else{
this.cm_setThis("cm_clicksuccess","no");
return "cm_fail";}};
CaluMath.Html.DiscretePlot.prototype.cm_redraw=function(){
var cm_compositeobject=this.cm_getThis("cm_compositeobject");
var cm_hidden=this.cm_getThis("cm_hidden");
cm_compositeobject.cm_redraw();
if(cm_hidden=="yes"){
this.hide();}
return this;};
CaluMath.Html.DiscretePlot.prototype.remove=function(){
var cm_compositeobject=this.cm_getThis("cm_compositeobject");
var cm_plot=this.cm_getThis("cm_plot");
cm_compositeobject.remove();
this.cm_removeequationmethod();
this.cm_removeoptionmethod();
if(cm_plot.cm_childarray!=null){
cm_plot.cm_deleteFromChildArray(this);}};
CaluMath.Html.DiscretePlot.prototype.hide=function(){
var cm_compositeobject=this.cm_getThis("cm_compositeobject");
var cm_equationcontainernode=this.cm_getThis("cm_equationcontainernode");
var cm_components=cm_compositeobject.cm_getComponents();
if(cm_components!=null){
var cm_componentslength=cm_components.length;
for(var i=0;i<cm_componentslength;i++){
if(cm_components[i]!=null&&cm_components[i].hide!=null){
cm_components[i].hide();}}}
if(cm_equationcontainernode!=null){
cm_equationcontainernode.style.display="none";}
this.cm_setThis("cm_hidden","yes");
if(arguments[0]=="yes"){
var children=this.cm_getThis("cm_childarray");
if(children!=null){
var childrenlength=children.length;
for(var i=0;i<childrenlength;i++){
if(children[i]!=null&&children[i].hide!=null){
children[i].hide("yes");}}}}
return this;};
CaluMath.Html.DiscretePlot.prototype.unhide=function(){
var cm_compositeobject=this.cm_getThis("cm_compositeobject");
var cm_equationcontainernode=this.cm_getThis("cm_equationcontainernode");
var cm_components=cm_compositeobject.cm_getComponents();
if(cm_components!=null){
var cm_componentslength=cm_components.length;
for(var i=0;i<cm_componentslength;i++){
if(cm_components[i]!=null&&cm_components[i].unhide!=null){
cm_components[i].unhide();}}}
if(cm_equationcontainernode!=null){
cm_equationcontainernode.style.display="";}
this.cm_setThis("cm_hidden",null);
if(arguments[0]=="yes"){
var children=this.cm_getThis("cm_childarray");
if(children!=null){
var childrenlength=children.length;
for(var i=0;i<childrenlength;i++){
if(children[i]!=null&&children[i].unhide!=null){
children[i].unhide("yes");}}}}
return this;};
CaluMath.Html.DiscretePlot.prototype.cm_coordinates=function(){
var cm_pointsarray=this.cm_getThis("cm_pointsarray");
var cm_pointsarraylength=cm_pointsarray.length;
var cm_plot=this.cm_getThis("cm_plot");
var cm_xprecision=this.cm_getThis("cm_xprecision");
var cm_yprecision=this.cm_getThis("cm_yprecision");
var cm_plot=this.cm_getThis("cm_plot");
var cm_pixelsperx=cm_plot.cm_getPixelsPerX();
var cm_pixelspery=cm_plot.cm_getPixelsPerY();
if(arguments[1]!=null){
this.cm_splitobjectproperties(arguments[1]);}
var temppoint=arguments[0];
var temppointx=temppoint[0].cm_evalmath();
var temppointy=temppoint[1].cm_evalmath();
var xtolerance=cm_xprecision;
var ytolerance=cm_yprecision;
pointcoordinatesloop:
for(var i=0;i<cm_pointsarraylength;i++){
if(Math.abs(temppointx-cm_pointsarray[i][0].cm_evalmath())<=xtolerance&&Math.abs(temppointy-cm_pointsarray[i][1].cm_evalmath())<=ytolerance){
var tempreturn=[CaluMath.Html.Round(cm_pointsarray[i][0].cm_evalmath(),cm_xprecision),CaluMath.Html.Round(cm_pointsarray[i][1].cm_evalmath(),cm_yprecision)];
break pointcoordinatesloop;}}
if(tempreturn==null){
var tempreturn=this.cm_getThis("cm_notongraphmessage");}
return tempreturn;};
CaluMath.Html.DiscretePlot.prototype.cm_highlight=function(){
var pointinput=arguments[0];
var pointinputx=pointinput[0];
var pointinputy=pointinput[1];
var optionsforhighlight=arguments[1];
var cm_plot=this.cm_getThis("cm_plot");
var name=this.cm_getThis("name");
var cm_xstart=cm_plot.cm_getXStart();
var cm_xfinish=cm_plot.cm_getXFinish();
var cm_ystart=cm_plot.cm_getYStart();
var cm_yfinish=cm_plot.cm_getYFinish();
if(pointinputx<cm_xstart||pointinputx>cm_xfinish||pointinputy>cm_yfinish||pointinputy<cm_ystart){
return alert("The value ("+pointinput+") is outside the scope of this graph!");}
else{
var matchedpoint=this.cm_coordinates(pointinput);
if(matchedpoint.cm_constructorname!="String"){
if(arguments.length==1){
var cm_pointplot=cm_plot.cm_pointplot(matchedpoint,"parent="+name+",cm_option=no,cm_objecttype=CM_HighlightPlot");}
else{
var cm_pointplot=cm_plot.cm_pointplot(matchedpoint,"parent="+name+",cm_option=no,cm_objecttype=CM_HighlightPlot,"+optionsforhighlight);}
return cm_pointplot;}}};
CaluMath.Html.DiscretePlot.prototype.cm_translateby=function(){
var args0=arguments[0];
var args1=arguments[1];
var args2=arguments[2];
if(this.cm_plot.cm_delay=="yes"){
var tempthis=this;
if(args2==null){
return cm_onloadarray[cm_onloadarray.length]=function(){
return tempthis.cm_translateby([args0,args1]);}}
else{
return cm_onloadarray[cm_onloadarray.length]=function(){
return tempthis.cm_translateby([args0,args1],args2);};}}
var x=args0.cm_evalmath();
var y=args1.cm_evalmath();
var cm_pointsarray=this.cm_getThis("cm_pointsarray");
var cm_pointsarraylength=cm_pointsarray.length;
var cm_compositeobject=this.cm_getThis("cm_compositeobject");
var cm_components=cm_compositeobject.cm_getComponents();
var cm_componentslength=cm_components.length;
var cm_dragpointsindividually=this.cm_getThis("cm_dragpointsindividually");
var name=this.cm_getThis("name");
if(cm_dragpointsindividually!="yes"){
for(var i=0;i<cm_pointsarraylength;i++){
cm_components[i].cm_translateby(x,y);
cm_pointsarray[i][0]=cm_components[i].cm_xcoordinate;
cm_pointsarray[i][1]=cm_components[i].cm_ycoordinate;}
var updatedfunction=cm_pointsarray.cm_parsediscretefunction(name,null,"x");}
else{
for(var i=0;i<cm_componentslength;i++){
if(this.cm_getThis("cm_draggedpoint")==cm_components[i]){
cm_components[i].cm_translateby(x,y);
cm_pointsarray[i][0]=cm_components[i].cm_xcoordinate;
cm_pointsarray[i][1]=cm_components[i].cm_ycoordinate;}}
var updatedfunction=cm_pointsarray.cm_parsediscretefunction(name,null,"x");}
this.cm_setThis("cm_map",updatedfunction.cm_getMap());
this.cm_changedisplayequation();};
CaluMath.Html.DiscretePlot.prototype.cm_postscript=function(){
return[];};
