
CaluMath.Html=function(){};
CaluMath.Html.RedefineMaxAndMin=function(){
if(!isFinite(Math.min(3))){alert("We will re-adjust Math.min and Math.max for your browser");
Math.cm_oldmin=Math.min;
Math.min=function(){
if(arguments.length==1){
return arguments[0];}
else{
var args=CaluMath.Html.ArgumentsToArray(arguments);
return Math.cm_oldmin.apply(null,args);}};
Math.cm_oldmax=Math.max;
Math.max=function(){
if(arguments.length==1){
return arguments[0];}
else{
var args=CaluMath.Html.ArgumentsToArray(arguments);
return Math.cm_oldmax.apply(null,args);}};}};
CaluMath.Html.RedefineMaxAndMin();
CaluMath.Html.ReturnFalse=function(){
return false;};
CaluMath.Html.LOG=function(x){
return Math.LOG10E*Math.log(x);};
CaluMath.Html.SimpleEval=function(){
var input=arguments[0];
if(input.cm_constructorname!="String"){
return input;}
else{
if(input.match(/\</)!=null||input.match(/\>/)!=null){
var errormessage="You are evaluating an expression that contains a < symbol or a > symbol. This is causing an error.";
alert(errormessage);
throw new Error(errormessage);}
else{
return eval(input);}}};
CaluMath.Html.RoundString=function(){
var num=arguments[0];
var cm_precision=arguments[1];
var cm_sciprecision=arguments[2];
if(num==null){alert("Passed an undefined value in CM_Roundstring");
return "";}
else if(cm_precision=="String"){
return numberstring;}
else{
if(num.cm_constructorname=="Number"){
if(isNaN(num)){
return "";}
else{
num=num;}}
else if(num.cm_constructorname=="String"){
if(num.match(/\S/)==null){
return "";}
else{
try{
var num=CaluMath.Html.SimpleEval(CaluMath.Html.ParseMath(num));}
catch(e){
cm_catch(e,"CaluMath.Html.RoundString",arguments,"The first argument should be either a Number or a String that is a valid mathematical expression.");}}}
else{
var errormessage="In CaluMath.Html.RoundString your input was not a Number or String. It was "+num;
alert(errormessage);
throw new Error(errormessage);}}
if(cm_precision==null){
cm_precision=CaluMath.Html.RoundString.cm_precision;}
else{
cm_precision=Math.min(14,Math.max(0,cm_precision));}
if(cm_sciprecision==null){
cm_sciprecision=Math.floor(cm_precision);}
else{
cm_sciprecision=Math.min(14,Math.max(0,cm_sciprecision));}
if(num.toString().match("e")){
return num.toExponential(cm_sciprecision).replace(/0*e/,"e").replace(/\.e/,"e");}
else{
if(cm_precision==.5){
return CaluMath.Html.Round(num,.5).toString();}
else if(cm_precision==.25){
return CaluMath.Html.Round(num,.25).toString();}
numstring=num.toFixed(cm_precision);
if(numstring.match(/\./)){
return numstring.replace(/0*$/,"").replace(/\.$/,"");}
else{
return numstring;}}};
CaluMath.Html.Round=function(){
var num=arguments[0];
var cm_precision=arguments[1];
var cm_sciprecision=arguments[2];
try{
if(num!=null&&num.cm_constructorname=="Array"){
var temparray=num;
var temparraylength=temparray.length;
var returnarray=new Array();
var Round=CaluMath.Html.Round;
for(var i=0;i<temparraylength;i++){
returnarray[i]=Round(temparray[i],cm_precision,cm_sciprecision);}
return returnarray;}
else if(num==null){
return;}
else if(num.cm_constructorname=="String"){
if(num.match(/\S/)==null){
return;}
else{
num=num.cm_evalmath();}
if(!isFinite(num)){
return;}}
if(cm_precision==null){
var cm_precision=0;}
else if(cm_precision==.5){
if(num<0){
return -1*CaluMath.Html.Round(-1*num,.5);}
var num=1*num;
var digitpart=num%1;
if(digitpart<.25){
return Math.floor(num);}
else if(digitpart<.75){
return Math.floor(num)+.5;}
else{
return Math.round(num);}}
else if(cm_precision==.25){
if(num<0){
return -1*CaluMath.Html.Round(-1*num,.25);}
var num=1*num;
var digitpart=num%1;
if(digitpart<.125){
return Math.floor(num);}
else if(digitpart<.375){
return Math.floor(num)+.25;}
else if(digitpart<.625){
return Math.floor(num)+.5;}
else if(digitpart<.875){
return Math.floor(num)+.75;}
else{
return Math.round(num);}}
else{
var cm_precision=Math.max(0,1*cm_precision);}
if(num.cm_constructorname=="Array"){
var tempreturn=new Array();
var numarraylength=num.length;
for(var ii=0;ii<numarraylength;ii++){
tempreturn=tempreturn.concat(CaluMath.Html.Round(num[ii],cm_precision,cm_sciprecision));}
return tempreturn;}
if(Math.abs(num)<.5*Math.pow(.1,cm_precision+1)){
return 0;}
if(cm_precision<21&&Math.abs(num)<Math.pow(10,21)&&num.toFixed!=null){
if(cm_precision==0){
return Math.round(num);}
else{
return 1*(num.toFixed(cm_precision));}}
else{
if(arguments.length==3){
var tempreturn=1*(CaluMath.Html.RoundString(num,cm_precision,cm_sciprecision));}
else{
var tempreturn=1*(CaluMath.Html.RoundString(num,cm_precision,CaluMath.Html.Round.cm_sciprecision));}
if(Math.abs(tempreturn)<.5*Math.pow(.1,cm_precision+1)){
return 0;}
else{
return tempreturn;}}}
catch(e){
cm_catch(e,"CaluMath.Html.Round",arguments,"If your input is a String it must be a valid mathematical expression.");}};
CaluMath.Html.RoundString.cm_precision=10;
CaluMath.Html.Round.cm_sciprecision=5;
CaluMath.Html.ConvertToScientific=function(){
var numberinput=arguments[0];
var power=arguments[1];
var cm_precision=arguments[2];
try{
var num=CaluMath.Html.SimpleEval(numberinput);
if(num==0){
return "0";}
var power=Math.round(power);
if(power>20){
power=20;}
else if(power<-20){
power=-20;}
var cm_precision=1*(cm_precision);
if(numberinput<0){
return "-"+CaluMath.Html.ConvertToScientific(-1*numberinput,power,cm_precision);}
if(power>=0){
if(num<Math.pow(10,power)){
num=num.toFixed(Math.max(0,Math.min(cm_precision-power,20)));}
else{
num=num.toExponential(Math.min(20,Math.abs(cm_precision)));}}
else{
if(num<Math.pow(10,power)){
num=num.toExponential(Math.min(20,Math.abs(cm_precision)));}
else{
num=num.toFixed(Math.max(0,Math.min(cm_precision-power+1,20)));}}
if(num.match(/\./)){
if(num.match(/e/)){
return num.replace(/\.0*$/,"").replace(/0*e/,"e").replace(/\.e/,"e");}
else{
return num.replace(/0*$/,"").replace(/\.$/,"");}}
else{
return num;}}
catch(e){
cm_catch(e,"CaluMath.Html.ConvertToScientific",arguments);}};
CaluMath.Html.Max=function(){
if(arguments.length==1&&arguments[0].cm_constructorname=="Array"){
var args=arguments[0];}
else{
args=arguments;}
var max=CaluMath.Html.EvalMath(args[0]);
var argslength=args.length;
for(var i=0;i<argslength;i++){
var potentialmax=CaluMath.Html.EvalMath(args[i]);
if(potentialmax>max){
max=potentialmax;}}
return max;};
CaluMath.Html.Min=function(){
if(arguments.length==1&&arguments[0].cm_constructorname=="Array"){
var args=arguments[0];}
else{
args=arguments;}
var min=CaluMath.Html.EvalMath(args[0]);
var argslength=args.length;
for(var i=0;i<argslength;i++){
var potentialmin=CaluMath.Html.EvalMath(args[i]);
if(potentialmin<CaluMath.Html.EvalMath(min)){
min=potentialmin;}}
return min;};
CaluMath.Html.UnevaluateVersion=function(){
var fun=arguments[0];
var obj=arguments[1];
var args=arguments[2];
var tempreturn=function(){
return fun.apply(obj,args);};
if(obj==null){
arg2=fun.cm_name+CaluMath.Html.ArgumentsToArray(args).cm_arraytostring();
tempreturn.cm_stringversion=arg2;}
else{
if(obj.constructor==String){
arg2="'"+obj.toString().replace(/'/g,"\\\'")+"'."+fun.cm_name+CaluMath.Html.ArgumentsToArray(args).cm_arraytostring();
tempreturn.cm_stringversion=arg2;}}
return tempreturn;};
CaluMath.Html.Display=function(){
var args0=arguments[0];
try{
if(args0==null){
return "";}
else if(args0.cm_constructorname!="Array"){
return args0.toString();}
else if(args0.cm_constructorname=="Array"&&args0.length==0){
return "[ ]";}
else{
var tempreturn="[ ";
var args0lengthm1=args0.length-1;
for(var i=0;i<args0lengthm1;i++){
tempreturn=tempreturn+CaluMath.Html.Display(args0[i])+",";}
tempreturn=tempreturn+CaluMath.Html.Display(args0[args0lengthm1])+" ]";
return tempreturn;}}
catch(e){
cm_catch(e,"CaluMath.Html.Display",arguments);}};
CaluMath.Html.Display=function(){
var args0=arguments[0];
try{
if(args0==null){
return "";}
else if(args0.cm_constructorname!="Array"){
return ""+args0;}
else if(args0.cm_constructorname=="Array"&&args0.length==0){
return "[ ]";}
else{
var tempreturn=new Array();
var args0length=args0.length;
for(var i=0;i<args0length;i++){
tempreturn[i]=CaluMath.Html.Display(args0[i]);}
tempreturn="["+tempreturn.join()+"]";
return tempreturn;}}
catch(e){
cm_catch(e,"CaluMath.Html.Display",arguments);}};
CaluMath.Html.ArgumentsToArray=function(arg){
return Array.prototype.slice.apply(arguments[0],[0]);};
CaluMath.Html.AbsoluteValue=function(){
return Math.abs(arguments[0]);};
CaluMath.Html.ParseMath=function(){
try{
var args0=arguments[0];
if(arguments[0]==null){
return;}
else if(args0.cm_constructorname=="Number"){
return args0.toString();}
else if(args0.cm_constructorname=="String"){
return args0.cm_parsemath();}
else if(args0.cm_constructorname=="Array"){
return args0.cm_parsemath();}}
catch(e){
cm_catch(e,"CaluMath.Html.ParseMath",arguments);}};
CaluMath.Html.EvalMath=function(){
try{
var tempreturn=eval(eval(CaluMath.Html.ParseMath(arguments[0])));
if(tempreturn!=null&&tempreturn.cm_constructorname=="Array"){
return tempreturn.cm_evalmath();}
if(!isNaN(tempreturn)){
if(tempreturn!=Infinity&&tempreturn!=-Infinity){
return tempreturn;}
else{
return undefined;}}
else{
return undefined;}}
catch(e){
return undefined;}};
CaluMath.Html.IsEvalMathDoNotUse=function(){
var tempstring=arguments[0];
if(tempstring==null){
return "no";}
else{
try{
tempeval=CaluMath.Html.SimpleEval(CaluMath.Html.ParseMath(tempstring));
if(tempeval.cm_constructorname=="Number"){
return "yes";}
else{
return "no";}}
catch(e){
return "no";}}};
CaluMath.Html.IsEvalMath=function(){
try{
var tempreturn=CaluMath.Html.EvalMath(arguments[0]);
if(tempreturn!=null&&tempreturn.cm_constructorname=="Number"){
return "yes";}
else{
return "no";}}
catch(e){
cm_catch(e,"CaluMath.Html.IsEvalMath",arguments);}};
CaluMath.Html.IsArrayOfMath=function(){
var args0=arguments[0];
var IsEvalMath=CaluMath.Html.IsEvalMath;
if(arguments[0].cm_constructorname=="String"){
if(args0.match(/\s*\[/)==null&&args0.match(/\,/)==null){
try{
var tempevaluated=eval(args0);}
catch(e){
return "no";}
return CaluMath.Html.IsArrayOfMath(tempevaluated);}
else{
var temparray=args0.replace(/^\s*\[/,"").replace(/\]\s*$/,"").split(",");}}
else if(arguments[0].cm_constructorname=="Array"){
var temparray=arguments[0];}
else{
alert(["In Global.js file, you passed "+arguments[0]+" to CaluMath.Html.IsArrayOfMath however it it not an array or a String"]);
return "no";}
if(temparray==null){
return "no";}
else{
var temparraylength=temparray.length;
for(var j=0;j<temparraylength;j++){
try{
tempeval=IsEvalMath(temparray[j]);
if(tempeval!="yes"){
return "no";}}
catch(e){
return "no";}}}
return "yes";};
CaluMath.Html.IsParseFunction=function(){
try{
if(arguments[0]==null){
return "no";}
else{
var tempinput=arguments[0];
if(tempinput.cm_constructorname!="String"){
return "no";}
else{
if(arguments.length==1){
var tempreturn=tempinput.cm_parsefunction();}
else{
var tempreturn=tempinput.cm_parsefunction(arguments[1]);}}}
if(tempreturn!=null&&tempreturn!="cm_fail"){
return "yes";}
else{
return "no";}}
catch(e){
return "no";}};
CaluMath.Html.RandomInteger=function(){
var a=arguments[0];
var b=arguments[1];
try{
var a1=Math.min(a,b);
var b=Math.max(a,b);
a=Math.ceil(a1);
b=Math.floor(b);
if(a>b){
return Math.floor(b+(a+1-b)*Math.random());};
return Math.floor(a+(b+1-a)*Math.random());}
catch(e){
cm_catch(e,"CaluMath.Html.RandomInteger",arguments);}};
CaluMath.Html.RandomNumber=function(){
var a=arguments[0];
var b=arguments[1];
try{
var a1=Math.min(a,b);
var b=Math.max(a,b);
return a1+(b-a1)*Math.random();}
catch(e){
cm_catch(e,"CaluMath.Html.RandomNumber",arguments);}};
CaluMath.Html.NonZeroRandomInteger=function(){
var a=arguments[0];
var b=arguments[1];
try{
var a1=Math.min(a,b);
var b=Math.max(a,b);
a1=Math.ceil(a1);
b=Math.floor(b);
if(a1>b){
return CaluMath.Html.NonZeroRandomInteger(b,a1);}
else if(b==0&&a1==0){
var errormessage="You are asking for a nonzero random integer between 0 and 0 in CaluMath.Html.NonZeroRandomInteger. This is causing an error."
alert(errormessage);
throw new Error(errormessage);}
else{
var tempreturn=Math.floor(a1+(b+1-a1)*Math.random());
if(tempreturn!=0){
return tempreturn;}
else{
return CaluMath.Html.NonZeroRandomInteger(a1,b);}}}
catch(e){
cm_catch(e,"CaluMath.Html.NonZeroRandomInteger",arguments);}};
CaluMath.Html.NonZeroRandomNumber=function(){
var a=arguments[0];
var b=arguments[1];
try{
var a1=Math.min(a,b);
var b=Math.max(a,b);
if(b==0&&a1==0){
var errormessage="You are asking for a nonzero random integer between 0 and 0 in CaluMath.Html.NonZeroRandomNumber. This is causing an error."
alert(errormessage);
throw new Error(errormessage);}
else{
var tempcaslocalvariable=a1+(b-a1)*Math.random();
if(tempcaslocalvariable!=0){
return tempcaslocalvariable;}
else{
return CaluMath.Html.NonZeroRandomNumber(a1,b);}}}
catch(e){
cm_catch(e,"CaluMath.Html.NonZeroRandomNumber",arguments);}};
CaluMath.Html.RandomArray=function(){
var length=arguments[0];
var a=arguments[1];
var b=arguments[2];
var type=arguments[3];
var distinct=arguments[4];
var precision=arguments[5];
var randomfunction=CaluMath.Html[type];
if(type.match(/Number/)){
if(precision==0){
var newtype=type.replace(/Number/,"Integer");
return CaluMath.Html.RandomArray(length,a,b,newtype,distinct);}
else if(precision==null){
precision=8;}}
if(distinct=="yes"){
if(type.match(/Integer/)){
if(!type.match(/NonZero/)){
var availableintegers=1+Math.abs(b-a);}
else{
if(a*b<=0){
var availableintegers=Math.abs(b-a);}
else{
var availableintegers=1+Math.abs(b-a);}}
if(length>availableintegers){
return alert("You are trying to define an array of length "+length+" consisting of distinct integer (or nonzero integer) entries between "+a+" and "+b+". This is not possible.");}}}
try{
if(type.match(/Integer/)){
if(Math.abs(b-a)>1.4*length||distinct!="yes"){
var returnarray=new Array();
while(returnarray.length<length){
var newentry=randomfunction(a,b);
if(distinct=="yes"){
var alreadycontainedintemparray=returnarray.cm_contains(newentry);
if(alreadycontainedintemparray===false){
returnarray.push(newentry);}}
else{
returnarray.push(newentry);}}
return returnarray;}
else{
var possiblearray=new Array();
if(a>b){
var a1=b;
b=a;
a=a1;}
if(!type.match(/NonZero/)){
var bminusa=b-a;
for(var i=0;i<=bminusa;i++){
possiblearray[i]=a+i;}}
else{
if(a==0){
for(var i=1;i<=b;i++){
possiblearray[i-1]=i;}}
else if(b==0){
for(var i=-1;i>=a;i--){
possiblearray[-i-1]=i;}}
else if(a<0&&b>0){
for(var i=-1;i>=a;i--){
possiblearray[-i-1]=i;}
var possiblearraylength=possiblearray.length;
for(var i=1;i<=b;i++){
possiblearray[possiblearraylength+i-1]=i;}}}
var randomfunction=CaluMath.Html.RandomInteger;
var returnarray=new Array();
while(returnarray.length<length){
var newindex=randomfunction(0,possiblearray.length-1);
returnarray.push(possiblearray[newindex]);
possiblearray.splice(newindex,1);}
return returnarray;}}
else{
var returnarray=new Array();
var RoundFunction=CaluMath.Html.Round;
var iterationcounter=0;
var maximuminterations=length*100;
if(type.match(/NonZero/)){
while(returnarray.length<length){
var newentry=RoundFunction(randomfunction(a,b),precision);
if(newentry!=0){
if(distinct=="yes"){
var alreadycontainedintemparray=returnarray.cm_contains(newentry);
if(alreadycontainedintemparray===false){
returnarray.push(newentry);}}
else{
returnarray.push(newentry);}
iterationcounter++;
if(iterationcounter>maximuminterations){
return alert("There is a problem with returning an Array of length "+length+" of (possibly distinct) random numbers between "+a+" and "+b+" rounded to "+precision+" decimal places. Please check your input again.");}}}}
else{
while(returnarray.length<length){
var newentry=RoundFunction(randomfunction(a,b),precision);
if(distinct=="yes"){
var alreadycontainedintemparray=returnarray.cm_contains(newentry);
if(alreadycontainedintemparray===false){
returnarray.push(newentry);}}
else{
returnarray.push(newentry);}
iterationcounter++;
if(iterationcounter>maximuminterations){
return alert("There is a problem with returning an Array of length "+length+" of (possibly distinct) random numbers between "+a+" and "+b+" rounded to "+precision+" decimal places. Please check your input again.");}}}
return returnarray;}}
catch(e){
cm_catch(e,"CaluMath.Html.RandomArray",arguments);}};
CaluMath.Html.ArraySortFunction=function(a,b){
if(1*a<1*b){
return -1;}
else if(1*a>1*b){
return 1;}
else{
return 0;}};
CaluMath.Html.ArraySortFunctionDescending=function(a,b){
if(1*a<1*b){
return 1;}
else if(1*a>1*b){
return -1;}
else{
return 0;}};
CaluMath.Html.SequentialArray=function(){
var start=arguments[0];
var end=arguments[1];
var returnarray=new Array();
if(start<end){
for(var i=start;i<=end;i++){
returnarray.push(i);}}
else{
for(var i=start;i<=end;i--){
returnarray.push(i);}}
return returnarray;};
CaluMath.Html.SequentialNonZeroArray=function(){
var returnarray=CaluMath.Html.SequentialArray(arguments[0],arguments[1]);
return returnarray.cm_delete(0);};
CaluMath.Html.MakeArrayOfPoints=function(){
var firstarray=arguments[0];
var secondarray=arguments[1];
var firstarraylength=firstarray.length;
if(firstarraylength!=secondarray.length){
return alert("You are invoking MakeArrayOfPoints, however your arguments are arrays of different lengths. This is not allowed.");}
returnarray=new Array();
for(var i=0;i<firstarraylength;i++){
returnarray.push([firstarray[i],secondarray[i]]);}
return returnarray;};
CaluMath.Html.ZoomInOnAllAxes=function(){
var scalefactor=arguments[0];
if(scalefactor==null){
scalefactor=.8;}
var plotarray=CaluMath.Html.PlotArray;
if(plotarray!=null){
var plotarraylength=plotarray.length;
for(var i=0;i<plotarraylength;i++){
window[plotarray[i]].cm_rescaleaxes("same/"+scalefactor+"","same/"+scalefactor+"","same","same","same","same","same","same");}}};
CaluMath.Html.ZoomOutOnAllAxes=function(){
var scalefactor=arguments[0];
if(scalefactor==null){
scalefactor=.8;}
var plotarray=CaluMath.Html.PlotArray;
if(plotarray!=null){
var plotarraylength=plotarray.length;
for(var i=0;i<plotarraylength;i++){
window[plotarray[i]].cm_rescaleaxes(""+scalefactor+"*same",""+scalefactor+"*same","same","same","same","same","same","same");}}};
CaluMath.Html.IsEmptyString=function(){
try{
var input=' '+arguments[0];
if(input.match(/\S/)!=null){
return "no";}
else{
return "yes";}}
catch(e){
cm_catch(e,"CaluMath.Html.IsEmptyString",arguments);}};
CaluMath.Html.Distance=function(){
if(arguments.length==1){
if(arguments[0].cm_constructorname=="Array"){
var x=arguments[0][0];
var y=arguments[0][1];}
else if(arguments[0].cm_xcoordinate!=null){
var x=arguments[0].cm_xcoordinate;
var y=arguments[0].cm_ycoordinate;}
return Math.pow(Math.pow(x,2)+Math.pow(y,2),1/2);}
else{
if(arguments[0].cm_constructorname=="Array"){
var x0=arguments[0][0];
var y0=arguments[0][1];}
else if(arguments[0].cm_xcoordinate!=null){
var x0=arguments[0].cm_xcoordinate;
var y0=arguments[0].cm_ycoordinate;}
if(arguments[1].cm_constructorname=="Array"){
var x1=arguments[1][0];
var y1=arguments[1][0];}
else if(arguments[1].cm_xcoordinate!=null){
var x1=arguments[1].cm_xcoordinate;
var y1=arguments[1].cm_ycoordinate;}
return Math.pow(Math.pow(x1-x0,2)+Math.pow(y1-y0,2),1/2);}};
CaluMath.Html.Factorial=function(){
if(arguments.length!=1){
var errormessage="You must enter a nonnegative integer when calling the factorial function. You entered "+numberinput+".";
alert(errormessage);
throw new Error(errormessage);}
var numberinput=arguments[0].cm_evalmath();
if(numberinput==0){
return 1;}
else if(numberinput%1!=0||numberinput<0){
var errormessage="You must enter a nonnegative integer when calling the factorial function. You entered "+numberinput+".";
alert(errormessage);
throw new Error(errormessage);}
else{
return numberinput*CaluMath.Html.Factorial(numberinput-1);}};
CaluMath.Html.Alert=function(){
return alert(arguments[0]);};
CaluMath.Html.ColorArray=[["aliceblue","#F0F8FF"],["antiquewhite","#FAEBD7"],["aqua","#00FFFF"],["aquamarine","#7FFFD4"],["azure","#F0FFFF"],["bisque","#FFE4C4"],["black","#000000"],["blanchedalmond","#FFEBCD"],["blue","#0000FF"],["blueviolet","#8A2BE2"],["brown","#A52A2A"],["burlywood","#DEB887"],["cadetblue","#5F9EA0"],["chartreuse","#7FFF00"],["chocolate","#D2691E"],["coral","#FF7F50"],["cornflowerblue","#6495ED"],["cornsilk","#FFF8DC"],["crimson","#DC143C"],["cyan","#00FFFF"],["darkblue","#00008B"],["darkcyan","#008B8B"],["darkgoldenrod","#B8860B"],["darkgray","#A9A9A9"],["darkgreen","#006400"],["darkkhaki","#BDB76B"],["darkmagenta","#8B008B"],["darkolivegreen","#556B2F"],["darkorange","#FF8C00"],["darkorchid","#9932CC"],["darkred","#8B0000"],["darksalmon","#E9967A"],["darkseagreen","#8FBC8F"],["darkslateblue","#483D8B"],["darkslategray","#2F4F4F"],["darkturquoise","#00CED1"],["darkviolet","#9400D3"],["deeppink","#FF1493"],["deepskyblue","#00BFFF"],["dimgray","#696969"],["dodgerblue","#1E90FF"],["firebrick","#B22222"],["floralwhite","#FFFAF0"],["forestgreen","#228B22"],["fuchsia","#FF00FF"],["gainsboro","#DCDCDC"],["ghostwhite","#F8F8FF"],["gold","#FFD700"],["goldenrod","#DAA520"],["gray","#808080"],["green","#008000"],["greenyellow","#ADFF2F"],["honeydew","#F0FFF0"],["hotpink","#FF69B4"],["indianred","#CD5C5C"],["indigo","#4B0082"],["ivory","#FFFFF0"],["khaki","#F0E68C"],["lavender","#E6E6FA"],["lavenderblush","#FFF0F5"],["lawngreen","#7CFC00"],["lemonchiffon","#FFFACD"],["lightblue","#ADD8E6"],["lightcoral","#F08080"],["lightcyan","#E0FFFF"],["lightgoldenrodyellow","#FAFAD2"],["lightgreen","#90EE90"],["lightgrey","#D3D3D3"],["lightpink","#FFB6C1"],["lightsalmon","#FFA07A"],["lightseagreen","#20B2AA"],["lightskyblue","#87CEFA"],["lightslategray","#778899"],["lightsteelblue","#B0C4DE"],["lightyellow","#FFFFE0"],["lime","#00FF00"],["lime","#00FF00"],["limegreen","#32CD32"],["linen","#FAF0E6"],["magenta","#FF00FF"],["maroon","#800000"],["mediumaquamarine","#66CDAA"],["mediumblue","#0000CD"],["mediumorchid","#BA55D3"],["mediumpurple","#9370DB"],["mediumseagreen","#3CB371"],["mediumslateblue","#7B68EE"],["mediumspringgreen","#00FA9A"],["mediumturquoise","#48D1CC"],["mediumvioletred","#C71585"],["midnightblue","#191970"],["mintcream","#F5FFFA"],["mistyrose","#FFE4E1"],["moccasin","#FFE4B5"],["navajowhite","#FFDEAD"],["navy","#000080"],["oldlace","#FDF5E6"],["olive","#808000"],["olivedrab","#6B8E23"],["orange","#FFA500"],["orangered","#FF4500"],["orchid","#DA70D6"],["palegoldenrod","#EEE8AA"],["palegreen","#98FB98"],["paleturquoise","#AFEEEE"],["palevioletred","#DB7093"],["papayawhip","#FFEFD5"],["peachpuff","#FFDAB9"],["peru","#CD853F"],["pink","#FFC0CB"],["plum","#DDA0DD"],["powderblue","#B0E0E6"],["purple","#800080"],["red","#FF0000"],["rosybrown","#BC8F8F"],["royalblue","#4169E1"],["saddlebrown","#8B4513"],["salmon","#FA8072"],["sandybrown","#F4A460"],["seagreen","#2E8B57"],["seashell","#FFF5EE"],["sienna","#A0522D"],["silver","#C0C0C0"],["skyblue","#87CEEB"],["slateblue","#6A5ACD"],["slategray","#708090"],["snow","#FFFAFA"],["springgreen","#00FF7F"],["steelblue","#4682B4"],["tan","#D2B48C"],["teal","#008080"],["thistle","#D8BFD8"],["tomato","#FF6347"],["turquoise","#40E0D0"],["violet","#EE82EE"],["wheat","#F5DEB3"],["white","#FFFFFF"],["whitesmoke","#F5F5F5"],["yellow","#FFFF00"]];
CaluMath.Html.GetColorName=function(){
if(arguments[0].cm_constructorname!="String"){
return arguments[0];}
else{
if(arguments[0].match(/\#/)){
var tempmatch=arguments[0].replace(/\s*/g,"");
var tempCM_ColorArray=CaluMath.Html.ColorArray;
var tempCM_ColorArraylength=tempCM_ColorArray.length;
for(var i=0;i<tempCM_ColorArraylength;i++){
if(tempCM_ColorArray[i][1]==tempmatch){
return tempCM_ColorArray[i][0];}}
return tempmatch;}
else{
return arguments[0];}}};
CaluMath.Html.GetColorNumber=function(){
if(arguments[0].cm_constructorname!="String"){
return arguments[0];}
else{
if(!arguments[0].match(/\#/)){
var tempmatch=arguments[0].replace(/\s*/g,"").toLowerCase();
var tempCM_ColorArray=CaluMath.Html.ColorArray;
var tempCM_ColorArraylength=tempCM_ColorArray.length;
for(var i=0;i<tempCM_ColorArraylength;i++){
if(tempCM_ColorArray[i][0]==tempmatch){
return tempCM_ColorArray[i][1];}}
return tempmatch;}
else{
return arguments[0];}}};
CaluMath.Html.DisplayOwnObjectPairs=function(obj){
var mystring="";
for(var name in obj){
if(obj.hasOwnProperty(name)){
mystring=mystring+[name,obj[name]]+";  ";}}
alert(mystring);};
CaluMath.Html.ListOwnObjectPairs=function(obj){
var myarray=[];
for(var name in obj){
if(obj.hasOwnProperty(name)){
myarray=myarray.concat([[name,obj[name]]]);}}
return myarray;};
CaluMath.Html.ListObjectPairs=function(obj){
var myarray=[];
for(var name in obj){
myarray=myarray.concat([[name,obj[name]]]);}
return myarray;};
CaluMath.Html.ListObjectNames=function(obj){
var myarray=[];
for(var name in obj){
myarray=myarray.concat(name);}
return myarray;};
CaluMath.Html.DisplayObjectNames=CaluMath.Html.ListObjectNames;
CaluMath.Html.DisplayOwnObjectNames=CaluMath.Html.ListOwnObjectPairs;
CaluMath.Html.LoadModule=function(){
var modulename=arguments[0];
modulename=modulename.replace(/\.js$/i,"");
if(CaluMath.Html.Modules[modulename]==null){
var pElement=document.createElement("script");
pElement.src=CM_DotsToCaluMathFolder+"library/"+modulename+".js";
document.body.appendChild(pElement);
CaluMath.Html.Modules[modulename]="yes";}
return;};
CaluMath.Html.ContentDocument=function(){
var cm_node=arguments[0];
if(cm_node.contentDocument!=null){
cm_node.cm_contentDocument=cm_node.contentDocument;}
else if(cm_node.Document!=null){
cm_node.cm_contentDocument=cm_node.Document;}
if(cm_node.cm_contentDocument==null){
var tempiframelist=document.getElementsByTagName("iframe");
var tempiframelistlength=tempiframelist.length;
tempiframeloop:
for(var j=0;j<tempiframelistlength;j++){
if(tempiframelist[j]==cm_node){
cm_node.cm_contentDocument=frames[j].document;
break tempiframeloop;}}}
return cm_node.cm_contentDocument;};
CaluMath.Html.MatchTagWithIframe=function(iframeinput){
var iframelist=iframeinput.parent.document.getElementsByTagName("iframe");
var iframelength=iframelist.length;
if(iframeinput.document==null||(iframeinput.document.body==null&&iframeinput.document.getElementsByTagName("svg")[0]==null)){
return alert("Your input "+iframeinput+" in CaluMath.Html.MatchTagWithIframe does not seem to be a frame or window of the document");}
for(var i=0;i<iframelength;i++){
if(CaluMath.Html.ContentDocument(iframelist[i]).body!=null&&CaluMath.Html.ContentDocument(iframelist[i]).body==iframeinput.document.body){
return iframelist[i];}
if(CaluMath.Html.ContentDocument(iframelist[i]).getElementsByTagName("svg")[0]!=null&&CaluMath.Html.ContentDocument(iframelist[i]).getElementsByTagName("svg")[0]==iframeinput.document.getElementsByTagName("svg")[0]){
return iframelist[i];}}
return;};
CaluMath.Html.NewTempWindow=function(){
try{
CaluMath.Html.NewTempWindowObject.TempWindowCounter++;
var name="CM_Temp_Window "+CaluMath.Html.NewTempWindowObject.TempWindowCounter;
var writestring=arguments[0];
var cm_options=arguments[1];
var tempscreen=window.screen;
var newheight=Math.round(eval(CaluMath.Html.NewTempWindowObject.cm_heightfraction)*tempscreen.availHeight);
var newwidth=Math.round(eval(CaluMath.Html.NewTempWindowObject.cm_widthfraction)*tempscreen.availWidth);
if(cm_options==null){
var cm_center="yes";
var newheightstring="height="+newheight+"px";
var newwidthstring="width="+newwidth+"px";
window[name]=window.open("","",newheightstring+","+newwidthstring+","+"menubar=yes, scrollbars=yes, resizable=yes","");}
else if(cm_options.cm_constructorname=="String"){
CaluMath.Html.MakeTempObject(CaluMath.Html.NewTempWindow);
CaluMath.Html.NewTempWindow.cm_tempobject.cm_splitobjectproperties(cm_options);
var resizable=CaluMath.Html.NewTempWindow.cm_tempobject.resizable;
var scrollbars=CaluMath.Html.NewTempWindow.cm_tempobject.scrollbars;
var menubar=CaluMath.Html.NewTempWindow.cm_tempobject.menubar;
var cm_widthfraction=CaluMath.Html.NewTempWindow.cm_tempobject.cm_widthfraction;
var cm_heightfraction=CaluMath.Html.NewTempWindow.cm_tempobject.cm_heightfraction;
var cm_scripts=CaluMath.Html.NewTempWindow.cm_tempobject.cm_scripts;
var cm_checkbox=CaluMath.Html.NewTempWindow.cm_tempobject.cm_checkbox;
var parent=CaluMath.Html.NewTempWindow.cm_tempobject.parent;
var cm_center=CaluMath.Html.NewTempWindow.cm_tempobject.cm_center;
delete CaluMath.Html.NewTempWindow.cm_tempobject;
if(cm_center==null){
cm_center="yes";}
if(parent==null){
parent="window";}
if(resizable==null){
resizable=CaluMath.Html.NewTempWindowObject.resizable;}
if(scrollbars==null){
scrollbars=CaluMath.Html.NewTempWindowObject.scrollbars;}
if(menubar==null){
menubar=CaluMath.Html.NewTempWindowObject.menubar;menubar="yes";}
if(cm_widthfraction!=null){
newwidth=Math.round(eval(cm_widthfraction)*tempscreen.availWidth);
newwidthstring="width="+newwidth+"px";}
else{
newwidth=Math.round(eval(CaluMath.Html.NewTempWindowObject.cm_widthfraction)*tempscreen.availWidth);
newwidthstring="width="+newwidth+"px";}
if(cm_heightfraction!=null){
newheight=Math.round(eval(cm_heightfraction)*tempscreen.availHeight);
newheightstring="height="+newheight+"px";}
else{
newheight=Math.round(eval(CaluMath.Html.NewTempWindowObject.cm_heightfraction)*tempscreen.availHeight);
newheightstring="height="+newheight+"px";}
window[name]=window.open("","",newheightstring+","+newwidthstring+","+"menubar="+menubar+", scrollbars="+scrollbars+", resizable="+resizable,"");}
else{
var heighttemp=cm_options[2].cm_getpropertyvalue("height");
if(heighttemp[0]!=null){
newheight=parseInt(heighttemp[0]);}
var widthtemp=cm_options[2].cm_getpropertyvalue("width");
if(widthtemp[0]!=null){
newwidth=parseInt(widthtemp[0]);}
window[name]=window.open(cm_options[0],cm_options[1],cm_options[2],cm_options[3]);}
window[name+"Counter"]=0;
window[name].cm_newwindowwritefunction=function(){window[name+"Counter"]++;
if(window[name].document!=null){
if(cm_center!="no"){
window[name].moveTo((tempscreen.width-newwidth)/2, (tempscreen.height-newheight)/2);}
if(window[name].outerWidth!=null&&window[name].outerWidth<50){
setTimeout(function(){window[name].resizeTo(newwidth,newheight);},0);}
if(cm_scripts=="yes"){
var newwindowstring="<\!DOCTYPE html PUBLIC \"-\/\/W3C\/\/DTD HTML 4.01 Transitional\/\/EN\" \n\"http:\/\/www.w3.org\/TR\/html4\/loose.dtd\">\n<html>\n<head>\n<title> "+name+ " </title>\n<\/head>\n<body>\n<script type=\"text/javascript\" src=\"place_this_in_folder_with_web_pages.js\"></script>\n";}
else{
var newwindowstring="<\!DOCTYPE html PUBLIC \"-\/\/W3C\/\/DTD HTML 4.01 Transitional\/\/EN\" \n\"http:\/\/www.w3.org\/TR\/html4\/loose.dtd\">\n<html>\n<head>\n<title> "+name+ " </title>\n<\/head>\n<body>\n\n";}
newwindowstring=newwindowstring+'\n<\script type="text/javascript">Counter='+window[name+"Counter"]+'; nameinopener="'+name+'"; </\script>\n<p style="text-align:center">'+writestring+'</p>'
if(cm_checkbox=="yes"){
var tempwritestring='<br><p style="text-align:center"><input id="donotshowbox" type="checkbox"/>Do not show this window again.</p>\n<br>\n<p style="text-align:center"><input type="button" id="closebutton" value="Close" /></p>\n<script>CM_TempWindowCloseButton=document.getElementById("closebutton");   CM_TempWindowCloseFunction = function(){ if(document.getElementById("donotshowbox").checked==true){ eval("window.opener.'+parent+'").cm_instructionmessage="no"; }; window.close();}; CM_TempWindowCloseButton.onclick=function(){ if(document.getElementById("donotshowbox").checked==true){ eval("window.opener.'+parent+'").cm_instructionmessage="no"; }; window.close();};  for(var ii=0; ii<40; ii++){ setTimeout(\'if(!window.closed&&window.CM_TempWindowCloseButton!=null&&window.CM_TempWindowCloseFunction!=null&&CM_TempWindowCloseButton.onclick==null){CM_TempWindowCloseButton.onclick=CM_TempWindowCloseFunction;};\', 10*ii);};  </script>';}
else{
var tempwritestring='<br>\n<p style="text-align:center"><input type="button" id="closebutton" value="Close" /></p>\n<script type="text/javascript">CM_TempWindowCloseFunction = function(){window.close();};  CM_TempWindowCloseButton=document.getElementById("closebutton"); CM_TempWindowCloseButton.onclick=CM_TempWindowCloseFunction; for(var ii=0; ii<40; ii++){ setTimeout(\'if(!window.closed&&window.CM_TempWindowCloseButton!=null&&window.CM_TempWindowCloseFunction!=null&&CM_TempWindowCloseButton.onclick==null){CM_TempWindowCloseButton.onclick=CM_TempWindowCloseFunction;};\', 10*ii);}; </script>';}
newwindowstring=newwindowstring+tempwritestring+'\n</body>\n</html>';
window[name].document.write(newwindowstring);
window[name].document.close();}
else{
setTimeout("window[\""+name+"\"].cm_newwindowwritefunction()",50);}};
window[name].cm_newwindowwritefunction();
var tempclose=window.cm_onunloadarray;
var tempcloselength=tempclose.length;
window.cm_onunloadarray[tempcloselength]=function(){
if(window[name].closed==false){
window[name].close();}};
return window[name];}
catch(e){
cm_catch(e,"CaluMath.Html.NewTempWindow",arguments);}};
CaluMath.Html.NewTempWindowObject=new Object();
CaluMath.Html.NewTempWindowObject.resizable="yes";
CaluMath.Html.NewTempWindowObject.scrollbars="yes";
CaluMath.Html.NewTempWindowObject.menubar="yes";
CaluMath.Html.NewTempWindowObject.cm_widthfraction=Math.min(CaluMath.Html.Round(600/window.screen.availWidth,1),.7).toString();
CaluMath.Html.NewTempWindowObject.cm_heightfraction=Math.min(CaluMath.Html.Round(600/window.screen.availHeight,1),.7).toString();
CaluMath.Html.NewTempWindowObject.TempWindowCounter=0;
CaluMath.Html.Prompt=function(){
try{
var name="Prompt"+CaluMath.Html.PromptObject.PromptCounter;
CaluMath.Html.PromptObject.PromptCounter++;
if(arguments[1]!=null&&arguments[1].cm_constructorname=="String"){
var writestring=arguments[0];
var parentfullname=arguments[1];
var cm_coordinates=arguments[2];
var cm_functionarray=arguments[3];
if(arguments[4]!=null){
var cm_options=arguments[4];}}
else{
var writestring=arguments[0];
var parentfullname="window";
var cm_coordinates=arguments[1];
var cm_functionarray=arguments[2];
if(arguments[3]!=null){
var cm_options=arguments[3];}}
writestring=writestring.cm_javascript();
var tempscreen=window.screen;
var newheight=Math.max(CaluMath.Html.PromptObject.cm_minimumheight,Math.round(CaluMath.Html.PromptObject.cm_heightfraction*tempscreen.availHeight));
var newwidth=Math.max(CaluMath.Html.PromptObject.cm_minimumwidth,Math.round(CaluMath.Html.PromptObject.cm_widthfraction*tempscreen.availWidth));
if(cm_options==null){
var newheightstring="height="+newheight+"px";
var newwidthstring="width="+newwidth+"px";
window[name]=window.open("","",newheightstring+","+newwidthstring+","+"menubar=yes, scrollbars=yes, resizable=yes","");
var cm_ok="OK";
var cm_cancel="Cancel";}
else if(cm_options.cm_constructorname=="String"){
CaluMath.Html.MakeTempObject(CaluMath.Html.NewWindow);
CaluMath.Html.NewWindow.cm_tempobject.cm_splitobjectproperties(cm_options);
var resizable=CaluMath.Html.NewWindow.cm_tempobject.resizable;
var scrollbars=CaluMath.Html.NewWindow.cm_tempobject.scrollbars;
var menubar=CaluMath.Html.NewWindow.cm_tempobject.menubar;
var cm_widthfraction=CaluMath.Html.NewWindow.cm_tempobject.cm_widthfraction;
var cm_heightfraction=CaluMath.Html.NewWindow.cm_tempobject.cm_heightfraction;
var cm_ok=CaluMath.Html.NewWindow.cm_tempobject.cm_ok;
var cm_cancel=CaluMath.Html.NewWindow.cm_tempobject.cm_cancel;
delete CaluMath.Html.NewWindow.cm_tempobject;
if(resizable==null){
resizable=CaluMath.Html.PromptObject.resizable;}
if(scrollbars==null){
scrollbars=CaluMath.Html.PromptObject.scrollbars;}
if(menubar==null){
menubar=CaluMath.Html.PromptObject.menubar;menubar="yes";}
if(cm_widthfraction!=null){
newwidth=Math.round(eval(cm_widthfraction)*tempscreen.availWidth);}
else{
newwidth=Math.round(CaluMath.Html.PromptObject.cm_widthfraction*tempscreen.availWidth);}
newwidth=Math.max(CaluMath.Html.PromptObject.cm_minimumwidth,newwidth);
newwidthstring="width="+newwidth+"px";
if(cm_heightfraction!=null){
newheight=Math.round(eval(cm_heightfraction)*tempscreen.availHeight);}
else{
newheight=Math.round(CaluMath.Html.PromptObject.cm_heightfraction*tempscreen.availHeight);}
newheight=Math.max(CaluMath.Html.PromptObject.cm_minimumheight,newheight);
newheightstring="height="+newheight+"px";
if(cm_ok==null){
cm_ok=CM_Prompt.cm_ok;}
if(cm_cancel==null){
cm_cancel=CM_Prompt.cm_cancel;}
window[name]=window.open("","",newheightstring+","+newwidthstring+","+"menubar="+menubar+", scrollbars="+scrollbars+", resizable="+resizable,"");}
else{
var cm_ok="OK";
var cm_cancel="Cancel";
var heighttemp=cm_options[2].cm_getpropertyvalue("height");
if(heighttemp[0]!=null){
newheight=parseInt(heighttemp[0]);}
var widthtemp=cm_options[2].cm_getpropertyvalue("width");
if(widthtemp[0]!=null){
newwidth=parseInt(widthtemp[0]);}
window[name]=window.open(cm_options[0],cm_options[1],cm_options[2],cm_options[3]);}
eval("window."+parentfullname)[name+"checkedout"]=false;
window[name+"Counter"]=0;
window[name].cm_newwindowwritefunction=function(){
window[name+"Counter"]++;
if(window[name].document!=null){
if((cm_coordinates[1]+newheight>=window.screen.availHeight)&&(cm_coordinates[0]+newwidth>=window.screen.availWidth)){
window[name].moveTo((window.screen.availWidth-newwidth)/3, (window.screen.availHeight-newheight)/3);}
else if(cm_coordinates[1]+newheight>=window.screen.availHeight){
window[name].moveTo(cm_coordinates[0],(window.screen.availHeight-newheight)/3);}
else if(cm_coordinates[0]+newwidth>=window.screen.availWidth){
window[name].moveTo((window.screen.availWidth-newwidth)/3,cm_coordinates[1]);}
else{
window[name].moveTo(cm_coordinates[0],cm_coordinates[1]);}
if(window[name].outerWidth!=null&&window[name].outerWidth<50){
setTimeout(function(){window[name].resizeTo(newwidth,newheight);},0);}
var newwindowstring="<\!DOCTYPE html PUBLIC \"-\/\/W3C\/\/DTD HTML 4.01 Transitional\/\/EN\" \n\"http:\/\/www.w3.org\/TR\/html4\/loose.dtd\">\n<html>\n<head>\n<title> Do This Before Continuing! </title>\n<\/head>\n<body>\n<script> Counter="+window[name+"Counter"]+";</\script>\n";
newwindowstring=newwindowstring+'<p style="text-align:center;">'+writestring+'</p>';
var tempwritestring='<br><br><input id="tempinput" type="text" size="30" /><br><p style="text-align:center"><input type="button" id="OKbutton" value="'+cm_ok+'"><input type="button" id="Cancelbutton" value="'+cm_cancel+'"></p>\n<script> if(document.getElementById("tempinput")!= null){document.getElementById("tempinput").focus();}  CM_PromptWindowOKButton= document.getElementById("OKbutton"); CM_PromptWindowOKButtonFunction = function(){ window.opener.'+parentfullname+'["'+name+'checkedout"]=true; if(document.getElementById("tempinput").value.match(/\\w/)){window.opener.'+parentfullname+'.cm_promptreturn=document.getElementById("tempinput").value; window.opener.CaluMath.Html.Eval("'+cm_functionarray[0]+'");}else{ window.opener.CaluMath.Html.Eval("'+cm_functionarray[1]+'"); };  window.close();};  CM_PromptWindowOKButton.onclick=CM_PromptWindowOKButtonFunction; CM_PromptWindowCancelButton= document.getElementById("Cancelbutton");  CM_PromptWindowCancelButtonFunction = function(){ window.opener.'+parentfullname+'["'+name+'checkedout"]=true;  window.opener.CaluMath.Html.Eval("'+cm_functionarray[1]+'"); window.close();}; CM_PromptWindowCancelButton.onclick=CM_PromptWindowCancelButtonFunction; for(var ii=0; ii<40; ii++){ setTimeout(\'if(!window.closed&&window.CM_PromptWindowOKButton!=null&&window.CM_PromptWindowOKButtonFunction!=null&&CM_PromptWindowOKButton.onclick==null){CM_PromptWindowOKButton.onclick=CM_PromptWindowOKButtonFunction;};if(!window.closed&&window.CM_PromptWindowCancelButton!=null&&window.CM_PromptWindowCancelButtonFunction!=null&&CM_PromptWindowCancelButton.onclick==null){CM_PromptWindowOKButton.onclick=CM_PromptWindowOKButtonFunction;}\', 10*ii);};  </script>\n</body>\n</html>';
window[name].document.write(newwindowstring+tempwritestring);
window[name].cm_newwindowwritefunction=null;
window[name].document.close();
window[name].opener=window;}
else{
setTimeout("window[\""+name+"\"].cm_newwindowwritefunction()",50);}};
window[name].cm_newwindowwritefunction();
window[name+"closecheck"]=function(){
if(window[name].closed||window[name].closed==null){
if(eval("window."+parentfullname)[name+"checkedout"]!=true){
eval(cm_functionarray[1]);
window[name+"closecheck"]=null;}
else{
window[name+"closecheck"]=null;}}
else{
window.setTimeout("if(window[\""+name+"closecheck\"] != null){window[\""+name+"closecheck\"]()}",1000);}};
window[name+"closecheck"]();
var tempclose=window.cm_onunloadarray;
var tempcloselength=tempclose.length;
window.cm_onunloadarray[tempcloselength]=function(){
if(window[name]!=null){
window[name+"closecheck"]=null;
if(window[name].closed==false){
window[name].close();
window[name].focus();}
window[name]=null;}};
return window[name];}
catch(e){
cm_catch(e,"CaluMath.Html.Prompt",arguments);}};
CaluMath.Html.PromptObject=new Object();
CaluMath.Html.PromptObject.resizable="yes";
CaluMath.Html.PromptObject.scrollbars="yes";
CaluMath.Html.PromptObject.menubar="no";
CaluMath.Html.PromptObject.cm_widthfraction=.5;
CaluMath.Html.PromptObject.cm_heightfraction=.3;
CaluMath.Html.PromptObject.cm_ok="OK";
CaluMath.Html.PromptObject.cm_cancel="Keep";
CaluMath.Html.PromptObject.cm_minimumwidth=500;
CaluMath.Html.PromptObject.cm_minimumheight=250;
CaluMath.Html.PromptObject.PromptCounter=0;
CaluMath.Html.Html=function(){
var arg0=arguments[0];
var arg1=arguments[1];
if(arg1!=null){
var tempreturn=new CaluMath.Html.HtmlBlock(arg0,arg1);}
else{
var tempreturn=new CaluMath.Html.HtmlBlock(arg0);}
return tempreturn;};
CaluMath.Html.HtmlU=function(){
var args=arguments;
return CaluMath.Html.UnevaluateVersion(CaluMath.Html.Html,null,args);};
CaluMath.Html.ComparisonOneTerm=function(){
var lhs=arguments[0];
var comparison=arguments[1];
var rhs=arguments[2];
var precision=arguments[3];
if(precision!=null){
precision=1*precision;}
var result="no";
var nullentries=(lhs==null||rhs==null);
switch(comparison){
case "=":
if(nullentries===true){
if(lhs==null&&rhs==null){
return "yes";}
else{
return "no";}}
if(precision==null){
if(eval(lhs)==eval(rhs)){
result="yes";}}
else{
if(Math.abs(eval(lhs)-eval(rhs))<precision){
result="yes";}}
break;
case "==":
if(nullentries===true){
if(lhs==null&&rhs==null){
return "yes";}
else{
return "no";}}
if(precision==null){
if(eval(lhs)==eval(rhs)){
result="yes";}}
else{
if(Math.abs(eval(lhs)-eval(rhs))<precision){
result="yes";}}
break;
case "<":
if(nullentries===true){
return "no";}
if(precision==null){
if(eval(lhs)<eval(rhs)){
result="yes";}}
else{
if(eval(lhs)<eval(rhs)+precision){
result="yes";}}
break;
case "<=":
if(nullentries===true){
return "no";}
if(precision==null){
if(eval(lhs)<=eval(rhs)){
result="yes";}}
else{
if(eval(lhs)<=eval(rhs)+precision){
result="yes";}}
break;
case ">":
if(nullentries===true){
return "no";}
if(precision==null){
if(eval(lhs)>eval(rhs)){
result="yes";}}
else{
if(eval(lhs)>eval(rhs)-precision){
result="yes";}}
break;
case ">=":
if(nullentries===true){
return "no";}
if(precision==null){
if(eval(lhs)>=eval(rhs)){
result="yes";}}
else{
if(eval(lhs)>=eval(rhs)-precision){
result="yes";}}
break;
case "<>":
if(nullentries===true){
if(lhs==null&&rhs==null){
return "no";}
else{
return "yes";}}
if(precision==null){
if(!(eval(lhs)==eval(rhs))){
result="yes";}}
else{
if(Math.abs(eval(lhs)-eval(rhs))>=precision){
result="yes";}}
break;
case "e":
if(CaluMath.Html.IsEqual(lhs,rhs)){
result="yes";}
break;
case "ne":
if(!CaluMath.Html.IsEqual(lhs,rhs)){
result="yes";}
break;
case "in":
if(precision==null){
rhs=eval(rhs);
if(rhs.cm_constructorname=="Array"){
if(rhs.cm_contains(lhs)){
result="yes";}}}
else{
if(rhs.cm_constructorname=="Array"){
rhs=eval(rhs);
if(rhs.cm_contains(lhs,precision)){
result="yes";}}}
break;
case "notin":
if(precision==null){
rhs=eval(rhs);
if(rhs.cm_constructorname=="Array"){
if(!rhs.cm_contains(lhs)){
result="yes";}}}
else{
if(rhs.cm_constructorname=="Array"){
rhs=eval(rhs);
if(!rhs.cm_contains(lhs,precision)){
result="yes";}}}
break;
case "t":
result="yes";
break;
case "f":
break;
default:}
return result;};
CaluMath.Html.Comparison=function(){
var args=arguments;
if(args.length==1||args.length==2){
var andor=args[1];
if(andor==null){
andor="and";}
if(args[0]==null||args[0].cm_constructorname!="Array"){
return alert("Your first term in CaluMath.Html.Comparison should be an array instead of :"+args[0]);}
if(args[0][0].cm_constructorname!="Array"){
if(args[0].length==3){
return CaluMath.Html.ComparisonOneTerm(args[0][0],args[0][1],args[0][2]);}
else{
return CaluMath.Html.ComparisonOneTerm(args[0][0],args[0][1],args[0][2],args[0][3]);}}
else{
if(andor=="and"){
var result="yes";
firstloop:
for(var i=0;i<args[0].length;i++){
if(args[0][i].length==3){
var newresult=CaluMath.Html.ComparisonOneTerm(args[0][i][0],args[0][i][1],args[0][i][2]);}
else{
var newresult=CaluMath.Html.ComparisonOneTerm(args[0][i][0],args[0][i][1],args[0][i][2],args[0][i][3]);}
if(newresult=="no"){
result="no";
break firstloop;}}
return result;}
else{
var result="no";
firstloop:
for(var i=0;i<args[0].length;i++){
if(args[0][i].length==3){
var newresult=CaluMath.Html.ComparisonOneTerm(args[0][i][0],args[0][i][1],args[0][i][2]);}
else{
var newresult=CaluMath.Html.ComparisonOneTerm(args[0][i][0],args[0][i][1],args[0][i][2],args[0][i][3]);}
if(newresult=="yes"){
result="yes";
break firstloop;}}
return result;}}}
else{alert(args.length);
return alert("You have passed an inappropriate number of arguments to CaluMath.Html.Comparison. You passed "+CaluMath.Html.ArgumentsToArray(arguments)+" .");}};
CaluMath.Html.IsEqual=function(){
var left=arguments[0];
var right=arguments[1];
var precision=arguments[2];
if(left==null&&right==null){
return true;}
else if(left==null||right==null){
return false;}
else{
if(precision==null){
if(left.cm_constructorname!="Array"&&right.cm_constructorname!="Array"){
return left==right;}
else if(left.cm_constructorname!="Array"||right.cm_constructorname!="Array"){
return false;}
else{
var leftlength=left.length;
var rightlength=right.length;
if(leftlength!=rightlength){
return false;}
else{
tempreturn=true;
arrayloop:
for(var i=0;i<leftlength;i++){
if(!CaluMath.Html.IsEqual(left[i],right[i])){
tempreturn=false;
break arrayloop;}}
return tempreturn;}}}
else{
precision=eval(precision);
if(left.cm_constructorname!="Array"&&right.cm_constructorname!="Array"){
if(left==right){
return true;}
else if(Math.abs(left-right)<precision){
return true;}}
else if(left.cm_constructorname!="Array"||right.cm_constructorname!="Array"){
return false;}
else{
var leftlength=left.length;
var rightlength=right.length;
if(leftlength!=rightlength){
return false;}
else{
tempreturn=true;
arrayloop:
for(var i=0;i<leftlength;i++){
if(!CaluMath.Html.IsEqual(left[i],right[i],precision)){
tempreturn=false;
break arrayloop;}}
return tempreturn;}}}}};
CaluMath.Html.LoadXml=function(){
var args=arguments;
var url=args[0];
if(args.length==1){
var handler=CaluMath.Html.NullFunction;}
else{
var handler=args[1];}
if(document.implementation&&document.implementation.createDocument){
var newxmldoc=document.implementation.createDocument("","",null);
windowfunction=function(){
if(newxmldoc!=null){
newxmldoc.onload=function(){
handler(newxmldoc,url);};
newxmldoc.load(url);}
else{
setTimeout("windowfunction()",50);}}
windowfunction();
return newxmldoc;}
else if(window.ActiveXObject){
var newxmldoc=new ActiveXObject("Microsoft.XMLDOM");
newxmldoc.onreadystatechange=function(){
if(newxmldoc.readyState==4){
handler(newxmldoc,url);}}
newxmldoc.load(url);
return newxmldoc;}
else{
var cm_tempwindow=window.open(url);
cm_tempwindow.onload=function(){
var newxmldoc=cm_tempwindow.document;
handler(newxmldoc,url,cm_tempwindow);};
window.focus();}};
CaluMath.Html.Eval=function(){
var args=arguments[0];
if(args!=null){
if(args.cm_constructorname=="String"){
return eval(args.cm_javascript());}
else{
return eval(args);}}};
CaluMath.Html.SortDoubleArrayByFirstEntry=function(a,b){
return a[0]-b[0];};
CaluMath.Html.SortNumberFunction=function(a,b){
return a-b;};
CaluMath.Html.SortPointFunctionxaa=function(a,b,c){
if(a[0]<b[0]){
return -1;}
else if(a[0]>b[0]){
return 1;}
else if(a[1]<b[1]){
return -1;}
else if(a[1]>b[1]){
return 1;}
else{
return 0;}};
CaluMath.Html.SortPointFunctionxad=function(a,b,c){
if(a[0]<b[0]){
return -1;}
else if(a[0]>b[0]){
return 1;}
else if(a[1]<b[1]){
return 1;}
else if(a[1]>b[1]){
return -1;}
else{
return 0;}};
CaluMath.Html.SortPointFunctionxda=function(a,b,c){
if(a[0]>b[0]){
return -1;}
else if(a[0]<b[0]){
return 1;}
else if(a[1]<b[1]){
return -1;}
else if(a[1]>b[1]){
return 1;}
else{
return 0;}};
CaluMath.Html.SortPointFunctionxdd=function(a,b,c){
if(a[0]>b[0]){
return -1;}
else if(a[0]<b[0]){
return 1;}
else if(a[1]<b[1]){
return 1;}
else if(a[1]>b[1]){
return -1;}
else{
return 0;}};
CaluMath.Html.SortPointFunctionyaa=function(a,b){
if(a[1]<b[1]){
return -1;}
else if(a[1]>b[1]){
return 1;}
else if(a[0]<b[0]){
return -1;}
else if(a[0]>b[0]){
return 1;}
else{
return 0;}};
CaluMath.Html.SortPointFunctionyad=function(a,b){
if(a[1]<b[1]){
return -1;}
else if(a[1]>b[1]){
return 1;}
else if(a[0]<b[0]){
return 1;}
else if(a[0]>b[0]){
return -1;}
else{
return 0;}};
CaluMath.Html.SortPointFunctionyda=function(a,b){
if(a[1]>b[1]){
return -1;}
else if(a[1]<b[1]){
return 1;}
else if(a[0]<b[0]){
return -1;}
else if(a[0]>b[0]){
return 1;}
else{
return 0;}};
CaluMath.Html.SortPointFunctionydd=function(a,b){
if(a[1]>b[1]){
return -1;}
else if(a[1]<b[1]){
return 1;}
else if(a[0]<b[0]){
return 1;}
else if(a[0]>b[0]){
return -1;}
else{
return 0;}};
CaluMath.Html.SortPointFunctionza=function(a,b){
if(a[2]<b[2]){
return -1;}
else if(a[2]>b[2]){
return 1;}
else{
return 0;}};
CaluMath.Html.SortPointFunctionzd=function(a,b){
if(a[2]>b[2]){
return -1;}
else if(a[2]<b[2]){
return 1;}
else{
return 0;}};
CaluMath.Html.SortPoints=function(){
var arrayofpoints=arguments[0].slice(0).cm_converttopoints();
var xory=arguments[1];
var ascendingordecending=arguments[2];
var extraascendingordecending=arguments[3];
if(extraascendingordecending==null){
if(xory=="x"){
if(ascendingordecending=="d"||ascendingordecending=="descending"){
return arrayofpoints.sort(CaluMath.Html.SortPointFunctionxd);}
else{
return arrayofpoints.sort(CaluMath.Html.SortPointFunctionxa);}}
else if(xory=="y"){
if(ascendingordecending=="d"||ascendingordecending=="descending"){
return arrayofpoints.sort(CaluMath.Html.SortPointFunctionyd);}
else{
return arrayofpoints.sort(CaluMath.Html.SortPointFunctionya);}}
else{
if(ascendingordecending=="d"||ascendingordecending=="descending"){
return arrayofpoints.sort(CaluMath.Html.SortPointFunctionzd);}
else{
return arrayofpoints.sort(CaluMath.Html.SortPointFunctionza);}}}
else{
if(ascendingordecending=="d"||ascendingordecending=="descending"){
var temp1="d";}
else if(ascendingordecending=="a"||ascendingordecending=="ascending"){
var temp1="a";}
if(extraascendingordecending=="d"||extraascendingordecending=="descending"){
var temp2="d";}
else if(extraascendingordecending=="a"||extraascendingordecending=="ascending"){
var temp2="a";}
var tempfunction=CaluMath.Html["SortPointFunction"+xory+temp1+temp2];
return arrayofpoints.sort(tempfunction);}};
CaluMath.Html.Focus=function(){
var args=arguments[0];
var cm_tempwindow=arguments[1];
if(cm_tempwindow!=null){
cm_tempwindow.focus();}
if(args.cm_constructorname!="String"){
if(args.tagName!=null){
if(args.scrollIntoView!=null){
args.scrollIntoView();}
else{
args.blur();
args.focus();}}
else if(args.cm_node!=null){
if(args.cm_node.cm_constructorname!="Array"){
if(args.cm_node.scrollIntoView!=null){
args.cm_node.scrollIntoView();}
else if(args.cm_objecttype!=null&&args.cm_objecttype=="CM_FocusObject"&&args.cm_node.focus!=null){
if(args.cm_node.style.display!="inline"){
args.cm_node.style.display="inline";}
args.cm_node.style.visibility="visible";
setTimeout(''+args.cm_fullname()+'.cm_node.blur()\;'+args.cm_fullname()+'.cm_node.focus()',300);
setTimeout(''+args.cm_fullname()+'.cm_node.blur()\;',500);
setTimeout(''+args.cm_fullname()+'.cm_node.style.display="none"',600);
return 'The focus is on the cm_node of the object';}
else if(args.cm_node.focus!=null){
args.cm_node.blur();
args.cm_node.focus();
return 'The focus is on the cm_node of the object';}}
else{
if(args.cm_node[0]!=null&&args.cm_node[0].scrollIntoView!=null){
if(args.cm_node[0].scrollIntoView!=null){
args.cm_node[0].scrollIntoView();}
else{
args.cm_node[0].blur();
args.cm_node[0].focus();}}
else if(args.cm_node[0]!=null&&args.cm_node[0].childNodes!=null&&args.cm_node[0].childNodes[0]!=null&&args.cm_node[0].childNodes[0].scrollIntoView!=null){
if(args.cm_node[0].childNodes[0].scrollIntoView!=null){
args.cm_node[0].childNodes[0].scrollIntoView();}
else{
args.cm_node[0].childNodes[0].blur();
args.cm_node[0].childNodes[0].focus();}}
else if(args.cm_node[0].focus!=null){
args.cm_node[0].blur();
args.cm_node[0].focus();
return 'The focus is on the cm_node of the object';}}}}
else{
if(document.getElementById(args)!=null){
if(document.getElementById(args).scrollIntoView!=null){
document.getElementById(args).scrollIntoView();}
else if(document.getElementById(args).focus!=null){
document.getElementById(args).blur();
document.getElementById(args).focus();
return 'The focus is on the object.'}}}};
CaluMath.Html.Quadrant=function(){
var pointx=arguments[0];
var pointy=arguments[1];
var cm_plot=arguments[2];
var xtolerance=arguments[3];
var ytolerance=arguments[4];
if(cm_plot!=null&&xtolerance==null){
var xtolerance=10;}
if(xtolerance!=null&&ytolerance==null){
ytolerance=xtolerance;}
if(cm_plot==null){
xtolerance=0;
ytolerance=0;}
else{
xtolerance=xtolerance/cm_plot.cm_pixelsperx;
ytolerance=xtolerance/cm_plot.cm_pixelspery;}
if(Math.abs(pointx)<=xtolerance&&Math.abs(pointy)<=ytolerance){
return 1234;}
if(Math.abs(pointx)<=xtolerance&&pointy>ytolerance){
return 12;}
else if(pointx<-xtolerance&&Math.abs(pointy)<=ytolerance){
return 23;}
else if(Math.abs(pointx)<=xtolerance&&pointy<-ytolerance){
return 34;}
else if(pointx>xtolerance&&Math.abs(pointy)<=ytolerance){
return 41;}
else if(pointx>0&&pointy>0){
return 1;}
else if(pointx<0&&pointy>0){
return 2;}
else if(pointx<0&&pointy<0){
return 3;}
else if(pointx>0&&pointy<0){
return 4;}};
CaluMath.Html.Rotate=function(){
var arrayofpoints=arguments[0];
var arrayofpointslength=arrayofpoints.length;
var rotationangle=arguments[1].cm_evalmath();
var argumentslength=arguments.length;
if(argumentslength==5){
var center=arguments[2];
if(arguments[3].cm_constructorname=="String"){
var movepoints=arguments[3];
var precision=arguments[4];}
else{
var movepoints=arguments[4];
var precision=arguments[3];}}
else if(argumentslength==3){
if(arguments[2].cm_constructorname=="Array"){
var center=arguments[2];}
else if(arguments[2].cm_constructorname=="String"){
var movepoints=arguments[2];}
else{
var precision=arguments[2];}}
else if(argumentslength==4){
if(arguments[2].cm_constructorname=="Array"){
var center=arguments[2];
if(arguments[3].cm_constructorname=="String"){
var movepoints=arguments[3];}
else{
var precision=arguments[3];}}
else if(arguments[2].cm_constructorname=="String"){
var movepoints=arguments[2];
var precision=arguments[3];}
else{
var movepoints=arguments[3];
var precision=arguments[2];}}
if(center==null){
var center=[0,0];}
if(movepoints==null){
var movepoints="no";}
if(precision==null){
var precision=8;}
var xcenter=center[0];
var ycenter=center[1];
var Atan2=Math.atan2;
var Power=Math.pow;
var Cos=Math.cos;
var Sin=Math.sin;
var returnarray=new Array();
if(movepoints!="yes"){
for(var i=0;i<arrayofpointslength;i++){
var thispoint=arrayofpoints[i];
if(arrayofpoints[i].cm_constructorname=="Array"){
var tempangle=Atan2(thispoint[1]-ycenter,thispoint[0]-xcenter)+rotationangle;
var distance=Power(Power(thispoint[0]-xcenter,2)+Power(thispoint[1]-ycenter,2),.5);
returnarray[i]=[xcenter+distance*Cos(tempangle),ycenter+distance*Sin(tempangle)].cm_round(precision);}
else if(arrayofpoints[i].cm_objecttype=="CM_PointPlot"||arrayofpoints[i].cm_objecttype=="CM_HighlightPlot"){
var tempangle=Atan2(thispoint.cm_ycoordinate-ycenter,thispoint.cm_xcoordinate-xcenter)+rotationangle;
var distance=Power(Power(thispoint.cm_xcoordinate-xcenter,2)+Power(thispoint.cm_ycoordinate-ycenter,2),.5);
returnarray[i]=[xcenter+distance*Cos(tempangle),ycenter+distance*Sin(tempangle)].cm_round(precision);}}}
else{
for(var i=0;i<arrayofpointslength;i++){
var thispoint=arrayofpoints[i];
if(arrayofpoints[i].cm_constructorname=="Array"){
var tempangle=Atan2(thispoint[1]-ycenter,thispoint[0]-xcenter)+rotationangle;
var distance=Power(Power(thispoint[0]-xcenter,2)+Power(thispoint[1]-ycenter,2),.5);
returnarray[i]=[xcenter+distance*Cos(tempangle),ycenter+distance*Sin(tempangle)].cm_round(precision);}
else if(arrayofpoints[i].cm_objecttype=="CM_PointPlot"||arrayofpoints[i].cm_objecttype=="CM_HighlightPlot"){
var tempangle=Atan2(thispoint.cm_ycoordinate-ycenter,thispoint.cm_xcoordinate-xcenter)+rotationangle;
var distance=Power(Power(thispoint.cm_xcoordinate-xcenter,2)+Power(thispoint.cm_ycoordinate-ycenter,2),.5);
var newcoordinates=[xcenter+distance*Cos(tempangle),ycenter+distance*Sin(tempangle)].cm_round(precision);
returnarray[i]=newcoordinates;
var thispoint=arrayofpoints[i];
thispoint.cm_movegraph(newcoordinates);}}}
return returnarray;};
CaluMath.Html.Magnify=function(){
var arrayofpoints=arguments[0];
var arrayofpointslength=arrayofpoints.length;
var scalefactor=arguments[1].cm_evalmath();
var argumentslength=arguments.length;
if(argumentslength==4){
if(arguments[2].cm_constructorname=="String"){
var movepoints=arguments[2];
var precision=arguments[3];}
else{
var movepoints=arguments[3];
var precision=arguments[2];}}
else if(argumentslength==3){
if(arguments[2].cm_constructorname=="String"){
var movepoints=arguments[2];}
else{
var precision=arguments[2];}}
var rotationangle=0;
var center=[0,0];
if(movepoints==null){
var movepoints="no";}
if(precision==null){
var precision=8;}
var xcenter=center[0];
var ycenter=center[1];
var Atan2=Math.atan2;
var Power=Math.pow;
var Cos=Math.cos;
var Sin=Math.sin;
var returnarray=new Array();
if(movepoints!="yes"){
for(var i=0;i<arrayofpointslength;i++){
var thispoint=arrayofpoints[i];
if(arrayofpoints[i].cm_constructorname=="Array"){
var tempangle=Atan2(thispoint[1]-ycenter,thispoint[0]-xcenter)+rotationangle;
var distance=scalefactor*Power(Power(thispoint[0]-xcenter,2)+Power(thispoint[1]-ycenter,2),.5);
returnarray[i]=[xcenter+distance*Cos(tempangle),ycenter+distance*Sin(tempangle)].cm_round(precision);}
else if(arrayofpoints[i].cm_objecttype=="CM_PointPlot"||arrayofpoints[i].cm_objecttype=="CM_HighlightPlot"){
var tempangle=Atan2(thispoint.cm_ycoordinate-ycenter,thispoint.cm_xcoordinate-xcenter)+rotationangle;
var distance=scalefactor*Power(Power(thispoint.cm_xcoordinate-xcenter,2)+Power(thispoint.cm_ycoordinate-ycenter,2),.5);
returnarray[i]=[xcenter+distance*Cos(tempangle),ycenter+distance*Sin(tempangle)].cm_round(precision);}}}
else{
for(var i=0;i<arrayofpointslength;i++){
var thispoint=arrayofpoints[i];
if(arrayofpoints[i].cm_constructorname=="Array"){
var tempangle=Atan2(thispoint[1]-ycenter,thispoint[0]-xcenter)+rotationangle;
var distance=scalefactor*Power(Power(thispoint[0]-xcenter,2)+Power(thispoint[1]-ycenter,2),.5);
returnarray[i]=[xcenter+distance*Cos(tempangle),ycenter+distance*Sin(tempangle)].cm_round(precision);}
else if(arrayofpoints[i].cm_objecttype=="CM_PointPlot"||arrayofpoints[i].cm_objecttype=="CM_HighlightPlot"){
var tempangle=Atan2(thispoint.cm_ycoordinate-ycenter,thispoint.cm_xcoordinate-xcenter)+rotationangle;
var distance=scalefactor*Power(Power(thispoint.cm_xcoordinate-xcenter,2)+Power(thispoint.cm_ycoordinate-ycenter,2),.5);
var newcoordinates=[xcenter+distance*Cos(tempangle),ycenter+distance*Sin(tempangle)].cm_round(precision);
returnarray[i]=newcoordinates;
var thispoint=arrayofpoints[i];
thispoint.cm_movegraph(newcoordinates);}}}
return returnarray;};
CaluMath.Html.Translate=function(){
var arrayofpoints=arguments[0];
var arrayofpointslength=arrayofpoints.length;
var translationarray=arguments[1].cm_evalmath();
var argumentslength=arguments.length;
if(argumentslength==4){
if(arguments[2].cm_constructorname=="String"){
var movepoints=arguments[2];
var precision=arguments[3];}
else{
var movepoints=arguments[3];
var precision=arguments[2];}}
else if(argumentslength==3){
if(arguments[2].cm_constructorname=="String"){
var movepoints=arguments[2];}
else{
var precision=arguments[2];}}
var rotationangle=0;
if(movepoints==null){
var movepoints="no";}
if(precision==null){
var precision=8;}
var xtranslationarray=translationarray[0];
var ytranslationarray=translationarray[1];
var returnarray=new Array();
if(movepoints!="yes"){
for(var i=0;i<arrayofpointslength;i++){
var thispoint=arrayofpoints[i];
if(arrayofpoints[i].cm_constructorname=="Array"){
returnarray[i]=[1*xtranslationarray+1*thispoint[0],1*ytranslationarray+1*thispoint[0]].cm_round(precision);}
else if(arrayofpoints[i].cm_objecttype=="CM_PointPlot"||arrayofpoints[i].cm_objecttype=="CM_HighlightPlot"){
returnarray[i]=[1*xtranslationarray+1*thispoint.cm_xcoordinate,1*ytranslationarray+1*thispoint.cm_ycoordinate].cm_round(precision);}}}
else{
for(var i=0;i<arrayofpointslength;i++){
var thispoint=arrayofpoints[i];
if(arrayofpoints[i].cm_constructorname=="Array"){
returnarray[i]=[1*xtranslationarray+1*thispoint[0],1*ytranslationarray+1*thispoint[1]].cm_round(precision);}
else if(arrayofpoints[i].cm_objecttype=="CM_PointPlot"||arrayofpoints[i].cm_objecttype=="CM_HighlightPlot"){
var newcoordinates=[1*xtranslationarray+1*thispoint.cm_xcoordinate,1*ytranslationarray+1*thispoint.cm_ycoordinate].cm_round(precision);
returnarray[i]=newcoordinates;
var thispoint=arrayofpoints[i];
thispoint.cm_movegraph(newcoordinates);}}}
return returnarray;};
CaluMath.Html.DetermineXAndYCoordinates=function(){
var cm_points=new Array();
var firstargument=arguments[0];
var CM_ConstantDefinitions=CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions;
if(firstargument!=null&&firstargument.cm_constructorname=="String"&&firstargument.match(/^\s*\[/)&&firstargument.match(/\]\s*$/)){
firstargument=firstargument.replace(/\s*/g,"").replace(/^\[/,"").replace(/\]$/,"").split(/\,/);}
if(firstargument!=null&&(firstargument.cm_objecttype=="CM_PointPlot"||firstargument.cm_objecttype=="CM_HighlightPlot")){
var tempx=firstargument.cm_xcoordinate;
var tempy=firstargument.cm_ycoordinate;
cm_points=[firstargument];}
else if(firstargument!=null&&firstargument.cm_constructorname=="Array"){
if(firstargument[0]==null){
return;}
if(firstargument[0].cm_constructorname=="String"){
var firstargument0=firstargument[0].replace(/\s*/g,"");
if(CM_ConstantDefinitions[firstargument0]!=null&&CM_ConstantDefinitions[firstargument0].cm_value!=null){
tempx=CM_ConstantDefinitions[firstargument0].cm_value;
cm_points.push(CM_ConstantDefinitions[firstargument0]);}
else{
var tempx=firstargument[0].cm_evalmath();
var potentialpoint=firstargument0.cm_returnobjectfromname("pointsonly");
if(potentialpoint!=null){
cm_points.push(potentialpoint[1]);}}
if(tempx==null){
var newtempx=firstargument0.cm_returnobjectfromname("pointsonly");
if(newtempx==null){
return;}
else{
newtempx=newtempx[0];}
if(newtempx.cm_getObjectType()=="CM_PointPlot"||newtempx.cm_getObjectType()=="CM_HighlightPlot"){
var tempx=newtempx.cm_xcoordinate;
var tempy=newtempx.cm_ycoordinate;
cm_points=[newtempx];}
else{
return;}}
else if(tempx.cm_constructorname=="Array"&&tempx.length==2&&tempx[1]!=null){
tempy=tempx[1];
tempx=tempx[0];}}
else{
var tempx=firstargument[0].cm_evalmath();}
if(tempy==null&&firstargument[1]==null){
return;}
else if(tempy==null&&firstargument[1].cm_constructorname=="String"){
var firstargument1=firstargument[1].replace(/\s*/g,"");
if(CM_ConstantDefinitions[firstargument1]!=null&&CM_ConstantDefinitions[firstargument1].cm_value!=null){
tempy=CM_ConstantDefinitions[firstargument1].cm_value;
cm_points.push(CM_ConstantDefinitions[firstargument1]);}
else{
var tempy=firstargument[1].cm_evalmath();
var potentialpoint=firstargument1.cm_returnobjectfromname("pointsonly");
if(potentialpoint!=null){
cm_points.push(potentialpoint[1]);}}}
else if(tempy==null){
var tempy=firstargument[1].cm_evalmath();}}
else if(firstargument!=null&&firstargument.cm_constructorname=="String"&&CM_ConstantDefinitions[firstargument.replace(/\s*/g,"")]!=null&&CM_ConstantDefinitions[firstargument.replace(/\s*/g,"")].cm_value!=null){
var firstargument=firstargument.replace(/\s*/g,"");
tempx=CM_ConstantDefinitions[firstargument].cm_value;
cm_points.push(CM_ConstantDefinitions[firstargument]);
if(tempx.cm_constructorname=="Array"){
if(tempx[1]!=null){
var tempy=tempx[1];
tempx=tempx[0];}}
if(tempy==null&&arguments[1]!=null&&arguments[1].cm_constructorname=="String"){
var arguments1=arguments[1].replace(/\s*/g,"");
if(CM_ConstantDefinitions[arguments1]!=null&&CM_ConstantDefinitions[arguments1].cm_value!=null){
tempy=CM_ConstantDefinitions[arguments1].cm_value;
cm_points.push(CM_ConstantDefinitions[arguments1]);}
else if(arguments[1]!=null){
var tempy=arguments[1].cm_evalmath();
var potentialpoint=arguments1.cm_returnobjectfromname("pointsonly");
if(potentialpoint!=null){
cm_points.push(potentialpoint[1]);}}}}
else if(firstargument!=null){
if(firstargument.cm_constructorname=="String"&&firstargument.match(/\.x$/)){
var possibleparameter=firstargument.cm_returnobjectfromname("pointsonly");
if(possibleparameter!=null){
cm_points.push(possibleparameter[1]);}}
if(firstargument.cm_constructorname=="String"&&firstargument.match(/\.y$/)){
var possibleparameter=firstargument.cm_returnobjectfromname("pointsonly");
if(possibleparameter!=null){
cm_points.push(possibleparameter[1]);}}
var secondargument=arguments[1];
if(secondargument!=null&&secondargument.cm_constructorname=="String"&&secondargument.match(/\.x$/)){
var possibleparameter=secondargument.cm_returnobjectfromname("pointsonly");
if(possibleparameter!=null){
cm_points.push(possibleparameter[1]);}}
if(secondargument!=null&&secondargument.cm_constructorname=="String"&&secondargument.match(/\.y$/)){
var possibleparameter=secondargument.cm_returnobjectfromname("pointsonly");
if(possibleparameter!=null){
cm_points.push(possibleparameter[1]);}}
var args0=firstargument.cm_evalmath();
if(args0!=null){
if(args0.cm_constructorname=="Number"){
var tempx=args0;
if(arguments[1]!=null){
var tempy=arguments[1].cm_evalmath();}}
else if(args0.cm_constructorname=="Array"){
if(args0[0].cm_constructorname=="Number"){
var tempx=args0[0];
var tempy=args0[1];}
else if(args0[0].cm_constructorname=="Array"){
var tempx=args0[0][0];
var tempy=args0[0][1];}
else if(args0[0].cm_objecttype=="CM_PointPlot"||args0[0].cm_objecttype=="CM_HighlightPlot"){
var tempx=args0[0].cm_xcoordinate;
var tempy=args0[0].cm_ycoordinate;
cm_points=[args0[0]];}}}
else{
var potentialpoint=firstargument.cm_returnobjectfromname("pointsonly");
if(potentialpoint!=null){
var args0=potentialpoint[1];}
if(args0==null){
return;}
if(args0.cm_objecttype=="CM_PointPlot"||args0.cm_objecttype=="CM_HighlightPlot"){
var tempx=args0.cm_xcoordinate;
var tempy=args0.cm_ycoordinate;
cm_points=[args0];}
else{
return;}}}
else{
return alert(["The argument passed to CaluMath.Html.DetermineXAndYCoordinates is null. It is ",firstargument]);}
if(arguments[2]!="returnpoints"){
return[tempx,tempy];}
else{
var newmethodparameters=CaluMath.Html.DetermineParameters(arguments[0],arguments[1]);
return[[tempx,tempy],newmethodparameters];}};
CaluMath.Html.DetermineXCoordinate=function(){
var cm_points=new Array();
if(arguments[0].cm_constructorname=="String"){
var CM_ConstantDefinitions=CM_MainWindow.CaluMath.Html.DefinedConstantConstructor.CM_ConstantDefinitions;
var args0=arguments[0].replace(/\s*/g,"");
if(CM_ConstantDefinitions[args0]!=null){
tempx=CM_ConstantDefinitions[args0].cm_value;
cm_points.push(CM_ConstantDefinitions[args0]);
if(tempx.cm_constructorname=="Array"){
tempx=tempx[0];}}
else{
var tempx=args0.cm_evalmath();
var potentialpoint=args0.cm_determineconstantparameters();
if(potentialpoint!=null){
cm_points.push(potentialpoint);}
if(tempx==null&&potentialpoint!=null){
var tempx=potentialpoint[0].cm_xcoordinate;}}}
else if(arguments[0]!=null&&arguments[0].cm_getObjectType!=null&&(arguments[0].cm_getObjectType()=="CM_PointPlot"||arguments[0].cm_getObjectType()=="CM_HighlightPlot")){
var tempx=arguments[0].cm_xcoordinate;
cm_points.push(arguments[0]);}
if(tempx==null){
if(args0==null){
var args0=arguments[0];}
var tempx=args0.cm_evalmath();}
if(tempx!=null){
if(tempx.cm_constructorname=="Array"){
tempx=tempx[0];}}
if(arguments[1]!="returnpoints"){
return tempx;}
else{
return[tempx,cm_points];}};
CaluMath.Html.DetermineParameters=function(){
var cm_parameters=new Array();
if(arguments[0]!=null){
if(arguments[0].cm_objecttype=="CM_PointPlot"||arguments[0].cm_objecttype=="CM_HighlightPlot"){
cm_parameters.push(arguments[0]);}
else if(arguments[0].cm_constructorname=="String"||arguments[0].cm_constructorname=="Array"){
var childparameters=arguments[0].cm_determineparameters();
if(childparameters!=null){
cm_parameters=cm_parameters.concat(childparameters);}}}
if(arguments[1]!=null){
if(arguments[1].cm_objecttype=="CM_PointPlot"||arguments[1].cm_objecttype=="CM_HighlightPlot"){
cm_parameters.push(arguments[1]);}
else if(arguments[1].cm_constructorname=="String"||arguments[1].cm_constructorname=="Array"){
var childparameters=arguments[1].cm_determineparameters();
if(childparameters!=null){
cm_parameters=cm_parameters.concat(childparameters);}}}
var tempreturn=cm_parameters.cm_removeduplicates();
return tempreturn;};
CaluMath.Html.ArrayOfConsecutiveObjects=function(){
var commonname=arguments[0];
var startindex=arguments[1];
var endindex=arguments[2];
var spacing=(arguments[3]==null?1:arguments[3]);
if(commonname.match(/\./)==null){
var commonobject=window;}
else{
var commonarray=commonname.split(/\./);
var commonarraylengthminus1=commonarray.length-1;
var commonobject=window;
for(var i=0;i<commonarraylengthminus1;i++){
commonobject=commonobject[commonarray[i]];}
commonname=commonarray[commonarraylengthminus1];}
var returnarray=new Array();
for(var i=startindex;i<=endindex;i=i+spacing){
returnarray.push(commonobject[commonname+i]);}
return returnarray;};
CaluMath.Html.DoesArrayDefineAFunction=function(){
var inputarray=arguments[0];
var inputarraylength=inputarray.length;
var tempreturn="yes";
if(arguments[0]==null||arguments[0].cm_constructorname!="Array"||arguments[0].length<=1){
return alert("You cannot invoke DoesArrayDefineAFunction on an Array of length less than 2");}
var convertedarray=new Array();
for(var i=0;i<inputarraylength;i++){
if(inputarray[i]==undefined){
return undefined;}
else if(inputarray[i].cm_constructorname=="Array"){
var currentobject=inputarray[i];
if(currentobject[0]==undefined||currentobject[1]==undefined){
return undefined;}
convertedarray[i]=[currentobject[0],currentobject[1]];}
else if(inputarray[i].cm_constructorname=="String"){
var currentobject=eval(inputarray[i].cm_javascript());
if(currentobject==undefined){
return undefined;}
else if(currentobject.cm_constructorname=="Array"){
if(currentobject[0]==undefined||currentobject[1]==undefined){
return undefined;}
convertedarray[i]=[currentobject[0],currentobject[1]];}
else{
if(currentobject.x==undefined||currentobject.y==undefined){
return undefined;}
convertedarray[i]=[currentobject.x,currentobject.y];}}
else{
var currentobject=inputarray[i];
if(currentobject.x==undefined||currentobject.y==undefined){
return undefined;}
convertedarray[i]=[currentobject.x,currentobject.y];}}
var convertedarraylength=convertedarray.length;
if(convertedarray[0][0]<=convertedarray[1][0]){
var previousvalue=convertedarray[0];
for(var i=1;i<convertedarraylength;i++){
var currentvalue=convertedarray[i];
if(previousvalue[0]==currentvalue[0]){
if(previousvalue[1]==currentvalue[1]){
return[i-1];}
else{
return[i-1,i];}}
else if(previousvalue[0]>currentvalue[0]){
return[i-2,i-1,i];}
else{
previousvalue=convertedarray[i];}}
return tempreturn;}
else{
var previousvalue=convertedarray[0];
for(var i=1;i<convertedarraylength;i++){
var currentvalue=convertedarray[i];
if(previousvalue[0]==currentvalue[0]){
if(previousvalue[1]==currentvalue[1]){
return[i-1];}
else{
return[i-1,i];}}
else if(previousvalue[0]<currentvalue[0]){
return[i-2,i-1,i];}
else{
previousvalue=convertedarray[i];}}
return tempreturn;}};
CaluMath.Html.ConstantsAndFunctionUpdateRegistrationObject={
cm_automaticupdatearray:[],
cm_initialobject:null,
cm_makeInitialObject:function(){
var cm_initialobject=this.cm_initialobject;
if(cm_initialobject==null){
this.cm_initialobject=arguments[0];
return "yes";}
return this.cm_initialobject;},
cm_deleteInitialObject:function(){
if(arguments[0]!=null){
if(arguments[0]==this.cm_initialobject){
this.cm_initialobject=null;}}
else{
this.cm_initialobject=null;}},
cm_executeRegisteredObjects:function(){
var cm_automaticupdatearray=this.cm_automaticupdatearray;
var firstelement=cm_automaticupdatearray.shift();
this.cm_initialobject=null;
if(firstelement!=null){
firstelement();}
else{
CaluMath.Html.GraphUpdateRegistrationObject.cm_executeRegisteredObjects();}}};
CaluMath.Html.GraphUpdateRegistrationObject={
cm_automaticupdatearray:[],
cm_makeInitialObject:function(){
var cm_initialobject=CaluMath.Html.ConstantsAndFunctionUpdateRegistrationObject.cm_initialobject;
if(cm_initialobject==null){
CaluMath.Html.ConstantsAndFunctionUpdateRegistrationObject.cm_initialobject=arguments[0];
return "yes";}},
cm_deleteInitialObject:function(){
if(arguments[0]!=null){
if(arguments[0]==CaluMath.Html.ConstantsAndFunctionUpdateRegistrationObject.cm_initialobject){
CaluMath.Html.ConstantsAndFunctionUpdateRegistrationObject.cm_initialobject=null;}}
else{
CaluMath.Html.ConstantsAndFunctionUpdateRegistrationObject.cm_initialobject=null;}},
cm_executeRegisteredObjects:function(){
cm_automaticupdatearray=this.cm_automaticupdatearray;
var firstelement=cm_automaticupdatearray.shift();
CaluMath.Html.ConstantsAndFunctionUpdateRegistrationObject.cm_initialobject=null;
if(firstelement!=null){
firstelement();}}};
CaluMath.Html.RegisterAutomaticUpdateArray=function(){
var cm_automaticupdatearray=arguments[0];
var cm_automaticupdatearraylength=cm_automaticupdatearray.length;
for(var i=0;i<cm_automaticupdatearraylength;i++){
var cm_updatetype=cm_automaticupdatearray[i].cm_updatetype;
if(cm_updatetype=="DefinedConstant"||cm_updatetype=="DefinedFunction"||cm_updatetype=="CM_HighlightPoint"||cm_updatetype=="CM_PointPlot"){
CaluMath.Html.ConstantsAndFunctionUpdateRegistrationObject.cm_automaticupdatearray.push(cm_automaticupdatearray[i]);}
else{
var graphautomaticupdatearray=CaluMath.Html.GraphUpdateRegistrationObject.cm_automaticupdatearray;
var cm_automaticupdatearrayi=cm_automaticupdatearray[i];
var duplicatefunction="no";
duplicateloop:
for(var j=0;j<graphautomaticupdatearray.length;j++){
if(graphautomaticupdatearray[j].cm_duplicateidentifier==cm_automaticupdatearrayi.cm_duplicateidentifier){
duplicatefunction="yes";
break duplicateloop;}}
if(duplicatefunction=="no"){
CaluMath.Html.GraphUpdateRegistrationObject.cm_automaticupdatearray.push(cm_automaticupdatearrayi);}}}};
CaluMath.Html.NodeToPostscriptInternal=function(){
var htmlnode=arguments[0];
var args=arguments;
var newobject=new Object();
newobject.cm_node=htmlnode;
newobject.type=htmlnode.nodeType;
if(args.length>1){
newobject.cm_stylearray=args[1].slice(0);}
else{
newobject.cm_stylearray=new Array();}
if(htmlnode.style&&htmlnode.style.color&&htmlnode.style.color.match(/\w/)){
newobject.cm_stylearray[0]=htmlnode.style.color;}
else if(htmlnode.getAttribute!=null&&htmlnode.getAttribute("fill")&&htmlnode.getAttribute("fill").match(/\w/)){
newobject.cm_stylearray[0]=htmlnode.getAttribute("fill");}
if(htmlnode.style&&htmlnode.style.fontSize&&htmlnode.style.fontSize.match(/\w/)){
newobject.cm_stylearray[1]=parseInt(htmlnode.style.fontSize);}
else if(htmlnode.getAttribute!=null&&htmlnode.getAttribute("font-size")&&htmlnode.getAttribute("font-size").match(/\w/)){
newobject.cm_stylearray[1]=parseInt(htmlnode.getAttribute("font-size"));}
if(htmlnode.style&&htmlnode.style.fontFamily&&htmlnode.style.fontFamily.match(/\w/)){
newobject.cm_stylearray[2]=htmlnode.style.fontFamily;}
else if(htmlnode.getAttribute!=null&&htmlnode.getAttribute("font-family")&&htmlnode.getAttribute("font-family").match(/\w/)){
newobject.cm_stylearray[2]=htmlnode.getAttribute("font-family");}
if(htmlnode.style&&htmlnode.style.fontStyle&&htmlnode.style.fontStyle.toLowerCase()=="italic"){
newobject.cm_stylearray[3]="yes";}
else if(htmlnode.getAttribute!=null&&htmlnode.getAttribute("font-style")&&htmlnode.getAttribute("font-style").toLowerCase()=="italic"){
newobject.cm_stylearray[3]="yes";}
if(htmlnode.style&&htmlnode.style.fontWeight&&htmlnode.style.fontWeight.toLowerCase()=="bold"){
newobject.cm_stylearray[4]="yes";}
else if(htmlnode.getAttribute!=null&&htmlnode.getAttribute("font-weight")&&htmlnode.getAttribute("font-weight").toLowerCase()=="bold"){
newobject.cm_stylearray[4]="yes";}
if(htmlnode.tagName&&htmlnode.tagName.toLowerCase()=="i"){
newobject.cm_stylearray[3]="yes";}
if(htmlnode.tagName&&htmlnode.tagName.toLowerCase()=="b"){
newobject.cm_stylearray[4]="yes";}
if(newobject.cm_stylearray[3]=="yes"&&newobject.cm_stylearray[4]=="yes"){
var font=newobject.cm_stylearray[2]+"-BoldOblique";}
else if(newobject.cm_stylearray[3]=="yes"){
var font=newobject.cm_stylearray[2]+"-Oblique";}
else if(newobject.cm_stylearray[4]=="yes"){
var font=newobject.cm_stylearray[2]+"-Bold";}
else{
var font=newobject.cm_stylearray[2];}
if(font==null){
font="New Times Roman";}
var font=font.replace(/\s/g,"-")
if(newobject.cm_stylearray[3]=="yes"&&newobject.cm_stylearray[4]=="yes"){
var Symbolfont="/Symbol-BoldOblique";}
else if(newobject.cm_stylearray[3]=="yes"){
var Symbolfont="/Symbolfont-Oblique";}
else if(newobject.cm_stylearray[4]=="yes"){
var Symbolfont="/Symbol-Bold";}
else{
var Symbolfont="/Symbol";}
var childlength=htmlnode.childNodes.length;
if(childlength==0){
if(newobject.type==3){
var newtext=htmlnode.data.cm_unicodetopostscript();
newtext=newtext.replace(/BEGINSYMBOL/g,") testwidth "+Symbolfont+" findfont "+newobject.cm_stylearray[1]+" scalefont setfont (");
newtext=newtext.replace(/ENDSYMBOL/g,") testwidth  /"+font+" findfont "+newobject.cm_stylearray[1]+" scalefont setfont (");
newobject.cm_data=newtext;
var cm_temparray=new Array();
if(newobject.cm_stylearray[0]){
cm_temparray=cm_temparray.concat(CaluMath.Html.GeneralizedPlot.prototype.cm_postscriptcolor(newobject.cm_stylearray[0])+" ");}
if(font){
cm_temparray=cm_temparray.concat("/"+font+" findfont ");}
if(newobject.cm_stylearray[1]){
cm_temparray=cm_temparray.concat(newobject.cm_stylearray[1]+" scalefont setfont ("+newobject.cm_data+") testwidth ");}
newobject.cm_postscript=cm_temparray;
return newobject;}
else{
if(htmlnode.tagName&&htmlnode.tagName.toLowerCase()=="br"){
newobject.cm_postscript=["CM_Htmllinebreak"];
return newobject;}
else{
return newobject;}}}
else{
var tempchildarray=new Array();
var temppostscript=new Array();
for(var i=0;i<childlength;i++){
tempchildarray[i]=CaluMath.Html.NodeToPostscriptInternal(htmlnode.childNodes[i],newobject.cm_stylearray);
if(tempchildarray[i].cm_postscript){
temppostscript=temppostscript.concat(tempchildarray[i].cm_postscript);}}
newobject.cm_childarray=tempchildarray;
newobject.cm_postscript=temppostscript;
return newobject;}};
CaluMath.Html.NodeToPostscript=function(){
var args=arguments;
if(args.length==1){
var temp=CaluMath.Html.NodeToPostscriptInternal(args[0]);
if(temp!=null&&temp.cm_postscript!=null&&temp.cm_postscript.join!=null){
return temp.cm_postscript.join(" \n ").cm_adjustquotes('"');}}
else{
var temp=CaluMath.Html.NodeToPostscriptInternal(args[0],args[1]);
if(temp!=null&&temp.cm_postscript!=null&&temp.cm_postscript.join!=null){
return temp.cm_postscript.join(" \n ").cm_adjustquotes('"');}}};
CaluMath.Html.NullFunction=function(){
return;};
CaluMath.Html.DefinedFunctionInAllWindows=function(){
var definedfunction=arguments[0];
var passedwindow=arguments[1];
var name=definedfunction.name;
var cm_map=definedfunction.cm_map;
var tempCM_MainWindow=CM_MainWindow;
if(tempCM_MainWindow[name]==null){
tempCM_MainWindow[name]=cm_map;}
var NewWindowArray=tempCM_MainWindow.CaluMath.Html.NewWindowArray;
var NewWindowArraylength=NewWindowArray.length;
for(var i=0;i<NewWindowArraylength;i++){
var differentwindow=tempCM_MainWindow[NewWindowArray[i]];
if(differentwindow!=null&&differentwindow!=passedwindow&&!differentwindow.closed){
differentwindow[name]=cm_map;}}};
CaluMath.Html.CheckForInternetExplorer=function(){
if(document.implementation!=null&&document.implementation.createDocument==null){
if(navigator.appName=='Microsoft Internet Explorer'){
var useragent=navigator.userAgent;
var regularexpression=new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
if(regularexpression.exec(useragent)!=null)
var version=parseFloat(RegExp.$1);}
CaluMath.Html.IEVersion=version;
if(version<7){
CaluMath.Html.IE6Detected="yes";}
else{
CaluMath.Html.IE6Detected="no";}
return CaluMath.Html.InternetExplorerDetected="yes";}
else{
return CaluMath.Html.InternetExplorerDetected="no";}};
CaluMath.Html.IE6Detected=null;
CaluMath.Html.IE6DPIAlreadyWarned="no";
CaluMath.Html.Modules=new Object();
CaluMath.Html.Modules["cm_plot"]="yes";
CaluMath.Html.NewWindowArray=new Array();
CaluMath.Html.PlotArray=new Array();
CaluMath.Html.DefinedFunctionArray=new Array();
CaluMath.Html.CatchFunction1=function(e,cm_functionname,args,messageinput){
if(cm_functionname.cm_constructorname=="Array"){
var message="You have called "+cm_functionname[0]+" on "+cm_functionname[1]+" with arguments ("+CaluMath.Html.ArgumentsToArray(args);}
else{
var message="You have called "+cm_functionname+" with arguments ("+CaluMath.Html.ArgumentsToArray(args);};
if(messageinput==null){
message=message+"). This is causing an error.";}
else{
var message=message+"). "+messageinput;}
alert(message);
if(e.lineNumber!=null){
throw new CaluMath.Html.Error(e.message+"\nLine Number \n"+e.lineNumber+"\nFile Name: \n"+e.fileName);}
else{
throw new CaluMath.Html.Error(e.message);}};
CaluMath.Html.CatchFunction2=function(e,cm_functionname,args,messageinput){
if(CM_AlertErrorsCounter<CM_AlertErrorsLimit){
if(CM_AlertErrorsCounter=="stopped"){
CM_AlertErrorsCounter=0;}
if(cm_functionname.cm_constructorname=="Array"){
var message="You have called "+cm_functionname[0]+" on "+cm_functionname[1]+"with arguments ("+CaluMath.Html.ArgumentsToArray(args);}
else{
var message="You have called "+cm_functionname+" with arguments ("+CaluMath.Html.ArgumentsToArray(args);}
if(messageinput==null){
message=message+"). This is causing an error.";}
else{
var message=message+"). "+messageinput;}
alert(message);
CM_AlertErrorsCounter++;}
else{
CM_AlertErrorsCounter="stopped";
throw new CaluMath.Html.Error(e.message);}};
CaluMath.Html.CaptureErrors=function(){
cm_catch=CaluMath.Html.CatchFunction1;};
CaluMath.Html.IgnoreErrors=function(){
cm_catch=CaluMath.Html.NullFunction;};
CaluMath.Html.AlertErrors=function(n){
CM_AlertErrorsCounter=0;
if(n!=null){
CM_AlertErrorsLimit=n;}
else{
CM_AlertErrorsLimit=5;}
cm_catch=CaluMath.Html.CatchFunction2;};
CaluMath.Html.MakeTempObject=function(){
var objectactedon=arguments[0];
return objectactedon.cm_tempobject=new CaluMath.Html.GeneralizedPlot();};
CaluMath.Html.RemoveNamesMemoryList=new Array();
CaluMath.Html.MemoryLeakArray=new Array();
CaluMath.Html.BreakReferences=function(){
if(document.getElementById("texteditbutton")!=null){
document.getElementById("texteditbutton").onclick=null;}
if(window.CaluMath.Html.MemoryLeakArray!=null&&window.CaluMath.Html.MemoryLeakArray.length!=null){
for(var i=0;i<CaluMath.Html.MemoryLeakArray.length;i++){
if(CaluMath.Html.MemoryLeakArray[i]!=null){
CaluMath.Html.MemoryLeakArray[i].cm_object=null;
CaluMath.Html.MemoryLeakArray[i].cm_currentobject=null;
CaluMath.Html.MemoryLeakArray[i].cm_button=null;
CaluMath.Html.MemoryLeakArray[i].cm_parentobject=null;
CaluMath.Html.MemoryLeakArray[i].cm_node=null;
CaluMath.Html.MemoryLeakArray[i].cm_controlledby=null;
CaluMath.Html.MemoryLeakArray[i].cm_draggingarray=null;
CaluMath.Html.MemoryLeakArray[i].cm_draggingpoint=null;
CaluMath.Html.MemoryLeakArray[i].cm_draggingrectangle=null;
CaluMath.Html.MemoryLeakArray[i].cm_stretchingarray=null;
CaluMath.Html.MemoryLeakArray[i].cm_stretchingrectangle=null;
CaluMath.Html.MemoryLeakArray[i].cm_onclick=null;
CaluMath.Html.MemoryLeakArray[i].cm_ondrag=null;
CaluMath.Html.MemoryLeakArray[i].onmousedown=null;
CaluMath.Html.MemoryLeakArray[i].onmouseup=null;
CaluMath.Html.MemoryLeakArray[i].cm_onmousemove=null;
CaluMath.Html.MemoryLeakArray[i].cm_onmouseover=null;
CaluMath.Html.MemoryLeakArray[i].cm_onmouseoff=null;
CaluMath.Html.MemoryLeakArray[i].onmousemove=null;
CaluMath.Html.MemoryLeakArray[i].onmouseover=null;
CaluMath.Html.MemoryLeakArray[i].onmouseoff=null;
CaluMath.Html.MemoryLeakArray[i].onchange=null;
CaluMath.Html.MemoryLeakArray[i].onkeypress=null;
CaluMath.Html.MemoryLeakArray[i]=null;}}
CaluMath.Html.MemoryLeakArray=null;}
for(var i=0;i<cm_onunloadarray.length;i++){
cm_onunloadarray[i]();
cm_onunloadarray[i]=null;}
cm_onunloadarray=null;
if(window.cm_onunload!=null){
cm_onunload();}
if(window.CaluMath.Html.NewWindowArray!=null){
for(var i=0;i<CaluMath.Html.NewWindowArray.length;i++){
window[CaluMath.Html.NewWindowArray[i]]=null;
CaluMath.Html.NewWindowArray[i]=null;}
CaluMath.Html.NewWindowArray=null;}
if(window.CaluMath.Html.DefinedFunctionArray!=null){
for(var i=0;i<CaluMath.Html.DefinedFunctionArray.length;i++){
window[CaluMath.Html.DefinedFunctionArray[i]]=null;
CaluMath.Html.DefinedFunctionArray[i]=null;}
CaluMath.Html.DefinedFunctionArray=null;}
if(window.CaluMath.Html.PlotArray!=null){
for(var i=0;i<CaluMath.Html.PlotArray.length;i++){
window[CaluMath.Html.PlotArray[i]]=null;
CaluMath.Html.PlotArray[i]=null;}
CaluMath.Html.PlotArray=null;}
if(window.CaluMath.Html.RemoveNamesMemoryList!=null){
for(var i=0;i<window.CaluMath.Html.RemoveNamesMemoryList.length;i++){
window[window.CaluMath.Html.RemoveNamesMemoryList[i]]=null;}
window.CaluMath.Html.RemoveNamesMemoryList=null;}
cm_onunload=null;
onunload=null;
if(window.CM_MainWindow!=null){
CM_MainWindow=null;}};
CaluMath.Html.BreakNewWindowReferences=function(){
if(window.CM_MainWindow!=null&&window.CM_MainWindow!=window&&!CM_MainWindow.closed&&CM_MainWindow.CaluMath.Html.PlotArray!=null&&CM_MainWindow.CaluMath.Html.PlotArray.length!=null){
var tempCM_PlotArray=CM_MainWindow.CaluMath.Html.PlotArray;
var tempCM_PlotArraylength=CM_MainWindow.CaluMath.Html.PlotArray.length;
for(var i=0;i<tempCM_PlotArraylength;i++){
window[tempCM_PlotArray[i]]=null;}}
if(window.CM_MainWindow!=null&&window.CM_MainWindow!=window&&!CM_MainWindow.closed){
for(var fun in CM_MainWindow.CaluMath.Html.DefinedFunction.CM_FunctionDefinitions){
if(CM_MainWindow.CaluMath.Html.DefinedFunction.CM_FunctionDefinitions.hasOwnProperty(fun)){
window[fun]=null;}}}
if(window.CM_MainWindow!=null&&CM_MainWindow.CaluMath.Html.NewWindowArray!=null&&!CM_MainWindow.closed){
for(var i=0;i<CM_MainWindow.CaluMath.Html.NewWindowArray.length;i++){
if(CM_MainWindow.CaluMath.Html.NewWindowArray[i]!=null&&CM_MainWindow.CaluMath.Html.NewWindowArray[i].closed!=null&&!CM_MainWindow.CaluMath.Html.NewWindowArray[i].closed){
window[CM_MainWindow.CaluMath.Html.NewWindowArray[i].CM_WindowName]=null;}}}};
CaluMath.Html.WriteIframeCommand=function(){
try{
var rendertype=arguments[0];
var tempname=arguments[1];
if(rendertype==null||rendertype.length==0||rendertype=="cm_calumath"){
var filename="place_this_in_folder_with_web_pages.html";}
else if(rendertype=="cm_java"){
var filename="place_this_in_folder_with_web_pages_java.html";}
else if(rendertype=="cm_svg"){
if(CaluMath.Html.InternetExplorerDetected!="yes"){
var filename="place_this_in_folder_with_web_pages.svg";}
else{
var filename="place_this_in_folder_with_web_pages_vml.html";}}
if(arguments[2]!="no"){
return document.write('<iframe src="'+filename+'" class="cm_iframe"  name="cm_iframefor'+tempname+'" scrolling="no"  frameborder="0" marginheight="1px" marginwidth="1px" width="300" height="300"></iframe>');}
else{
return document.write('<iframe src="'+filename+'" class="cm_iframe"  name="'+tempname+'" scrolling="no"  frameborder="0" marginheight="1px" marginwidth="1px" width="300" height="300"></iframe>');}}
catch(e){
alert("Problem loding the svg web page.");}};
CaluMath.Html.WriteIframeCommandForPageMaker=function(){
try{
var rendertype=arguments[0][0];
var tempname=arguments[0][1];
if(rendertype==null||rendertype.length==0||rendertype=="cm_calumath"){
var filename="place_this_in_folder_with_web_pages.html";}
else if(rendertype=="cm_java"){
var filename="place_this_in_folder_with_web_pages_java.html";}
else if(rendertype=="cm_svg"){
if(CaluMath.Html.InternetExplorerDetected!="yes"){
var filename="place_this_in_folder_with_web_pages.svg";}
else{
var filename="place_this_in_folder_with_web_pages_vml.html";}}
if(arguments[0][2]!="no"){
return '</script><iframe src="'+filename+'" class="cm_iframe"  name="cm_iframefor'+tempname+'" scrolling="no"  frameborder="0" marginheight="1px" marginwidth="1px" width="300" height="300"></iframe><script>';}
else{
return '</script><iframe src="'+filename+'" class="cm_iframe"  name="'+tempname+'" scrolling="no"  frameborder="0" marginheight="1px" marginwidth="1px" width="300" height="300"></iframe><script>';}}
catch(e){
alert("Problem loding the svg web page.");}};
CaluMath.Html.DecreaseFontSize=function(){
var node=arguments[0];
if(node==null){
node=document.getElementsByTagName("body");
if(node==null){
return;}
else{
node=node[0];}
if(node==null){
return;}}
if(node.cm_node!=null){
node=node.cm_node;
if(node!=null&&node.cm_constructorname=="Array"){
nodelength=node.length;
for(var j=0;j<nodelength;j++){
CaluMath.Html.DecreaseFontSize(node[j]);}
return node;}}
if(node==null){
return;}
var style=node.style;
if(style!=null){
var fontSize=style.fontSize;
if(fontSize!=null){
if(fontSize.match(/px$/)){
fontSize=Math.max(6,Math.round(.8*parseInt(fontSize)))+"px";}
else if(fontSize=="xx-large"){
fontSize="x-large";}
else if(fontSize=="x-large"){
fontSize="large";}
else if(fontSize=="large"){
fontSize="medium";}
else if(fontSize=="medium"){
fontSize="small";}
else if(fontSize=="small"){
fontSize="x-small";}
else if(fontSize=="x-small"){
fontSize="xx-small";}
style.fontSize=fontSize;}}
var childNodes=node.childNodes;
var childNodesLength=childNodes.length
for(var i=0;i<childNodesLength;i++){
CaluMath.Html.DecreaseFontSize(childNodes[i]);}
return node;};
CaluMath.Html.IncreaseFontSize=function(){
var node=arguments[0];
if(node==null){
node=document.getElementsByTagName("body");
if(node==null){
return;}
else{
node=node[0];}
if(node==null){
return;}}
if(node.cm_node!=null){
node=node.cm_node;
if(node!=null&&node.cm_constructorname=="Array"){
nodelength=node.length;
for(var j=0;j<nodelength;j++){
CaluMath.Html.IncreaseFontSize(node[j]);}
return node;}}
if(node==null){
return;}
var style=node.style;
if(style!=null){
var fontSize=style.fontSize;
if(fontSize!=null){
if(fontSize.match(/px$/)){
fontSize=Math.round(1.25*parseInt(fontSize))+"px";}
else if(fontSize=="x-large"){
fontSize="xx-large";}
else if(fontSize=="large"){
fontSize="x-large";}
else if(fontSize=="medium"){
fontSize="large";}
else if(fontSize=="small"){
fontSize="medium";}
else if(fontSize=="x-small"){
fontSize="small";}
else if(fontSize=="xx-small"){
fontSize="x-small";}
style.fontSize=fontSize;}}
var childNodes=node.childNodes;
var childNodesLength=childNodes.length;
for(var i=0;i<childNodesLength;i++){
CaluMath.Html.IncreaseFontSize(childNodes[i]);}
return node;};
CaluMath.Html.ConvertNumberToWordArray=["zero","one","two","three","four","five","six","seven","eight","nine","ten","eleven","twelve","thirteen","fourteen","fifteen","sixteen","seventeen","eighteen","nineteen","twenty"];
CaluMath.Html.AdjustBeginningPlotValues=function(){
if(arguments[0]==null){
return NaN;};
if(arguments[0].cm_evalmath()<0){
return 1.2*arguments[0];}
else{
return .8*arguments[0];}};
CaluMath.Html.AdjustEndingPlotValues=function(){
if(arguments[0]==null){
return NaN;};
if(arguments[0].cm_evalmath()<0){
return .8*arguments[0];}
else{
return 1.2*arguments[0];}};
CaluMath.Html.AlphabetLowerCaseArray=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"];
CaluMath.Html.AlphabetUpperCaseArray=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
CaluMath.Html.AlphabetArray=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
CaluMath.Html.Digits=[0,1,2,3,4,5,6,7,8,9,"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
CaluMath.Html.CorrectDigits=["3","6","7","8","A","E","H","I","L","N","O","T","b","c","d","e","j","m","p","x"];
CaluMath.Html.IncorrectDigits=["0","1","2","4","5","9","a","f","g","h","i","k","l","n","o","q","r","s","t","u","v","w","y","z","B","C","D","F","G","J","K","M","P","Q","R","S","U","V","W","X","Y","Z"];
CaluMath.Html.CreateRandomDigitsArray=function(){
var Digits=CaluMath.Html.Digits.slice(0);
var CorrectDigits=new Array();
for(var i=0;i<20;i++){
var j=CaluMath.Html.RandomInteger(0,Digits.length-1);
CorrectDigits.push(Digits[j]);
Digits.splice(j,1);}
return[CorrectDigits,Digits];};
CaluMath.Html.CorrectCode=function(){
var CorrectDigits=CaluMath.Html.CorrectDigits;
var CorrectDigitsLength=CorrectDigits.length;
var IncorrectDigits=CaluMath.Html.IncorrectDigits;
var IncorrectDigitsLength=IncorrectDigits.length;
var returnarray=new Array();
var correctindices=new Array();
if(arguments.length!=1){
var correctindiceslength=arguments.length-1;
var codelength=arguments[arguments.length-1];
for(var i=0;i<correctindiceslength;i++){
correctindices[i]=arguments[i]-1;}}
else{
var correctindiceslength=arguments[0].length-1;
var codelength=arguments[0][arguments[0].length-1];
for(var i=0;i<correctindiceslength;i++){
correctindices[i]=arguments[0][i]-1;}}
for(var j=0;j<correctindiceslength;j++){
var randomnumber=CaluMath.Html.RandomInteger(0,CorrectDigitsLength-1);
returnarray[correctindices[j]]=CorrectDigits[randomnumber];}
for(var j=0;j<codelength;j++){
if(returnarray[j]==null){
var randomnumber=CaluMath.Html.RandomInteger(0,IncorrectDigitsLength-1);
returnarray[j]=IncorrectDigits[randomnumber];}}
return returnarray.join("");};
CaluMath.Html.IncorrectCode=function(){
var IncorrectDigits=CaluMath.Html.IncorrectDigits;
var IncorrectDigitsLength=IncorrectDigits.length;
var returnarray=new Array();
if(arguments.length!=1){
var codelength=arguments[arguments.length-1];}
else{
var codelength=arguments[0][arguments[0].length-1];}
for(var j=0;j<codelength;j++){
var randomnumber=CaluMath.Html.RandomInteger(0,IncorrectDigitsLength-1);
returnarray[j]=IncorrectDigits[randomnumber];}
return returnarray.join("");};
CaluMath.Html.CorrectCode.Parameters=[6,7,8,9,10,10];
CaluMath.Html.DetermineBlackboardAnswerInformation=function(){
var BlackboardIframeNode=CaluMath.Html.MatchTagWithIframe(window);
var startingnode=BlackboardIframeNode;
if(startingnode==null){
return;}
var nextSibling=startingnode.nextSibling;
while(nextSibling!=null&&!(nextSibling.tagName!=null&&nextSibling.tagName.toLowerCase()=="script")){
nextSibling=nextSibling.nextSibling;}
if(nextSibling!=null){
if(nextSibling.text!=null&&nextSibling.text.length>0){
var nextscript=nextSibling;
var nextscripttext=nextscript.text;
nextscripttext=nextscripttext.replace(/\s*\"/g,"").replace(/\s*\'/g,"");}};
var nextSibling=startingnode.nextSibling;
while(nextSibling!=null&&!(nextSibling.tagName!=null&&nextSibling.tagName.toLowerCase()=="input"&&nextSibling.getAttribute("type")!=null&&nextSibling.getAttribute("type").toLowerCase()=="text")){
nextSibling=nextSibling.nextSibling;}
var answerbox=nextSibling;
if(answerbox!=null){
answerbox.style.display="none";
var currentlyinbox=answerbox.value;
var answerboxid=answerbox.id;
if(answerboxid!=null){
var problemnumber=answerbox.id.split(/_/)[0];}
else{
alert("There is a Blackboard problem, the answerbox does not have an id.");}
if(answerbox.previousSibling!=null){
var answerboxlabel=answerbox.previousSibling;
var answerboxlabeltext=answerboxlabel.childNodes[0];}}
else{
var framesarray=parent.frames;
var framesarraylength=framesarray.length;
framesloop:
for(var i=0;i<framesarraylength;i++){
if(framesarray[i]==window){
var problemnumber=i-1;
break framesloop;}}}
var returnobject={iframenode:BlackboardIframeNode,problemnumber:problemnumber,nextscript:nextscript,nextscripttext:nextscripttext,answerbox:answerbox,answerboxid:answerboxid,answerboxlabel:answerboxlabel,answerboxlabeltext:answerboxlabeltext};
return returnobject;};
CaluMath.Html.SaveToBlackboard=function(){
var visibledata=arguments[0];
if(visibledata==null){
visibledata="";}
var saveddata=arguments[1];
if(saveddata==null){
saveddata=[];}
var correctanswer=arguments[2];
if(correctanswer==null){
correctanswer="";}
var yesorno=arguments[3];
if(yesorno==null){
alert(["There is a mistake in saving your page to Blackboard. Your page should generate the object CorrectAnswerCode which is undefined in your page."]);
return;}
var parameters=arguments[4];
var probleminfo=CaluMath.Html.DetermineBlackboardAnswerInformation();
if(probleminfo==null){
return;}
if(probleminfo.nextscripttext!=null){
var matchzindex=probleminfo.nextscripttext.match(/z/i);
if(matchzindex!=null){
matchzindex=matchzindex.index;
var temptext=probleminfo.nextscripttext.slice(0,matchzindex);
var temparray=temptext.split(/[a-zA-Z]/);
temparray.sort(function(a,b){return 1*a-1*b});}
else{
temparray=CaluMath.Html.CorrectCode.Parameters;}}
else{
temparray=CaluMath.Html.CorrectCode.Parameters;}
if(parameters==null){
parameters=[];}
parameters=parameters.slice(0);
var parameterslength=parameters.length;
for(var i=0;i<parameterslength;i++){
if(window[parameters[i]]!=null){
if(window[parameters[i]].cm_constructorname=="Array"){
parameters[i]=parameters[i]+"="+window[parameters[i]].cm_display();}
else if(window[parameters[i]].cm_constructorname=="String"){
parameters[i]=parameters[i]+"='"+window[parameters[i]]+"'";}
else{
parameters[i]=parameters[i]+"="+window[parameters[i]];}}}
if(yesorno=="yes"){
yesorno=CaluMath.Html.CorrectCode(temparray.slice(0));}
else if(yesorno=="partial"){
yesorno=CaluMath.Html.CorrectCode(temparray.slice(1));}
else if(yesorno=="partial1"){
yesorno=CaluMath.Html.CorrectCode(temparray.slice(1));}
else if(yesorno=="partial2"){
yesorno=CaluMath.Html.CorrectCode(temparray.slice(2));}
else if(yesorno=="partial3"){
yesorno=CaluMath.Html.CorrectCode(temparray.slice(3));}
else if(yesorno=="partial4"){
yesorno=CaluMath.Html.CorrectCode(temparray.slice(4));}
else{
yesorno=CaluMath.Html.IncorrectCode(temparray.slice(0));}
var otherparameters=[];
if(parent!=null){
var parentframes=parent.frames;
var parentframeslength=parentframes.length;
for(var i=0;i<parentframeslength;i++){
if(parentframes[i].CaluMath!=null&&parentframes[i].CaluMath.Html!=null&&parentframes[i].CaluMath.Html.SaveRandomParametersToBlackboard!=null){
var thisframeparameters=parentframes[i].CaluMath.Html.SaveRandomParametersToBlackboard();
if(thisframeparameters!=null){
otherparameters[thisframeparameters[0]]=thisframeparameters[1];}}}}
var problemnumber=probleminfo.problemnumber;
if(parameters!=null){
var savethis="CMBLACKBOARDPROBLEMNUMBER"+problemnumber+"ENDCMBLACKBOARDPROBLEMNUMBER"+"CMBLACKBOARDOTHERPARAMETERS"+otherparameters.cm_display()+"ENDCMBLACKBOARDOTHERPARAMETERS"+"CMBLACKBOARDPARAMETERS["+parameters.cm_display().cm_keniqrx62bp()+"]ENDCMBLACKBOARDPARAMETERS"+"CMBLACKBOARDVISIBLEDATA"+visibledata+"ENDCMBLACKBOARDVISIBLEDATA"+"CMBLACKBOARDSAVEDDATA"+saveddata+"ENDCMBLACKBOARDSAVEDDATA"+"CMBLACKBOARDOTHERINFORMATION["+correctanswer.cm_keniqrx62bp()+"]ENDCMBLACKBOARDOTHERINFORMATION"+yesorno;}
else{
var savethis="CMBLACKBOARDPROBLEMNUMBER"+problemnumber+"ENDCMBLACKBOARDPROBLEMNUMBER"+"CMBLACKBOARDOTHERPARAMETERS"+otherparameters.cm_display()+"ENDCMBLACKBOARDOTHERPARAMETERS"+"CMBLACKBOARDVISIBLEDATA"+visibledata+"ENDCMBLACKBOARDVISIBLEDATA"+"CMBLACKBOARDSAVEDDATA"+saveddata+"ENDCMBLACKBOARDSAVEDDATA"+"CMBLACKBOARDOTHERINFORMATION["+correctanswer.cm_keniqrx62bp()+"]ENDCMBLACKBOARDOTHERINFORMATION"+yesorno;}
if(probleminfo.answerbox==null){
return;}
probleminfo.answerbox.value=savethis;
probleminfo.answerboxlabeltext.data="Your current saved answer is: "+visibledata;
if(parent.saveAnswer!=null){
parent.saveAnswer(parent.CM_BlackBoardOnclickSaveType,probleminfo.problemnumber);}
return;};
CaluMath.Html.SaveRandomParametersToBlackboard=function(){
if(window.RandomConstantsArray==null){
return "";}
var parameters=window.RandomConstantsArray;
if(parameters.cm_constructorname!="Array"||parameters.length==0){
return;}
var probleminfo=CaluMath.Html.DetermineBlackboardAnswerInformation();
if(probleminfo==null){
return;}
if(probleminfo.answerbox!=null&&probleminfo.answerbox.value.length>0){
return;}
if(parameters==null){
parameters=[];}
parameters=parameters.slice(0);
var parameterslength=parameters.length;
for(var i=0;i<parameterslength;i++){
if(window[parameters[i]]!=null){
if(window[parameters[i]].cm_constructorname=="Array"){
parameters[i]=parameters[i]+"="+window[parameters[i]].cm_display();}
else if(window[parameters[i]].cm_constructorname=="String"){
parameters[i]=parameters[i]+"='"+window[parameters[i]]+"'";}
else{
parameters[i]=parameters[i]+"="+window[parameters[i]];}}}
return[probleminfo.problemnumber,parameters.cm_display().cm_keniqrx62bp()];};
CaluMath.Html.BlackboardLoadParametersFunction=function(){
if(window.parent==null||window.parent.CM_BlackBoardRecreatedParametersArray==null){
return;}
else{
if(window.CaluMath.Html.DetermineBlackboardAnswerInformation!=null){
var probleminfo=CaluMath.Html.DetermineBlackboardAnswerInformation();
if(probleminfo!=null){
var parameters=parent.CM_BlackBoardRecreatedParametersArray[probleminfo.problemnumber];
if(parameters!=null){
parameters=window.Array.prototype.cm_keniqrx62bps.apply(parameters,[]);
if(parameters!=null){
try{
eval(parameters);}
catch(e){
alert(["There is an Error with the Parameters",parameters,parameters.length,parameters.match(/\S/)==null,parameters.match(/\w]/)==null,parameters.constructor]);}}}}}}};
CaluMath.Html.CheckXYEquationCorrectness=function(){
var stringequation=arguments[0].replace(/\s*/g,"");
var variablesarray=arguments[1];
var correctfunction=arguments[2];
var precision=arguments[3];
var range=arguments[4];
var n=arguments[5];
var Round=CaluMath.Html.Round;
var RandomNumber=CaluMath.Html.RandomNumber;
if(n==null){
n=CaluMath.Html.CheckXYEquationCorrectness.N;}
var checkthesevaluesarray=new Array();
if(variablesarray[0].cm_constructorname!="Array"){
checkthesevaluesarray[0]=CaluMath.Html.RandomArray(2*n,range[0],range[1],"RandomNumber","yes",3);
checkthesevaluesarray[1]=checkthesevaluesarray[0].cm_applyfunction(correctfunction);}
var splitstringequation=stringequation.split(/=/);
if(splitstringequation.length==1){
return alert("Your equation "+stringequation+" does not contain an = sign.");}
var lhs="*"+splitstringequation[0]+"*";
var rhs="*"+splitstringequation[1]+"*";
var regexpressionarray=new Array();
for(var j=0;j<variablesarray.length;j++){
regexpressionarray[j]=new RegExp("([\+\*\-\/\^\(\)\,\\[])"+variablesarray[j]+"([\+\*\-\/\^\(\)\,\\]])","g");}
var correctarray=new Array();
var checkthesevaluesarray0length=checkthesevaluesarray[0].length;
correctloop:
for(var i=0;i<checkthesevaluesarray0length;i++){
var lhsi=lhs;
var rhsi=rhs;
for(var j=0;j<regexpressionarray.length;j++){
var lhsi=lhsi.replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2").replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2");
var rhsi=rhsi.replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2").replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2");}
lhsi=lhsi.replace(/^\*/,"").replace(/\*$/,"");
rhsi=rhsi.replace(/^\*/,"").replace(/\*$/,"");
var lhsi=Round(lhsi,precision);
var rhsi=Round(rhsi,precision);
if(isNaN(lhsi)!=true&&isNaN(lhsi)!=true){
if(isFinite(lhsi)&&isFinite(rhsi)){
if(lhsi==rhsi){
correctarray.push(i);
if(correctarray.length>=n){
break correctloop;}}
else{
return "no";}}}}
if(correctarray.length<n){
return "no";}
for(var i=0;i<checkthesevaluesarray[1].length;i++){
checkthesevaluesarray[1][i]=checkthesevaluesarray[1][i]+Round(RandomNumber(2,10),3);}
var incorrectarray=new Array();
var checkthesevaluesarray0length=checkthesevaluesarray[0].length;
incorrectloop:
for(var i=0;i<checkthesevaluesarray0length;i++){
var lhsi=lhs;
var rhsi=rhs;
for(var j=0;j<regexpressionarray.length;j++){
var lhsi=lhsi.replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2").replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2");
var rhsi=rhsi.replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2").replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2");}
lhsi=lhsi.replace(/^\*/,"").replace(/\*$/,"");
rhsi=rhsi.replace(/^\*/,"").replace(/\*$/,"");
var lhsi=Round(lhsi,precision);
var rhsi=Round(rhsi,precision);
if(isNaN(lhsi)!=true&&isNaN(lhsi)!=true){
if(isFinite(lhsi)&&isFinite(rhsi)){
if(lhsi!=rhsi){
incorrectarray.push(i);
if(incorrectarray.length>=n){
break incorrectloop;}}}}}
if(incorrectarray.length<n){
return "no";}
return "yes";};
CaluMath.Html.CheckXYEquationCorrectness=function(){
var stringequation=arguments[0].replace(/\s*/g,"");
var variablesarray=arguments[1];
var correctfunction=arguments[2];
var precision=arguments[3];
var range=arguments[4];
var n=arguments[5];
var Round=CaluMath.Html.Round;
var RandomNumber=CaluMath.Html.RandomNumber;
if(n==null){
n=CaluMath.Html.CheckXYEquationCorrectness.N;}
var checkthesevaluesarray=new Array();
if(variablesarray[0].cm_constructorname!="Array"){
checkthesevaluesarray[0]=CaluMath.Html.RandomArray(2*n,range[0],range[1],"RandomNumber","yes",3);
checkthesevaluesarray[1]=checkthesevaluesarray[0].cm_applyfunction(correctfunction);}
var splitstringequation=stringequation.split(/=/);
if(splitstringequation.length==1){
return alert("Your equation "+stringequation+" does not contain an = sign.");}
else if(splitstringequation.length>2){
return alert("Your equation "+stringequation+" contains more than one = sign.");}
var lhs="*"+splitstringequation[0]+"*";
var rhs="*"+splitstringequation[1]+"*";
var regexpressionarray=new Array();
for(var j=0;j<variablesarray.length;j++){
regexpressionarray[j]=new RegExp("([\+\*\-\/\^\(\)\,\\[])"+variablesarray[j]+"([\+\*\-\/\^\(\)\,\\]])","g");}
var correctarray=new Array();
var checkthesevaluesarray0length=checkthesevaluesarray[0].length;
correctloop:
for(var i=0;i<checkthesevaluesarray0length;i++){
var lhsi=lhs;
var rhsi=rhs;
for(var j=0;j<regexpressionarray.length;j++){
var lhsi=lhsi.replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2").replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2");
var rhsi=rhsi.replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2").replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2");}
lhsi=lhsi.replace(/^\*/,"").replace(/\*$/,"");
rhsi=rhsi.replace(/^\*/,"").replace(/\*$/,"");
var lhsi=Round(lhsi,precision);
var rhsi=Round(rhsi,precision);
if(isNaN(lhsi)!=true&&isNaN(lhsi)!=true){
if(isFinite(lhsi)&&isFinite(rhsi)){
if(lhsi==rhsi){
correctarray.push(i);
if(correctarray.length>=n){
break correctloop;}}
else{
return "no";}}}}
if(correctarray.length<n){
return "no";}
for(var i=0;i<checkthesevaluesarray[1].length;i++){
checkthesevaluesarray[1][i]=checkthesevaluesarray[1][i]+Round(RandomNumber(2,10),3);}
var incorrectarray=new Array();
var checkthesevaluesarray0length=checkthesevaluesarray[0].length;
incorrectloop:
for(var i=0;i<checkthesevaluesarray0length;i++){
var lhsi=lhs;
var rhsi=rhs;
for(var j=0;j<regexpressionarray.length;j++){
var lhsi=lhsi.replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2").replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2");
var rhsi=rhsi.replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2").replace(regexpressionarray[j],"$1("+checkthesevaluesarray[j][i]+")$2");}
lhsi=lhsi.replace(/^\*/,"").replace(/\*$/,"");
rhsi=rhsi.replace(/^\*/,"").replace(/\*$/,"");
var lhsi=Round(lhsi,precision);
var rhsi=Round(rhsi,precision);
if(isNaN(lhsi)!=true&&isNaN(lhsi)!=true){
if(isFinite(lhsi)&&isFinite(rhsi)){
if(lhsi!=rhsi){
incorrectarray.push(i);
if(incorrectarray.length>=n){
break incorrectloop;}}}}
else{
incorrectarray.push(i);}}
if(incorrectarray.length<n){
return "no";}
return "yes";};
CaluMath.Html.CheckXYEquationCorrectness.N=5;
CaluMath.Html.OnlyNonDegenerateSegments=function(){
var temparray=arguments[0];
var temparraylength=temparray.length;
for(var i=0;i<temparraylength;i++){
var firstpoint=temparray[i][0];
var secondpoint=temparray[i][1];
if(firstpoint.cm_objecttype=="CM_PointPlot"){
firstpoint=[1*firstpoint.x,1*firstpoint.y];}
if(secondpoint.cm_objecttype=="CM_PointPlot"){
secondpoint=[1*secondpoint.x,1*secondpoint.y];}
if((firstpoint[0]==secondpoint[0])&&(firstpoint[1]==secondpoint[1])){
return firstpoint.slice(0);}}
return "yes";};
CaluMath.Html.DomainAndRange=function(){
var tempreturn=CaluMath.Html.OnlyNonDegenerateSegments(arguments[0]);
if(tempreturn!="yes"){
return["degeneratesegments",tempreturn];}
else{
var temparray=arguments[0];
var temparraylength=temparray.length;
for(var i=0;i<temparraylength;i++){
var firstpoint=temparray[i][0];
var secondpoint=temparray[i][1];
if(firstpoint.cm_objecttype=="CM_PointPlot"){
firstpoint=[1*firstpoint.x,1*firstpoint.y];}
if(secondpoint.cm_objecttype=="CM_PointPlot"){
secondpoint=[1*secondpoint.x,1*secondpoint.y];}
if((firstpoint[0]==secondpoint[0])&&(firstpoint[1]!=secondpoint[1])){
if(firstpoint[1]<=secondpoint[1]){
return["verticalpoints",firstpoint,secondpoint];}
else{
return["verticalpoints",secondpoint,firstpoint];}}}
var args0array=arguments[0];
var args0arraylength=args0array.length;
var temparray=new Array();
for(var i=0;i<args0arraylength;i++){
var args0arrayi=args0array[i];
var firstpointi=args0arrayi[0];
var secondpointi=args0arrayi[1];
if(firstpointi.cm_objecttype=="CM_PointPlot"){
firstpointi=[1*firstpointi.x,1*firstpointi.y];}
else{
var firstpointi=args0arrayi[0].slice(0);}
if(secondpointi.cm_objecttype=="CM_PointPlot"){
secondpointi=[1*secondpointi.x,1*secondpointi.y];}
else{
var secondpointi=args0arrayi[1].slice(0);}
if(args0arrayi[2]!=null){
if(args0arrayi[2]=="o"){
var typeentry="oo";}
else if(args0arrayi[2]=="c"){
var typeentry="cc";}
else{
var typeentry=args0arrayi[2];}}
else if(args0arrayi[2]==null){
var typeentry="cc";}
temparray[i]=[firstpointi,secondpointi,typeentry];}
for(var i=0;i<temparraylength;i++){
var temparrayi=temparray[i];
var firstpointi=temparrayi[0];
var secondpointi=temparrayi[1];
if(temparrayi[2]=="cc"){
for(var j=i+1;j<temparraylength;j++){
var temparrayj=temparray[j];
var firstpointj=temparrayj[0];
var secondpointj=temparrayj[1];
if((firstpointi[0]==firstpointj[0])&&(firstpointi[1]==firstpointj[1])){
temparrayj[2]="o"+temparrayj[2].charAt(1);}
if((firstpointi[0]==secondpointj[0])&&(firstpointi[1]==secondpointj[1])){
temparrayj[2]=temparrayj[2].charAt(0)+"o";}
if((secondpointi[0]==firstpointj[0])&&(secondpointi[1]==firstpointj[1])){
temparrayj[2]="o"+temparrayj[2].charAt(1);}
if((secondpointi[0]==secondpointj[0])&&(secondpointi[1]==secondpointj[1])){
temparrayj[2]=temparrayj[2].charAt(0)+"o";}}}
else if(temparrayi[2]=="co"){
for(var j=i+1;j<temparraylength;j++){
var temparrayj=temparray[j];
var firstpointj=temparrayj[0];
var secondpointj=temparrayj[1];
if((firstpointi[0]==firstpointj[0])&&(firstpointi[1]==firstpointj[1])){
temparrayj[2]="o"+temparrayj[2].charAt(1);}
if((firstpointi[0]==secondpointj[0])&&(firstpointi[1]==secondpointj[1])){
temparrayj[2]=temparrayj[2].charAt(0)+"o";}}}
else if(temparrayi[2]=="oc"){
for(var j=i+1;j<temparraylength;j++){
var temparrayj=temparray[j];
var firstpointj=temparrayj[0];
var secondpointj=temparrayj[1];
if((secondpointi[0]==firstpointj[0])&&(secondpointi[1]==firstpointj[1])){
temparrayj[2]="o"+temparrayj[2].charAt(1);}
if((secondpointi[0]==secondpointj[0])&&(secondpointi[1]==secondpointj[1])){
temparrayj[2]=temparrayj[2].charAt(0)+"o";}}}}
var xarray=new Array();
for(var i=0;i<temparraylength;i++){
var firstpoint=temparray[i][0];
var secondpoint=temparray[i][1];
if(firstpoint.cm_objecttype=="CM_PointPlot"){
var firstx=1*firstpoint.x;}
else{
var firstx=1*firstpoint[0];}
if(secondpoint.cm_objecttype=="CM_PointPlot"){
var secondx=1*secondpoint.x;}
else{
var secondx=1*secondpoint[0];}
if(temparray[i][2]==null||temparray[i][2]=="c"){
xarray[i]=[firstx,secondx,"cc"];}
else if(temparray[i][2]=="o"){
xarray[i]=[firstx,secondx,"oo"];}
else{
xarray[i]=[firstx,secondx,temparray[i][2]];}}
var tempreturn=xarray.cm_isadomain();
if(tempreturn!="yes"){
return["notwelldefinedx",tempreturn];}
else{
var domain=xarray.cm_intervalstandardform();
var yarray=new Array();
for(var i=0;i<temparraylength;i++){
var firstpoint=temparray[i][0];
var secondpoint=temparray[i][1];
if(firstpoint.cm_objecttype=="CM_PointPlot"){
var firsty=1*firstpoint.y;}
else{
var firsty=1*firstpoint[1];}
if(secondpoint.cm_objecttype=="CM_PointPlot"){
var secondy=1*secondpoint.y;}
else{
var secondy=1*secondpoint[1];}
if(temparray[i][2]==null||temparray[i][2]=="c"){
yarray[i]=[firsty,secondy,"cc"];}
else if(firsty==secondy){
yarray[i]=[firsty,secondy,"cc"];}
else if(temparray[i][2]=="o"){
yarray[i]=[firsty,secondy,"oo"];}
else{
yarray[i]=[firsty,secondy,temparray[i][2]];}}
var range=yarray.cm_intervalstandardform();
return[domain,range];}}};

