
CM.Complex=function(){
var type=arguments[0].cm_instanceof;
if(type==="Array"){
this.terms=arguments[0];}
else if(type==="Complex"){
return arguments[0];}
else if(type=="Integer"||type=="Rational"||type=="Floating"){
this.terms=[arguments[0],CM.Integer.zero]}
else{
var errorstring="An incorrect type was passed to the Complex number constructor. It was "+arguments[0]+" and "+arguments[1]+".";
alert(errorstring);
throw new Error(errorstring);}};
CM.Complex.prototype=new CM.Atomic();
CM.Complex.prototype.constructor=CM.Complex;
CM.Complex.prototype.cm_instanceof="Complex";
CM.Complex.prototype.isNumber=true;
CM.Complex.i=new CM.Complex([CM.Integer.zero,CM.Integer.one]);
CM.Complex.one=new CM.Complex([CM.Integer.one,CM.Integer.zero]);
CM.Complex.minusI=new CM.Complex([CM.Integer.zero,CM.Integer.minusOne]);
CM.Complex.prototype.getTerms=function(){
var thisterms=this.terms;
return[thisterms[0],thisterms[1]];};
CM.Complex.prototype.simplifyInCLass=function(){
if(this.simplifiedInClass!=null){
return this.simplifiedInClass;}
else{
var tempa=this.terms[0].simplify();
var tempb=this.terms[1].simplify();
return this.simplifiedInClass=new CM.Complex([tempa,tempb]);}};
CM.Complex.prototype.simplify=function(){
if(this.simplified!=null){
return this.simplified;}
else{
var tempa=this.terms[0].simplify();
var tempb=this.terms[1].simplify();
if(tempb.equalTo(CM.Integer.zero)){
return tempa;}
else{
var tempComplex=new CM.Complex([tempa,tempb]);}
return this.simplified=tempComplex;}};
CM.Complex.prototype.equalTo=function(){
var left=this.simplify();
var right=arguments[0];
if(right.cm_instanceof!="Complex"&&right.simplify!=null){
right=right.simplify();}
if(right.isNumber!=true){
return false;}
if(left.real().equalTo(right.real())&&left.imaginary().equalTo(right.imaginary())){
return true;}
else{
return false;}};
CM.Complex.prototype.isZero=function(){
var terms=this.terms;
return(terms[0].isZero()&&terms[1].isZero());};
CM.Complex.prototype.add=function(){
var leftReal=this.terms[0];
var leftImaginary=this.terms[1];
var rightReal=arguments[0].real();
var rightImaginary=arguments[0].imaginary();
var tempReal=(new CM.Sum([leftReal,rightReal])).simplify();
var tempImaginary=(new CM.Sum([leftImaginary,rightImaginary])).simplify();
if(tempImaginary.equalTo(CM.Integer.zero)){
return tempReal;}
else{
return new CM.Complex([tempReal,tempImaginary]);}};
CM.Complex.prototype.subtract=function(){
var leftReal=this.terms[0];
var leftImaginary=this.terms[1];
var rightReal=arguments[0].real();
var rightImaginary=arguments[0].imaginary();
var tempReal=(new CM.Sum([leftReal,(new CM.Factor([CM.Integer.minusOne,rightReal])).simplify()])).simplify();
var tempImaginary=(new CM.Sum([leftImaginary,(new CM.Factor([CM.Integer.minusOne,rightImaginary])).simplify()])).simplify();
if(tempImaginary.equalTo(CM.Integer.zero)){
return tempReal;}
else{
return new CM.Complex([tempReal,tempImaginary]);}};
CM.Complex.prototype.multiply=function(){
var leftReal=this.terms[0];
var leftImaginary=this.terms[1];
var rightReal=arguments[0].real()
var rightImaginary=arguments[0].imaginary();
var tempReal=(new CM.Sum([(new CM.Factor([leftReal,rightReal])),(new CM.Factor([(new CM.Factor([CM.Integer.minusOne,leftImaginary])),rightImaginary]))])).simplify();
var tempImaginary=(new CM.Sum([(new CM.Factor([leftReal,rightImaginary])),(new CM.Factor([leftImaginary,rightReal]))])).simplify();
if(tempImaginary.equalTo(CM.Integer.zero)){
return tempReal;}
else{
return new CM.Complex([tempReal,tempImaginary]);}};
CM.Complex.prototype.divide=function(){
var leftReal=this.terms[0];
var leftImaginary=this.terms[1];
var rightReal=arguments[0].real();
var rightImaginary=arguments[0].imaginary();
if(leftReal.cm_instanceof=="Floating"||leftImaginary.cm_instanceof=="Floating"||rightReal.cm_instanceof=="Floating"||rightImaginary.cm_instanceof=="Floating"){
leftReal=new CM.Floating(leftReal);
leftImaginary=new CM.Floating(leftImaginary);
rightReal=new CM.Floating(rightReal);
rightImaginary=new CM.Floating(rightImaginary);
var tempReal=leftReal.multiply(rightReal).add(leftImaginary.multiply(rightImaginary)).divide(rightReal.power(CM.Integer.two).add(rightImaginary.power(CM.Integer.two)));
var tempImaginary=rightReal.multiply(leftImaginary).subtract(leftReal.multiply(rightImaginary)).divide(rightReal.power(CM.Integer.two).add(rightImaginary.power(CM.Integer.two)));}
else{
leftReal=new CM.Rational(leftReal);
leftImaginary=new CM.Rational(leftImaginary);
rightReal=new CM.Rational(rightReal);
rightImaginary=new CM.Rational(rightImaginary);
var tempReal=new CM.Rational(CM.Atomic.Add([leftReal.multiply(rightReal),leftImaginary.multiply(rightImaginary)])).divide(CM.Atomic.Add([rightReal.power(CM.Integer.two),rightImaginary.power(CM.Integer.two)]));
var tempImaginary=new CM.Rational(CM.Atomic.Add([rightReal.multiply(leftImaginary),leftReal.multiply(rightImaginary).multiply(CM.Integer.minusOne)])).divide(CM.Atomic.Add([rightReal.power(CM.Integer.two),rightImaginary.power(CM.Integer.two)]));}
if(tempImaginary.equalTo(CM.Integer.zero)){
return tempReal;}
else{
return new CM.Complex([tempReal,tempImaginary]);}};
CM.Complex.prototype.square=function(){
return new CM.Complex(this.multiply(this));};
CM.Complex.prototype.power=function(){
var exponent=arguments[0];
if(exponent.equalTo(CM.Integer.zero)){
return CM.Integer.one;}
if(exponent.equalTo(CM.Integer.one)){
return this;}
if(exponent.sign=="-"){
return CM.Complex.one.divide(this.power(exponent.abs()));}
var binaryString=exponent.toBaseTwo();
var bLength=binaryString.length;
var returnthis=this;
for(var i=1;i<bLength;i++){
if(binaryString.charAt(i)=='1'){
returnthis=returnthis.square();
returnthis=returnthis.multiply(this);}
else{
returnthis=returnthis.square();}}
return returnthis;};
CM.Complex.prototype.toString=function(){
var terms=this.terms;
if(terms[0].equalTo(CM.Integer.zero)){
if(terms[1].sign=='+'){
if(terms[1].cm_instanceof!=="Rational"){
if(terms[1].equalTo(CM.Integer.one)){
return 'i';}
else{
return ' '+terms[1].toString()+'*i';}}
else{
return '('+terms[1].toString()+')*i';}}
if(terms[1].sign=='-'){
if(terms[1].cm_instanceof!=="Rational"){
if(terms[1].equalTo(CM.Integer.minusOne)){
return '-i';}
else{
return terms[1].toString()+'*i';}}
else{
return '-('+terms[1].abs().toString()+')*i';}}}
else{
if(terms[1].cm_instanceof!=="Rational"){
if(terms[1].equalTo(CM.Integer.one)){
return terms[0].toString()+" + i";}
else if(terms[1].equalTo(CM.Integer.minusOne)){
return terms[0].toString()+" -  i";}
else if(terms[1].sign=="-"){
return terms[0].toString()+" "+terms[1].toString()+'*i';}
else{
return terms[0].toString()+" +"+terms[1].toString()+'*i';}}
else{
return terms[0].toString()+' + ('+terms[1].toString()+')*i';}}};
CM.Complex.prototype.absoluteValue=function(){
var leftReal=this.terms[0];
var leftImaginary=this.terms[1];
var absValue=new CM.Power([new CM.Sum([new CM.Power([leftReal,CM.Integer.two]),new CM.Power([leftImaginary,CM.Integer.two])]),CM.Rational.half]);
return absValue;};
CM.Complex.prototype.real=function(){
return this.terms[0];};
CM.Complex.prototype.imaginary=function(){
return this.terms[1];};
CM.Complex.prototype.round=function(){
return new CM.Complex([this.terms[0].round(arguments[0],arguments[1]),this.terms[1].round(arguments[0],arguments[1])]);};
CM.Complex.prototype.reciprocal=function(){
return CM.Complex.one.divide(this);};
CM.Complex.Add=function(){
var temparray=arguments[0];
var realarray=new Array();
var imaginaryarray=new Array();
var temparraylength=temparray.length;
for(var i=0;i<temparraylength;i++){
realarray.push(temparray[i].real());
imaginaryarray.push(temparray[i].imaginary());}
var realpart=CM.Atomic.Add(realarray);
var imaginarypart=CM.Atomic.Add(imaginaryarray);
if(imaginarypart.equalTo(CM.Integer.zero)){
return realpart;}
else{
return new CM.Complex([realpart,imaginarypart]);}};
CM.Complex.Multiply=function(){
var temparray=arguments[0];
var tempreturn=temparray[0];
for(var i=1;i<temparray.length;i++)
tempreturn=new CM.Complex(tempreturn).multiply(new CM.Complex(temparray[i]));
return tempreturn.simplify();}
CM.Complex.prototype.isInteger=function(){
if(this.simplify().cm_instanceof=="Integer"){
return true;}
else{
return false;}};

