
CM.Cos=function(){
this.terms=arguments[0];
this.hasDerivative=new Object();};
CM.Cos.prototype=new CM.StandardFunction("cos",["x"]);
CM.Cos.prototype.constructor=CM.Cos;
CM.Cos.prototype.name="cos";
CM.Cos.prototype.constructorName="Cos";
CM.Cos.prototype.argumentsLength=1;
CM.Cos.prototype.simplify=function(){
var thissimplified=this.simplified;
if(thissimplified!=null){
return thissimplified;}
var args=this.terms[0];
if(args.cm_instanceof=="Sum"){
args=args.expand();}
else{
args=args.simplify();}
if(args.isNumber===true){
var argssimplified=args.simplify();
if(argssimplified.equalTo(CM.Integer.zero)){
var tempreturn=CM.Integer.one;
tempreturn.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=new CM.Cos([argssimplified]);
tempreturn.simplified=tempreturn;
this.simplified=tempreturn;
return tempreturn;}}
var tempreturn=new CM.Sin([
new CM.Sum([
new CM.Factor([
CM.Rational.half,CM.Definitions.Constants.Standard["pi"]]),
new CM.Factor([
CM.Integer.minusOne,this.getTerms()[0]])])]).simplify();
if(tempreturn.cm_instanceof=="StandardFunction"){
var tempreturn=new CM.Cos([this.getTerms()[0].simplify()]);
tempreturn.simplified=tempreturn;
this.simplified=tempreturn;
return tempreturn;}
else{
tempreturn.simplified=tempreturn;
return tempreturn;}};
CM.Cos.prototype.round=function(){
var tempexponent=this.terms[0].round(arguments[0],arguments[1]);
var EValue=CM.RealConstant.EValue;
var sixtyfourth=new CM.Floating(new CM.Integer(15625),-6);
var extraprecision=20;
var two=CM.Floating.two;
var one=CM.Floating.one;
var log=Math.log;
var E=Math.E;
minusOne=CM.Floating.minusOne;
if(tempexponent.equalTo(CM.Integer.zero)){
return CM.Floating.one;}
if(tempexponent.isNumber===true){
if(tempexponent.sign=="-"){
var positiveexponentexponential=new CM.Exp([new CM.Floating(this.terms[0]).multiply(minusOne)]);
return CM.Floating.one.divide(positiveexponentexponential.round(arguments[0],arguments[1]),extraprecision+1*arguments[0],arguments[1]).round(arguments[0],arguments[1]);}
if(tempexponent.cm_instanceof=="Integer"){
return EValue.power(tempexponent,extraprecision+1*arguments[0],arguments[1]);}
var integermultiple=tempexponent.truncate(0);
tempexponent=tempexponent.subtract(integermultiple,extraprecision+1*arguments[0],arguments[1]);
var integerpart=EValue.power(integermultiple,extraprecision+1*arguments[0],arguments[1]);
var k=0;
while(tempexponent.greaterThan(sixtyfourth)){
tempexponent=tempexponent.divide(two,extraprecision+1*arguments[0],arguments[1]);
k++;}
smallexponential=new CM.Exp([tempexponent]);
var n=10;
while((n+1)*(log(n+1)-log(tempexponent)-1)/log(10)<=extraprecision+1*arguments[0]){
n++;}
smallexponential=smallexponential.evaluateTaylorSeries(n,extraprecision+1*arguments[0],arguments[1]);
smallexponential=smallexponential.power(CM.Integer.two.power(new CM.Integer(k)),extraprecision+1*arguments[0],arguments[1]);
smallexponential=smallexponential.multiply(integerpart,extraprecision+1*arguments[0],arguments[1]);
return smallexponential.round(arguments[0],arguments[1]);}
else{
return new CM.Exp([tempexponent]);}};
CM.Cos.prototype.evaluateTaylorSeries=function(){
var Floating=CM.Floating;
var minusOne=Floating.minusOne;
var tempreturn=Floating.one;
var previousterm=tempreturn;
var numberofterms=Math.floor(1*arguments[0].toString());
var precision=arguments[1];
var type=arguments[2];
if(precision==null){
precision=Floating.precision;}
precision=1*precision.toString();
if(type==null){
type="s";}
var exponent=this.terms[0].round(precision,type);
for(var i=1;i<numberofterms;i++){
previousterm=minusOne.multiply(previousterm,precision,type).multiply(exponent,precision,type).multiply(exponent,precision,type).divide(new CM.Floating(new CM.Integer(2*i)).multiply(new CM.Floating(new CM.Integer(2*i-1)),precision,type),precision,type);
tempreturn=tempreturn.add(previousterm,precision,type);}
return tempreturn;};

