
CM.Definitions.Functions=function(){}
CM.Definitions.Functions.User=function(){}
CM.Definitions.Functions.Standard=function(){}
CM.Definitions.Functions.Standard.cm_instanceof="Standard";
CM.Definitions.Functions.InterfaceCommand=function(){}
CM.Definitions.Functions.InterfaceCommand.cm_instanceof="InterfaceCommand";
CM.Definitions.Functions.Standard["sin"]=new CM.Sin(["_x_sin"]);
CM.Definitions.Functions.Standard["cos"]=new CM.Cos(["_x_cos"]);
CM.Definitions.Functions.Standard["tan"]=new CM.Tan(["_x_tan"]);
CM.Definitions.Functions.Standard["ln"]=new CM.Ln(["_x_ln"]);
CM.Definitions.Functions.Standard["log"]=new CM.Log(["_x_log"]);
CM.Definitions.Functions.Standard["exp"]=new CM.Exp(["_x_exp"]);
CM.Definitions.Functions.Standard["Abs"]=new CM.Abs(["_x_Abs"]);
CM.Definitions.Functions.Standard["Root"]=new CM.Root(["_x_Root"]);
CM.Definitions.Functions.InterfaceCommand.Simplify=function(){
return arguments[0].simplify();};
CM.Definitions.Functions.InterfaceCommand.FactorsArray=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(args0.cm_instanceof!="Integer"){
var errorstring="You are invoking FactorArray on an argument that is not an integer. You entered "+arguments[0]+" which cannot be converted into an integer.";
alert(errorstring);
throw new Error(errorstring);}
var tempreturn=args0.factorsArray();
var tempreturnlength=tempreturn.length;
var finalreturn=new Array();
for(var i=0;i<tempreturnlength;i++){
finalreturn[i]=new CM.Vector(tempreturn[i]);}
return new CM.Vector(finalreturn);};
CM.Definitions.Functions.InterfaceCommand.Factor=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(args0.cm_instanceof!="Integer"){
var errorstring="You are invoking Factor on an argument that is not an integer. You entered "+arguments[0]+" which cannot be converted into an integer.";
alert(errorstring);
throw new Error(errorstring);}
return args0.factor();};
CM.Definitions.Functions.InterfaceCommand.SetFactorTimeout=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
var args0=1000*(args0.toString());
CM.Integer.prototype.rhoMethod.Timeout=args0;};
CM.Definitions.Functions.InterfaceCommand.Phi=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(args0.cm_instanceof!="Integer"){
var errorstring="You are invoking Phi on an argument that is not an integer. You entered "+arguments[0]+" which cannot be converted into an integer.";
alert(errorstring);
throw new Error(errorstring);}
return args0.phi();};
CM.Definitions.Functions.InterfaceCommand.Equals=function(){
if(arguments[2]!=null){
if(arguments[2].cm_instanceof=="Expression")
var args2=arguments[2].terms[0].simplify();
else
var args2=arguments[2].simplify();}
if(arguments[3]!=null){
if(arguments[3].cm_instanceof=="Expression"){
var args3=arguments[3].terms[0].simplify();}
else{
var args3=arguments[3].simplify();}
if(args3==null){
args3="s";}}
if(args2==null){
var args0=arguments[0].simplify();
var args1=arguments[1].simplify();
if(args0.equalTo(args1)===true){
return true;}
if(args0.containsFractionalExponents()===true){
args0=args0.reduceFractionalExponentsAndSimplify();}
if(args1.containsFractionalExponents()===true){
args1=new CM.Factor([CM.Integer.minusOne,args1]).reduceFractionalExponentsAndSimplify();}
else{
args1=new CM.Factor([CM.Integer.minusOne,args1]);}
var tempreturn=new CM.Sum([args0.fastExpand(),args1.fastExpand()]);
tempreturn=tempreturn.numeratorAndDenominator(tempreturn);
if(tempreturn.equalTo(CM.Integer.zero)){
return true;}
if(tempreturn.containsFractionalExponents()===true){
tempreturn=tempreturn.reduceFractionalExponentsAndSimplify();
if(tempreturn.equalTo(CM.Integer.zero)){
return true;}}
return false;}
else{
var previousprecision=CM.Floating.precision;
CM.Floating.precision=10+1*args2;
var newargs0=arguments[0].round().expand().round(args2,args3);
var newargs1=arguments[1].round().expand().round(args2,args3);
CM.Floating.precision=previousprecision;
return newargs0.equalTo(newargs1,args2,args3);}};
CM.Definitions.Functions.InterfaceCommand.StructurallyEquivalent=function(){
return arguments[0].structurallyEquivalent(arguments[1]);};
CM.Definitions.Functions.InterfaceCommand.Evaluate=function(){
if(arguments[0].cm_instanceof=="Expression")
return arguments[0].terms[0];
else
return arguments[0].simplify();};
CM.Definitions.Functions.InterfaceCommand.Fibonacci=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(args0.cm_instanceof=="Integer"&&!args0.lessThan(CM.Integer.zero))
return CM.Integer.fibonacci(args0);
else{
alert("You are calling Fibonacci  on an object that cannot be converted to a nonnegative integer. The object is "+arguments[0]+".");
throw new Error("You are calling Fibonacci  on an object that cannot be converted to a nonnegative integer. The object is "+arguments[0]+".");}};
CM.Definitions.Functions.InterfaceCommand.IsPrime=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(arguments[1]!=null){
if(arguments[1].cm_instanceof=="Expression"){
var args1=arguments[1].terms[0].simplify();}
else{
var args1=arguments[1].simplify();}}
if(args0.cm_instanceof=="Integer"){
if(args1==null){
return args0.isPrime();}
else if(args1.cm_instanceof="Integer"){
return args0.isPrime(args1);}
else{
alert("You are calling IsPrime  on an Integer, however the number of times you want the test run cannot be converted into an Integer. The object that cannot be converted is "+arguments[1]+".");
throw new Error("You are calling IsPrime  on an Integer, however the number of times you want the test run cannot be converted into an Integer. The object that cannot be converted is "+arguments[1]+".");}}
else{
alert("You are calling IsPrime  on an object that cannot be converted to an integer. The object is "+arguments[0]+".");
throw new Error("You are calling IsPrime  on an object that cannot be converted to an integer. The object is "+arguments[0]+".");}};
CM.Definitions.Functions.InterfaceCommand.NextPrime=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(arguments[1]!=null){
if(arguments[1].cm_instanceof=="Expression"){
var args1=arguments[1].terms[0].simplify();}
else{
var args1=arguments[1].simplify();}}
if(args0.cm_instanceof=="Integer"){
if(args1==null){
return args0.nextPrime();}
else if(args1.cm_instanceof="Integer"){
return args0.nextPrime(args1);}
else{
alert("You are calling NextPrime  on an Integer, however the number of times you want the test run cannot be converted into an Integer. The object that cannot be converted is "+arguments[1]+".");
throw new Error("You are calling NextPrime  on an Integer, however the number of times you want the test run cannot be converted into an Integer. The object that cannot be converted is "+arguments[1]+".");}}
else{
alert("You are calling NextPrime  on an object that cannot be converted to an integer. The object is "+arguments[0]+".");
throw new Error("You are calling NextPrime  on an object that cannot be converted to an integer. The object is "+arguments[0]+".");}};
CM.Definitions.Functions.InterfaceCommand.PreviousPrime=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(arguments[1]!=null){
if(arguments[1].cm_instanceof=="Expression"){
var args1=arguments[1].terms[0].simplify();}
else{
var args1=arguments[1].simplify();}}
if(args0.cm_instanceof=="Integer"){
if(args1==null){
return args0.previousPrime();}
else if(args1.cm_instanceof="Integer"){
return args0.previousPrime(args1);}
else{
alert("You are calling PreviousPrime  on an Integer, however the number of times you want the test run cannot be converted into an Integer. The object that cannot be converted is "+arguments[1]+".");
throw new Error("You are calling PreviousPrime  on an Integer, however the number of times you want the test run cannot be converted into an Integer. The object that cannot be converted is "+arguments[1]+".");}}
else{
alert("You are calling PreviousPrime  on an object that cannot be converted to an integer. The object is "+arguments[0]+".");
throw new Error("You are calling PreviousPrime  on an object that cannot be converted to an integer. The object is "+arguments[0]+".");}};
CM.Definitions.Functions.InterfaceCommand.LegendreSymbol=function(){
if(arguments[2]!=null){
if(arguments[1].cm_instanceof=="Expression"){
var args2=arguments[2].terms[0];}
else{
var args2=arguments[2];}
if(args2.terms[0]!="yes"&&args2.terms[0]!="no"){
var errorstring=('You are calling LegrendreSymbol('+arguments[0]+','+arguments[1]+','+arguments[2]+'), however the last entry should either be "yes" or "no", or it should not appear.');
alert(errorstring);
throw new Error(errorstring);}}
else{
args2="yes";}
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(arguments[1].cm_instanceof=="Expression"){
var args1=arguments[1].terms[0].simplify();}
else{
var args1=arguments[1].simplify();}
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"){
return CM.Integer.LegendreSymbol(args0,args1,args2);}
else{
var errorstring=('You are calling LegrendreSymbol with the arguments '+arguments[0]+' and '+arguments[1]+'. However, one of these arguments cannot be converted into an integer. This is causing an error.');
alert(errorstring);
throw new Error(errorstring);}};
CM.Definitions.Functions.InterfaceCommand.RandomInteger=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(arguments[1].cm_instanceof=="Expression"){
var args1=arguments[1].terms[0].simplify();}
else{
var args1=arguments[1].simplify();}
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"){
return CM.Integer.random(args0,args1);}
else{
var tempstring="You are calling RandomInteger either on an object That cannot be converted to an Integer. The objects you entered are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.RandomnNonZeroInteger=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(arguments[1].cm_instanceof=="Expression"){
var args1=arguments[1].terms[0].simplify();}
else{
var args1=arguments[1].simplify();}
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"){
return CM.Integer.nonZeroRandom(args0,args1);}
else{
var tempstring="You are calling RandomInteger either on an object That cannot be converted to an Integer. The objects you entered are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.ModN=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if((args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Rational")&&args1.cm_instanceof=="Integer"){
return args0.mod(args1);}
else if(args0.cm_instanceof=="Polynomial"&&args1.cm_instanceof=="Integer"){
return args0.simplify(args1);}
else{
var tempstring="You are calling ModN either on an object that cannot be converted to an Integer, Rational number or Polynomial, or you are using a modulus that cannot be converted to integers. The objects you entered are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.Matrix=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(args0.cm_instanceof=="Vector"){
var termsarray=[];
var terms=args0.terms;
var termslength=terms.length;
for(var i=0;i<termslength;i++){
termsarray[i]=terms[i].terms;}
return new CM.Matrix(termsarray);}
else{
var tempstring="You are trying to define a Matrix with the input "+arguments[0]+". This is causing an error.";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.AddN=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Vector"&&args1.cm_instanceof=="Integer")
return CM.Integer.AddM(args0.terms,args1);
else{
var tempstring="You are calling AddN on objects that cannot be converted to integers. The objects are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.SubtractN=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(arguments[2].cm_instanceof=="Expression")
var args2=arguments[2].terms[0].simplify();
else
var args2=arguments[2].simplify();
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"&&args2.cm_instanceof=="Integer")
return args0.subtractM(args1,args2);
else{
var tempstring="You are calling SubtractN on objects that cannot be converted to integers. The objects are "+arguments[0]+"and "+arguments[1]+"and "+arguments[2]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.MultiplyN=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Vector"&&args1.cm_instanceof=="Integer")
return CM.Integer.MultiplyM(args0.terms,args1);
else{
var tempstring="You are calling MultiplyN on objects that cannot be converted to integers. The objects are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.PowerN=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(arguments[2].cm_instanceof=="Expression")
var args2=arguments[2].terms[0].simplify();
else
var args2=arguments[2].simplify();
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"&&args2.cm_instanceof=="Integer")
return args0.powerM(args1,args2);
else{
var tempstring="You are calling PowerN on objects that cannot be converted to integers. The objects are "+arguments[0]+" and "+arguments[1]+" and "+arguments[2]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.AddN=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(arguments[1].cm_instanceof=="Expression"){
var args1=arguments[1].terms[0].simplify();}
else{
var args1=arguments[1].simplify();}
if(arguments[2].cm_instanceof=="Expression"){
var args2=arguments[2].terms[0].simplify();}
else{
var args2=arguments[2].simplify();}
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"&&args2.cm_instanceof=="Integer"){
return args0.addM(args1,args2);}
else if((args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Polynomial")&&(args1.cm_instanceof=="Integer"||args1.cm_instanceof=="Polynomial")&&(args2.cm_instanceof=="Integer")){
return(CM.Composite.CreatePolynomial(args0)).add(CM.Composite.CreatePolynomial(args1),args2);}
else{
var tempstring="You are calling AddN and either the first or second parameter passed cannot be converted to an integer or polynomial, or the third parameter passed cannot be converted to an integer.  The parameters are "+arguments[0]+"and "+arguments[1]+"and "+arguments[2]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.MultiplyN=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
if(arguments[1].cm_instanceof=="Expression"){
var args1=arguments[1].terms[0].simplify();}
else{
var args1=arguments[1].simplify();}
if(arguments[2].cm_instanceof=="Expression"){
var args2=arguments[2].terms[0].simplify();}
else{
var args2=arguments[2].simplify();}
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"&&args2.cm_instanceof=="Integer"){
return args0.multiplyM(args1,args2);}
else if((args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Polynomial")&&(args1.cm_instanceof=="Integer"||args1.cm_instanceof=="Polynomial")&&(args2.cm_instanceof=="Integer")){
return(CM.Composite.CreatePolynomial(args0)).multiply(CM.Composite.CreatePolynomial(args1),args2);}
else{
var tempstring="You are calling AddN and either the first or second parameter passed cannot be converted to an integer or polynomial, or the third parameter passed cannot be converted to an integer.  The parameters are "+arguments[0]+"and "+arguments[1]+"and "+arguments[2]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.QuotientN=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(arguments[2].cm_instanceof=="Expression")
var args2=arguments[2].terms[0].simplify();
else
var args2=arguments[2].simplify();
if((args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Polynomial")&&(args1.cm_instanceof=="Integer"||args1.cm_instanceof=="Polynomial")&&(args2.cm_instanceof=="Integer")){
var divisionobject=(CM.Composite.CreatePolynomial(args0)).divide(CM.Composite.CreatePolynomial(args1),args2);
return divisionobject.quotient;}
else{
var tempstring="You are calling QuotientN and either the first or second parameter passed cannot be converted to a polynomial or the third parameter passed cannot be converted to an integer.  The parameters are "+arguments[0]+"and "+arguments[1]+"and "+arguments[2]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.Quotient=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"){
var divisionobject=args0.divide(args1);
return divisionobject.modQuotient;}
else if((args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Polynomial")&&(args1.cm_instanceof=="Integer"||args1.cm_instanceof=="Polynomial")){
var divisionobject=(CM.Composite.CreatePolynomial(args0)).divide(CM.Composite.CreatePolynomial(args1));
return divisionobject.quotient;}
else{
var tempstring="You are calling Quotient and either the first or second parameter passed cannot be converted to a polynomial The parameters are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.MultivariateQuotient=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(arguments[2].cm_instanceof=="Expression")
var args2=arguments[2].terms[0].simplify();
else
var args2=arguments[2].simplify();
if((args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Polynomial")&&(args1.cm_instanceof=="Integer"||args1.cm_instanceof=="Polynomial")){
var divisionobject=(CM.Composite.CreatePolynomial(args0)).multivariateDivide(CM.Composite.CreatePolynomial(args1),args2.toString());
return divisionobject.quotient;}
else{
var tempstring="You are calling MultivariateQuotient and either the first or second parameter passed cannot be converted to a polynomial The parameters are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.MultivariateRemainder=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(arguments[2].cm_instanceof=="Expression")
var args2=arguments[2].terms[0].simplify();
else
var args2=arguments[2].simplify();
if((args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Polynomial")&&(args1.cm_instanceof=="Integer"||args1.cm_instanceof=="Polynomial")){
var divisionobject=(CM.Composite.CreatePolynomial(args0)).multivariateDivide(CM.Composite.CreatePolynomial(args1),args2.toString());
return divisionobject.remainder;}
else{
var tempstring="You are calling MultivariateQuotient and either the first or second parameter passed cannot be converted to a polynomial The parameters are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.RemainderN=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(arguments[2].cm_instanceof=="Expression")
var args2=arguments[2].terms[0].simplify();
else
var args2=arguments[2].simplify();
if((args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Polynomial")&&(args1.cm_instanceof=="Integer"||args1.cm_instanceof=="Polynomial")&&(args2.cm_instanceof=="Integer")){
var divisionobject=(new CM.Polynomial(args0)).divide(new CM.Polynomial(args1),args2);
return divisionobject.remainder;}
else{
var tempstring="You are calling RemainderN on objects that cannot be converted to Polynomials. The objects are "+arguments[0]+"and "+arguments[1]+"and "+arguments[2]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.Remainder=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"){
var divisionobject=args0.divide(args1);
return divisionobject.mod;}
else if((args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Polynomial")&&(args1.cm_instanceof=="Integer"||args1.cm_instanceof=="Polynomial")){
var divisionobject=(new CM.Polynomial(args0)).divide(new CM.Polynomial(args1));
return divisionobject.remainder;}
else{
var tempstring="You are calling Remainder on objects that cannot be converted to Polynomials. The objects are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.SimpleQuotient=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"){
var divisionobject=args0.divide(args1);
return divisionobject.quotient;}
else{
var tempstring="You are calling SimpleQuotient on objects that cannot be converted to Integers. The objects are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.SimpleRemainder=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"){
var divisionobject=args0.divide(args1);
return divisionobject.remainder;}
else{
var tempstring="You are calling SimpleRemainder on objects that cannot be converted to Integers. The objects are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}}
CM.Definitions.Functions.InterfaceCommand.Ceiling=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"){
var divisionobject=args0.divide(args1);
return divisionobject.ceiling;}
else{
var tempstring="You are calling Ceiling on objects that cannot be converted to Integers. The objects are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.Floor=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"){
var divisionobject=args0.divide(args1);
return divisionobject.floor;}
else{
var tempstring="You are calling Floor on objects that cannot be converted to Integers. The objects are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.ConvertToRational=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(args0.isAtomic===true){
if(args0.cm_instanceof!="Complex"){
return new CM.Rational(args0).simplify();}
else{
return new CM.Complex([new CM.Rational(args0.real()),new CM.Rational(args0.imaginary())]).simplify();}}
else{
var tempstring="You are calling ConvertToRational on an object that cannot be converted to a Rational number. The object is "+arguments[0]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.BigPrimeGCD=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if((args0.cm_instanceof=="Polynomial"||args0.cm_instanceof=="Integer")&&(args1.cm_instanceof=="Polynomial"||args1.cm_instanceof=="Integer")){
var divisionobject=(new CM.PolynomialNativeExponents(args0)).BigPrimeGCD(new CM.PolynomialNativeExponents(args1));
return divisionobject;}
else{
var tempstring="You are calling Big Prime GCD on objects that cannot be converted to Polynomials. The objects are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.SmallPrimeGCD=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if((args0.cm_instanceof=="Polynomial"||args0.cm_instanceof=="Integer")&&(args1.cm_instanceof=="Polynomial"||args1.cm_instanceof=="Integer")){
var divisionobject=(new CM.PolynomialNativeExponents(args0)).smallPrimeGcd(new CM.PolynomialNativeExponents(args1));
return divisionobject;}
else{
var tempstring="You are calling Small Prime GCD on objects that cannot be converted to Polynomials. The objects are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.Linfinity=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Polynomial"&&args1.cm_instanceof=="Integer"){
return args0.linfinity(args1);}
else if(args0.cm_instanceof=="Integer"){
return args0.abs();}
else{
var tempstring="You are calling Linfinity on an object that cannot be converted to a Polynomial. The object is "+arguments[0]+"."+"Or "+arguments[1]+" is not an interger.";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.Content=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1]==null){
if(args0.cm_instanceof=="Polynomial"||args0.isNumber===true){
return args0.content();}
else{
var tempstring="You are calling Content on object that cannot be converted to a Polynomial. The object is "+arguments[0]+".";
alert(tempstring);
throw new Error(tempstring);}}
else{
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Polynomial"||args0.isNumber===true){
return args0.content(args1);}
else{
var tempstring="You are calling Content on object that cannot be converted to a Polynomial. The object is "+arguments[0]+".";
alert(tempstring);
throw new Error(tempstring);}}};
CM.Definitions.Functions.InterfaceCommand.Primitive=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(args0.cm_instanceof=="Polynomial"){
return args0.primitive();}
else if(args0.cm_instanceof=="Integer"){
return args0.abs();}
else{
var tempstring="You are calling Primitive on object that cannot be converted to a Polynomial. The object is "+arguments[0]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.Numerator=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
return args0.rationalize()[0];};
CM.Definitions.Functions.InterfaceCommand.Denominator=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0].simplify();}
else{
var args0=arguments[0].simplify();}
return args0.rationalize()[1];};
CM.Definitions.Functions.InterfaceCommand.InverseN=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer")
return args0.inverseM(args1);
else{
var tempstring="You are calling InverseN on objects that cannot be converted to integers. The objects are "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.ChineseRemainder=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0];
else
var args0=arguments[0];
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0];
else
var args1=arguments[1]
if(arguments[2]!=null){
if(arguments[2].cm_instanceof=="Expression")
var args2=arguments[2].terms[0];
else
var args2=arguments[2];}
if(args0.cm_instanceof=="Vector"&&args1.cm_instanceof=="Vector"){
args0=args0.simplify().terms;
args1=args1.simplify().terms;
return CM.Integer.ChineseRemainder(args0,args1);}
else{
args0=args0.simplify();
args1=args1.simplify();
if(args0.cm_instanceof=="Integer"&&args1.cm_instanceof=="Integer"&&args2.cm_instanceof=="Vector"){
args2=args2.simplify().terms;
var tempreturn=CM.Integer.ChineseRemainder(args0,args1,args2);
return new CM.Vector(tempreturn);}
else{
var tempstring="You are calling ChineseRemainder on objects that cannot be converted to integers. The objects are "+arguments[0]+"and "+arguments[1]+" and "+arguments[2]+".";
alert(tempstring);
throw new Error(tempstring);}}};
CM.Definitions.Functions.InterfaceCommand.ChineseRemainderArrayVersion=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0];
else
var args0=arguments[0];
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0];
else
var args1=arguments[1]
args0=args0.terms;
args1=args1.simplify();
if(arguments[2]!=null){
if(arguments[2].cm_instanceof=="Expression")
var args2=arguments[2].terms[0];
else
var args2=arguments[2];}
else{
var tempreturn=CM.Integer.ChineseRemainderArrayVersion(args0,args1);
return new CM.Vector(tempreturn);}
args2=args2.terms;alert([args2[0].cm_instanceof,args2[1].cm_instanceof]);
if(args2[0].cm_instanceof=="Vector"){
var args3=args2[0].terms;}
else{
var args3=args2[0];}
var args4=args2[1];
alert([args3,args3.cm_instanceof,args4,args4.cm_instanceof]);
if(args0.cm_instanceof=="Array"&&args1.cm_instanceof=="Integer"&&args2.cm_instanceof=="Array"){
var tempreturn=CM.Integer.ChineseRemainderArrayVersion(args0,args1,[args3,args4]);
return new CM.Vector(tempreturn);}
else{
var tempstring="You are calling ChineseRemainderArrayVersion on objects that cannot be converted to Arrays of Integers. The objects are "+arguments[0]+"and "+arguments[1]+" and "+arguments[2]+".";
alert(tempstring);
throw new Error(tempstring);}};
CM.Definitions.Functions.InterfaceCommand.Factorial=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
return new CM.Factorial([args0]);};
CM.Definitions.Functions.InterfaceCommand.Gcd=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
var tempreturn=CM.Composite.Gcd(args0,args1);
return tempreturn.gcd;};
CM.Definitions.Functions.InterfaceCommand.GcdLinearCombination=function(){
if(arguments[0].cm_instanceof=="Expression")
var args0=arguments[0].terms[0].simplify();
else
var args0=arguments[0].simplify();
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(args0.cm_instanceof!="Integer"||args1.cm_instanceof!="Integer"){
var errorstring=" You are invoking GcdLinearCombination on "+arguments[0]+" and "+arguments[1]+". At lease one of these arguments cannot be converted into an integer.";
alert(errorstring);
throw new Error(errorstring);}
var tempreturn=CM.Integer.extended_gcd(args0,args1);
return new CM.Sum([new CM.Factor([tempreturn.x,arguments[0]]),new CM.Factor([tempreturn.y,arguments[1]])]);};
CM.Definitions.Functions.InterfaceCommand.Max=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
if(args0.cm_instanceof=="Vector"){
args0=args0.terms;
var newterms=new Array();
var termslength=args0.length;
for(var i=0;i<termslength;i++){
if(args0[i].cm_instanceof=="Expression"){
newterms[i]=args0[i].terms[0];}
else{
newterms[i]=args0[i];}}
args0=newterms;}
return CM.Atomic.Max(args0);};
CM.Definitions.Functions.InterfaceCommand.Min=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
if(args0.cm_instanceof=="Vector"){
args0=args0.terms;
var newterms=new Array();
var termslength=args0.length;
for(var i=0;i<termslength;i++){
if(args0[i].cm_instanceof=="Expression"){
newterms[i]=args0[i].terms[0];}
else{
newterms[i]=args0[i];}}
args0=newterms;}
return CM.Atomic.Min(args0);};
CM.Definitions.Functions.InterfaceCommand.Apply=function(){
if(arguments[0].cm_instanceof=="Expression")
var functionname=arguments[0].terms[0];
else
var functionname=arguments[0];
if(arguments[1].cm_instanceof=="Expression")
var args1=arguments[1].terms[0].simplify();
else
var args1=arguments[1].simplify();
if(functionname.cm_instanceof!="String"||args1.cm_instanceof!="Vector"){
var tempstring="You are calling the function Apply. The first entry should be a String name for a function and the second entry should be a Vector on whose elements you want to apply the function. This does not seem to be the case with your entry. You entered "+arguments[0]+"and "+arguments[1]+".";
alert(tempstring);
throw new Error(tempstring);}
var args2=arguments[2];
var args3=arguments[3];
var args4=arguments[4];
var args5=arguments[5];
var temparray=args1.terms;
var temparraylength=temparray.length;
var returnarray=new Array();
var applyfunction=CM.Definitions.Functions.InterfaceCommand[functionname];
if(applyfunction!=null){
for(var i=0;i<temparraylength;i++){
returnarray[i]=applyfunction(temparray[i],args2,args3,args4,args5);}
return new CM.Vector(returnarray);}
var applyfunction=CM.Definitions.Functions.Standard[functionname];
if(applyfunction!=null){
for(var i=0;i<temparraylength;i++){
var applyfunctionargumentslength=applyfunction.argumentslength;
returnarray[i]=new CM.StandardFunction(functionname,[temparray[i],args2,args3,args4,args5].slice(0,applyfunctionargumentslength));}
return new CM.Vector(returnarray);}
var applyfunction=CM.Definitions.Functions.User[functionname];
if(applyfunction!=null){
for(var i=0;i<temparraylength;i++){
returnarray[i]=applyfunction.terms[0].replacePolynomialVariables(applyfunction.arguments,[temparray[i],args2,args3,args4,args5].slice(0,applyfunction.arguments.length));}
return new CM.Vector(returnarray);}};
CM.Definitions.Functions.InterfaceCommand.InstanceOf=function(){
return new CM.String(arguments[0].cm_instanceof);};
CM.Definitions.Functions.InterfaceCommand.Structure=function(){
return new CM.String([arguments[0].structure()]);};
CM.Definitions.Functions.InterfaceCommand.Substitute=function(){
if(arguments.length!=3&&arguments.length!=4){
var errorstring="You are calling Substitute, however this command requires three arguments or four arguments: the object in which you want the substitution to be done, the orignal variables in a list enclosed in square brackets, the replacement expressions enclosed in square brackets, and an option: either \"simultaneous\" if you want the substitutions done all at the same time, or \"recursive\" if you want the substitutions done one after the other.";
alert(errorstring);
throw new Error(errorstring);}
if(arguments[1].cm_instanceof=="Vector"&&arguments[2].cm_instanceof=="Vector"){
return arguments[0].substitute(arguments[1].terms,arguments[2].terms,arguments[3]!=null?arguments[3].terms[0]:null);}
else{
var errorstring="You are calling Substitute, however your original variables and their replacements should be enclosed in square brackets.";
alert(errorstring);
throw new Error(errorstring);}};
CM.Definitions.Functions.InterfaceCommand.Unassign=function(){
if(arguments.length!=1){
var errorstring="You are calling Unassign, however this command requires one argument. It is the name of the object that you no longer want assigned to anything.";
alert(errorstring);
throw new Error(errorstring);}
if(arguments[0].cm_instanceof!="String"){
var errorstring="You are calling Unassign, however this command requires that you put either single or double quotes around the variable that you no longer want assigned to a value.";
alert(errorstring);
throw new Error(errorstring);}
var tempstring=arguments[0].terms[0];
CM.Definitions.Constants.User[tempstring]=null;
CM.Definitions.Expressions.User[tempstring]=null;
CM.Definitions.Functions.User[tempstring]=null;
return ""+tempstring+" is no longer assigned to anything";};
CM.Definitions.Functions.InterfaceCommand.String=function(){
var argslength=arguments.length;
var argsarray=new Array();
for(var i=0;i<argslength;i++){
argsarray[i]=arguments[i];}
return new CM.String(argsarray);};
CM.Definitions.Functions.InterfaceCommand.Expand=function(){
if(arguments[0].cm_instanceof=="Expression"){
var tempthis=arguments[0].terms[0];}
else{
tempthis=arguments[0];}
return tempthis.fastExpand();};
CM.Definitions.Functions.InterfaceCommand.ExpandWithoutSimplification=function(){
var args1=arguments[1];
if(args1!=null){
args1=args1.toString();}
return arguments[0].expandWithoutSimplification(args1);};
CM.Definitions.Functions.InterfaceCommand.SquareRoot=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return new CM.Root([args0,CM.Integer.two]);};
CM.Definitions.Functions.InterfaceCommand.Sqrt=CM.Definitions.Functions.InterfaceCommand.SquareRoot;
CM.Definitions.Functions.InterfaceCommand.CubeRoot=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return new CM.Root([args0,CM.Integer.three]);};
CM.Definitions.Functions.InterfaceCommand.ThirdRoot=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return new CM.Root([args0,CM.Integer.three]);};
CM.Definitions.Functions.InterfaceCommand.FourthRoot=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return new CM.Root([args0,CM.Integer.four]);};
CM.Definitions.Functions.InterfaceCommand.FifthRoot=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return new CM.Root([args0,CM.Integer.five]);};
CM.Definitions.Functions.InterfaceCommand.SixthRoot=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return new CM.Root([args0,CM.Integer.six]);};
CM.Definitions.Functions.InterfaceCommand.SeventhRoot=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return new CM.Root([args0,CM.Integer.seven]);};
CM.Definitions.Functions.InterfaceCommand.EigthRoot=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return new CM.Root([args0,CM.Integer.eight]);};
CM.Definitions.Functions.InterfaceCommand.NinthRoot=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return new CM.Root([args0,CM.Integer.nine]);};
CM.Definitions.Functions.InterfaceCommand.ConvertToRoots=function(){
var args1=arguments[1];
if(args1!=null){
if(args1.cm_instanceof=="Expression"){
var args1=args1.terms[0];}
return arguments[0].convertToRoots(args1.toString());}
return arguments[0].convertToRoots();};
CM.Definitions.Functions.InterfaceCommand.ConvertRootsToFractionalExponents=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
var args0=arguments[0];}
return arguments[0].convertRootsToFractionalExponents();};
CM.Definitions.Functions.InterfaceCommand.ReduceFractionalExponents=function(){
return arguments[0].reduceFractionalExponents();};
CM.Definitions.Functions.InterfaceCommand.ReduceFractionalExponentsAndSimplify=function(){
return arguments[0].reduceFractionalExponentsAndSimplify();};
CM.Definitions.Functions.InterfaceCommand.ContainsNegativeExponents=function(){
return arguments[0].containsNegativeExponents();};
CM.Definitions.Functions.InterfaceCommand.ContainsNegativeExponents=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return args0.containsNegativeExponents();};
CM.Definitions.Functions.InterfaceCommand.ContainsRoots=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return args0.containsRoots();};
CM.Definitions.Functions.InterfaceCommand.ContainsFractionalExponents=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return args0.containsFractionalExponents();};
CM.Definitions.Functions.InterfaceCommand.ContainsUnsimplifiedFractionalExponents=function(){
if(arguments[0].cm_instanceof=="Expression"){
var args0=arguments[0].terms[0];}
else{
args0=arguments[0];}
return args0.containsUnsimplifiedFractionalExponents();};
CM.Definitions.Functions.InterfaceCommand.Derivative=function(){
if(arguments[0].cm_instanceof=="Expression"){
var tempthis=arguments[0].terms[0];}
else{
tempthis=arguments[0];}
var args1=arguments[1].simplify();
var args2=1*arguments[2].toString();
if(args1.isVariable()===false){
var errorstring="You are calling the Derivative function, however your second entry should be the variable with which you are taking the derivative. Unfortunately you entered "+arguments[1]+" which is not a variable.";
alert(errorstring);
throw new Error(errorstring);}
return tempthis.derivative(args1,args2);};
CM.Definitions.Functions.InterfaceCommand.TaylorSeries=function(){
if(arguments[0].cm_instanceof=="Expression"){
var tempthis=arguments[0].terms[0];}
else{
tempthis=arguments[0];}
var args1=arguments[1].simplify();
var args2=arguments[2];
var args3=arguments[3].toString();
if(args1.isVariable()===false){
var errorstring="You are calling the Derivative function, however your second entry should be the variable with which you are taking the derivative. Unfortunately you entered "+arguments[1]+" which is not a variable.";
alert(errorstring);
throw new Error(errorstring);}
return tempthis.taylorSeries(args1,args2,args3);};
CM.Definitions.Functions.InterfaceCommand.Integral=function(){
var tempthis=arguments[0];
var args1=arguments[1];
if(args1.isVariable()===false){
var errorstring="You are calling the Integral function, however your second entry should be the variable with which you are integrating. Unfortunately you entered "+arguments[1]+" which is not a variable.";
alert(errorstring);
throw new Error(errorstring);}
return tempthis.integration(args1);};
CM.Definitions.Functions.InterfaceCommand.IsVariable=function(){
return arguments[0].isVariable();};
CM.Definitions.Functions.InterfaceCommand.ConvertToDense=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
if(args0.cm_instanceof!="Polynomial")
args0=args0.expand();
return new CM.DensePolynomial(args0);};
CM.Definitions.Functions.InterfaceCommand.Coeff=function(){
var args0=arguments[0];
var args1=arguments[1].simplify();
var args2=arguments[2];
if(arguments[2]!=null){
var args2=arguments[2].simplify();}
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
if(args0.cm_instanceof!="Polynomial")
args0=args0.expand();
if((args2==null||args2.cm_instanceof=="Integer")){
if(args2==null){
return new CM.Vector(args0.coeff(args1,args2));}
else{
return args0.coeff(args1,args2);}}
else{
alert("You have not used Coeff correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial, and your last entry should be an Integer.");
throw new Error("You have not used Coeff correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial, and your last entry should be an Integer.");}}
CM.Definitions.Functions.InterfaceCommand.LeadingCoeff=function(){
var args0=arguments[0];
var args1=arguments[1];
if(args1!=null){
args1=args1.simplify();
if(args1.cm_instanceof!="Polynomial"){
alert("You have not used LeadingCoeff correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");
throw new Error("You have not used LeadingCoeff correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");}}
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
if(args0.cm_instanceof!="Polynomial")
var args0=args0.simplify().expand(args1);
if(args0.cm_instanceof=="Polynomial")
return args0.lCoeff(args1);
else{
alert("You have not used LeadingCoeff correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");
throw new Error("You have not used LeadingCoeff correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");}};
CM.Definitions.Functions.InterfaceCommand.Degree=function(){
var args0=arguments[0];
var args1=arguments[1];
if(args1!=null){
args1=args1.simplify();
if(args1.cm_instanceof!="Polynomial"){
alert("You have not used Degree correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");
throw new Error("You have not used Degree correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");}}
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
if(args0.cm_instanceof!="Polynomial")
var args0=args0.simplify().expand().maxDegree(args1);
if(args0.cm_instanceof=="Polynomial")
return args0.maxDegree(args1);
else{
alert("You have not used Degree correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");
throw new Error("You have not used Degree correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");}};
CM.Definitions.Functions.InterfaceCommand.TrailingCoeff=function(){
var args0=arguments[0];
var args1=arguments[1];
if(args1!=null){
args1=args1.simplify();}
if(args1==null||args1.cm_instanceof!="Polynomial"){
alert("You have not used TrailingCoeff correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");
throw new Error("You have not used TrailingCoeff correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");}
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
if(args0.cm_instanceof!="Polynomial")
var args0=args0.simplify().expand(args1);
if(args0.cm_instanceof=="Polynomial")
return args0.tCoeff(args1);
else{
alert("You have not used TrailingCoeff correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");
throw new Error("You have not used TrailingCoeff correctly. Your first entry must be a polynomial, your second entry must be a variable in the polynomial.");}}
CM.Definitions.Functions.InterfaceCommand.ConstantTerm=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
if(arguments[0].cm_instanceof!="Polynomial")
var args0=args0.simplify();
if(args0.cm_instanceof=="Polynomial"){
return args0.constantTerm();}
else if(args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Rational"||args0.cm_instanceof=="Floating"){
return CM.Composite.CreatePolynomial(args0);}
else{
alert("You have not used ConstantTerm correctly. Your first entry must be a polynomial.");
throw new Error("You have not used ConstantTerm correctly. Your first entry must be a polynomial.");}}
CM.Definitions.Functions.InterfaceCommand.Sort=function(){
if(arguments[2]!=null)
var temparg2=arguments[2].terms;
var args0=arguments[0];
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
if(args0.cm_instanceof!="Polynomial")
args0=args0.simplify();
if(args0.cm_instanceof=="Polynomial"){
if(arguments[1].cm_instanceof=="Vector"){
var newkey=arguments[1].getTerms();
var newkeylength=newkey.length;
for(var i=0;i<newkeylength;i++){
if(newkey[i].cm_instanceof=="String"){
newkey[i]=newkey[i].terms[0];}
else if(newkey[i].isVariable()===true){
newkey[i]=newkey[i].toString();}}
return args0.sort(newkey,temparg2);}
else
return args0.sort(args0.key,temparg2);}
else if(args0.cm_instanceof=="Integer"||args0.cm_instanceof=="Rational"||args0.cm_instanceof=="Floating"){
return CM.Composite.CreatePolynomial(args0);}
else{
alert("You are calling Sort on an object that cannot be converted to a polynomial. The object is "+arguments[0]+".");
throw new Error("You are calling Sort on an object that cannot be converted to a polynomial. The object is "+arguments[0]+".");}};
CM.Definitions.Functions.InterfaceCommand.LagrangeInterpolation=function(){
var args0=arguments[0];
var args1=arguments[1];
var args2=arguments[2];
var args3=arguments[3];
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
if(args1.cm_instanceof=="Expression")
args1=args1.terms[0];
if(args2.cm_instanceof=="Expression")
args2=args2.terms[0];
if(args3!=null&&args3.cm_instanceof=="Expression")
args3=args3.terms[0];
if(args0.cm_instanceof!="Vector"){
args2=args2.terms;
var tempreturn=CM.PolynomialNativeExponents._LagrangeInterpolation(args0,args1,args2,args3);
return new CM.Vector([tempreturn[0],tempreturn[1]]);}
args0=args0.terms;
args1=args1.terms;
if(args2.cm_instanceof=="String"){
args2=args2.terms[0];}
return CM.PolynomialNativeExponents._LagrangeInterpolation(args0,args1,args2);};
CM.Definitions.Functions.InterfaceCommand.Collect=function(){
if(arguments[2]!=null){
var temparg2=arguments[2].terms;}
var args0=arguments[0];
if(arguments[1].cm_instanceof=="Vector"){
var newkey=arguments[1].getTerms();}
else{
var newkey=[arguments[1]];}
var newkeylength=newkey.length;
for(var i=0;i<newkeylength;i++){
if(newkey[i].cm_instanceof=="String"){
newkey[i]=newkey[i].terms[0];}
else if(newkey[i].isVariable()===true){}}
return args0.collect(newkey,temparg2);};
CM.Definitions.Functions.InterfaceCommand.Solve=function(){
return CM.Composite.Solve(arguments[0],arguments[1],arguments[2]);};
CM.Definitions.Functions.InterfaceCommand.SimplifyAndReduce=function(){
return arguments[0].simplify().reduceCommonFactors().simplify();};
CM.Definitions.Functions.InterfaceCommand.IsMultipliedOutPolynomial=function(){
return arguments[0].isMultipliedOutPolynomial();};
CM.Definitions.Functions.InterfaceCommand.ContainsPowers=function(){
return arguments[0].containsPowers();};
CM.Definitions.Functions.InterfaceCommand.NumeratorAndDenominator=function(){
return arguments[0].numeratorAndDenominator();};
CM.Definitions.Functions.InterfaceCommand.NumeratorAndDenominatorArray=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression"){
args0=args0.terms[0];}
return new CM.Vector(args0.rationalize());};
CM.Definitions.Functions.InterfaceCommand.NumeratorAndDenominatorWithoutCancelingArray=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression"){
args0=args0.terms[0];}
return new CM.Vector(args0.rationalizeWithoutCanceling());};
CM.Definitions.Functions.InterfaceCommand.Type=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression"){
args0=args0.terms[0];}
return args0.cm_instanceof;};
CM.Definitions.Functions.InterfaceCommand.IsPolynomial=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression"){
args0=args0.terms[0];}
return args0.isPolynomial;};
CM.Definitions.Functions.InterfaceCommand.IsNumber=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression"){
args0=args0.terms[0];}
return args0.isNumber;};
CM.Definitions.Functions.InterfaceCommand.GetQuotientNumerator=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression"){
args0=args0.terms[0];}
if(args0.cm_instanceof!="Quotient"){
return false;}
else{
return args0.getTerms()[0];}};
CM.Definitions.Functions.InterfaceCommand.GetQuotientDenominator=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression"){
args0=args0.terms[0];}
if(args0.cm_instanceof!="Quotient"){
return false;}
else{
return args0.getTerms()[1];}};
CM.Definitions.Functions.InterfaceCommand.Terms=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression"){
args0=args0.terms[0];}
var cm_instanceof=args0.cm_instanceof;
if(cm_instanceof=="Integer"||cm_instanceof=="Rational"||cm_instanceof=="Floating"||cm_instanceof=="Complex"){
return new CM.Vector([args0]);}
else if(cm_instanceof=="Polynomial"){
return new CM.Vector(args0.breakUpPolynomial().getTerms());}
else{
return new CM.Vector(args0.getTerms());}};
CM.Definitions.Functions.InterfaceCommand.TermsLength=function(){
return CM.Definitions.Functions.InterfaceCommand.Terms(arguments[0]).terms.length;};
CM.Definitions.Functions.InterfaceCommand.Concat=function(){
var argslength=arguments.length;
returnArray=new Array(argslength);
for(var i=0;i<argslength;i++){
returnArray[i]=arguments[i];}
return new CM.String(returnArray);}
CM.Definitions.Functions.InterfaceCommand.Get=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression"){
args0=args0.terms[0];}
if(args0.cm_instanceof!="Vector")
return alert("You are trying to use get on an object that is not a vector");
else
return args0.get(arguments[1]);}
CM.Definitions.Functions.InterfaceCommand.Set=function(){
if(arguments.length!=3){
alert("The function Set requires 3 arguments: a vector, an entry, and the value you want to put in that entry");
throw new Error("The function Set requires 3 arguments: a vector, an entry, and the value you want to put in that entry");}
if(arguments[0].cm_instanceof=="Expression")
return CM.Definitions.Functions.InterfaceCommand.Set(arguments[0].terms[0],arguments[1],arguments[2]);
else if(arguments[0].cm_instanceof!="Vector")
return alert("You are trying to use set on an object that is not a vector");
else{
var tempterms=arguments[0].getTerms();
tempterms[1*arguments[1].toString()]=arguments[2];
return new CM.Vector(tempterms);}}
CM.Definitions.Functions.InterfaceCommand.Round=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
var precision=arguments[1];
if(precision!=null){
precision=1*precision.toString();}
var type=arguments[2];
if(type!=null){
type=type.terms[0];}
if(type==null){
type="s";}
return args0.round(precision,type);}
CM.Definitions.Functions.InterfaceCommand.Truncate=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
var precision=arguments[1];
if(precision!=null){
precision=1*precision.toString();}
var type=arguments[2];
if(type!=null){
type=type.terms[0];}
if(type==null){
type="s";}
return args0.truncate(precision,type);};
CM.Definitions.Functions.InterfaceCommand.SimplifyTerms=function(){
var args0=arguments[0];
if(args0.cm_instanceof=="Expression")
args0=args0.terms[0];
var terms=args0.terms;
var termslength=terms.length;
for(var i=0;i<termslength;i++){
terms[i]=terms[i].simplify();}
args0.stringVersion=null;
return args0;};
CM.Definitions.Functions.InterfaceCommand.evalf=CM.Definitions.Functions.InterfaceCommand.Round;
CM.Definitions.Functions.InterfaceCommand.SetProperty=function(){
if(arguments[0].cm_instanceof=="String"&&arguments[1].cm_instanceof=="String"){
var tempproperty=arguments[0].terms[0];
var tempvalue=arguments[1].terms[0];}
else{
tempproperty=arguments[0].toString();
tempvalue=arguments[1].toString();}
if(arguments[1].terms[0].toLowerCase()=="true")
var tempvalue=true;
else if(arguments[1].terms[0].toLowerCase()=="false")
var tempvalue=false;
switch(tempproperty){
case "Precision":
return CM.Floating.precision=1*tempvalue;
break;
case "PrecisionType":
return CM.Floating.precisionType=tempvalue;
break;
default:
return CM[tempproperty]=tempvalue
break;}};
CM.Definitions.Functions.InterfaceCommand.CorrectStudentPolynomialExpansionWithoutSimplification=function(){
var minusOne=CM.Integer.minusOne;
var zero=CM.Integer.zero;
var givenexpression=arguments[0];
var studentresponse=arguments[1];
var givenexpressionexpanded=givenexpression.expand();
var ispolynomial=studentresponse.isPolynomial;
if(ispolynomial===false){
return "not a polynomial";};
var subtracted=new CM.Sum([givenexpressionexpanded.multiply(minusOne),studentresponse]).expand();
var equaltooriginal=subtracted.equalTo(zero);
if(equaltooriginal===false){
return "not equal to the original expression";}
var multipliedoutpolynomial=studentresponse.isMultipliedOutPolynomial();
if(multipliedoutpolynomial===false){
return "equal to the original expression, however it is not multiplied out completely";}
if(studentresponse.cm_instanceof=="Polynomial"&&studentresponse.terms.length==givenexpressionexpanded.terms.length){
return "simplified, which was contrary to the directions";}
var givenexpressionexpandedf=givenexpression.expandWithoutSimplification("f");
if(givenexpressionexpandedf.structurallyEquivalent(studentresponse)){
return true;}
var givenexpressionexpandedfe=givenexpression.expandWithoutSimplification("fe");
if(givenexpressionexpandedfe.structurallyEquivalent(studentresponse)){
return true;}
return "equal to  the original expression, however it was partially simplified or modified after being multiplied out, which was contrary to the directions";};
CM.Definitions.Functions.InterfaceCommand.CorrectStudentPolynomialExpansion=function(){
var minusOne=CM.Integer.minusOne;
var zero=CM.Integer.zero;
var givenexpression=arguments[0];
var studentresponse=arguments[1];
var givenexpressionexpanded=givenexpression.expand();
var ispolynomial=studentresponse.isPolynomial;
if(ispolynomial===false){
return "not a polynomial";};
var subtracted=new CM.Sum([givenexpressionexpanded.multiply(minusOne),studentresponse]).expand();
var equaltooriginal=subtracted.equalTo(zero);
if(equaltooriginal===false){
return "not equal to the original expression";}
if(studentresponse.cm_instanceof!="Polynomial"){
return "equal to the original expression but not multiplied out completely"}
if(studentresponse.cm_instanceof=="Polynomial"&&studentresponse.terms.length!=givenexpressionexpanded.terms.length){
return "multiplied out but not completely simplified, which was contrary to the directions";}
if(studentresponse.cm_instanceof=="Polynomial"&&studentresponse.terms.length==givenexpressionexpanded.terms.length){
return true;}};
CM.Definitions.Functions.InterfaceCommand.CorrectStudentComplexFractionConversion=function(){
var one=CM.Integer.one;
var minusOne=CM.Integer.minusOne;
var zero=CM.Integer.zero;
var givenexpression=arguments[0];
var studentresponse=arguments[1];
var givenexpressionnumeratoranddenominatorarray=givenexpression.rationalize();
var subtracted=new CM.Sum([new CM.Factor([minusOne,givenexpression.numeratorAndDenominator()]),studentresponse]);
subtracted=subtracted.numeratorAndDenominator();
if(!subtracted.equalTo(zero)){
return "not equal to the original expression";}
if(studentresponse.containsQuotientsOrNegativeExponents()===true){
return "equal to the original expression, but is either is a complex fraction or contains negative exponents, contrary to the instructions";}
if(givenexpressionnumeratoranddenominatorarray[1].equalTo(one)){
givenexpressionnumeratoranddenominatorarray0=givenexpressionnumeratoranddenominatorarray[0].simplify();
if(givenexpressionnumeratoranddenominatorarray0.cm_instanceof=="Polynomial"){
if(studentresponse.cm_instanceof!="Polynomial"){
return "equal to the original expression, but not simplified completely, contrary to the instructions";}
else{
if(studentresponse.terms.length==givenexpressionnumeratoranddenominatorarray0.terms.length){
return true;}
else{
return "equal to the original expression, but not simplified completely, contrary to the instructions";}}}
if(givenexpressionnumeratoranddenominatorarray0.isAtomic===true){
if(studentresponse.isAtomic===true){
return true;}
else{
return "equal to the original expression, but not simplified completely, contrary to the instructions";}}}
else{
if(studentresponse.cm_instanceof!="Quotient"&&studentresponse.cm_instanceof!="Factor"){
return "equal to the original expression, but not simplified completely, contrary to the instructions";}
else{
if(studentresponse.cm_instanceof=="Factor"){
var studentresponsearray=studentresponse.rationalizeWithoutCanceling();
var studentresponsetop=studentresponsearray[0];
var studentresponsebottom=studentresponsearray[1];}
else{
var studentresponsetop=studentresponse.terms[0];
var studentresponsebottom=studentresponse.terms[1];}
var gcd=CM.Composite.Gcd(studentresponsetop,studentresponsebottom).gcd;
if(gcd.equalTo(one)||gcd.equalTo(minusOne)){
return true;}
else{
return "equal to the original expression, but not simplified completely, contrary to the instructions";}}}};
CM.Definitions.Functions.InterfaceCommand.CorrectStudentComplexFractionConversionUnsimplified=function(){
var one=CM.Integer.one;
var minusOne=CM.Integer.minusOne;
var zero=CM.Integer.zero;
var givenexpression=arguments[0];
var studentresponse=arguments[1];
var givenexpressionnumeratoranddenominatorarray=givenexpression.rationalize();
var givenexpressionnumeratoranddenominatorarrayunsimplified=givenexpression.rationalizeWithoutCanceling();
var subtracted=new CM.Sum([new CM.Factor([minusOne,givenexpression.numeratorAndDenominator()]),studentresponse]);
subtracted=subtracted.numeratorAndDenominator();
if(!subtracted.equalTo(zero)){
return "not equal to the original expression";}
if(studentresponse.cm_instanceof!="Quotient"&&studentresponse.cm_instanceof!="Factor"){
return "equal to the original expression, but simplified or modified, contrary to the instructions";}
else{
if(studentresponse.isComplexFraction()===true){
return "equal to the original expression, but is either is a complex fraction or contains negative exponents, contrary to the instructions";}
if(studentresponse.cm_instanceof=="Factor"){
var studentresponsearray=studentresponse.rationalizeWithoutCanceling();
var studentresponsetop=studentresponsearray[0];
var studentresponsebottom=studentresponsearray[1];}
else{
var studentresponsetop=studentresponse.terms[0];
var studentresponsebottom=studentresponse.terms[1];}
var gcd=CM.Composite.Gcd(studentresponsetop,studentresponsebottom).gcd;
if(gcd.equalTo(one)||gcd.equalTo(minusOne)){
return "equal to the original expression, but simplified, contrary to the instructions";}
var topquotient=new CM.Quotient([givenexpressionnumeratoranddenominatorarrayunsimplified[0],studentresponsetop]);
var bottomquotient=new CM.Quotient([givenexpressionnumeratoranddenominatorarrayunsimplified[1],studentresponsebottom]);
var topquotientrationalized=topquotient.rationalize();
var bottomquotientrationalized=bottomquotient.rationalize();
if(!((topquotientrationalized[1].equalTo(one)===true||topquotientrationalized[1].equalTo(minusOne))&&(bottomquotientrationalized[1].equalTo(one)===true||bottomquotientrationalized[1].equalTo(minusOne)===true))){
return "equal to the original expression, but simplified or modified, contrary to the instructions";}
var topquotient=new CM.Quotient([studentresponsetop,givenexpressionnumeratoranddenominatorarray[0]]);
var bottomquotient=new CM.Quotient([studentresponsebottom,givenexpressionnumeratoranddenominatorarray[1]]);
var topquotientrationalized=topquotient.rationalize();
var bottomquotientrationalized=bottomquotient.rationalize();
if(!((topquotientrationalized[1].equalTo(one)===true||topquotientrationalized[1].equalTo(minusOne))&&(bottomquotientrationalized[1].equalTo(one)===true||bottomquotientrationalized[1].equalTo(minusOne)===true))){
return "equal to the original expression, but simplified or modified, contrary to the instructions";}
return true;}};
CM.Definitions.Functions.InterfaceCommand.Join=function(){
if(arguments[1]==null)
return new CM.String([arguments[0].terms.join("")]);
else
return new CM.String([arguments[0].terms.join(arguments[0].toString())]);}
CM.Definitions.Functions.InterfaceCommand.Parse=function(){
if(arguments[0].cm_instanceof=="Expression")
return arguments[0].terms[0].toString().parseInput();
else{
return arguments[0].toString().cm_parseInput();}};

