CM.PolynomialNativeExponents.prototype.multiplyByNumber=function(){
var thissimplified=this.simplify();
var right=arguments[0].simplify();
var Multiply=CM.Atomic.MultiplyTwoNumbers;
if(right.isNumber){
var terms=thissimplified.getPolynomialTerms();
var termslength=terms.length;
for(var i=0;i<termslength;i++){
var termsi=terms[i];
termsi[0]=Multiply(termsi[0],right);}
var key=thissimplified.key;
var tempreturn=new CM.PolynomialNativeExponents(terms,key);
tempreturn.simplified=tempreturn;}
return tempreturn;};
CM.PolynomialNativeExponents.prototype.multivariateDivideOLD=function(){
var Integer=CM.Integer;
var PolynomialNativeExponents=CM.PolynomialNativeExponents;
var right=arguments[0];
var divisionvariable=arguments[1].toString();
if(arguments[2]!=null){
var modulus=new Integer(arguments[2]);
var left=new PolynomialNativeExponents(this.simplify(modulus));
right=new PolynomialNativeExponents(right.simplify(modulus));}
else{
right=new PolynomialNativeExponents(right.simplify());
var left=new PolynomialNativeExponents(this.simplify());}
if(left.key.length==1&&right.key.length==1&&left.key[0]==right.key[0]){
return left.divide(right,modulus);}
if(right.equalTo(PolynomialNativeExponents.zero)){
alert("You are dividing the polynomial "+left.toString()+" by zero");
throw new Error("You are dividing the polynomial "+left.toString()+" by zero");}
var leftcoeffarray=left.coeff(divisionvariable);
var rightcoeffarray=right.coeff(divisionvariable);
if(leftcoeffarray.length<rightcoeffarray.length){
var retObj=new Object();
retObj.quotient=Integer.zero;
retObj.remainder=left;
return retObj;}
var lTerms=left.getPolynomialTerms();
if(lTerms.length==0){
var retObj=new Object();
retObj.quotient=Integer.zero;
retObj.remainder=Integer.zero
return retObj;}
var lKey=left.getKey();
var ltLength=lTerms.length;
var lkLength=lKey.length;
var rTerms=right.getPolynomialTerms(modulus);
var rtLength=rTerms.length;
var rKey=right.getKey();
var rkLength=rKey.length;
var qTerms=new Array();
var qKey=lKey;
var termLength=lTerms[0].length;
var one=Integer.one;
var minusOne=Integer.minusOne;
var zero=Integer.zero;
var copyOf=PolynomialNativeExponents._CopyTerm;
if(modulus==null){
if(rtLength==1&&rkLength==1&&(rTerms[0].length==1||rTerms[0][1]==0)){
var rTerms00=rTerms[0][0]
for(var i=0;i<ltLength;i++){
var lTermsi0=lTerms[i][0];
var termigcd=CM.Composite.Gcd(lTermsi0,rTerms00).gcd;
if(termigcd.isNumber===true){
var numerator=CM.Atomic.MultiplyTwoNumbers(lTermsi0,termigcd.reciprocal());
var denominator=CM.Atomic.MultiplyTwoNumbers(rTerms00,termigcd.reciprocal());}
else{
var termigcdkey=termigcd.key;
var divisionvariable=termigcdkey[termigcdkey.length-1];
var numerator=lTermsi0.multivariateDivide(termigcd,divisionvariable);
var denominator=rTerms00.multivariateDivide(termigcd,divisionvariable);}
lTerms[i][0]=new CM.Factor([numerator,new CM.Power([denominator,minusOne])]).expand().simplify();}
var retObj=new Object();
retObj.quotient=new PolynomialNativeExponents(lTerms,lKey);
retObj.remainder=zero
return retObj;}}
else{
if(rtLength==1&&rkLength&&(rTerms[0].length==1||rTerms[0][1]==0)){
for(var i=0;i<ltLength;i++){
lTerms[i][0]=lTerms[i][0].multiplyM(rTerms[0][0].inverseM(modulus),modulus);}
var retObj=new Object();
retObj.quotient=new PolynomialNativeExponents(lTerms,lKey);
retObj.remainder=zero
return retObj;}}
if(ltLength==1&&lkLength==1&&(lTerms[0].length==1||lTerms[0][1]==0)){
var retObj=new Object();
retObj.quotient=zero;
retObj.remainder=left.simplify();
return retObj;}
var rightLeadingCoeff=rightcoeffarray[rightcoeffarray.length-1];
var maxRightDegree=rightcoeffarray.length-1;
var quotientTerms=new Array();
var maxLeftDegree=leftcoeffarray.length-1;
if(modulus==null){
var rightleadingterm=rightcoeffarray[maxRightDegree];
divisionloop:
while(maxRightDegree<=maxLeftDegree){
var leftleadingterm=leftcoeffarray[maxLeftDegree];
var multiplier=new CM.Factor([leftleadingterm,new CM.Power([rightleadingterm,minusOne])]).expand().simplify().reduceCommonFactors().expand();
if(multiplier.cm_instanceof=="Factor"){
multiplier=multiplier.reduceCommonFactors();}
var multiplierrationalized=multiplier.rationalize();
var multipliernumerator=multiplierrationalized[0];
var multiplierdenominator=multiplierrationalized[1];
var degreeDifference=1*maxLeftDegree.toString()-1*maxRightDegree.toString();
quotientTerms[degreeDifference]=new CM.Factor([multiplier,new PolynomialNativeExponents([[one,degreeDifference]],[divisionvariable])]).simplify().reduceCommonFactors();
for(var j=0;j<maxRightDegree;j++){
leftcoeffarray[j+degreeDifference]=new CM.Quotient([new CM.Sum([new CM.Factor([leftcoeffarray[j+degreeDifference],multiplierdenominator]),new CM.Factor([Integer.minusOne,multipliernumerator,rightcoeffarray[j]])]).simplify(),multiplierdenominator]).simplify().reduceCommonFactors();}
leftcoeffarray.length=maxLeftDegree;
maxLeftDegree--;}
var quotient=new CM.Sum(quotientTerms).simplify();
var leftcoeffarraylength=leftcoeffarray.length;
for(var i=0;i<leftcoeffarraylength;i++){
if(leftcoeffarray[i].isPolynomial===true){
leftcoeffarray[i]=new CM.Factor([leftcoeffarray[i].fastExpand(),(new PolynomialNativeExponents([[one,i]],[divisionvariable]))]).expand().reduceCommonFactors();}
else{
leftcoeffarray[i]=new CM.Factor([leftcoeffarray[i],(new PolynomialNativeExponents([[one,i]],[divisionvariable]))]).expand().reduceCommonFactors();}}
if(leftcoeffarray.length>1){
remainder=new CM.Sum(leftcoeffarray).simplify();}
else if(leftcoeffarray.length==1){
remainder=leftcoeffarray[0].simplify();}
else{
remainder=zero;}
var retObj=new Object();
retObj.quotient=quotient;
retObj.remainder=remainder;
return retObj;}
else{
divisionloop1:
while(maxRightDegree<=maxLeftDegree){
var multiplier=new CM.Factor([leftcoeffarray[maxLeftDegree],rightcoeffarray[maxRightDegree].inverseM(modulus)]).expand().simplify(modulus);
var degreeDifference=1*maxLeftDegree.toString()-1*maxRightDegree.toString();
quotientTerms[degreeDifference]=new CM.Factor([multiplier,new PolynomialNativeExponents([[one,degreeDifference]],[divisionvariable])]).expand().simplify(modulus);
var newRightTerms=new Array();
for(var j=0;j<maxRightDegree;j++){
leftcoeffarray[j+degreeDifference]=new CM.Sum([leftcoeffarray[j+degreeDifference],new CM.Factor([Integer.minusOne,multiplier,rightcoeffarray[j]])]).expand().simplify(modulus);}
leftcoeffarray.length=maxLeftDegree;
maxLeftDegree--;}
var quotient=new CM.Sum(quotientTerms).simplify(modulus);
var leftcoeffarraylength=leftcoeffarray.length;
for(var i=0;i<leftcoeffarraylength;i++){
leftcoeffarray[i]=new CM.Factor([leftcoeffarray[i],(new PolynomialNativeExponents([[one,i]],[divisionvariable]))]).expand().simplify(modulus);}
var remainder=new CM.Sum(leftcoeffarray).simplify(modulus);
var retObj=new Object();
retObj.quotient=quotient;
retObj.remainder=remainder;
return retObj;}};
CM.Power.prototype.replaceStandardFunctions=function(){
var originalarray=CM.Composite.originalStandardFunctionsArray;
var replacementobject=CM.Composite.replacementObject;
var originallength=originalarray.length;
var tempthis=this.simplify();
if(tempthis.cm_instanceof!="Power"){
return tempthisreplaceStandardFunctions();}
var terms=tempthis.getTerms();
var termslength=terms.length;
for(var i=0;i<termslength;i++){
if(terms[i].cm_instanceof!=="Polynomial"&&terms[i].isNumber===false){
terms[i]=terms[i].replaceStandardFunctions();}}
var terms1=terms[1];
if(terms1.cm_instanceof=="Rational"){
var exponent=terms1.numerator;
var terms1=new CM.Rational(CM.Integer.one,terms1.denominator);}
else if(terms1.cm_instanceof=="Polynomial"){
var content=terms1.content();
if(content.cm_instanceof=="Integer"){
var exponent=content;}
if(content.cm_instanceof=="Rational"){
var exponent=content.numerator;}
var terms1=terms1.multiply(exponent.reciprocal());}
else if(terms1.cm_instanceof=="Factor"){
if(terms1.isPolynomial===true){
alert(["In exp expanding polynomial exponent",terms1,terms1.expand()]);
return new CM.Power([terms[0],terms1.expand()]).replaceStandardFunctions();}
else{
var factorterms=terms1.getTerms();
var factortermslength=factorterms.length;
if(factorterms[1].cm_instanceof=="Integer"){
alert(["In Power with integer coefficient of factor",factorterms[0],factorterms.cm_toString()]);
var exponent=factorterms[0];
if(factortermslength==2){
return new CM.Power([terms[0],factorterms[1]]).replaceStandardFunctions().power(exponent);}
else{
return new CM.Power([terms[0],factorterms.splice(0,1)]).replaceStandardFunctions().power(exponent);}}}}
var tempthis=new CM.Power(terms);
var matchfound=false;
for(var j=0;j<originallength;j++){
if(tempthis.equalTo(originalarray[j][0])){
var newtempthis=originalarray[j][1];
matchfound=true;}}
if(matchfound===false){
var replaceby="_b"+CM.Composite.uniqueId();
var newtempthis=CM.Composite.CreateVariable([replaceby]);
originalarray.push([tempthis,newtempthis]);
CM.Composite.replacementObject[replaceby]=tempthis;}
return newtempthis;};

