
CM.Factor=function(){
var args=arguments[0];
var argslength=args.length;
var tempterms=new Array();
var isNumber=true;
var isPolynomial=true;
var isRationalFunction=true;
this.hasDerivative=new Object;
var isFunction=true;
for(var i=0;i<argslength;i++){
var argsi=args[i];
if(argsi==null){
var errorstring="One of the arguments passed to the Function Constructor is null. This is causing an error. The array passed to the constructor is "+args.cm_toString()+".";
alert(errorstring);
throw new Error(errorstring);}
if(argsi.cm_instanceof!="Factor"){
tempterms.push(argsi);
isNumber=isNumber===true&&argsi.isNumber===true;
isPolynomial=isPolynomial===true&&argsi.isPolynomial===true;
isRationalFunction=isRationalFunction===true&&argsi.isRationalFunction===true;
isFunction=(isFunction===true&&(argsi.isFunction===true||argsi.isNumber===true));}
else{
var argsiterms=argsi.terms;
var argsitermslength=argsiterms.length;
for(var j=0;j<argsitermslength;j++){
var argsj=argsiterms[j];
tempterms.push(argsj);
isNumber=isNumber===true&&argsj.isNumber===true;
isPolynomial=isPolynomial===true&&argsj.isPolynomial===true;
isRationalFunction=isRationalFunction===true&&argsj.isRationalFunction===true;
isFunction=(isFunction===true&&(argsj.isFunction===true||argsj.isNumber===true));}}}
this.isNumber=isNumber;
this.isPolynomial=isPolynomial;
this.isRationalFunction=isRationalFunction;
this.isFunction=isFunction;
this.terms=tempterms;};
CM.Factor.prototype=new CM.Composite();
CM.Factor.prototype.constructor=CM.Factor;
CM.Factor.prototype.cm_instanceof="Factor";
CM.Factor.prototype.toStringUnsimplified=function(){
var thisstring=this.stringUnsimplified;
if(thisstring!=null){
return thisstring;};
var terms=this.terms;
var termslength=terms.length;
if(termslength==1)
return this.stringUnsimplified=terms[0].toString();
else if(termslength==0)
return this.stringUnsimplified="";
else{
var temparray=new Array(termslength);
for(var i=0;i<termslength;i++){
var termsi=terms[i];
if(((termsi.cm_instanceof=="Integer"&&termsi.sign=="+")||(termsi.cm_instanceof=="Floating"&&termsi.sign=="+"))||(termsi.cm_instanceof=="Polynomial"&&termsi.terms.length<2)||termsi.cm_instanceof=="StandardFunction")
temparray[i]=terms[i];
else if(termsi.cm_instanceof=="Power"&&i==termslength-1)
temparray[i]=terms[i];
else if(i==0&&(termsi.cm_instanceof=="Integer"||termsi.cm_instanceof=="Floating"))
temparray[i]=terms[i];
else
temparray[i]="("+terms[i]+")";}
return this.stringUnsimplified=temparray.join("*").replace(/^\s*\-\s*1\*/,"-");}};
CM.Factor.prototype.toStringSimplified=function(){
var thisstring=this.string;
if(thisstring!=null){
return thisstring;};
var minusOne=CM.Integer.minusOne;
var negativeexponents=new Array();
var positiveexponents=new Array();
var terms=this.terms;
var termslength=terms.length;
if(termslength==1){
alert(["Why is there a factor with one term?",terms[0]]);
return this.string=terms[0].toString();}
else if(termslength==0){
alert(["Why is there a factor with no terms?"]);
return this.string="";}
else{
var temparray=new Array();
for(var i=0;i<termslength;i++){
var termsi=terms[i];
if(((termsi.cm_instanceof=="Integer"&&termsi.sign=="+")||(termsi.cm_instanceof=="Floating"&&termsi.sign=="+"))||(termsi.cm_instanceof=="Polynomial"&&termsi.terms.length<2)||termsi.cm_instanceof=="StandardFunction"){
temparray.push(terms[i]);
positiveexponents.push(termsi);}
else if(termsi.cm_instanceof=="Power"&&(termsi.terms[1].cm_instanceof=="Integer"||termsi.terms[1].cm_instanceof=="Rational"||termsi.terms[1].cm_instanceof=="Floating")&&termsi.terms[1].sign=="-"){
if(termsi.terms[1].equalTo(minusOne)){
negativeexponents.push(termsi.terms[0]);}
else{
negativeexponents.push(new CM.Power([termsi.terms[0],termsi.terms[1].abs()]));}}
else if(termsi.cm_instanceof=="Power"&&i==termslength-1){
positiveexponents.push(termsi);
temparray.push(terms[i]);}
else if(i==0&&(termsi.cm_instanceof=="Integer"||termsi.cm_instanceof=="Floating")){
positiveexponents.push(termsi);
temparray.push(terms[i]);}
else{
positiveexponents.push(termsi);
temparray.push("("+terms[i]+")");}}
if(temparray.length==0){
temparray=["1"];
var topobject=CM.Integer.one;}
else if(temparray.length==1){
var topobject=positiveexponents[0];}
if(temparray.length>1){
var topobject=new CM.Factor(positiveexponents);}
if(negativeexponents.length==0){
this.simplifiedObjectsForString=[topobject];
return this.string=temparray.join("*").replace(/^\s*\-\s*1\*/,"-");}
else{
if(negativeexponents.length==1){
var bottomobject=negativeexponents[0];
this.simplifiedObjectsForString=[topobject,bottomobject];
return this.string=temparray.join("*").replace(/^\s*\-\s*1\*/,"-")+"/("+negativeexponents[0].toString()+")";}
else{
var denominator=new CM.Factor(negativeexponents);
denominator=denominator.maximizePolynomials();
this.simplifiedObjectsForString=[topobject,denominator];
return this.string=temparray.join("*").replace(/^\s*\-\s*1\*/,"-")+"/("+denominator.toString()+")";}}}};
CM.Factor.prototype.toString=function(){
if(this.simplified===this){
return this.toStringSimplified();}
else if(this.reduceCommonFactorsDone!=null&&this===this.reduceCommonFactorsDone){
alert(["Invoking the toStringSimplified method because this is something that has been calculated using NumeratorAndDenominator"]);
return this.toStringSimplified();}
else{
return this.toStringUnsimplified();}};
CM.Factor.prototype.equalTo=function(){
var another=arguments[0];
var ignoreFirst=arguments[1];
var precision=arguments[2];
var type=arguments[3];
if(precision==null){
var precision=CM.Floating.precision;}
var precision=1*(precision.toString());
var left=this;
var right=arguments[0];
if(ignoreFirst==null){
if(left.cm_instanceof!=right.cm_instanceof){
return false;}
var lTerms=this.terms;
var rTerms=another.terms;
var ltLength=lTerms.length;
var rtLength=rTerms.length;
if(left.cm_instanceof=="StandardFunction"){
if(left.name!=right.name)
return false;}
if(ltLength!=rtLength)
return false;
for(var i=0;i<ltLength;i++)
if(lTerms[i].cm_instanceof!=rTerms[i].cm_instanceof||lTerms[i].equalTo(rTerms[i],ignoreFirst,precision,type)!==true)
return false;
return true;}
else{
var lTerms=this.terms;
var rTerms=another.terms;
var ltLength=lTerms.length;
var rtLength=rTerms.length;
var thisBegin=0;
var anotherBegin=0;
var t=0;
while(this.terms[t].isNumber==true){
thisBegin++;
t++;}
var t=0;
while(another.terms[t]!=null&&another.terms[t].isNumber==true){
anotherBegin++;
t++;}
if(right.cm_instanceof!=="Factor"){
if(this.terms.length-thisBegin!=1){
return false;}
else{
return right.equalTo(this.terms[this.terms.length-thisBegin],null,precision,type);}}
if(this.terms[thisBegin].cm_instanceof==="Polynomial"&&another.terms[anotherBegin].cm_instanceof==="Polynomial"){
if(thisBegin==0&&anotherBegin==0){
if(!this.terms[thisBegin].equalTo(another.terms[anotherBegin],"ignorefirst",precision,type)){
return false;}}
else{
if(!this.terms[thisBegin].equalTo(another.terms[anotherBegin],null,precision,type)){
return false;}}
thisBegin++;
anotherBegin++;}
if(ltLength-thisBegin!=rtLength-anotherBegin)
return false;
for(var i=thisBegin,j=anotherBegin;i<ltLength;i++,j++){
if(lTerms[i].cm_instanceof!=rTerms[j].cm_instanceof||!(lTerms[i].equalTo(rTerms[j],null,precision,type))){
return false;
if(lTerms[i].cm_instanceof=="StandardFunction"){
if(lTerms[i].name!=rTerms[j].name)
return false;}}}
return true;}}
CM.Factor.prototype._simpleSort=function(sortFunc){
var lTerms=this.getTerms();
var ltLength=lTerms.length;
var numbers=new Array();
var polys=new Array();
var other=new Array();
var onetermpolynomialpowers=new Array();
for(var i=0;i<ltLength;i++){
var curTerm=lTerms[i];
if(curTerm.isNumber===true){
numbers.push(curTerm);}
else if(curTerm.cm_instanceof=="Polynomial"&&curTerm.terms.length==1){
polys.push(curTerm);}
else if(curTerm.cm_instanceof=="Power"&&curTerm.terms[0].cm_instanceof=="Polynomial"&&curTerm.terms[0].terms.length==1&&curTerm.terms[1].cm_instanceof=="Integer"){
onetermpolynomialpowers.push(curTerm);}
else{
other.push(curTerm);}}
return{numbers:numbers,
polynomial:polys,
onetermpolynomialpowers:onetermpolynomialpowers,
other:other};}
CM.Factor.prototype.simplify=function(){
if(this.simplified!=null){
return this.simplified;}
var lTerms=this.terms;
var tLength=lTerms.length;
var newTerms=new Array(tLength);
for(var i=0;i<tLength;i++)
newTerms[i]=lTerms[i].simplify();
var arrays=new CM.Factor(newTerms)._simpleSort();
var returnArray=new Array();
var temp;
var currentArray=new Array();
if(arrays.numbers.length>0){
var tempnumber=CM.Atomic.Multiply(arrays.numbers).simplify();
if(tempnumber.equalTo(CM.Integer.zero)){
var tempreturn=CM.Integer.zero;
this.simplified=tempreturn;
tempreturn.simplified=tempreturn;
return tempreturn;}
currentArray.push(tempnumber);}
if(arrays.polynomial.length>0){
var multipliedsingletermpolynomials=CM.Composite.PolynomialMultiply(arrays.polynomial);
if(multipliedsingletermpolynomials.cm_instanceof=="Polynomial"){
if(arrays.onetermpolynomialpowers.length>0){
var polynomialandreciprocalarray=multipliedsingletermpolynomials.singleTermPolynomialDivision(arrays.onetermpolynomialpowers);
currentArray.push(polynomialandreciprocalarray[0])
if(polynomialandreciprocalarray[1]!=null){
arrays.other=arrays.other.concat(polynomialandreciprocalarray[1]);}}
else{
currentArray.push(multipliedsingletermpolynomials);}}
else{
arrays.other.push(multipliedsingletermpolynomials);
arrays.other=arrays.other.concat(arrays.onetermpolynomialpowers);}}
else{
arrays.other=arrays.other.concat(arrays.onetermpolynomialpowers);}
if(currentArray.length==2){
currentArray=[CM.Composite.CreatePolynomial(currentArray[0]).multiply(currentArray[1])];}
if(arrays.other.length>0){
if(currentArray.length==1&&currentArray[0].equalTo(CM.Integer.one)){
currentArray=arrays.other.sort(CM.Sorts.SortingFunction);}
else{
currentArray=currentArray.concat(arrays.other.sort(CM.Sorts.SortingFunction));}}
var ignoreFirst=true;
var length=currentArray.length;
if(length==1){
var tempreturn=currentArray[0];
this.simplified=tempreturn;
tempreturn.simplified=tempreturn;
return tempreturn;}
var expressionmodified=false;
factorloop:
for(var i=0;i<length;i++){
var curElement=currentArray[i];
var j=1;
if(currentArray[i+j]==null){
returnArray.push(curElement);
break factorloop;}
if(curElement.cm_instanceof!="Power"&&!(curElement.cm_instanceof=="StandardFunction"&&curElement.name=="exp")){
if(currentArray[i+j].cm_instanceof!="Power"){
var isequal=curElement.equalTo(currentArray[i+j]);
var type="NN";}
else{
var isequal=curElement.equalTo(currentArray[i+j].terms[0]);
var type="NP";}}
else if(curElement.cm_instanceof=="StandardFunction"&&curElement.name=="exp"){
if(currentArray[i+j].cm_instanceof=="StandardFunction"&&currentArray[i+j].name=="exp"){
var isequal=true
var type="EE";}
else{
var isequal=false;}}
else{
if(currentArray[i+j].cm_instanceof!="Power"){
var isequal=curElement.terms[0].equalTo(currentArray[i+j]);
var type="PN";}
else{
var isequal=curElement.terms[0].equalTo(currentArray[i+j].terms[0]);
var type="PP";}}
var totalexponent=new Array();
while(isequal===true){
if(type=="NP"||type=="PP"){
var exp=currentArray[i+j].terms[1];}
else if(type=="EE"){
var exp=currentArray[i+j].terms[0];}
else{
var exp=CM.Integer.one;}
totalexponent.push(exp);
j++;
if(i+j<currentArray.length){
if(curElement.cm_instanceof!="Power"&&!(curElement.cm_instanceof=="StandardFunction"&&curElement.name=="exp")){
if(currentArray[i+j].cm_instanceof!="Power"){
var isequal=curElement.equalTo(currentArray[i+j]);
var type="NN";}
else{
var isequal=curElement.equalTo(currentArray[i+j].terms[0]);
var type="NP";}}
else if(curElement.cm_instanceof=="StandardFunction"&&curElement.name=="exp"){
if(currentArray[i+j].cm_instanceof=="StandardFunction"&&currentArray[i+j].name=="exp"){
var isequal=true
var type="EE";}
else{
var isequal=false;}}
else{
if(currentArray[i+j].cm_instanceof!="Power"){
var isequal=curElement.terms[0].equalTo(currentArray[i+j]);
var type="PN";}
else{
var isequal=curElement.terms[0].equalTo(currentArray[i+j].terms[0]);
var type="PP";}}}
else
var isequal=false;}
if(totalexponent.length>0){
expressionmodified=true
if(curElement.cm_instanceof=="Power"){
totalexponent.push(curElement.terms[1]);
returnArray.push(new CM.Power([curElement.terms[0],new CM.Sum(totalexponent).simplify()]));}
else if(curElement.cm_instanceof=="StandardFunction"&&curElement.name=="exp"){
totalexponent.push(curElement.terms[0]);
returnArray.push(new CM.Exp([new CM.Sum(totalexponent).simplify()]));}
else{
totalexponent.push(CM.Integer.one);
returnArray.push(new CM.Power([curElement,new CM.Sum(totalexponent).simplify()]));}}
else
returnArray.push(curElement);
i=i+j-1;
var totalexponent=new Array();}
if(expressionmodified==false){
var tempreturn=new CM.Factor(returnArray);
tempreturn.simplified=tempreturn;
this.simplified=tempreturn;
return tempreturn;
var returnArrayLength=returnArray.length;
var finalnumberarray=new Array();
var polywithsingletermarray=new Array();
var remainingarray=new Array();
for(var i=0;i<returnArrayLength;i++){
if(returnArray[i].isNumber===true){
finalnumberarray.push(returnArray[i]);}
else if((returnArray[i].cm_instanceof=="Polynomial"&&returnArray[i].terms.length==1)||(returnArray[i].cm_instanceof=="Power"&&returnArray[i].terms[0].cm_instanceof=="Polynomial"&&returnArray[i].terms[0].terms.length==1&&returnArray[i].terms[1].cm_instanceof=="Integer")){
polywithsingletermarray.push(returnArray[i]);}
else{
remainingarray.push(returnArray[i]);}}
if(polywithsingletermarray.length==0){
if(returnArray.length==1){
var tempreturn=returnArray[0];}
else{
var tempreturn=new CM.Factor(returnArray);}
this.simplified=tempreturn;
tempreturn.simplified=tempreturn;
return tempreturn;}
if(CM.UseNativeExponents===false){
var combinedpolyandnegpowerarray=CM.Polynomial.simplifySingleTermExpressions(polywithsingletermarray);}
else{
var combinedpolyandnegpowerarray=CM.PolynomialNativeExponents.simplifySingleTermExpressions(polywithsingletermarray);}
if(finalnumberarray.length==0){
if(combinedpolyandnegpowerarray.length==1&&combinedpolyandnegpowerarray[0].equalTo(CM.Integer.one)){
var tempreturnarray=remainingarray;}
else{
var tempreturnarray=combinedpolyandnegpowerarray.concat(remainingarray);}
if(tempreturnarray.length>1){
var tempreturn=new CM.Factor(tempreturnarray);}
else if(tempreturnarray.length==1){
var tempreturn=tempreturnarray[0];}
else{
var tempreturn=CM.Integer.one;}}
else{
if(combinedpolyandnegpowerarray[0]!=null&&combinedpolyandnegpowerarray[0].isNumber===true){
combinedpolyandnegpowerarray[0]=(new CM.Factor([combinedpolyandnegpowerarray[0]].concat(finalnumberarray))).simplify();
if(combinedpolyandnegpowerarray.length>1){
if(combinedpolyandnegpowerarray[0].equalTo(CM.Integer.one)){
combinedpolyandnegpowerarray=combinedpolyandnegpowerarray.slice(1);}
var tempreturn=new CM.Factor(combinedpolyandnegpowerarray.concat(remainingarray));}
else{
if(remainingarray.length==0){
var tempreturn=combinedpolyandnegpowerarray[0];}
else{
if(!combinedpolyandnegpowerarray[0].equalTo(CM.Integer.one)){
var tempreturn=new CM.Factor(combinedpolyandnegpowerarray.concat(remainingarray));}
else{
var tempreturn=new CM.Factor(remainingarray);}}}}
else if(combinedpolyandnegpowerarray[0]!=null&&combinedpolyandnegpowerarray[0].cm_instanceof=="Polynomial"){
var polyterms=combinedpolyandnegpowerarray[0].getPolyTerms();
polyterms[0][0]=(new CM.Factor(finalnumberarray.concat(polyterms[0][0]))).simplify();
combinedpolyandnegpowerarray[0]=new CM.Polynomial(polyterms,combinedpolyandnegpowerarray[0].getKey());
var tempreturnarray=combinedpolyandnegpowerarray.concat(remainingarray);
if(tempreturnarray.length>1){
var tempreturn=new CM.Factor(tempreturnarray);}
else{
var tempreturn=tempreturnarray[0];}}
else if(combinedpolyandnegpowerarray[0]!=null&&combinedpolyandnegpowerarray[0].cm_instanceof=="Power"){
var tempreturn=new CM.Factor(finalnumberarray.concat(combinedpolyandnegpowerarray).concat(remainingarray));}}
this.simplified=tempreturn;
tempreturn.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=new CM.Factor(returnArray).simplify();
tempreturn.simplified=tempreturn;
this.simplified=tempreturn;
return tempreturn;}};
CM.Factor.prototype._simpleExpandSort=function(){
var lTerms=this.getTerms();
var ltLength=lTerms.length;
var numbers=new Array();
var polys=new Array();
var sums=new Array();
var other=new Array()
for(var i=0;i<ltLength;i++){
var curTerm=lTerms[i];
if(curTerm.isNumber===true)
numbers.push(curTerm);
else if(curTerm.cm_instanceof=="Polynomial")
polys.push(curTerm);
else if(curTerm.cm_instanceof=="Sum")
sums.push(curTerm);
else
other.push(curTerm);}
return{numbers:numbers,
polynomial:polys,
sums:sums,
other:other};}
CM.Factor.prototype.expandOLD=function(){
var terms=this.getTerms();
var termslength=terms.length;
for(var i=0;i<termslength;i++){
terms[i]=terms[i].expand();}
var arrays=new CM.Factor(terms)._simpleExpandSort();
var currentArray=new Array();
if(arrays.numbers.length>0){
var tempnumber=CM.Atomic.Multiply(arrays.numbers);
if(!tempnumber.equalTo(CM.Integer.one)){
currentArray.push(tempnumber);}}
if(arrays.polynomial.length>0){
if(currentArray.length>0){
currentArray=[CM.Composite.PolynomialMultiply([CM.Composite.CreatePolynomial(currentArray[0])].concat(arrays.polynomial)).sort()];}
else{
currentArray=[CM.Composite.PolynomialMultiply(arrays.polynomial)];}}
if(arrays.sums.length==0){
if(currentArray.length>0){
if(arrays.other.length==0){
return currentArray[0];}
else{
if(currentArray[0].isNumber===true){
return new CM.Factor(currentArray.concat(arrays.other));}
else{
var broken=currentArray[0].breakUpPolynomial();
var brokenterms=broken.terms;
var brokentermslength=brokenterms.length;
var sumterms=[];
for(var j=0;j<brokentermslength;j++){
sumterms.push(new CM.Factor([brokenterms[j]].concat(arrays.other)).simplify());}
return new CM.Sum(sumterms).simplify();}}}
else{
if(arrays.other.length>0){
return new CM.Factor(arrays.other);}
else{
return CM.Integer.one;}}}
if(arrays.sums.length>0){
if(currentArray.length>0){
var firstsumterms=arrays.sums[0].simplify().getTerms();
var firstsumtermslength=firstsumterms.length;
var newterms=[];
for(var j=0;j<firstsumtermslength;j++){
newterms[j]=new CM.Factor([currentArray[0],firstsumterms[j]]);}
currentArray=[new CM.Sum(newterms).simplify()];
if(arrays.other.length>0){
return new CM.Factor([currentArray[0]].concat(arrays.sums.slice(1).concat(arrays.other))).expand();}
else if(arrays.sums.length>1){
return new CM.Factor([currentArray[0]].concat(arrays.sums.slice(1))).expand();}
else{
return currentArray[0].expand();}}
else if(arrays.sums.length>1){
var firstsumterms=arrays.sums[0].simplify().getTerms();
var firstsumtermslength=firstsumterms.length;
var secondsumterms=arrays.sums[1].simplify().getTerms();
var secondsumtermslength=secondsumterms.length;
var newterms=[];
for(var i=0;i<firstsumtermslength;i++){
var firstsumi=firstsumterms[i];
for(var j=0;j<secondsumtermslength;j++){
newterms.push(new CM.Factor([firstsumi,secondsumterms[j]]));}}
currentArray=[new CM.Sum(newterms).simplify()];
if(arrays.other.length>0){
return new CM.Factor([currentArray[0]].concat(arrays.sums.slice(2).concat(arrays.other))).expand();}
else if(arrays.sums.length>2){
return new CM.Factor([currentArray[0]].concat(arrays.sums.slice(2))).expand();}
else{
return currentArray[0].expand();}}
else{
var firstsumterms=arrays.sums[0].simplify().getTerms();
var firstsumtermslength=firstsumterms.length;
var newterms=[];
for(var j=0;j<firstsumtermslength;j++){
newterms[j]=new CM.Factor([firstsumterms[j]].concat(arrays.other));}
return new CM.Sum(newterms).expand();}}
if(arrays.other.length>0)
currentArray=currentArray.concat(arrays.other.sort(CM.Sorts.SortingFunction));
if(currentArray.length>1){
return new CM.Factor(currentArray);}
else if(currentArray.length==1){
return currentArray[0];}
else{
return CM.Integer.one;}};
CM.Factor.prototype.expandAux=function(){
var terms=this.getTerms();
var termslength=terms.length;
for(var i=0;i<termslength;i++){
terms[i]=terms[i].reduceFractionalExponents().expandAux();}
var arrays=new CM.Factor(terms)._simpleExpandSort();
var currentArray=new Array();
if(arrays.numbers.length>0){
var tempnumber=CM.Atomic.Multiply(arrays.numbers);
if(!tempnumber.equalTo(CM.Integer.one)){
currentArray.push(tempnumber);}}
if(arrays.polynomial.length>0){
if(currentArray.length>0){
currentArray=[CM.Composite.PolynomialMultiply([CM.Composite.CreatePolynomial(currentArray[0])].concat(arrays.polynomial)).sort()];}
else{
currentArray=[CM.Composite.PolynomialMultiply(arrays.polynomial)];}}
if(arrays.sums.length==0){
if(currentArray.length>0){
if(arrays.other.length==0){
return currentArray[0];}
else{
if(currentArray[0].isNumber===true){
return new CM.Factor(currentArray.concat(arrays.other));}
else{
var broken=currentArray[0].breakUpPolynomial();
var brokenterms=broken.terms;
var brokentermslength=brokenterms.length;
var sumterms=[];
for(var j=0;j<brokentermslength;j++){
sumterms.push(new CM.Factor([brokenterms[j]].concat(arrays.other)).simplify());}
return new CM.Sum(sumterms).simplify();}}}
else{
if(arrays.other.length>0){
return new CM.Factor(arrays.other);}
else{
return CM.Integer.one;}}}
if(arrays.sums.length>0){
if(currentArray.length>0){
var firstsumterms=arrays.sums[0].simplify().getTerms();
var firstsumtermslength=firstsumterms.length;
var newterms=[];
for(var j=0;j<firstsumtermslength;j++){
newterms[j]=new CM.Factor([currentArray[0],firstsumterms[j]]);}
currentArray=[new CM.Sum(newterms).simplify()];
if(arrays.other.length>0){
return new CM.Factor([currentArray[0]].concat(arrays.sums.slice(1).concat(arrays.other))).expandAux();}
else if(arrays.sums.length>1){
return new CM.Factor([currentArray[0]].concat(arrays.sums.slice(1))).expandAux();}
else{
return currentArray[0].expandAux();}}
else if(arrays.sums.length>1){
var firstsumterms=arrays.sums[0].simplify().getTerms();
var firstsumtermslength=firstsumterms.length;
var secondsumterms=arrays.sums[1].simplify().getTerms();
var secondsumtermslength=secondsumterms.length;
var newterms=[];
for(var i=0;i<firstsumtermslength;i++){
var firstsumi=firstsumterms[i];
for(var j=0;j<secondsumtermslength;j++){
newterms.push(new CM.Factor([firstsumi,secondsumterms[j]]));}}
currentArray=[new CM.Sum(newterms).simplify()];
if(arrays.other.length>0){
return new CM.Factor([currentArray[0]].concat(arrays.sums.slice(2).concat(arrays.other))).expandAux();}
else if(arrays.sums.length>2){
return new CM.Factor([currentArray[0]].concat(arrays.sums.slice(2))).expandAux();}
else{
return currentArray[0].expandAux();}}
else{
var firstsumterms=arrays.sums[0].simplify().getTerms();
var firstsumtermslength=firstsumterms.length;
var newterms=[];
for(var j=0;j<firstsumtermslength;j++){
newterms[j]=new CM.Factor([firstsumterms[j]].concat(arrays.other));}
return new CM.Sum(newterms).expandAux();}}
if(arrays.other.length>0)
currentArray=currentArray.concat(arrays.other.sort(CM.Sorts.SortingFunction));
if(currentArray.length>1){
return new CM.Factor(currentArray);}
else if(currentArray.length==1){
return currentArray[0];}
else{
return CM.Integer.one;}};
CM.Factor.prototype.expand=function(){
if(this.isPolynomial===true){
return this.expandAux();}
var expandAuxResult=this.expandAux();
return expandAuxResult;
var rationalizedarray=expandAuxResult.rationalize();
var numerator=rationalizedarray[0].expandAux();
var denominator=rationalizedarray[1];
if(denominator.equalTo(CM.Integer.one)){
return numerator;}
else{
if(numerator.cm_instanceof=="Polynomial"&&denominator.isNumber===true){
return numerator.multiply(denominator.reciprocal());}
else if(numerator.isNumber===true&&denominator.isNumber===true){
return CM.Atomic.MultiplyTwoNumbers(numerator,denominator.reciprocal());}
if(numerator.cm_instanceof=="Polynomial"){
numerator=numerator.breakUpPolynomial();}
if(numerator.cm_instanceof=="Sum"){
var numeratorterms=numerator.getTerms();
var numeratortermslength=numeratorterms.length;
var Factor=CM.Factor;
var returnterms=new Array();
for(var i=0;i<numeratortermslength;i++){
returnterms.push(new CM.Quotient([numeratorterms[i],denominator]).simplify());}
var tempreturn=new CM.Sum(returnterms);
return tempreturn;}
else{
return new CM.Quotient([numerator,denominator]).simplify();}}};
CM.Factor.prototype.expandWithoutSimplification=function(){
var simplify=arguments[0];
var terms=this.getTerms();
var termslength=terms.length;
for(var i=0;i<termslength;i++){
if(terms[i].expandWithoutSimplification!=null){
terms[i]=terms[i].expandWithoutSimplification(simplify);}}
if(simplify==null||simplify.match(/f/)==null){
var currentterm=terms[0];
for(var i=1;i<termslength;i++){
var nextterm=terms[i];
if(currentterm.cm_instanceof!="Sum"){
if(nextterm.cm_instanceof!="Sum"){
currentterm=new CM.Factor([currentterm,nextterm]);}
else{
var nexttermTerms=nextterm.getTerms();
var nexttermTermsLength=nexttermTerms.length;
for(var j=0;j<nexttermTermsLength;j++){
nexttermTerms[j]=new CM.Factor([currentterm,nexttermTerms[j]]);}
currentterm=new CM.Sum(nexttermTerms);}}
else{
if(nextterm.cm_instanceof!="Sum"){
var currenttermTerms=currentterm.getTerms();
var currenttermTermsLength=currenttermTerms.length;
for(var j=0;j<currenttermTermsLength;j++){
currenttermTerms[j]=new CM.Factor([currenttermTerms[j],nextterm]);}
currentterm=new CM.Sum(currenttermTerms);}
else{
var currenttermTerms=currentterm.getTerms();
var currenttermTermsLength=currenttermTerms.length;
var nexttermTerms=nextterm.getTerms();
var nexttermTermsLength=nexttermTerms.length;
var newterms=new Array();
for(var iii=0;iii<currenttermTermsLength;iii++){
for(var j=0;j<nexttermTermsLength;j++){
newterms.push(new CM.Factor([currenttermTerms[iii],nexttermTerms[j]]));}}
currentterm=new CM.Sum(newterms);}}}
return currentterm;}
else{
var currentterm=terms[0];
for(var i=1;i<termslength;i++){
var nextterm=terms[i];
if(currentterm.cm_instanceof!="Sum"){
if(nextterm.cm_instanceof!="Sum"){
currentterm=new CM.Factor([currentterm,nextterm]).simplify();}
else{
var nexttermTerms=nextterm.getTerms();
var nexttermTermsLength=nexttermTerms.length;
for(var j=0;j<nexttermTermsLength;j++){
nexttermTerms[j]=new CM.Factor([currentterm,nexttermTerms[j]]).simplify();}
currentterm=new CM.Sum(nexttermTerms);}}
else{
if(nextterm.cm_instanceof!="Sum"){
var currenttermTerms=currentterm.getTerms();
var currenttermTermsLength=currenttermTerms.length;
for(var j=0;j<currenttermTermsLength;j++){
currenttermTerms[j]=new CM.Factor([currenttermTerms[j],nextterm]).simplify();}
currentterm=new CM.Sum(currenttermTerms);}
else{
var currenttermTerms=currentterm.getTerms();
var currenttermTermsLength=currenttermTerms.length;
var nexttermTerms=nextterm.getTerms();
var nexttermTermsLength=nexttermTerms.length;
var newterms=new Array();
for(var iii=0;iii<currenttermTermsLength;iii++){
for(var j=0;j<nexttermTermsLength;j++){
newterms.push(new CM.Factor([currenttermTerms[iii],nexttermTerms[j]]).simplify());}}
currentterm=new CM.Sum(newterms);}}}
return currentterm;}};
CM.Factor.prototype.round=function(){
var precision=arguments[0];
var type=arguments[1];
if(precision==null){
var precision=CM.Floating.precision;}
var precision=1*(precision.toString());
var lTerms=this.terms;
var tLength=lTerms.length;
var newTerms=new Array(tLength);
for(var i=0;i<tLength;i++)
newTerms[i]=lTerms[i].round(precision,type);
var arrays=new CM.Factor(newTerms)._simpleSort();
var returnArray=new Array();
var temp;
var currentArray=new Array();
if(arrays.numbers.length>0){
var tempnumber=CM.Atomic.MultiplyRounded(arrays.numbers,precision,type);
if(tempnumber.equalTo(CM.Integer.zero,precision,type)){
var tempreturn=CM.Integer.zero;
this.simplified=tempreturn;
return tempreturn;}
currentArray.push(tempnumber);}
if(arrays.polynomial.length>0){
currentArray.push(CM.Composite.PolynomialMultiplyRounded(arrays.polynomial,precision,type).sort());}
if(currentArray.length==2){
currentArray=[CM.Composite.CreatePolynomial(currentArray[0]).multiplyrounded(currentArray[1],precision,type)];}
if(arrays.other.length>0){
if(currentArray.length==1&&currentArray[0].equalTo(CM.Integer.one,precision,type)){
currentArray=arrays.other.sort(CM.Sorts.SortingFunction);}
else{
currentArray=currentArray.concat(arrays.other.sort(CM.Sorts.SortingFunction));}}
var ignoreFirst=true;
var length=currentArray.length;
if(length==1){
var tempreturn=currentArray[0];
this.simplified=tempreturn;
return tempreturn;}
var expressionmodified=false
factorloop:
for(var i=0;i<length;i++){
var curElement=currentArray[i];
var j=1;
if(currentArray[i+j]==null){
returnArray.push(curElement);
break factorloop;}
if(curElement.cm_instanceof!="Power"&&!(curElement.cm_instanceof=="StandardFunction"&&curElement.name=="exp")){
if(currentArray[i+j].cm_instanceof!="Power"){
var isequal=curElement.equalTo(currentArray[i+j],precision,type);
var type="NN";}
else{
var isequal=curElement.equalTo(currentArray[i+j].terms[0],precision,type);
var type="NP";}}
else if(curElement.cm_instanceof=="StandardFunction"&&curElement.name=="exp"){
if(currentArray[i+j].cm_instanceof=="StandardFunction"&&currentArray[i+j].name=="exp"){
var isequal=true
var type="EE";}
else{
var isequal=false;}}
else{
if(currentArray[i+j].cm_instanceof!="Power"){
var isequal=curElement.terms[0].equalTo(currentArray[i+j],precision,type);
var type="PN";}
else{
var isequal=curElement.terms[0].equalTo(currentArray[i+j].terms[0],precision,type);
var type="PP";}}
var totalexponent=new Array();
while(isequal===true){
if(type=="NP"||type=="PP"){
var exp=currentArray[i+j].terms[1];}
else if(type=="EE"){
var exp=currentArray[i+j].terms[0];}
else{
var exp=CM.Integer.one;}
totalexponent.push(exp);
j++;
if(i+j<currentArray.length){
if(curElement.cm_instanceof!="Power"&&!(curElement.cm_instanceof=="StandardFunction"&&curElement.name=="exp")){
if(currentArray[i+j].cm_instanceof!="Power"){
var isequal=curElement.equalTo(currentArray[i+j],precision,type);
var type="NN";}
else{
var isequal=curElement.equalTo(currentArray[i+j].terms[0],precision,type);
var type="NP";}}
else if(curElement.cm_instanceof=="StandardFunction"&&curElement.name=="exp"){
if(currentArray[i+j].cm_instanceof=="StandardFunction"&&currentArray[i+j].name=="exp"){
var isequal=true
var type="EE";}
else{
var isequal=false;}}
else{
if(currentArray[i+j].cm_instanceof!="Power"){
var isequal=curElement.terms[0].equalTo(currentArray[i+j],precision,type);
var type="PN";}
else{
var isequal=curElement.terms[0].equalTo(currentArray[i+j].terms[0],precision,type);
var type="PP";}}}
else
var isequal=false;}
if(totalexponent.length>0){
expressionmodified=true
if(curElement.cm_instanceof=="Power"){
totalexponent.push(curElement.terms[1]);
returnArray.push(new CM.Power([curElement.terms[0],new CM.Sum(totalexponent).round(precision,type)]));}
else if(curElement.cm_instanceof=="StandardFunction"&&curElement.name=="exp"){
totalexponent.push(curElement.terms[0]);
returnArray.push(new CM.Exp([new CM.Sum(totalexponent).round(precision,type)]));}
else{
totalexponent.push(CM.Integer.one);
returnArray.push(new CM.Power([curElement,new CM.Sum(totalexponent).round(precision,type)]));}}
else
returnArray.push(curElement);
i=i+j-1;
var totalexponent=new Array();}
if(expressionmodified==false){
var returnArrayLength=returnArray.length;
var finalnumberarray=new Array();
var polywithsingletermarray=new Array();
var remainingarray=new Array();
for(var i=0;i<returnArrayLength;i++){
if(returnArray[i].isNumber===true){
finalnumberarray.push(returnArray[i]);}
else if((returnArray[i].cm_instanceof=="Polynomial"&&returnArray[i].terms.length==1)||(returnArray[i].cm_instanceof=="Power"&&returnArray[i].terms[0].cm_instanceof=="Polynomial"&&returnArray[i].terms[0].terms.length==1&&returnArray[i].terms[1].cm_instanceof=="Integer")){
polywithsingletermarray.push(returnArray[i]);}
else{
remainingarray.push(returnArray[i]);}}
if(polywithsingletermarray.length==0){
if(returnArray.length==1){
var tempreturn=returnArray[0];}
else{
var tempreturn=new CM.Factor(returnArray);}
this.simplified=tempreturn;
tempreturn.simplified=tempreturn;
return tempreturn;}
if(CM.UseNativeExponents===false){
var combinedpolyandnegpowerarray=CM.Polynomial.simplifySingleTermExpressions(polywithsingletermarray);}
else{
var combinedpolyandnegpowerarray=CM.PolynomialNativeExponents.simplifySingleTermExpressions(polywithsingletermarray);}
if(finalnumberarray.length==0){
if(combinedpolyandnegpowerarray.length==1&&combinedpolyandnegpowerarray[0].equalTo(CM.Integer.one,precision,type)){
var tempreturnarray=remainingarray;}
else{
var tempreturnarray=combinedpolyandnegpowerarray.concat(remainingarray);}
if(tempreturnarray.length>1){
var tempreturn=new CM.Factor(tempreturnarray);}
else if(tempreturnarray.length==1){
var tempreturn=tempreturnarray[0];}
else{
var tempreturn=CM.Integer.one;}}
else{
if(combinedpolyandnegpowerarray[0]!=null&&combinedpolyandnegpowerarray[0].isNumber===true){
combinedpolyandnegpowerarray[0]=(new CM.Factor([combinedpolyandnegpowerarray[0]].concat(finalnumberarray))).round(precision,type);
if(combinedpolyandnegpowerarray.length>1){
if(combinedpolyandnegpowerarray[0].equalTo(CM.Integer.one,precision,type)){
combinedpolyandnegpowerarray=combinedpolyandnegpowerarray.slice(1);}
var tempreturn=new CM.Factor(combinedpolyandnegpowerarray.concat(remainingarray));}
else{
if(remainingarray.length==0){
var tempreturn=combinedpolyandnegpowerarray[0];}
else{
if(!combinedpolyandnegpowerarray[0].equalTo(CM.Integer.one,precision,type)){
var tempreturn=new CM.Factor(combinedpolyandnegpowerarray.concat(remainingarray));}
else{
var tempreturn=new CM.Factor(remainingarray);}}}}
else if(combinedpolyandnegpowerarray[0]!=null&&combinedpolyandnegpowerarray[0].cm_instanceof=="Polynomial"){
var polyterms=combinedpolyandnegpowerarray[0].getPolyTerms();
polyterms[0][0]=(new CM.Factor(finalnumberarray.concat(polyterms[0][0]))).round(precision,type);
combinedpolyandnegpowerarray[0]=new CM.Polynomial(polyterms,combinedpolyandnegpowerarray[0].getKey());
var tempreturnarray=combinedpolyandnegpowerarray.concat(remainingarray);
if(tempreturnarray.length>1){
var tempreturn=new CM.Factor(tempreturnarray);}
else{
var tempreturn=tempreturnarray[0];}}
else if(combinedpolyandnegpowerarray[0]!=null&&combinedpolyandnegpowerarray[0].cm_instanceof=="Power"){
var tempreturn=new CM.Factor(finalnumberarray.concat(combinedpolyandnegpowerarray).concat(remainingarray));}}
this.simplified=tempreturn;
tempreturn.simplified=tempreturn;
return tempreturn;}
else{
return new CM.Factor(returnArray).round(precision,type);}};
CM.Factor.prototype.rationalizeAux=function(){
var thissimplified=this.simplify();
if(thissimplified.cm_instanceof!=this.cm_instanceof){
return thissimplified.rationalize();}
var zero=CM.Integer.zero;
var minusOne=CM.Integer.minusOne;
var one=CM.Integer.one;
var terms=thissimplified.terms;
var termslength=terms.length;
var numerator=new Array();
var denominator=new Array();
var beginTime=new Date().getTime();
for(var i=0;i<termslength;i++){
var thistermrationalized=terms[i].rationalize();
if(!thistermrationalized[0].equalTo(one)){
numerator.push(thistermrationalized[0].simplify());}
if(!thistermrationalized[1].equalTo(one)){
denominator.push(thistermrationalized[1].simplify());}}
var endTime=new Date().getTime();
if(numerator.length>1){
numerator=new CM.Factor(numerator);}
else if(numerator.length==1){
numerator=numerator[0];}
else{
numerator=one;}
if(denominator.length>1){
denominator=new CM.Factor(denominator);}
else if(denominator.length==1){
denominator=denominator[0];}
else{
denominator=one;}
return[numerator,denominator];};
CM.Factor.prototype.numerator=function(){
return this.rationalize()[0];};
CM.Factor.prototype.denominator=function(){
return this.rationalize()[1];};
CM.Factor.prototype.reduceCommonFactors=function(){
if(this.reduceCommonFactorsDone!=null){
return this.reduceCommonFactorsDone;}
var tempreturn=this.numeratorAndDenominator().simplify();
this.reduceCommonFactorsDone=tempreturn;
tempreturn.reduceCommonFactorsDone=tempreturn;
return tempreturn;};
CM.Factor.prototype.numeratorAndDenominator=function(){
var minusOne=CM.Integer.minusOne;
var one=CM.Integer.one;
if(this.numeratorAndDenominatorDone!=null){
return this.numeratorAndDenominatorDone;}
var rationalized=this.rationalize();
if(rationalized[1].equalTo(one)){
var tempreturn=rationalized[0];}
else{
var tempreturn=new CM.Quotient(rationalized);}
this.numeratorAndDenominatorDone=tempreturn;
tempreturn.numeratorAndDenominatorDone=tempreturn;
return tempreturn;};
CM.Factor.prototype.rationalize=function(){
var BeginTime=new Date().getTime();
if(this.rationalizedVersion!=null){
return this.rationalizedVersion;}
var one=CM.Integer.one;
var rationalizedversion=this.replaceStandardFunctions().rationalizeAux();
var numerator=rationalizedversion[0];
var denominator=rationalizedversion[1];
if(denominator.cm_instanceof=="Factor"){
var denominatorterms=denominator.terms;
var denominatortermslength=denominatorterms.length;}
else{
if(denominator.equalTo(one)){
numerator=[numerator.unreplaceStandardFunctions(),one];
this.reduceCommonFactorsDone=numerator;
numerator.reduceCommonFactorsDone=numerator;
return numerator;}
else{
var denominatorterms=[denominator];
var denominatortermslength=1;}}
if(numerator.cm_instanceof=="Factor"){
var numeratorterms=numerator.terms;
var numeratortermslength=numeratorterms.length;}
else{
var numeratorterms=[numerator];
var numeratortermslength=1;}
var newdenominatorterms=new Array();
for(var i=0;i<denominatorterms.length;i++){
var EndTime=new Date().getTime();
if(.001*(EndTime-BeginTime)>CM.CancelingTimeout){
if(confirm("You have taken more than "+CM.CancelingTimeout+" seconds simplifying an expression. Click OK to continue for another  "+CM.CancelingTimeout+" seconds or click cancel to end the simplification")){
var BeginTime=new Date().getTime();}
else{
return;}}
var denominatori=denominatorterms[i];
numeratorloop:
for(var j=0;j<numeratortermslength;j++){
var EndTime=new Date().getTime();
if(.001*(EndTime-BeginTime)>CM.CancelingTimeout){
if(confirm("You have taken more than "+CM.CancelingTimeout+" seconds simplifying an expression. Click OK to continue for another  "+CM.CancelingTimeout+" seconds or click cancel to end the simplification")){
var BeginTime=new Date().getTime();}
else{
return;}}
var numeratorj=numeratorterms[j];
var tempgcdobject=CM.Composite.Gcd(denominatori,numeratorj);
var tempgcd=tempgcdobject.gcd;
if(!tempgcd.equalTo(one)){
numeratorterms[j]=tempgcdobject.rightquotient;
denominatori=tempgcdobject.leftquotient;
denominatorterms[i]=denominatori;
if(denominatori.equalTo(one)){
denominatorterms.splice(i,1);
i--;
break numeratorloop;}}}}
if(numeratorterms.length>1){
var newtop=new CM.Factor(numeratorterms).unreplaceStandardFunctions().simplify();}
else if(numeratorterms.length==1){
var newtop=numeratorterms[0].unreplaceStandardFunctions().simplify();}
else{
newtop=1;}
if(denominatorterms.length>1){
var newbottom=new CM.Factor(denominatorterms).unreplaceStandardFunctions().simplify();}
else if(denominatorterms.length==1){
var newbottom=denominatorterms[0].unreplaceStandardFunctions().simplify();}
else{
var newbottom=one;}
if((newbottom.cm_instanceof=="Integer"||newbottom.cm_instanceof=="Rational"||newbottom.cm_instanceof=="Floating")&&newbottom.sign=="-"){
newbottom=newbottom.abs();
newtop=new CM.Factor([CM.Integer.minusOne,newtop]).simplify();}
else if(newbottom.cm_instanceof=="Factor"){
var terms0=newbottom.terms[0];
if((terms0.cm_instanceof=="Integer"||terms0.cm_instanceof=="Rational"||terms0.cm_instanceof=="Floating")&&terms0.sign=="-"){
newbottom=new CM.Factor([CM.Integer.minusOne,newbottom]).simplify();
newtop=new CM.Factor([CM.Integer.minusOne,newtop]).simplify();}}
var tempreturn=[newtop,newbottom];
this.rationalizedVersion=tempreturn;
return tempreturn;};
CM.Factor.prototype.rationalizeWithoutCanceling=function(){
var simplifyparameters=arguments[0];
var zero=CM.Integer.zero;
var minusOne=CM.Integer.minusOne;
var one=CM.Integer.one;
var terms=this.terms;
var termslength=terms.length;
var numerator=new Array();
var denominator=new Array();
for(var i=0;i<termslength;i++){
var thistermrationalized=terms[i].rationalizeWithoutCanceling(simplifyparameters);
if(!thistermrationalized[0].equalTo(one)){
numerator.push(thistermrationalized[0].simplify());}
if(!thistermrationalized[1].equalTo(one)){
denominator.push(thistermrationalized[1].simplify());}}
if(numerator.length>1){
numerator=new CM.Factor(numerator).simplify();}
else if(numerator.length==1){
numerator=numerator[0].simplify();}
else{
numerator=one;}
if(denominator.length>1){
denominator=new CM.Factor(denominator).simplify();}
else if(denominator.length==1){
denominator=denominator[0].simplify();}
else{
denominator=one;}
var tempreturn=[numerator,denominator];
return tempreturn;};
CM.Factor.prototype.numeratorAndDenominatorWithoutCancelingOrShifting=function(){
var terms=this.terms;
var termslength=terms.length;
var numerator=new Array();
var denominator=new Array();
for(var i=0;i<termslength;i++){
if(terms[i].cm_instanceof!="Quotient"){
numerator.push(terms[i]);}
else{
numerator.push(terms[i].terms[0]);
denominator.push(terms[i].terms[1]);}}
if(numerator.length==1){
numerator=numerator[0];}
else{
numerator=new CM.Factor(numerator);}
if(denominator.length==0){
return numerator;}
if(denominator.length==1){
denominator=denominator[0];}
else{
denominator=new CM.Factor(denominator);}
return new CM.Quotient([numerator,denominator]);};
CM.Factor.prototype.isComplexFraction=function(){
var tempreturn=this.numeratorAndDenominatorWithoutCancelingOrShifting();
if(tempreturn.isComplexFraction!=null){
return tempreturn.isComplexFraction();}
else{
return tempreturn.containsQuotientsOrNegativeExponents();}};
CM.Factor.prototype.numeratorAndDenominatorUnsimplified=function(){
var args0=arguments[0];
var negativeexponents=new Array();
var terms=this.terms;
var termslength=terms.length;
if(termslength<=1){
alert(["There is a mistake in CM.Factor.prototype.numeratorAndDenominatorUnsimplified. It was invoked on a Factor with zero or one terms.",this]);
throw new Error("There is a mistake in CM.Factor.prototype.numeratorAndDenominatorUnsimplified. It was invoked on a Factor with with zero or one terms.");}
else{
var temparray=new Array();
for(var i=0;i<termslength;i++){
var termsi=terms[i];
if(termsi.cm_instanceof=="Power"&&(termsi.terms[1].cm_instanceof=="Integer"||termsi.terms[1].cm_instanceof=="Rational"||termsi.terms[1].cm_instanceof=="Floating")&&termsi.terms[1].sign=="-"){
negativeexponents.push(new CM.Power([termsi.terms[0],termsi.terms[1].abs()]));}
else{
temparray.push(terms[i]);}}
if(temparray.length==1){
var numerator=temparray[0];}
else{
var numerator=new CM.Factor(temparray);}
if(args0=="numerator"){
return numerator;}
if(negativeexponents.length==0){
if(args0==null){
return numerator;}
else{
return CM.Integer.one;}}
else{
if(negativeexponents.length==1){
var denominator=negativeexponents[0];}
else{
var denominator=new CM.Factor(negativeexponents);}
if(args0==null){
return new CM.Quotient([numerator,denominator]);}
else{
return denominator;}}}};
CM.Factor.prototype.maximizePolynomials=function(){
if(this.maximizePolynomialsDone!=null){
return this.maximizePolynomialsDone;}
var terms=this.terms;
var termslength=terms.length;
var newterms=new Array();
for(var i=0;i<termslength;i++){
newterms[i]=terms[i].maximizePolynomials();}
var newtermslength=newterms.length;
var adjustednewterms=new Array();
for(var i=0;i<newtermslength;i++){
var firstelement=newterms[i];
var secondelement=newterms[i+1];
if(secondelement==null){
adjustednewterms.push(firstelement);}
else{
var cm_instanceof=firstelement.cm_instanceof;
var secondelementcm_instanceof=secondelement.cm_instanceof;
if((cm_instanceof=="Integer"||cm_instanceof=="Rational"||cm_instanceof=="Floating")&&(secondelement.cm_instanceof=="Complex"&&secondelement.equalTo(CM.Complex.i))){
adjustednewterms.push(new CM.Complex([CM.Integer.zero,firstelement]));
i++;}
else if((secondelementcm_instanceof=="Integer"||secondelementcm_instanceof=="Rational"||secondelementcm_instanceof=="Floating")&&(cm_instanceof=="Complex"&&firstelement.equalTo(CM.Complex.i))){
adjustednewterms.push(new CM.Complex([CM.Integer.zero,secondelement]));
i++;}
else{
adjustednewterms.push(firstelement);}}}
newterms=adjustednewterms;
newtermslength=newterms.length;
var finalterms=new Array();
var firstelement=null;
var i=0;
while(i<newtermslength){
if(firstelement==null){
firstelement=newterms[i];}
if(i+1==newtermslength){
finalterms.push(firstelement);
i++;}
else{
var cm_instanceof=firstelement.cm_instanceof;
if(cm_instanceof=="Integer"||cm_instanceof=="Rational"||cm_instanceof=="Floating"||cm_instanceof=="Complex"){
var nextelement=newterms[i+1];
if(nextelement.cm_instanceof=="Polynomial"&&nextelement.terms.length==1&&nextelement.terms[0][0].equalTo(CM.Integer.one)){
firstelement=nextelement.multiply(firstelement);
i++;}
else{
finalterms.push(firstelement);
firstelement=null;
i++;}}
else if(cm_instanceof=="Polynomial"){
var nextelement=newterms[i+1];
var nextelementinstancof=nextelement.cm_instanceof;
if((firstelement.terms.length==1&&firstelement.terms[0][0].equalTo(CM.Integer.one))&&(nextelementinstancof=="Integer"||nextelementinstancof=="Rational"||nextelementinstancof=="Floating"||nextelementinstancof=="Complex")){
firstelement=firstelement.multiply(nextelement);
i++;}
else if(nextelementinstancof=="Polynomial"){
if(nextelement.terms.length==1&&firstelement.terms.length==1&&firstelement.key.cm_intersection(nextelement.key).length==0&&(firstelement.terms[0][0].equalTo(CM.Integer.one)||nextelement.terms[0][0].equalTo(CM.Integer.one))){
firstelement=firstelement.multiply(nextelement);
i++;}
else{
finalterms.push(firstelement);
firstelement=null;
i++;}}
else{
finalterms.push(firstelement);
firstelement=null;
i++;}}
else{
finalterms.push(firstelement);
firstelement=null;
i++;}}}
if(finalterms.length==1){
var tempreturn=finalterms[0];}
else{
var tempreturn=new CM.Factor(finalterms);}
this.maximizePolynomialsDone=tempreturn;
tempreturn.maximizePolynomialsDone=tempreturn;
return tempreturn;};
CM.Factor.prototype.isMultipliedOutPolynomial=function(){
if(this.isMultipliedOutPolynomialDone!=null){
return this.isMultipliedOutPolynomialDone;}
if(this.isPolynomial===false){
this.isMultipliedOutPolynomialDone=false;
return false;}
var terms=this.terms;
var termslength=terms.length;
for(var i=0;i<termslength;i++){
if(terms[i].isMultipliedOutPolynomial()===false){
this.isMultipliedOutPolynomialDone=false;
return false;}
else if(terms[i].cm_instanceof=="Polynomial"&&terms[i].terms.length>1){
this.isMultipliedOutPolynomialDone=false;
return false;}}
this.isMultipliedOutPolynomialDone=true;
return true;};
CM.Factor.prototype.evaluateAsFunction=function(){
var terms=this.terms;
var termslength=terms.length;
var argumentsforfunctionarray=arguments[0];
var newterms=new Array();
for(var i=0;i<termslength;i++){
if(terms[i].isFunction!==true){
newterms.push(terms[i]);}
else{
newterms.push(terms[i].evaluateAsFunction(argumentsforfunctionarray));}}
return new CM.Factor(newterms);};

