
CM.Integer=function(value,sign){
if(value==undefined){
return CM.Integer.zero;}
var incomingType=value.cm_instanceof;
if(incomingType=="Array"){
while((value[value.length-1]==null||value[value.length-1]==0)&&value.length>1){
value.pop();}
this.terms=value;
this.sign=sign||"+";
return;}
else if(incomingType=="Integer"){
if(arguments[1]==null||arguments[1]==arguments[0].sign){
return value;}
else{
return new CM.Integer(value.terms,arguments[1]);};}
else if(incomingType=="NativeString"||incomingType=="Number"){
value=(""+value).replace(/^\s*/,"").replace(/\s*$/,"");
if(isNaN(value))
throw new Error("Integer Constructor could not convert \"" + arguments[0] + "\" to a number.");
if(value.charAt(0)=="-"||value.charAt(0)=="+"){
this.sign=value.charAt(0);
value=value.slice(1);};
value=value.replace(/^0*/,"");
if(value.length==0){
if(CM.Integer.zero!=null)
return CM.Integer.zero;
else{
this.terms=[0];
this.sign="+";
return;};};
var length=value.length;
this.terms=new Array();
var chunk=CM.Integer._chunkSize;
var thisterms=this.terms;
var elements=Math.ceil(length/chunk);
var begin=length-chunk;
var end=length;
for(var i=elements;i>0;i--){
thisterms[elements-i]=value.substring((begin>0?begin:0),(end>0?end:0));
begin=begin-chunk;
end=end -chunk;};
this.sign=sign||this.sign||"+";}
else if(value.simplify!=null){
var tempthis=value.simplify();
if(tempthis.cm_instanceof=="Integer"){
return tempthis;}
else
throw new Error("Integer constructor was not passed an appropriate type. It was passed the arguments: "+arguments[0]+".");}
else
throw new Error("Integer constructor was not passed an appropriate type. It was passed the arguments: "+arguments[0]+".");};
CM.Integer.prototype=new CM.Atomic();
CM.Integer.prototype.constructor=CM.Integer;
CM.Integer.prototype.cm_instanceof="Integer";
CM.Integer.prototype.toString=function(radix){
if(radix!=undefined&&!radix.equalTo(CM.Integer.one)&&!radix.greaterThan(new CM.Integer(10))){
radix=radix.abs();
var temp=new CM.Integer(this).divide(radix);
var outString=temp.remainder.toString();
while(!temp.quotient.equalTo(CM.Integer.zero)){
temp=temp.quotient.divide(radix)
outString=temp.remainder+outString;};
return outString;};
var thisstring=this.string;
if(thisstring!=null){
return thisstring;};
var tempreturn=this._toBaseDigits();
var tempString="";
tempreturn=tempreturn.reverse().join("").replace(/^0*/,"");
if(tempreturn.length==0)
tempreturn="0";
if(this.sign=="-")
var tempreturn="-"+tempreturn;
return this.string=tempreturn;};
CM.Integer.prototype.simplify=function(){
if(arguments[0]==null){
return this;}
else{
return this.mod(arguments[0]);}};
CM.Integer.prototype.round=function(){
return this;};
CM.Integer.prototype.equalTo=function(){
var right=arguments[0];
if(right.cm_instanceof!="Integer"&&right.simplify!=null){
right=right.simplify();}
if(right.cm_instanceof!="Integer"){
return false;}
var thisterms=this.terms;
var rightterms=right.terms;
var rightLength=rightterms.length;
var thisLength=thisterms.length;
if(thisLength!=rightLength)
return false;
if(arguments[1]==null){
if(this.sign!=right.sign){
if(thisLength!=1||rightLength!=1)
return false;
else if(1*thisterms[0]!=0||1*rightterms[0]!=0)
return false;
else
return true;};};
for(var x=0;x<thisLength;x++)
if(1*(thisterms[x])!=1*(rightterms[x]))
return false;
return true;};
CM.Integer.prototype.isZero=function(){
if(this.terms.length!=1){
return false;}
else if(1*this.terms[0]!=0){
return false;}
return true;};
CM.Integer.prototype.notEqualTo=function(){
if(arguments[1]!=null)
return !(this.equalTo(arguments[0],arguments[1]));
else
return !(this.equalTo(arguments[0]));};
CM.Integer.prototype.greaterThan=function(){
var right=arguments[0];
var rightterms=right.terms;
var rightlength=rightterms.length;
var rightSign=right.sign;
var thisterms=this.terms;
var thislength=thisterms.length;
var thisSign=this.sign;
if(this===right)
return false;
if(arguments[1]==null){
if(thisSign<rightSign)
return true;
if(thisSign>rightSign)
return false;
if(thislength>rightlength){
if(thisSign=="+")
return true;
else
return false;};
if(thislength<rightlength){
if(thisSign=="+")
return false;
else
return true;};
for(var x=thislength-1;x>=0;x--){
if(1*thisterms[x]>1*rightterms[x]){
return thisSign=="+";}
else if(1*thisterms[x]==1*rightterms[x]){}
else{
return thisSign!="+";};};
return false;}
else{
for(var x=thislength-1;x>=0;x--){
if(1*thisterms[x]>1*rightterms[x]){
return true;}
else if(1*thisterms[x]==1*rightterms[x]){}
else{
return false;};};
return false;};};
CM.Integer.prototype.lessThan=function(){
var right=arguments[0];
if(right.cm_instanceof!="Integer"){
return !right.lessThan(this);}
var rightterms=right.terms;
var rightlength=rightterms.length;
var rightSign=right.sign;
var thisterms=this.terms;
var thislength=thisterms.length;
var thisSign=this.sign
if(this===right)
return false;
if(arguments[1]==null){
if(thisSign<rightSign)
return false;
if(thisSign>rightSign)
return true;
if(thislength>rightlength){
if(thisSign=="+")
return false;
else
return true;};
if(thislength<rightlength){
if(thisSign=="+")
return true;
else
return false;};
for(var x=thislength-1;x>=0;x--){
if(1*thisterms[x]>1*rightterms[x]){
return thisSign!="+";}
else if(1*thisterms[x]==1*rightterms[x]){}
else{
return thisSign=="+";};};
return false;}
else{
if(thislength<rightlength)
return true;
if(thislength>rightlength)
return false;
for(var x=thislength-1;x>=0;x--){
if(1*thisterms[x]<1*rightterms[x]){
return true;}
else if(1*thisterms[x]==1*rightterms[x]){}
else{
return false;};};
return false;};};
CM.Integer._chunkSize=7;
CM.Integer._base=Math.pow(10,CM.Integer._chunkSize);
CM.Integer._basesquared=Math.pow(10,2*CM.Integer._chunkSize);
CM.Integer._chunkSizeTwoPowerIndex=Math.floor(Math.log(CM.Integer._base)*Math.LOG2E);
CM.Integer._chunkSizeTwoPower=new CM.Integer(Math.pow(2,Math.floor(Math.log(CM.Integer._base)*Math.LOG2E)));
CM.Integer.prototype._twoPowerIndexArray=function(){
var powerindex=2*CM.Integer._chunkSize;
var base=CM.Integer._base;
var terms=this.terms;
var lastterm=terms[0];
if(terms.length==1&&lastterm==0)
return[0,CM.Integer.one,CM.Integer.one];
var currentindex=0;
if(terms.length>1)
var currentlastterm=terms[1]*base+1*lastterm;
else
var currentlastterm=1*lastterm;
var mod2=currentlastterm%2;
while(mod2==0&&currentindex<powerindex){
currentlastterm=currentlastterm/2;
currentindex++;
mod2=currentlastterm%2;};
if(currentindex==powerindex){
var tempreturn=this.divide(CM.Integer._powersOfTwoArray[currentindex]).quotient._twoPowerIndexArray();
return[currentindex+tempreturn[0],tempreturn[1]];}
else
return[currentindex,this.divide(CM.Integer._powersOfTwoArray[currentindex]).quotient];};
CM.Integer.prototype.twoFactorIndex=function(){
return new CM.Integer(""+this._twoPowerIndexArray()[0]);}
CM.Integer.prototype.twoFactor=function(){
return this._evenOddParts()[1];}
CM.Integer.prototype.oddFactor=function(){
return this._evenOddParts()[2];}
CM.Integer.prototype.isEven=function(){
var tempreturn=1*this.terms[0]%2;
if(tempreturn==0){
return true;}
else{
return false;}};
CM.Integer.prototype.isOdd=function(){
var tempreturn=1*this.terms[0]%2;
if(tempreturn==0){
return false;}
else{
return true;}};
CM.Integer.prototype._evenOddParts=function(){
var evenpowerindex=this._twoPowerIndexArray();
var tempindex=evenpowerindex[0];
if(tempindex<=CM.Integer._chunkSizeTwoPowerIndex)
return[tempindex,CM.Integer._powersOfTwoArray[tempindex],evenpowerindex[1]];
else
return[tempindex,CM.Integer.two.power(new CM.Integer(tempindex)),evenpowerindex[1]];}
CM.Integer.one=new CM.Integer("1");
CM.Integer.prototype.denominator=CM.Integer.one;
CM.Integer.two=new CM.Integer("2");
CM.Integer.three=new CM.Integer("3");
CM.Integer.four=new CM.Integer("4");
CM.Integer.five=new CM.Integer("5");
CM.Integer.six=new CM.Integer("6");
CM.Integer.seven=new CM.Integer("7");
CM.Integer.eight=new CM.Integer("8");
CM.Integer.nine=new CM.Integer("9");
CM.Integer.zero=new CM.Integer("0");
CM.Integer.minusOne=new CM.Integer("-1");
CM.Integer.ten=new CM.Integer(10);
CM.Integer.sixteen=new CM.Integer(16);
CM.Integer.twenty=new CM.Integer(20);
CM.Integer.productPrimes256=new CM.Integer("64266330917908644872330635228106713310880186591609208114244758680898150367880703152525200743234420230");
CM.Integer._powersOfTwoArray=(function(){
var temparray=[CM.Integer.one,CM.Integer.two,CM.Integer.four,CM.Integer.eight,CM.Integer.sixteen];
var length=CM.Integer._chunkSizeTwoPowerIndex;
for(var i=5;i<=length;i++)
temparray.push(new CM.Integer(Math.pow(2,i)));
return temparray;})();
CM.Integer.twoToFourteen=new CM.Integer(Math.pow(2,14));
CM.Integer.prototype.toRational=function(){
return new CM.Rational(this,CM.Integer.one,this.sign);};
CM.Integer.prototype.abs=function(){
if(this.sign=="+"){
return this;}
else{
return new CM.Integer(this.terms,"+");};};
CM.Integer.prototype.digits=function(){
return this.toString().replace(/^[\+\-]/,"").split("");};
CM.Integer.prototype.baseArray=(function(){
var baseArray=new Array(CM.Integer._chunkSize);
var baseArraylength=baseArray.length;
var leadingZeros;
for(var i=0;i<baseArraylength;i++){
leadingZeros="";
for(var j=0;j<i;j++)
leadingZeros=leadingZeros.concat("0");
baseArray[j]=leadingZeros;}
return baseArray;})();
CM.Integer.prototype._toBaseDigits=function(){
var retArray=this.terms.slice(0);
var chunkSize_=CM.Integer._chunkSize;
for(var i=0;i<this.terms.length;i++){
var retArrayi=""+retArray[i];
var retArrayilength=retArrayi.length;
if(retArrayilength>chunkSize_||retArrayilength<0)
throw new Error("Cannot convert "+this +" to "+chunkSize_+" digits.");
retArray[i]=(this.baseArray[chunkSize_-retArrayilength]+retArrayi);};
return retArray;};
CM.Integer.random=function(){
if(arguments[0].cm_instanceof=="Integer"&&arguments[1].cm_instanceof=="Integer"){
var terms=new Array();
if(arguments[0].sign!=arguments[1].sign){
if(Math.floor((Math.random()*10))%2==0){
var sign="+"
if(arguments[0].greaterThan(arguments[1]))
var bound=arguments[0].terms;
else
var bound=arguments[1].terms;}
else{
var sign="-";
if(arguments[0].greaterThan(arguments[1]))
var bound=arguments[1].terms;
else
var bound=arguments[0].terms;}
var bLength=bound.length;
var length=Math.floor(Math.random()*bLength);
terms[length]=Math.floor(Math.random()*bound[bLength-1]);
for(var x=0;x<length;x++)
terms[x]=Math.floor(Math.random()*bound[x]);}
else{
var upper;
var lower;
var base=CM.Integer._base;
var sign=arguments[0].sign;
var length;
var lLength;
var uLength;
var uTemp;
var lTemp;
if(arguments[0].abs().greaterThan(arguments[1].abs())){
upper=arguments[0].terms;
lower=arguments[1].terms;}
else{
upper=arguments[1].terms;
lower=arguments[0].terms;}
uLength=upper.length-1;
lLength=lower.length-1;
length=Math.floor(Math.random()*(uLength-lLength)+lLength);
terms[length]=Math.floor(Math.random()*(1*upper[uLength]-1*lower[lLength])+1*lower[lLength]);
for(var x=0;x<length;x++){
uTemp=base+1*upper[x];
lTemp=1*lower[x];
terms[x]=Math.floor(Math.random()*(uTemp-lTemp)+lTemp);}}
return new CM.Integer(terms,sign);}
else{
var lower=parseInt(arguments[0]);
var upper=parseInt(arguments[1]);
var chunkSize_=CM.Integer._chunkSize;
if(isNaN(lower))
lower=1;
if(isNaN(upper))
upper=chunkSize_*chunkSize_;
if(lower>upper){
var temp=lower;
lower=upper;
upper=temp;}
var digits=Math.floor(Math.random()*(upper-lower))+lower;
var chunks=Math.ceil(digits/chunkSize_);
var terms=new Array(chunks);
var base=CM.Integer._base;
if(digits%chunkSize_!=0){
terms[chunks-1]=Math.floor(Math.random()*Math.pow(10,(digits%chunkSize_)+1));
chunks--;}
for(var x=0;x<chunks;x++)
terms[x]=Math.floor(Math.random()*base);
var digits=Math.floor(Math.random()*(upper-lower))+lower;
var terms="";
for(var x=0;x<digits;x++)
terms=terms+Math.floor(Math.random()*10);
if(Math.floor(Math.random()*2)==0)
return new CM.Integer(terms,"+");
else
return new CM.Integer(terms,"-");}};
CM.Integer.nonZeroRandom=function(){
temp=CM.Integer.random(arguments[0],arguments[1]);
while(temp.equalTo(CM.Integer.zero))
temp=CM.Integer.random(arguments[0],arguments[1]);
return temp;};
CM.Integer._base2conversionarray=[1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192];
CM.Integer.BaseTwoToTen=function(){
var tempthis=arguments[0];
var returnnumber=0;
var conversionarray=CM.Integer._base2conversionarray;
var coefficients=tempthis.split("").reverse().slice(0,14);
var coefficientslength=coefficients.length;
for(var i=0;i<coefficientslength;i++){
returnnumber=returnnumber+coefficients[i]*conversionarray[i];};
return returnnumber;};
CM.Integer.prototype.toBaseTwo=function(){
var twoToFourteen=CM.Integer.twoToFourteen;
var BaseTwoToTen=CM.Integer.BaseTwoToTen;
var baseTwoExpansionArray=new Array();
var tempnumber=this;
var integerBase=CM.Integer._base;
var integerBaseSquared=CM.Integer._basesquared;
if(tempnumber.terms.length==1)
return(1*tempnumber.terms[0]).toString(2);
if(tempnumber.terms.length==2)
return(1*tempnumber.toString()).toString(2);
while(tempnumber.terms.length>1){
var expansionterm=(1*tempnumber.terms[0]+integerBase*tempnumber.terms[1]).toString(2).split("").reverse().slice(0,14).reverse().join("");
var expansionnumber=new CM.Integer(BaseTwoToTen(expansionterm));
tempnumber=tempnumber.subtract(expansionnumber).divide(twoToFourteen).quotient;
baseTwoExpansionArray.push(expansionterm);};
baseTwoExpansionArray.push(tempnumber.terms[0].toString(2));
return baseTwoExpansionArray.reverse().join("");};
CM.Integer.prototype.multiply=function(){
if(this.equalTo(CM.Integer.zero)||arguments[0].equalTo(CM.Integer.zero))
return new CM.Integer(0);
var retArray=new Array();
var integerBase=CM.Integer._base;
var argSign=arguments[0].sign;
if(this.terms.length<=arguments[0].terms.length){
var first=this.terms;
var second=arguments[0].terms;}
else{
var second=this.terms;
var first=arguments[0].terms;};
var firstLength=first.length;
var secondLength=second.length;
var combinedlength=firstLength+secondLength;
var nextterm=0;
if(firstLength==1){
first=first[0];
for(var i=0;i<secondLength;i++){
var tempterm=nextterm+first*second[i];
if(tempterm>=integerBase){
retArray[i]=tempterm%integerBase;
nextterm=Math.floor(tempterm/integerBase);}
else{
retArray[i]=tempterm;
nextterm=0;};};
if(nextterm>0)
retArray[secondLength]=nextterm;
if(this.sign==argSign)
return new CM.Integer(retArray,"+");
else
return new CM.Integer(retArray,"-");}
else{
var lengthminusone=combinedlength-1;
for(var i=0;i<lengthminusone;i++){
var thisterm=nextterm%integerBase;
var nextterm=Math.floor(nextterm/integerBase);
var stopAt=Math.min(firstLength,i+1);
var beginAt=Math.max(0,i-secondLength+1);
for(var j=beginAt;j<stopAt;j++){
tempterm=thisterm+first[j]*second[i-j];
if(tempterm>=integerBase){
thisterm=tempterm%integerBase;
nextterm=nextterm+Math.floor(tempterm/integerBase);}
else
thisterm=tempterm;};
retArray[i]=thisterm;};
if(nextterm>0){
if(nextterm>=integerBase){
retArray[retArray.length]=nextterm%integerBase;
retArray[retArray.length]=Math.floor(nextterm/integerBase);}
else
retArray[retArray.length]=nextterm;};
if(this.sign==argSign)
return new CM.Integer(retArray,"+");
else
return new CM.Integer(retArray,"-");}};
CM.Integer.Multiply=function(){
var inputarray=arguments[0];
var inputarraylength=inputarray.length;
if(inputarraylength==0)
return CM.Integer.one;
var tempproduct=inputarray[0];
for(var i=1;i<inputarraylength;i++){
tempproduct=tempproduct.multiply(inputarray[i]);};
return tempproduct;};
CM.Integer.prototype.times=CM.Integer.prototype.multiply;
CM.Integer.prototype.square=function(){
if(this.equalTo(CM.Integer.zero))
return new CM.Integer(0);
var retArray=new Array();
var integerBase=CM.Integer._base;
var first=this.terms;
var firstLength=first.length;
var combinedlength=2*firstLength;
var nextterm=0;
for(var i=0;i<combinedlength;i++){
var thisterm=nextterm;
nextterm=0;
var beginAt=Math.max(0,i-firstLength+1);
var stopAt=Math.min(firstLength,i+1)-beginAt;
if(stopAt%2==0)
stopAt=beginAt+stopAt/2;
else{
stopAt=beginAt+(stopAt-1)/2;
var tempterm=first[stopAt]*first[stopAt];
if(tempterm>=integerBase){
thisterm=thisterm+(tempterm%integerBase);
nextterm=nextterm+Math.floor(tempterm/integerBase);}
else
thisterm=thisterm+tempterm;};
for(var j=beginAt;j<stopAt;j++){
tempterm=first[j]*first[i-j];
if(tempterm>=integerBase){
thisterm=thisterm+2*(tempterm%integerBase);
nextterm=nextterm+2*Math.floor(tempterm/integerBase);}
else
thisterm=thisterm+2*tempterm;};
if(thisterm>=integerBase){
retArray[i]=thisterm%integerBase;
nextterm=nextterm+Math.floor(thisterm/integerBase);}
else
retArray[i]=thisterm;};
if(nextterm>0)
retArray[retArray.length]=nextterm;
return new CM.Integer(retArray,"+");};
CM.Integer.prototype.power=function(){
var zero=CM.Integer.zero;
var one=CM.Integer.one;
var exponent=arguments[0].simplify();
if(exponent.cm_instanceof!="Integer")
return new CM.Power(this,exponent);
if(exponent.equalTo(zero))
return one;
if(exponent.equalTo(one))
return new CM.Integer(this);
if(this.equalTo(one)||this.equalTo(zero))
return new CM.Integer(this);
if(exponent.sign=="-")
return new CM.Rational(one,this.power(exponent.abs()));
var retInt=this;
var binaryString=exponent.toBaseTwo();
var bLength=binaryString.length;
for(var i=1;i<bLength;i++)
if(binaryString.charAt(i)=="1"){
retInt=retInt.square();
retInt=retInt.multiply(this);}
else
retInt=retInt.square();
return retInt;}
CM.Integer.prototype.to=CM.Integer.prototype.power;
CM.Integer.prototype.add=function(){
var rightOperand=arguments[0];
var baseInteger=1*CM.Integer._base;
if(this.sign!=rightOperand.sign){
if(this.sign=="+"){
var tempPositive=new CM.Integer(rightOperand,"+");
tempPositive=this.subtract(tempPositive);}
else{
var tempPositive=new CM.Integer(this,"+");
tempPositive=rightOperand.subtract(tempPositive);};
return tempPositive;};
if(this.terms.length>=rightOperand.terms.length){
var first=this;
var second=rightOperand;
var maxlength=first.terms.length;
var minlength=second.terms.length;}
else{
var first=rightOperand;
var second=this;
var maxlength=first.terms.length;
var minlength=second.terms.length;};
var tempreturn=new Array();
var nextterm=0;
var firstterms=first.terms;
var secondterms=second.terms;
for(var i=0;i<minlength;i++){
var tempi=1*nextterm+1*firstterms[i]+1*secondterms[i];
if(tempi<baseInteger){
tempreturn[i]=tempi;
nextterm=0;}
else{
tempreturn[i]=tempi%baseInteger;
nextterm=1;};};
for(var i=minlength;i<maxlength;i++){
var tempi=1*nextterm+1*firstterms[i];
if(tempi<baseInteger){
tempreturn[i]=tempi;
nextterm=0;}
else{
tempreturn[i]=tempi%baseInteger;
nextterm=1;};};
if(nextterm==1){
tempreturn[tempreturn.length]=1;};
tempreturn=new CM.Integer(tempreturn,first.sign);
return tempreturn;};
CM.Integer.prototype.plus=CM.Integer.prototype.add;
CM.Integer.Add=function(){
var addarray=arguments[0];
if(addarray.length==0)
return CM.Integer.zero;
if(addarray.length==1)
return addarray[0];
var addarraylength=addarray.length;
var maxtermspos=1;
var maxtermsneg=1;
var Mathmax=Math.max;
var integerBase=CM.Integer._base;
var PositiveArray=new Array();
var NegativeArray=new Array();
for(var i=0;i<addarraylength;i++){
var addarrayi=addarray[i];
if(addarrayi.sign=="+"){
PositiveArray.push(addarrayi);
maxtermspos=Mathmax(addarrayi.terms.length,maxtermspos);}
else{
NegativeArray.push(addarrayi);
maxtermsneg=Mathmax(addarrayi.terms.length,maxtermsneg);};};
var PositiveArraylength=PositiveArray.length;
var NegativeArraylength=NegativeArray.length;
var returnarraypos=new Array();
var returnarrayneg=new Array();
if(PositiveArraylength==1){
var returnpos=PositiveArray[0];}
else if(PositiveArraylength>0){
var tempentry=0;
for(var i=0;i<maxtermspos;i++){
for(var j=0;j<PositiveArraylength;j++){
var PositiveArrayji=PositiveArray[j].terms[i];
if(PositiveArrayji!=null){
tempentry=1*tempentry+1*PositiveArrayji;};};
returnarraypos[i]=(tempentry)%integerBase;
tempentry=Math.floor(tempentry/integerBase);};
if(tempentry!=0){
returnarraypos[maxtermspos]=tempentry;};
var returnpos=new CM.Integer(returnarraypos);};
if(NegativeArraylength==1){
returnneg=NegativeArray[0];}
else if(NegativeArraylength>0){
var tempentry=0;
for(var i=0;i<maxtermsneg;i++){
for(var j=0;j<NegativeArraylength;j++){
var NegativeArrayji=NegativeArray[j].terms[i];
if(NegativeArrayji!=null){
tempentry=1*tempentry+1*NegativeArrayji;};};
returnarrayneg[i]=(tempentry)%integerBase;
tempentry=Math.floor(tempentry/integerBase);};
if(tempentry!=0){
returnarrayneg[maxtermsneg]=tempentry;};
var returnneg=new CM.Integer(returnarrayneg,"-");};
if(PositiveArraylength>0&&NegativeArraylength>0){
return returnpos.subtract(returnneg.abs());}
else if(PositiveArraylength>0)
return returnpos;
else
return returnneg;};
CM.Integer.prototype.subtract=function(){
var rightOperand=arguments[0];
var baseInteger=1*CM.Integer._base;
if(this.sign!=rightOperand.sign){
if(this.sign=="+"){
var tempPositive=new CM.Integer(rightOperand,"+");
tempPositive=this.add(tempPositive);}
else{
var tempPositive=new CM.Integer(rightOperand,"-");
tempPositive=this.add(tempPositive);}
return tempPositive;}
if(rightOperand.lessThan(this,"abs")){
var first=this;
var second=rightOperand;}
else{
var first=rightOperand;
var second=this;};
var firstterms=first.terms;
var secondterms=second.terms;
var firstlength=firstterms.length;
var secondlength=secondterms.length;
var nextterm=0;
var tempreturn=new Array();
for(var i=0;i<secondlength;i++){
var thisterm=firstterms[i]-secondterms[i]-nextterm;
if(thisterm>=0){
tempreturn[i]=thisterm;
nextterm=0;}
else{
tempreturn[i]=thisterm+baseInteger;
nextterm=1;};};
for(var i=secondlength;i<firstlength;i++){
var thisterm=firstterms[i]-nextterm;
if(thisterm>=0){
tempreturn[i]=thisterm;
nextterm=0;}
else{
tempreturn[i]=thisterm+baseInteger;
nextterm=1;};};
if(first==this){
var tempreturn=new CM.Integer(tempreturn,first.sign);
if(tempreturn.equalTo(CM.Integer.zero))
tempreturn.sign="+";
return tempreturn;}
else{
var tempreturn=new CM.Integer(tempreturn,second.sign=="+"?"-":"+");
if(tempreturn.equalTo(CM.Integer.zero))
tempreturn.sign="+";
return tempreturn;};}
CM.Integer.prototype.minus=CM.Integer.prototype.subtract;
CM.Integer.prototype.divide2=function(){
if(arguments[0].equalTo(CM.Integer.zero)){
throw new Error("Cannot divide by zero");}
var tempReturn=new Object();
if(this.equalTo(CM.Integer.zero)){
tempReturn.quotient=CM.Integer.zero;
tempReturn.remainder=CM.Integer.zero;
return tempReturn;}
var n=arguments[0].terms.length;
var m=this.terms.length-n;
var b=CM.Integer._base;
if(n==1){
var r=0;
var j=this.terms.length-1;
tempReturn.quotient=new CM.Integer(0);
do{
var temp=r*b+this.terms[j];
var vtemp=arguments[0].terms[0];
tempReturn.quotient.terms[j]=Math.floor(temp/vtemp);
r=temp%vtemp;
j=j-1;}while(j>=0);
if(this.sign=="+"){
if(arguments[0].sign=="+"){
tempReturn.quotient=new CM.Integer(tempReturn.quotient.terms.reverse().join(""));
tempReturn.remainder=this.subtract(tempReturn.quotient.multiply(arguments[0]));
tempReturn.floor=new CM.Integer(tempReturn.quotient);
if(tempReturn.remainder.notEqualTo(CM.Integer.zero)){
tempReturn.ceiling=tempReturn.floor.add(CM.Integer.one);}
else{
tempReturn.ceiling=new CM.Integer(tempReturn.floor);}
tempReturn.mod=new CM.Integer(tempReturn.remainder);}
else{
tempReturn.quotient=new CM.Integer(tempReturn.quotient.terms.reverse().join(""),"-");
tempReturn.remainder=this.subtract(tempReturn.quotient.multiply(arguments[0]));
if(tempReturn.remainder.notEqualTo(CM.Integer.zero)){
tempReturn.floor=tempReturn.quotient.subtract(CM.Integer.one);}
else{
tempReturn.floor=new CM.Integer(tempReturn.quotient);}
tempReturn.ceiling=new CM.Integer(tempReturn.quotient);
tempReturn.mod=NaN;}}
else{
if(arguments[0].sign=="+"){
tempReturn.quotient=new CM.Integer(tempReturn.quotient.terms.reverse().join(""),"-");
tempReturn.remainder=this.subtract(tempReturn.quotient.multiply(arguments[0]));
if(tempReturn.remainder.notEqualTo(CM.Integer.zero)){
tempReturn.floor=tempReturn.quotient.subtract(CM.Integer.one);}
else{
tempReturn.floor=new CM.Integer(tempReturn.quotient);}
tempReturn.ceiling=new CM.Integer(tempReturn.quotient);
tempReturn.mod=this.subtract(tempReturn.floor.multiply(arguments[0]));}
else{
tempReturn.quotient=new CM.Integer(tempReturn.quotient.terms.reverse().join(""));
tempReturn.remainder=this.subtract(tempReturn.quotient.multiply(arguments[0]));
tempReturn.floor=new CM.Integer(tempReturn.quotient);
if(tempReturn.remainder.notEqualTo(CM.Integer.zero)){
tempReturn.ceiling=tempReturn.floor.add(CM.Integer.one);}
else{
tempReturn.ceiling=new CM.Integer(tempReturn.floor);}
tempReturn.mod=NaN;}}
return tempReturn;}
var vn=arguments[0].terms[n-1];
var d=new CM.Integer(Math.floor(b/(1*vn+1)));
var unnormalizedLength=this.terms.length;
var posU=new CM.Integer(this,"+");
var posV=new CM.Integer(arguments[0],"+");
var u=posU.multiply(d);
var v=posV.multiply(d);
var normalizedLength=u.terms.length;
if(unnormalizedLength==normalizedLength){
u.terms[normalizedLength]=0;}
var tempArray=new Array;
for(var j=m;j>=0;j--){
var uTerm=(b*u.terms[j+n])+(1*u.terms[j+n-1]);
var vTerm=v.terms[n-1];
var q=Math.floor(uTerm/vTerm);
var r=uTerm%vTerm;
if(q==b||q*v.terms[n-2]>(b*r)+u.terms[j+n-2]){
q=q-1;
r=r+vTerm;
if(r<b){
if(q==b||q*v.terms[n-2]>(b*r)+u.terms[j+n-2]){
q=q-1;
r=r+vTerm;}}}
uTerm=u.terms.slice(j,j+n+1);
var intQbar=new CM.Integer(q);
uTerm=new CM.Integer(uTerm);
uTerm=uTerm.subtract(intQbar.multiply(v));
if(uTerm.sign=="-"){
tempArray[j]=q-1;
uTerm=uTerm.add(v);}
else{
tempArray[j]=q;}
while(uTerm.terms.length<n+1){
uTerm.terms.push(0);}
for(var i=n;i>=0;i--){
u.terms[j+i]=uTerm.terms[i];}}
if(this.sign=="+"){
if(arguments[0].sign=="+"){
tempReturn.quotient=new CM.Integer(tempArray);
tempReturn.remainder=this.subtract(tempReturn.quotient.multiply(arguments[0]));
tempReturn.floor=new CM.Integer(tempReturn.quotient);
if(tempReturn.remainder.notEqualTo(CM.Integer.zero)){
tempReturn.ceiling=tempReturn.floor.add(CM.Integer.one);}
else{
tempReturn.ceiling=new CM.Integer(tempReturn.floor);}
tempReturn.mod=new CM.Integer(tempReturn.remainder);}
else{
tempReturn.quotient=new CM.Integer(tempArray,"-");
tempReturn.remainder=this.subtract(tempReturn.quotient.multiply(arguments[0]));
if(tempReturn.remainder.notEqualTo(CM.Integer.zero)){
tempReturn.floor=tempReturn.quotient.subtract(CM.Integer.one);}
else{
tempReturn.floor=new CM.Integer(tempReturn.quotient);}
tempReturn.ceiling=new CM.Integer(tempReturn.quotient);
tempReturn.mod=NaN;}}
else{
if(arguments[0].sign=="+"){
tempReturn.quotient=new CM.Integer(tempArray,"-");
tempReturn.remainder=this.subtract(tempReturn.quotient.multiply(arguments[0]));
if(tempReturn.remainder.notEqualTo(CM.Integer.zero)){
tempReturn.floor=tempReturn.quotient.subtract(CM.Integer.one);}
else{
tempReturn.floor=new CM.Integer(tempReturn.quotient);}
tempReturn.ceiling=new CM.Integer(tempReturn.quotient);
tempReturn.mod=this.subtract(tempReturn.floor.multiply(arguments[0]));}
else{
tempReturn.quotient=new CM.Integer(tempArray);
tempReturn.remainder=this.subtract(tempReturn.quotient.multiply(arguments[0]));
tempReturn.floor=new CM.Integer(tempReturn.quotient);
if(tempReturn.remainder.notEqualTo(CM.Integer.zero)){
tempReturn.ceiling=tempReturn.floor.add(CM.Integer.one);}
else{
tempReturn.ceiling=new CM.Integer(tempReturn.floor);}
tempReturn.mod=NaN;}}
return tempReturn;}
CM.Integer.prototype.divide=function(){
var originaldivisor=new CM.Integer(arguments[0]);
if(originaldivisor.sign=="-"){
return this.divideWithNegativeDivisor(originaldivisor);}
var zero=CM.Integer.zero;
var one=CM.Integer.one;
var minusOne=CM.Integer.minusOne;
var left=this;
var lSign=this.sign;
var qSign=(lSign=="+"?"+":"-");
var retObj=new Object();
if(originaldivisor.equalTo(zero)){
var errorstring="You are attempting to divide by zero. This is causing an error."
alert(errorstring);
throw new Error(errorstring);}
if(left.equalTo(zero)){
retObj.quotient=zero;
retObj.remainder=zero;
retObj.floor=zero;
retObj.ceiling=zero;
retObj.mod=zero;
retObj.modQuotient=zero;
return retObj;};
if(originaldivisor.equalTo(one)){
retObj.quotient=new CM.Integer(left,qSign);
retObj.remainder=zero;
retObj.mod=zero;
retObj.modQuotient=retObj.quotient;
retObj.floor=new CM.Integer(left);
retObj.ceiling=new CM.Integer(left);
return retObj;};
if(left.abs().lessThan(originaldivisor)){
retObj.quotient=zero;
retObj.remainder=new CM.Integer(left);
if(lSign=="+"){
retObj.mod=new CM.Integer(left);
retObj.modQuotient=zero;
retObj.floor=zero;
retObj.ceiling=one;}
else{
var mod=new CM.Integer(left).add(originaldivisor);
retObj.mod=mod;
retObj.modQuotient=minusOne;
retObj.floor=minusOne;
retObj.ceiling=zero;}
return retObj;};
var u=left.terms.slice(0);
var v=originaldivisor.terms.slice(0);
var n=v.length;
var uLength=u.length;
var m=uLength-n;
var b=CM.Integer._base;
var Q=new Array();
if(n==1){
var divisor=1*v[0];
var dividend=1*u[uLength-1];
for(var i=uLength-1;i>=0;i--){
if(dividend>=divisor){
Q[i]=Math.floor(dividend/divisor);
dividend=dividend%divisor;
u[i]=dividend;
u[i+1]=0;}
else{
Q[i]=0;}
dividend=dividend*b+1*u[i-1];}
retObj.quotient=new CM.Integer(Q,qSign);
retObj.remainder=new CM.Integer(u[0]%divisor,lSign);
if(retObj.remainder.equalTo(zero)){
retObj.ceiling=new CM.Integer(retObj.quotient);
retObj.floor=new CM.Integer(retObj.quotient);
retObj.mod=zero;
retObj.modQuotient=retObj.quotient;}
else{
if(lSign=="-"){
retObj.ceiling=new CM.Integer(retObj.quotient);
retObj.floor=retObj.quotient.subtract(one);
retObj.mod=originaldivisor.add(retObj.remainder);
retObj.modQuotient=retObj.quotient.add(minusOne);}
else{
retObj.floor=new CM.Integer(retObj.quotient);
retObj.ceiling=retObj.quotient.add(one);
retObj.mod=retObj.remainder;
retObj.modQuotient=retObj.quotient;}}
return retObj;}
left=left.abs();
var right=originaldivisor;
var d=new CM.Integer(Math.floor(b/(1*v[n-1]+1)));
if(d.terms[0]==1)
u[m+n]=0;
else{
right=right.multiply(d);
v=right.terms;
left=left.multiply(d);
u=left.terms;
if(uLength==u.length)
u[m+n]=0;}
var q=0;
var r=0;
var j=m;
for(j;j>=0;j--){
q=Math.floor((1*u[j+n]*b+1*u[j+n-1])/(1*v[n-1]));
r=(1*u[j+n]*b+1*u[j+n-1])%(1*v[n-1]);
if(q==b||((q*1*v[n-2])>(b*r+1*u[j+n-2]))){
q=q-1;
r=r+1*v[n-1];
if(r<b){
if(q==b||q*1*v[n-2]>b*r+1*u[j+n-2]){
q=q-1;
r=r+1*v[n-1];}}}
var tempU=new CM.Integer(u.slice(j,j+n+1));
tempU=tempU.subtract(right.multiply(new CM.Integer(q,"+")));
if(tempU.sign=='-'){
tempU=tempU.add(right);
q--;}
tempU=tempU.terms;
for(var i=n;i>=0;i--)
if(tempU[i]!=undefined)
u[j+i]=tempU[i];
else
u[j+i]=0;
Q[j]=q;}
retObj.quotient=new CM.Integer(Q,qSign);
if(d.terms[0]==1){
retObj.remainder=new CM.Integer(tempU,lSign);}
else{
u=tempU.slice(0);
v=d.terms.slice(0);
uLength=u.length;
Q=new Array();
var divisor=1*v[0];
var dividend=1*u[uLength-1];
for(var i=uLength-1;i>=0;i--){
if(dividend>=divisor){
Q[i]=Math.floor(dividend/divisor);
dividend=dividend%divisor;}
else{
Q[i]=0;}
dividend=dividend*b+1*u[i-1];}
retObj.remainder=new CM.Integer(Q,lSign);}
if(retObj.remainder.equalTo(zero)){
retObj.ceiling=new CM.Integer(retObj.quotient);
retObj.floor=new CM.Integer(retObj.quotient);
retObj.mod=zero;
retObj.modQuotient=retObj.quotient;}
else{
if(lSign=="-"){
retObj.ceiling=new CM.Integer(retObj.quotient);
retObj.floor=retObj.quotient.subtract(one);
retObj.mod=originaldivisor.add(retObj.remainder);
retObj.modQuotient=retObj.quotient.add(minusOne);}
else{
retObj.floor=new CM.Integer(retObj.quotient);
retObj.ceiling=retObj.quotient.add(one);
retObj.mod=retObj.remainder;
retObj.modQuotient=retObj.quotient;}}
return retObj;};
CM.Integer.prototype.divideWithNegativeDivisor=function(){
var minusOne=CM.Integer.minusOne;
var right=arguments[0];
var rightpositive=right.abs();
var retObj=this.divide(rightpositive);
retObj.quotient=retObj.quotient.multiply(minusOne);
var floor=retObj.floor;
var ceiling=retObj.ceiling;
retObj.floor=ceiling.multiply(minusOne);
retObj.ceiling=floor.multiply(minusOne);
retObj.modQuotient=retObj.modQuotient.multiply(minusOne);
return retObj;};
CM.Integer.prototype.reciprocal=function(){
return new CM.Rational(CM.Integer.one,this).simplify();};
CM.Integer.prototype.dividedBy=CM.Integer.prototype.divide;
CM.Integer.prototype.quotient=function(){
return this.divide(arguments[0]).quotient;};
CM.Integer.prototype.remainder=function(){
return this.divide(arguments[0]).remainder;};
CM.Integer.prototype.floor=function(){
return this;};
CM.Integer.prototype.ceiling=function(){
return this;};
CM.Integer.prototype.mod=function(){
if(arguments[0]!=null)
return this.divide(arguments[0]).mod;
else
return this;};
CM.Integer.prototype.modSymmetric=function(){
var Integer=CM.Integer;
var two=Integer.two;
var minusOne=Integer.minusOne;
var divisor=arguments[0];
if(divisor!=null){
var tempreturn=this.divide(divisor).mod;
if(tempreturn.multiply(two).greaterThan(divisor.add(minusOne))){
return tempreturn.minus(divisor);}
else{
return tempreturn;}}
else{
return this;}};
CM.Integer.prototype.addM=function(right,modulus){
var left=this.mod(modulus);
var right=right.mod(modulus);
return left.plus(right).mod(modulus);};
CM.Integer.prototype.subtractM=function(right,modulus){
var left=this.mod(modulus);
var right=right.mod(modulus);
return left.minus(right).mod(modulus);};
CM.Integer.prototype.multiplyM=function(right,modulus){
var left=this.mod(modulus);
var right=right.mod(modulus);
return left.times(right).mod(modulus);};
CM.Integer.prototype.inverseM=function(){
var zero=CM.Integer.zero;
var modulus=arguments[0].abs();
if(modulus.equalTo(CM.Integer.one)){
return zero;}
var tempreturnobject=CM.Integer.extended_gcdPositiveIntegers(this.mod(modulus),modulus);
if(!tempreturnobject.gcd.equalTo(CM.Integer.one)){
var errorstring="You are trying to find the multiplicative inverse of "+this+" mod "+modulus+". However "+this+" does not have a multiplicative inverse mod "+modulus+".";
alert(errorstring);
throw new Error(errorstring);}
var tempreturn=tempreturnobject.x;
return tempreturnobject.x.mod(modulus);};
CM.Integer.prototype.powerM=function(){
var zero=CM.Integer.zero;
var one=CM.Integer.one;
var mod=arguments[1].abs();
if(mod.equalTo(one)){
return zero;}
var base=this;
base=base.divide(mod).mod;
var exponent=arguments[0];
if(exponent.equalTo(zero))
return one;
if(exponent.equalTo(one)){
return this.mod(mod);}
if(this.equalTo(one)){
return one;}
if(this.equalTo(zero)){
return zero;}
if(exponent.sign=="-"){
return this.powerM(exponent.abs(),mod).inverseM(mod);}
var retInt=new CM.Integer(this);
var binaryString=exponent.toBaseTwo();
var bLength=binaryString.length;
for(var i=1;i<bLength;i++){
if(binaryString.charAt(i)=="1"){
retInt=retInt.square();
retInt=retInt.multiply(base);}
else
retInt=retInt.square();
retInt=retInt.divide(mod).mod;}
return retInt;}
CM.Integer.ChineseRemainder=function(){
if(arguments[2]==null){
var args0=arguments[0];
var args0length=args0.length;
var args1=arguments[1];
var product=CM.Integer.Multiply(args0);
var additionarray=new Array();
for(var i=0;i<args0length;i++){
var args0i=args0[i];
var smallproduct=product.divide(args0i).quotient;
var inverse=smallproduct .inverseM(args0i);
additionarray.push(args1[i].multiply(inverse).mod(args0i).multiply(smallproduct));}
return CM.Integer.Add(additionarray).mod(product);}
else{
var originalnumber=arguments[0];
var originalproduct=arguments[1];
var newproduct=originalproduct.multiply(arguments[2][0]);
var newcoefficient=arguments[2][1].subtract(originalnumber);
var newnumber=originalproduct.inverseM(arguments[2][0]).multiply(originalproduct).multiply(newcoefficient).add(originalnumber).mod(newproduct);
return[newnumber,newproduct];}};
CM.Integer.ChineseRemainderArrayVersion=function(){
var zero=CM.Integer.zero;
var minusOne=CM.Integer.minusOne;
var two=CM.Integer.two;
var newoutputarray=arguments[0];
var newoutputarraylength=newoutputarray.length;
var newprime=new CM.Integer(arguments[1]);
if(arguments[2]==null){
var currentarray=new Array();
for(var i=0;i<newoutputarraylength;i++){
currentarray[i]=zero;}
currentproduct=CM.Integer.one;}
else{
var currentarray=arguments[2][0];
var currentproduct=arguments[2][1];}
var newproduct=currentproduct.multiply(newprime);
var halfnewproduct=newproduct.add(minusOne).divide(two).quotient;
var minushalfnewproduct=halfnewproduct.multiply(minusOne);
var returnarray=new Array();
for(var i=0;i<newoutputarraylength;i++){
var newcoefficient=new CM.Integer(newoutputarray[i]).subtract(currentarray[i]);
var returnarrayi=currentproduct.inverseM(newprime).multiply(currentproduct).multiply(newcoefficient).add(currentarray[i]).mod(newproduct);
returnarray[i]=returnarrayi.modSymmetric(newproduct);}
alert(["Chinese ",newproduct,newoutputarray.cm_toString(),returnarray.cm_toString()]);
return[returnarray,newproduct];};
CM.Integer.ChineseRemainderArrayVersion=function(){
var zero=CM.Integer.zero;
var minusOne=CM.Integer.minusOne;
var two=CM.Integer.two;
var newoutputarray=arguments[0];
var newoutputarraylength=newoutputarray.length;
var newprime=new CM.Integer(arguments[1]);
if(arguments[2]==null){
var currentarray=new Array();
for(var i=0;i<newoutputarraylength;i++){
currentarray[i]=zero;}
currentproduct=CM.Integer.one;}
else{
var currentarray=arguments[2][0];
var currentproduct=arguments[2][1];}
var newproduct=currentproduct.multiply(newprime);
var returnarray=new Array();
for(var i=0;i<newoutputarraylength;i++){
var newcoefficient=new CM.Integer(newoutputarray[i]).subtract(currentarray[i]);
returnarray[i]=currentproduct.inverseM(newprime).multiply(currentproduct).multiply(newcoefficient).add(currentarray[i]).modSymmetric(newproduct);}
return[returnarray,newproduct];};
CM.Integer.AddM=function(){
var additionarray=arguments[0];
var additionarraylength=additionarray.length;
var n=arguments[1];
var reducedarray=new Array();
for(var i=0;i<additionarraylength;i++){
reducedarray.push(additionarray[i].mod(n));}
return CM.Integer.Add(reducedarray).mod(n);}
CM.Integer.MultiplyM=function(){
var multiplicationarray=arguments[0];
var multiplicationarraylength=multiplicationarray.length;
var n=arguments[1];
var tempreturn=multiplicationarray[0];
for(var i=1;i<multiplicationarraylength;i++){
tempreturn=tempreturn.multiplyM(multiplicationarray[i],n);}
return tempreturn;}
CM.Integer.extended_gcdPositiveIntegers=function(){
var Integerone=CM.Integer.one;
var Integerzero=CM.Integer.zero;
var a=arguments[0].abs();
var b=arguments[1].abs();
var x=arguments[2];
var y=arguments[3];
var lastx=arguments[4];
var lasty=arguments[5];
if(x==null){
var x=Integerzero;
var lastx=Integerone;};
if(y==null){
var y=Integerone;
var lasty=Integerzero;};
while(b!=undefined&&b.notEqualTo(Integerzero)){
var temp=b;
var dividesObj=a.divide(b);
var quotient=dividesObj.quotient;
b=dividesObj.mod;
a=temp;
temp=x;
x=lastx.subtract(quotient.multiply(x));
lastx=temp;
temp=y;
y=lasty.subtract(quotient.multiply(y));
lasty=temp;
if(b.notEqualTo(Integerzero)&&x.terms.length<3&&y.terms.length<3&&a.terms.length<3&&b.terms.length<3&&lastx.terms.length<3&&lasty.terms.length<3){
return CM.Integer.smallextended_gcd(a,b,x,y,lastx,lasty);};};
var returnObj=new Object();
returnObj.x=new CM.Integer(lastx);
returnObj.y=new CM.Integer(lasty);
returnObj.gcd=new CM.Integer(a);
return returnObj;};
CM.Integer.extended_gcd=function(){
var minusOne=CM.Integer.minusOne;
var zero=CM.Integer.zero;
var a=arguments[0];
var b=arguments[1];
var positiveReturnObject=CM.Integer.extended_gcdPositiveIntegers(a.abs(),b.abs());
var x=positiveReturnObject.x;
var y=positiveReturnObject.y;
var gcd=positiveReturnObject.gcd;
if(a.lessThan(zero)){
x=x.multiply(minusOne);}
if(b.lessThan(zero)){
y=y.multiply(minusOne);}
var returnObj=new Object();
returnObj.x=x;
returnObj.y=y;
returnObj.gcd=gcd;
return returnObj;};
CM.Integer.extended_gcdNeverReduced=function(){
var Integerone=CM.Integer.one;
var Integerzero=CM.Integer.zero;
var a=arguments[0].abs();
var b=arguments[1].abs();
var x=arguments[2];
var y=arguments[3];
var lastx=arguments[4];
var lasty=arguments[5];
if(x==null){
var x=Integerzero;
var lastx=Integerone;};
if(y==null){
var y=Integerone;
var lasty=Integerzero;};
while(b!=undefined&&b.notEqualTo(Integerzero)){
var temp=b;
var dividesObj=a.divide(b);
var quotient=dividesObj.quotient;
b=dividesObj.mod;
a=temp;
temp=x;
x=lastx.subtract(quotient.multiply(x));
lastx=temp;
temp=y;
y=lasty.subtract(quotient.multiply(y));
lasty=temp;};
var returnObj=new Object();
returnObj.x=new CM.Integer(lastx);
returnObj.y=new CM.Integer(lasty);
returnObj.gcd=new CM.Integer(a);
return returnObj;};
CM.Integer.smallextended_gcd=function(){
var floor=Math.floor;
var basesquared=CM.Integer._basesquared;
var a=Math.abs(1*arguments[0].toString());
var b=Math.abs(1*arguments[1].toString());
var x=arguments[2];
var y=arguments[3];
var lastx=arguments[4];
var lasty=arguments[5];
if(x==null){
x=0;
lastx=1;}
else{
x=1*x;
lastx=1*lastx;};
if(y==null){
y=1;
lasty=0;}
else{
y=1*y;
lasty=1*lasty;};
while(b!=undefined&&b!=0){
var oldb=b;
var olda=a;
var temp=b;
var quotient=floor(a/b);
b=a%b;
a=temp;
temp=x;
x=lastx-quotient*x;
var oldlastx=lastx;
lastx=temp;
temp=y;
y=lasty-quotient*y;
var oldlasty=lasty;
lasty=temp;
if(Math.abs(x)>=basesquared||Math.abs(y)>=basesquared||Math.abs(a)>=basesquared||Math.abs(b)>=basesquared||Math.abs(lastx)>=basesquared||Math.abs(lasty)>=basesquared){
return CM.Integer.extended_gcdPositiveIntegers(new CM.Integer(olda),new CM.Integer(oldb),new CM.Integer(lastx),new CM.Integer(lasty),new CM.Integer(oldlastx),new CM.Integer(oldlasty));};};
var returnObj=new Object();
returnObj.x=new CM.Integer(lastx);
returnObj.y=new CM.Integer(lasty);
returnObj.gcd=new CM.Integer(a);
return returnObj;};
CM.Integer.gcd=function(){
if(arguments[0].terms==null){alert(["In Integer.gcd problem with argument[0] type ",this,arguments[0].cm_instanceof,arguments[0]]);}
if(arguments[0].terms.length<=2&&arguments[1].terms.length<=2){
return CM.Integer.smallgcd(arguments[0],arguments[1]);};
var a=arguments[0].abs();
var b=arguments[1].abs();
while(b!=undefined&&b.notEqualTo(CM.Integer.zero)){
var temp=b;
var dividesObj=a.divide(b);
b=dividesObj.mod;
a=temp;
if(a.terms.length<=2&&b.terms.length<=2)
return CM.Integer.smallgcd(a,b);};
return new CM.Integer(a);};
CM.Integer.smallgcd=function(a,b){
var a=Math.abs(1*arguments[0].toString());
var b=Math.abs(1*arguments[1].toString());
while(b!=0){
var temp=b;
b=a%b;
a=temp;};
return new CM.Integer(a);};
CM.Integer.multiplegcd=function(){
var integerarray=arguments[0];
var Gcd=CM.Integer.gcd;
var tempreturn=Gcd(integerarray[0],integerarray[1]);
var integerarraylength=integerarray.length;
for(var i=2;i<integerarraylength;i++){
tempreturn=Gcd(tempreturn,integerarray[i]);};
return tempreturn;};
CM.Integer.lcm=function(){
var a=arguments[0].abs();
var b=arguments[1].abs();
var Integer=CM.Integer;
var zero=Integer.zero;
if(a.equalTo(zero)||b.equalTo(zero))
return zero;
return a.divide(Integer.gcd(a,b)).quotient.multiply(b);};
CM.Integer.multiplelcm=function(){
var integerarray=arguments[0];
var integerarraylength=integerarray.length;
if(integerarraylength==1){
return integerarray[0].abs();}
var tempgcd=CM.Integer.gcd(integerarray[0],integerarray[1]);
var tempreturn=integerarray[0].abs().divide(tempgcd).quotient.multiply(integerarray[1].abs());
for(var i=2;i<integerarraylength;i++){
tempreturn=tempreturn.multiply(integerarray[i].abs().divide(CM.Integer.gcd(tempreturn,integerarray[i])).quotient);};
return tempreturn;};
CM.Integer._experimentalGcd=function(){
if(arguments[0].terms.length<=2&&arguments[1].terms.length<=2){
return CM.Integer.smallgcd(arguments[0],arguments[1]);}
var a=arguments[0].abs();
var b=arguments[1].abs();
if(a.terms.length>b.terms.length+1)
a=a.divide(b).remainder;
else if(b.terms.length>a.terms.length+1)
b=b.divide(a).remainder;
while(b!=undefined&&b.notEqualTo(CM.Integer.zero)){
if(b.lessThan(a)){
var temp=a.minus(b)._twoPowerIndexArray()[1];
if(temp.lessThan(b)){
a=b;
b=temp;}
else
a=temp;}
else{
var temp=b.minus(a)._twoPowerIndexArray()[1];
if(temp.lessThan(a)){
b=temp;}
else{
b=a;
a=temp;};}
if(a.terms.length<=2&&b.terms.length<=2)
return CM.Integer.smallgcd(a,b);
if(a.terms.length>b.terms.length+1)
a=a.divide(b).remainder;
else if(b.terms.length>a.terms.length+1)
b=b.divide(a).remainder;};
return new CM.Integer(a);};
CM.Integer._primeIndicator="Prime";
CM.Integer._probablyPrimeIndicator="Probably Prime";
CM.Integer._compositeIndicator="Composite";
CM.Integer._notPrimeIndicator="Not Prime";
CM.Integer._isPrimeDefaultAttempts=7;
CM.Integer.prototype.isPrime=function(){
var numberoftimes=arguments[0];
if(numberoftimes==null){
numberoftimes=CM.Integer._isPrimeDefaultAttempts;};
var NP=CM.Integer._notPrimeIndicator;
var PP=CM.Integer._probablyPrimeIndicator;
var CP=CM.Integer._compositeIndicator;
var DP=CM.Integer._primeIndicator;
if(this.sign=="-")
return NP;
if(this.equalTo(CM.Integer.two)||this.equalTo(CM.Integer.three)||this.equalTo(CM.Integer.five))
return DP;
if(this.equalTo(CM.Integer.one))
return NP;
if(this.terms[0]%2==0||this.terms[0]%5==0)
return CP;
var digits=this.digits();
var digitslength=digits.length;
var digitsum=1*0;
for(var i=0;i<digitslength;i++){
digitsum=digitsum+1*digits[i];};
if(digitsum%3==0)
return CP;
var hundredArray=CM.Integer.HundredPrimeArray;
if(!this.greaterThan(hundredArray[99])){
for(var i=0;i<100;i++){
hundredloop:
if(this.equalTo(hundredArray[i])){
return DP;
break hundredloop;}}
return CP;}
var gcd=CM.Integer.gcd(this,CM.Integer.productPrimes256);
if(gcd.greaterThan(CM.Integer.one)&&gcd.lessThan(this)){
return CP;}
var tN=this.subtract(CM.Integer.one);
if(this.lessThan(CM.Integer.SmallPrimeBoundary)){
numberoftimes=7;
var basesarray=CM.Integer.SmallPrimalityBases;}
var terms=tN.terms;
var length=terms.length;
var bString="";
var strLength=0;
var found=false;
var chunkSize=CM.Integer._chunkSize;
var basetworep=(""+tN.toBaseTwo()).split("").reverse().join("");
var k=new CM.Integer(basetworep.match(/1/).index);
var m=tN.divide(CM.Integer.two.power(k)).quotient;
var upperrandomdigits=Math.max(chunkSize,chunkSize*(this.terms.length-1));
for(var attemptnumber=0;attemptnumber<numberoftimes;attemptnumber++){
var a;
basesarray==null?a=CM.Integer.random(1,upperrandomdigits).abs():a=basesarray[attemptnumber];
var g=CM.Integer.gcd(a,this);
if(g.greaterThan(CM.Integer.one)&&g.lessThan(this)){
return CP;}
else if(g.equalTo(this)){
a=g.subtract(CM.Integer.one);};
var b=new Array(k);
b[0]=a.powerM(m,this);
if(b[0].equalTo(CM.Integer.one))
var tempreturn=PP;
for(var i=1;i<=k;i++)
b[i]=b[i-1].powerM(CM.Integer.two,this);
if(!b[k].equalTo(CM.Integer.one))
return CP;
var j;
for(var i=0;i<k;i++)
if(b[i+1].equalTo(CM.Integer.one)){
j=i;
break;}
g=CM.Integer.gcd(b[j].add(CM.Integer.one),this);
if(g.equalTo(CM.Integer.one)||g.equalTo(this)){
var tempeturn=PP;}
else{
return CP;};};
return basesarray==null?PP:DP;};
CM.Integer.SmallPrimeBoundary=new CM.Integer("34155071728321");
CM.Integer.SmallPrimalityBases=[CM.Integer.two,CM.Integer.three,CM.Integer.five,CM.Integer.seven,new CM.Integer("11"),new CM.Integer("13"),new CM.Integer("17")];
CM.Integer.prototype.nextPrime=function(){
var numberoftimes=arguments[0];
if(numberoftimes==null){
numberoftimes=CM.Integer._isPrimeDefaultAttempts;};
var PP=CM.Integer._probablyPrimeIndicator;
var DP=CM.Integer._primeIndicator;
var terms0=this.terms[0];
var zero=CM.Integer.zero;
var one=CM.Integer.one;
var two=CM.Integer.two;
if(!this.greaterThan(one))
return two;
if(terms0%2==0){
var next=this.add(one);
if(next.isPrime(numberoftimes)===DP){
return next;}
else if(next.isPrime(numberoftimes)===PP){
return next;}
else{
return next.nextPrime(numberoftimes);};};
var next=this.add(two);
if(next.isPrime(numberoftimes)===DP){
return next;}
else if(next.isPrime(numberoftimes)===PP){
return next;}
else{
return next.nextPrime(numberoftimes);};};
CM.Integer.prototype.previousPrime=function(){
var numberoftimes=arguments[0];
if(numberoftimes==null){
numberoftimes=CM.Integer._isPrimeDefaultAttempts;};
var PP=CM.Integer._probablyPrimeIndicator;
var DP=CM.Integer._primeIndicator;
var terms0=this.terms[0];
var zero=CM.Integer.zero;
var one=CM.Integer.one;
var two=CM.Integer.two;
if(!this.greaterThan(two))
return undefined;
if(terms0%2==0){
var next=this.subtract(one);
if(next.isPrime(numberoftimes)===DP){
return next;}
else if(next.isPrime(numberoftimes)===PP){
return next;}
else{
return next.previousPrime(numberoftimes);};};
var next=this.subtract(two);
if(next.isPrime(numberoftimes)===DP){
return next;}
else if(next.isPrime(numberoftimes)===PP){
return next;}
else{
return next.previousPrime(numberoftimes);};};
CM.Integer.LegendreSymbol=function(){
var zero=CM.Integer.zero;
var one=CM.Integer.one;
var prime=arguments[1];
var a=arguments[0].mod(prime);
var testprimatlity=arguments[2];
if(prime.equalTo(CM.Integer.two)){
if(a.equalTo(zero)){
return zero;}
if(a.equalTo(one)){
return one;}}
var errorstring="You have invoked the LegendreSymbol on a number "+prime+" that is not a  prime."
if(!prime.greaterThan(CM.Integer.one)){
alert(errorstring);
throw new Error(errorstring);}
if(testprimatlity=="yes"){
var isprime=prime.isPrime();
if(!(isprime==CM.Integer._probablyPrimeIndicator||isprime==CM.Integer._primeIndicator)){
alert(errorstring);
throw new Error(errorstring);}}
if(a.equalTo(zero)){
return zero;}
var tempreturn=a.powerM(prime.add(CM.Integer.minusOne).divide(CM.Integer.two).quotient,prime);
return tempreturn.modSymmetric(prime);};
CM.Integer.NativeHundredPrimeArray=[2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,467,479,487,491,499,503,509,521,523,541];
CM.Integer.HundredPrimeArray=(function(){
var tempreturn=[CM.Integer.two,CM.Integer.three,CM.Integer.five,CM.Integer.seven];
var primearray=CM.Integer.NativeHundredPrimeArray;
var length=primearray.length;
for(var i=4;i<length;i++){
tempreturn.push(new CM.Integer(primearray[i]));}
return tempreturn;})();
CM.Integer.NativeHundredLargestSingleTermPrimeArray=[9998279,9998281,9998309,9998321,9998323,9998333,9998377,9998381,9998393,9998413,9998423,9998441,9998447,9998459,9998479,9998539,9998543,9998557,9998561,9998581,9998587,9998603,9998623,9998633,9998641,9998689,9998699,9998701,9998719,9998741,9998743,9998749,9998753,9998777,9998797,9998801,9998809,9998851,9998861,9998867,9998887,9998893,9998903,9998929,9998969,9998971,9998977,9999047,9999049,9999053,9999071,9999083,9999161,9999163,9999167,9999193,9999217,9999221,9999233,9999271,9999277,9999289,9999299,9999317,9999337,9999347,9999397,9999401,9999419,9999433,9999463,9999469,9999481,9999511,9999533,9999593,9999601,9999637,9999653,9999659,9999667,9999677,9999713,9999739,9999749,9999761,9999823,9999863,9999877,9999883,9999889,9999901,9999907,9999929,9999931,9999937,9999943,9999971,9999973,9999991];
CM.Integer.HundredLargestSingleTermPrimeArray=(function(){
var tempreturn=new Array();
var primearray=CM.Integer.NativeHundredLargestSingleTermPrimeArray;
var length=primearray.length;
for(var i=0;i<length;i++){
tempreturn.push(new CM.Integer(primearray[i]));}
return tempreturn;})();
CM.Integer.FibonacciArray=[CM.Integer.zero,CM.Integer.one,CM.Integer.one,CM.Integer.two,CM.Integer.three,CM.Integer.five,CM.Integer.eight,new CM.Integer("13"),new CM.Integer("21"),new CM.Integer("34"),new CM.Integer("55"),new CM.Integer("89"),new CM.Integer("144"),new CM.Integer("233"),new CM.Integer("377"),new CM.Integer("610"),new CM.Integer("987"),new CM.Integer("1597"),new CM.Integer("2584"),new CM.Integer("4181"),new CM.Integer("6765"),new CM.Integer("10946"),new CM.Integer("17711"),new CM.Integer("28657"),new CM.Integer("46368"),new CM.Integer("75025"),new CM.Integer("121393"),new CM.Integer("196418"),new CM.Integer("317811"),new CM.Integer("514229"),new CM.Integer("832040"),new CM.Integer("1346269"),new CM.Integer("2178309"),new CM.Integer("3524578"),new CM.Integer("5702887"),new CM.Integer("9227465"),new CM.Integer("14930352"),new CM.Integer("24157817"),new CM.Integer("39088169"),new CM.Integer("63245986"),new CM.Integer("102334155"),new CM.Integer("165580141"),new CM.Integer("267914296"),new CM.Integer("433494437"),new CM.Integer("701408733"),new CM.Integer("1134903170"),new CM.Integer("1836311903"),new CM.Integer("2971215073"),new CM.Integer("4807526976"),new CM.Integer("7778742049"),new CM.Integer("12586269025"),new CM.Integer("20365011074"),new CM.Integer("32951280099"),new CM.Integer("53316291173"),new CM.Integer("86267571272"),new CM.Integer("139583862445"),new CM.Integer("225851433717"),new CM.Integer("365435296162"),new CM.Integer("591286729879"),new CM.Integer("956722026041"),new CM.Integer("1548008755920"),new CM.Integer("2504730781961"),new CM.Integer("4052739537881"),new CM.Integer("6557470319842"),new CM.Integer("10610209857723"),new CM.Integer("17167680177565"),new CM.Integer("27777890035288"),new CM.Integer("44945570212853"),new CM.Integer("72723460248141"),new CM.Integer("117669030460994"),new CM.Integer("190392490709135"),new CM.Integer("308061521170129"),new CM.Integer("498454011879264"),new CM.Integer("806515533049393"),new CM.Integer("1304969544928657"),new CM.Integer("2111485077978050"),new CM.Integer("3416454622906707"),new CM.Integer("5527939700884757"),new CM.Integer("8944394323791464"),new CM.Integer("14472334024676221"),new CM.Integer("23416728348467685"),new CM.Integer("37889062373143906"),new CM.Integer("61305790721611591"),new CM.Integer("99194853094755497"),new CM.Integer("160500643816367088"),new CM.Integer("259695496911122585"),new CM.Integer("420196140727489673"),new CM.Integer("679891637638612258"),new CM.Integer("1100087778366101931"),new CM.Integer("1779979416004714189"),new CM.Integer("2880067194370816120"),new CM.Integer("4660046610375530309"),new CM.Integer("7540113804746346429"),new CM.Integer("12200160415121876738"),new CM.Integer("19740274219868223167"),new CM.Integer("31940434634990099905"),new CM.Integer("51680708854858323072"),new CM.Integer("83621143489848422977"),new CM.Integer("135301852344706746049"),new CM.Integer("218922995834555169026"),new CM.Integer("354224848179261915075")];
CM.Integer.fibonacci=function(n){
var FibonacciArray=CM.Integer.FibonacciArray;
var FibonacciArrayLength=FibonacciArray.length;
nativeN=1*n.toString();
if(n<FibonacciArrayLength)
return FibonacciArray[nativeN];
else{
var difference=1+nativeN-FibonacciArray.length;
for(var i=0;i<difference;i++){
FibonacciArray[FibonacciArrayLength+i]=FibonacciArray[FibonacciArrayLength+i-1].add(FibonacciArray[FibonacciArrayLength+i-2])}
return FibonacciArray[nativeN];}}
CM.Integer.prototype.atomicSortIndex=10;
CM.Integer.prototype.largestFactor=function(n){
var zero=CM.Integer.zero;
var one=CM.Integer.one;
if(n.cm_instanceof!="Integer"){
throw new Error("You must pass a positive integer as an argument in CM.Integer.largestFactor. Instead "+n+" was passed.");}
else if(this.lessThan(zero)){
throw new Error("You must pass a positive integer as an argument in CM.Integer.largestFactor. Instead you passed the integer "+n+".");}
else if(this.equalTo(zero)){
return[0,one,zero];}
else if(n.equalTo(CM.Integer.two)){
return this._evenOddParts();}
var thisdivided=this;
var power=0;
var divisionobject=thisdivided.divide(n);
var remainder=divisionobject.remainder;
while(remainder.equalTo(zero)===true){
power++;
thisdivided=divisionobject.quotient;
divisionobject=thisdivided.divide(n);
remainder=divisionobject.remainder;}
return[power,n.power(new CM.Integer(power)),thisdivided];};
CM.Integer.FactorSortingFunction=function(a,b){
if(a[0].lessThan(b[0])){
return -1;}
else if(a[0].greaterThan(b[0])){
return 1;}
else{
return 0;}}
CM.Integer.prototype.factorsArray=function(){
var zero=CM.Integer.zero;
var one=CM.Integer.one;
var two=CM.Integer.two;
var three=CM.Integer.three;
var five=CM.Integer.five;
if(this.equalTo(zero)){
return[];}
var returnarray=new Array();
var currentnumber=this.abs();
var currentstate=currentnumber._evenOddParts();
if(currentstate[0]>0){
returnarray.push([two,new CM.Integer(currentstate[0])]);
currentnumber=currentstate[2];}
currentstate=currentnumber.largestFactor(three);
if(currentstate[0]>0){
returnarray.push([three,new CM.Integer(currentstate[0])]);
currentnumber=currentstate[2];}
currentstate=currentnumber.largestFactor(five);
if(currentstate[0]>0){
returnarray.push([five,new CM.Integer(currentstate[0])]);
currentnumber=currentstate[2];}
var gcd=CM.Integer.gcd(currentnumber,CM.Integer.productPrimes256);
if(gcd.greaterThan(CM.Integer.one)){
var HundredPrimeArray=CM.Integer.HundredPrimeArray;
smallprimeloop:
for(var smallprimeindex=3;smallprimeindex<54;smallprimeindex++){
var smallprime=HundredPrimeArray[smallprimeindex];
currentstate=currentnumber.largestFactor(smallprime);
if(currentstate[0]>0){
returnarray.push([smallprime,new CM.Integer(currentstate[0])]);
var currentnumber=currentstate[2];
gcd=gcd.divide(smallprime).quotient;
if(gcd.equalTo(one)){
break smallprimeloop;}}}}
var primetestreturn=currentnumber.isPrime();
while(currentnumber.greaterThan(one)&&!(primetestreturn==CM.Integer._probablyPrimeIndicator||primetestreturn==CM.Integer._primeIndicator)){
var integerLog10=Math.ceil(10*(1*currentnumber.integerLog10()+1)/24);
if((1*currentnumber)/(1*(new CM.Power([new CM.Integer(256),new CM.Integer(integerLog10)]).simplify()))>1){
alert(["Compare",(1*currentnumber)/(1*(new CM.Power([new CM.Integer(256),new CM.Integer(integerLog10)]).simplify()))]);}
var tt=0;
var NativeHundredPrimeArray=CM.Integer.NativeHundredPrimeArray;
var HundredPrimeArray=CM.Integer.HundredPrimeArray;
while(integerLog10>CM.Integer.NativeHundredPrimeArray[tt]){
var powerbase=currentnumber.hasIntegerFractionalPower(new CM.Rational(one,HundredPrimeArray[tt]));
if(powerbase!==false){
var factoredbase=powerbase.factorsArray();
for(var i=0;i<factoredbase.length;i++){
returnarray.push([factoredbase[i][0],factoredbase[i][1].multiply(HundredPrimeArray[tt])]);}
return returnarray.sort(CM.Integer.FactorSortingFunction);}
else{
tt++;}}
var rhoreturn=currentnumber.rhoMethod();
if(rhoreturn=="fail"){
alert(["Rho Method returns fail",currentnumber]);}
var rhofactors=rhoreturn.factorsArray();
for(var j=0;j<rhofactors.length;j++){
currentstate=currentnumber.largestFactor(rhofactors[j][0]);
returnarray.push([rhofactors[j][0],new CM.Integer(currentstate[0])]);
currentnumber=currentstate[2];}
var primetestreturn=currentnumber.isPrime();}
if(currentnumber.equalTo(one)){
return returnarray.sort(CM.Integer.FactorSortingFunction);}
else{
returnarray.push([currentnumber,one]);
return returnarray.sort(CM.Integer.FactorSortingFunction);}};
CM.Integer.prototype.factor=function(){
var zero=CM.Integer.zero;
var one=CM.Integer.one;
var minusOne=CM.Integer.minusOne;
if(this.equalTo(zero)){
return zero;}
if(this.equalTo(one)){
return one;}
if(this.equalTo(minusOne)){
return minusOne;}
var tempreturn=this.factorsArray();
var tempreturnlength=tempreturn.length;
var terms=new Array();
for(var i=0;i<tempreturnlength;i++){
if(tempreturn[i][1].equalTo(one)){
terms[i]=tempreturn[i][0];}
else{
terms[i]=new CM.Power([tempreturn[i][0],tempreturn[i][1]]);}}
if(this.sign!="-"){
return new CM.Factor(terms);}
else{
return new CM.Factor([minusOne].concat(terms));}};
CM.Integer.prototype.rhoMethod=function(){
var numberofattempts=arguments[0];
if(numberofattempts==null){
numberofattempts=100;}
else{
if(numberofattempts.cm_instanceof=="Integer"){
numberofattempts=1*numberofattempts.toString();}}
rhoMethodTimeout=CM.Integer.prototype.rhoMethod.Timeout;
var zero=CM.Integer.zero;
var one=CM.Integer.one;
var GCD=CM.Integer.gcd;
var beginTime=new Date().getTime();
var currentTime=new Date().getTime();
for(var j=0;j<numberofattempts;j++){
var x=CM.Integer.random(zero,this.subtract(one));
var y=x;
var i=0;
var gcd=one;
whileloop:
while(gcd.equalTo(one)){
i++;
x=x.square().add(one).mod(this);
y=y.square().add(one).square().add(one).mod(this);
gcd=GCD(x.subtract(y),this);
if(gcd.equalTo(this)){
j++;
break whileloop;}
else if(gcd.greaterThan(one)){
return gcd;}
else if(i%100==0){
var currentTime=new Date().getTime();
var elapsedTime=currentTime-beginTime;
if(elapsedTime>rhoMethodTimeout){
if(confirm("Factoring the integer "+this+" has taken "+Math.round(rhoMethodTimeout/1000)+" seconds so far. Do you want to continue for another "+Math.round(rhoMethodTimeout/1000)+" seconds?")){
var beginTime=new Date().getTime();}
else{
return "fail";}}}}}
return "fail";};
CM.Integer.prototype.rhoMethod.Timeout=3000000;
CM.Integer.prototype.phi=function(){
var zero=CM.Integer.zero;
var minusOne=CM.Integer.minusOne;
var one=CM.Integer.one;
if(this.equalTo(zero)){
return zero;}
if(this.abs().equalTo(one)){
return one;}
var returnarray=this.factorsArray();
var returnarraylength=returnarray.length;
var terms=[];
for(var i=0;i<returnarraylength;i++){
terms.push(returnarray[i][0].add(minusOne));
if(returnarray[i][1].greaterThan(one)){
terms.push(new CM.Power([returnarray[i][0],returnarray[i][1].add(minusOne)]));}}
return new CM.Factor(terms).simplify();};
CM.Integer.random=function(){
var zero=CM.Integer.zero;
var one=CM.Integer.one;
if(arguments.length==1){
var lowerbound=zero;
var upperbound=new CM.Integer(arguments[0]).add(one);}
else{
var lowerbound=new CM.Integer(arguments[0]);
var upperbound=new CM.Integer(arguments[1]).add(one).minus(lowerbound);}
if(upperbound.greaterThan(zero)===false){
throw new Error("Your upperbound of "+upperbound+" is not bigger than your lower bound of "+lowerbound+" in CM.Integer.random.");}
var chunkSize=CM.Integer._chunkSize;
chunkSize=Math.pow(10,chunkSize);
var upperboundtermslength=upperbound.terms.length;
var terms=[Math.floor(chunkSize*Math.random())];
while(terms.length<=upperboundtermslength){
terms.push(Math.floor(chunkSize*Math.random()));}
var tempreturn=new CM.Integer(terms);
tempreturn=tempreturn.mod(upperbound).add(lowerbound);
return tempreturn;};
CM.Integer.prototype.integerLog=function(){
var base=arguments[0];
var tempreturn=Math.floor(Math.log(this)/Math.log(base));
return new CM.Integer(tempreturn);};
CM.Integer.prototype.integerLog10=function(){
if(this.equalTo(CM.Integer.zero)){
return "MinusInfinity";}
return new CM.Integer(this.toString().length-1);};
CM.Integer.prototype.hasIntegerFractionalPower=function(){
var power=arguments[0].simplify();
var intlog=this.integerLog10();
if(power.cm_instanceof=="Integer"){
if(power.sign!="-"){
return this.power(arguments[0]);}
else{
return new CM.Rational(CM.Integer.one,this.power(arguments[0].abs())).simplify();}}
else if(power.cm_instanceof=="Rational"){
if(power.denominator.isEven()===true&&this.sign=="-"){
return false;}
if(power.sign!="-"){
var precision=new CM.Sum([CM.Integer.five,new CM.Factor([power,intlog.add(CM.Integer.one)])]).simplify();
if(precision.cm_instanceof=="Integer"){
var precision=Math.ceil(1*precision.toString()+1);}
else{
var precision=Math.ceil((1*precision.numerator.toString())/(1*precision.denominator.toString())+1);}
var rounded=new CM.Power([this,power]).round(precision).simplify();
var roundedtointeger=rounded.round(0,"d");
if(!rounded.equalTo(roundedtointeger)&&(rounded.subtract(roundedtointeger).abs()).greaterThan(CM.Floating.thousanth,3)){
return false;}
else{
var check1=roundedtointeger.power(power.denominator);
var check2=this.power(power.numerator);
if(check1.equalTo(check2)){
return roundedtointeger.simplify();}
else{
return false;}}}
else{
var tempreturn=this.hasIntegerFractionalPower(power.abs());
if(tempreturn!==false){
return new CM.Rational(CM.Integer.one,tempreturn).simplify();}
else{
return false;}}}
else{
return false;}};
CM.Integer.prototype.squareRoot=function(){
return new CM.Floating(this).squareRoot(arguments[0],arguments[1]);};
CM.Integer.prototype.content=function(){
return this.abs();};
CM.Integer.prototype.primitive=function(){
return CM.Integer.one;};
CM.Integer.prototype.isInteger=function(){
return true;};
CM.Integer.Max=function(){
var inputarray=arguments[0];
var inputarraylength=inputarray.length;
var tempreturn=inputarray[0];
for(var i=1;i<inputarraylength;i++){
if(inputarray[i].greaterThan(tempreturn)){
tempreturn=inputarray[i];}}
return tempreturn;};
CM.Integer.Min=function(){
var inputarray=arguments[0];
var inputarraylength=inputarray.length;
var tempreturn=inputarray[0];
for(var i=1;i<inputarraylength;i++){
if(inputarray[i].lessThan(tempreturn)){
tempreturn=inputarray[i];}}
return tempreturn;};
CM.Integer.LargestSevenDigitPrimesNativeJavaScriptArray=[9996737,9996751,9996757,9996781,9996803,9996809,9996817,9996823,9996829,9996859,9996887,9996929,9996937,9996949,9996979,9996991,9997007,9997033,9997049,9997063,9997087,9997093,9997109,9997123,9997129,9997133,9997177,9997189,9997201,9997219,9997237,9997291,9997303,9997319,9997321,9997327,9997333,9997349,9997357,9997367,9997381,9997397,9997441,9997451,9997483,9997517,9997523,9997573,9997577,9997579,9997583,9997597,9997601,9997613,9997621,9997627,9997643,9997661,9997697,9997703,9997711,9997739,9997747,9997753,9997777,9997783,9997787,9997817,9997829,9997831,9997859,9997873,9997877,9997879,9997913,9997927,9997937,9997951,9997957,9997969,9997987,9997991,9997997,9998017,9998033,9998099,9998117,9998119,9998129,9998141,9998143,9998147,9998173,9998179,9998201,9998203,9998207,9998239,9998249,9998273,9998279,9998281,9998309,9998321,9998323,9998333,9998377,9998381,9998393,9998413,9998423,9998441,9998447,9998459,9998479,9998539,9998543,9998557,9998561,9998581,9998587,9998603,9998623,9998633,9998641,9998689,9998699,9998701,9998719,9998741,9998743,9998749,9998753,9998777,9998797,9998801,9998809,9998851,9998861,9998867,9998887,9998893,9998903,9998929,9998969,9998971,9998977,9999047,9999049,9999053,9999071,9999083,9999161,9999163,9999167,9999193,9999217,9999221,9999233,9999271,9999277,9999289,9999299,9999317,9999337,9999347,9999397,9999401,9999419,9999433,9999463,9999469,9999481,9999511,9999533,9999593,9999601,9999637,9999653,9999659,9999667,9999677,9999713,9999739,9999749,9999761,9999823,9999863,9999877,9999883,9999889,9999901,9999907,9999929,9999931,9999937,9999943,9999971,9999973,9999991];
CM.Integer.LargestSevenDigitPrimesArray=new Array();(function(){
var nativeprimearray=CM.Integer.LargestSevenDigitPrimesNativeJavaScriptArray;
var nativeprimearraylength=nativeprimearray.length;
var primearray=CM.Integer.LargestSevenDigitPrimesArray;
var Integer=CM.Integer;
for(var i=0;i<nativeprimearraylength;i++){
primearray[i]=new Integer(nativeprimearray[i]);}})();

