
CM.Integer.prototype.integration=function(){
var terms=this.getTerms();
var iWRTO=arguments[0].getKey()[0];
if(arguments[0].isVariable()===false){
var errorstring="You are calling the Integration function, however your first prameter should be the variable with which you are taking the derivative. Unfortunately you entered "+arguments[0]+" which is not a variable.";
alert(errorstring);
throw new Error(errorstring);}
return new CM.Polynomial([[terms,CM.Integer.one]],[iWRTO]);};
CM.Rational.prototype.integration=function(){
var terms=this.getTerms();
var iWRTO=arguments[0].getKey()[0];
if(arguments[0].isVariable()===false){
var errorstring="You are calling the Integration function, however your first prameter should be the variable with which you are taking the derivative. Unfortunately you entered "+arguments[0]+" which is not a variable.";
alert(errorstring);
throw new Error(errorstring);}
return new CM.Polynomial([[terms,CM.Integer.one]],[iWRTO]);};
CM.Floating.prototype.integration=function(){
var terms=this.getTerms();
var iWRTO=arguments[0].getKey()[0];
if(arguments[0].isVariable()===false){
var errorstring="You are calling the Integration function, however your first prameter should be the variable with which you are taking the derivative. Unfortunately you entered "+arguments[0]+" which is not a variable.";
alert(errorstring);
throw new Error(errorstring);}
return new CM.Polynomial([[terms,CM.Integer.one]],[iWRTO]);};
CM.Polynomial.prototype.integration=function(){
var terms=this.getPolynomialTerms();
var newTerms=new Array();
var keys=this.getKey();
var termsLength=terms.length;
var keyLength=keys.length;
var iWRTO=arguments[0].getKey()[0];
var keyIndex=0;
if(this.getDependentVariables("local").cm_contains(iWRTO)==false){
return new CM.Factor([new CM.Polynomial(terms,keys),arguments[0]]).simplify();}
while(keys[keyIndex]!=iWRTO){
keyIndex++;}
for(var j=0;j<termsLength;j++){
terms[j][0]=new CM.Quotient([terms[j][0],new CM.Sum([terms[j][keyIndex+1],CM.Integer.one])]).simplify();
terms[j][keyIndex+1]=new CM.Sum([terms[j][keyIndex+1],CM.Integer.one]).simplify();
newTerms.push(new CM.Polynomial([terms[j].slice(0)],keys));}
return new CM.Sum(newTerms).simplify();};
CM.Sum.prototype.integration=function(){
var terms=this.getTerms();
var newTerms=new Array();
var termsLength=terms.length;
for(var i=0;i<termsLength;i++){
newTerms.push(terms[i].integration(arguments[0]));}
return new CM.Sum(newTerms);};
CM.Factor.prototype.integration=function(){
var terms=this.getTerms();
var arg=arguments[0]
var copyOfThis=new CM.Factor(terms);
var tempReturn;
copyOfThis=copyOfThis.simplify();
if(copyOfThis.cm_instanceof=="Factor"){
var copyOfThis_terms=copyOfThis.getTerms();
var copyOfThis_termsLength=copyOfThis_terms.length;
if(copyOfThis_termsLength==2){
if(copyOfThis_terms[0].cm_instanceof=='Integer'){
return new CM.Factor([copyOfThis_terms[0],copyOfThis_terms[1].integration(arg)]);}
else if(copyOfThis_terms[1].cm_instanceof=='Integer'){
return new CM.Factor([copyOfThis_terms[1],copyOfThis_terms[0].integration(arg)]);}}
return copyOfThis.integration_Substitutions(arg);}
return copyOfThis.integration(arg);};
CM.Quotient.prototype.integration=function(){
var terms=this.getTerms();
var top=terms[0];
var bottom=terms[1];
var iWRTO=arguments[0].getKey()[0];
if(this.getDependentVariables("local").cm_contains(iWRTO)==false){
return new CM.Factor([new CM.Quotient([top,bottom]),arguments[0]]);}
if(top.equalTo(CM.Integer.one)==true){
bottom=bottom.simplify();
if(bottom.cm_instanceof=='Polynomial'){
var polyTerms=bottom.getPolynomialTerms();
var keys=bottom.getKey();
var polyTermLength=polyTerms.length;
var firstTermLength=polyTerms[0].length;
var keyLength=keys.length;
if(keyLength==1&&polyTermLength==1&&polyTerms[0][1]==1){
return new CM.Factor([new CM.Quotient([CM.Integer.one,polyTerms[0][0]]),new CM.Ln([arguments[0]])]);}}}};
CM.Power.prototype.integration=function(){
var terms=this.getTerms();
var base=terms[0];
var power=terms[1];
var iWRTO=arguments[0].getKey()[0];
if(this.getDependentVariables("local").cm_contains(iWRTO)==false){
return new CM.Factor([new CM.Power([base,power]),arguments[0]]);}
if(base.cm_instanceof=='Integer'){
power=power.simplify();
if(power.cm_instanceof=='Polynomial'){
var polyTerms=power.getPolynomialTerms();
var keys=power.getKey();
var polyTermLength=polyTerms.length;
var firstTermLength=polyTerms[0].length;
var keyLength=keys.length;
if(keyLength==1&&polyTermLength==1&&polyTerms[0][1]==1){
return new CM.Factor([new CM.Quotient([CM.Integer.one,new CM.Factor([polyTerms[0][0],new CM.Ln([base])])]),new CM.Power([base,power])]).simplify();}}}
else{
base=base.simplify();
if(base.cm_instanceof=='Polynomial'){
var polyTerms=base.getPolynomialTerms();
var keys=base.getKey();
var polyTermLength=polyTerms.length;
var firstTermLength=polyTerms[0].length;
var keyLength=keys.length;
if(keyLength==1&&polyTermLength==1&&polyTerms[0][1]==1&&power.simplify().equalTo(CM.Integer.minusOne)==true){
return new CM.Factor([new CM.Quotient([CM.Integer.one,polyTerms[0][0]]),new CM.Ln([arguments[0]])]);}}}};
CM.Exp.prototype.integration=function(){
var terms=this.getTerms()[0];
var iWRTO=arguments[0].getKey()[0];
if(this.getDependentVariables("local").cm_contains(iWRTO)==false){
return new CM.Factor([new CM.Exp([terms]),arguments[0]]);}
terms=terms.simplify();
if(terms.cm_instanceof=='Polynomial'){
var polyTerms=terms.getPolynomialTerms();
var keys=terms.getKey();
var polyTermLength=polyTerms.length;
var firstTermLength=polyTerms[0].length;
var keyLength=keys.length;
if(keyLength==1&&polyTermLength==1&&polyTerms[0][1]==1){
return new CM.Factor([new CM.Quotient([CM.Integer.one,polyTerms[0][0]]),new CM.Exp([terms])]).simplify();}}};
CM.Ln.prototype.integration=function(){
var terms=this.getTerms()[0];
var iWRTO=arguments[0].getKey()[0];
if(this.getDependentVariables("local").cm_contains(iWRTO)==false){
return new CM.Factor([new CM.Ln([terms]),arguments[0]]);}
terms=terms.simplify();
if(terms.cm_instanceof=='Polynomial'){
var polyTerms=terms.getPolynomialTerms();
var keys=terms.getKey();
var polyTermLength=polyTerms.length;
var firstTermLength=polyTerms[0].length;
var keyLength=keys.length;
if(keyLength==1&&polyTermLength==1&&polyTerms[0][1]==1){
return new CM.Sum([new CM.Factor([arguments[0],new CM.Ln([new CM.Factor([polyTerms[0][0],arguments[0]])])]),new CM.Factor([CM.Integer.minusOne,arguments[0]]).simplify()]);}}};
CM.Sin.prototype.integration=function(){
var terms=this.getTerms()[0];
var iWRTO=arguments[0].getKey()[0];
if(this.getDependentVariables("local").cm_contains(iWRTO)==false){
return new CM.Factor([new CM.Sin([terms]),arguments[0]]);}
terms=terms.simplify();
if(terms.cm_instanceof=='Polynomial'){
var polyTerms=terms.getPolynomialTerms();
var keys=terms.getKey();
var polyTermLength=polyTerms.length;
var firstTermLength=polyTerms[0].length;
var keyLength=keys.length;
if(keyLength==1&&polyTermLength==1&&polyTerms[0][1]==1){
return new CM.Factor([CM.Integer.minusOne,new CM.Quotient([CM.Integer.one,polyTerms[0][0]]),new CM.Cos([new CM.Factor([polyTerms[0][0],arguments[0]])])]).simplify();}}};
CM.Cos.prototype.integration=function(){
var terms=this.getTerms()[0];
var iWRTO=arguments[0].getKey()[0];
if(this.getDependentVariables("local").cm_contains(iWRTO)==false){
return new CM.Factor([new CM.Sin([terms]),arguments[0]]);}
terms=terms.simplify();
if(terms.cm_instanceof=='Polynomial'){
var polyTerms=terms.getPolynomialTerms();
var keys=terms.getKey();
var polyTermLength=polyTerms.length;
var firstTermLength=polyTerms[0].length;
var keyLength=keys.length;
if(keyLength==1&&polyTermLength==1&&polyTerms[0][1]==1){
return new CM.Factor([new CM.Quotient([CM.Integer.one,polyTerms[0][0]]),new CM.Sin([new CM.Factor([polyTerms[0][0],arguments[0]])])]).simplify();}}};
CM.Tan.prototype.integration=function(){
var terms=this.getTerms()[0];
var iWRTO=arguments[0].getKey()[0];
if(this.getDependentVariables("local").cm_contains(iWRTO)==false){
return new CM.Factor([new CM.Ln([terms]),arguments[0]]);}
terms=terms.simplify();
if(terms.cm_instanceof=='Polynomial'){
var polyTerms=terms.getPolynomialTerms();
var keys=terms.getKey();
var polyTermLength=polyTerms.length;
var firstTermLength=polyTerms[0].length;
var keyLength=keys.length;
if(keyLength==1&&polyTermLength==1&&polyTerms[0][1]==1){
return new CM.Factor([CM.Integer.minusOne,new CM.Quotient([CM.Integer.one,polyTerms[0][0]]),new CM.Ln([new CM.Cos([new CM.Factor([polyTerms[0][0],arguments[0]])])])]).simplify();}}};
CM.Expression.prototype.integration=function(){
return this.terms[0].integration(arguments[0]);}

