
CM.Matrix=function(){
if(arguments[0]!=null&&arguments[0].cm_instanceof=="Array"){
this.terms=arguments[0];
var args=arguments[0];
var tempterms=new Array();
var argsLength=args.length;
var numberOfCol=args[0].length;
tempterms.push(args[0]);
for(var i=1;i<argsLength;i++){
if(numberOfCol!=args[i].length)
throw new Error("This Matrix does not have the same number of columns in each row");
else
numberOfCol=args[i].length;
tempterms.push(args[i]);}}
else if(arguments[0]!=null&&arguments[0].cm_instanceof=="Matrix"){
return arguments[0];}};
CM.Matrix.prototype=new CM.Composite();
CM.Matrix.prototype.constructor=CM.Matrix;
CM.Matrix.prototype.cm_instanceof="Matrix";
CM.Matrix.prototype.toString=function(){
var terms=this.terms;
var numberRows=terms.length;
var returnMatrix='[ [ '+terms[0].toString()+' ] ';
for(var i=1;i<numberRows;i++){
returnMatrix=returnMatrix+' [ '+terms[i].toString()+' ] ';}
return returnMatrix+']\n';};
CM.Matrix.prototype.add=function(){
var matrixA=this.terms;
var matrixB=arguments[0].terms;
var rowsOfMatrixA=matrixA.length;
var colOfMatrixA=matrixA[0].length;
var rowsOfMatrixB=matrixB.length;
var colOfMatrixB=matrixB[0].length;
var sum=new Array();alert(["In Matrix",rowsOfMatrixB]);
for(var i=0;i<rowsOfMatrixA;i++)
sum[i]=new Array();
if(rowsOfMatrixA!=rowsOfMatrixB||colOfMatrixA!=colOfMatrixB)
throw new Error("The Matrixs does not have the same number of columns and rows");
for(var i=0;i<rowsOfMatrixA;i++){
for(var j=0;j<colOfMatrixA;j++){
sum[i][j]=(new CM.Sum([matrixA[i][j],matrixB[i][j]])).simplify();}}
return new CM.Matrix(sum);};
CM.Matrix.prototype.subtract=function(){
var matrixA=this.terms;
var matrixB=arguments[0].terms;
var rowsOfMatrixA=matrixA.length;
var colOfMatrixA=matrixA[0].length;
var rowsOfMatrixB=matrixB.length;
var colOfMatrixB=matrixB[0].length;
var result=new Array();
for(var i=0;i<rowsOfMatrixA;i++)
result[i]=new Array();
if(rowsOfMatrixA!=rowsOfMatrixB||colOfMatrixA!=colOfMatrixB)
throw new Error("The Matrixs does not have the same number of columns and rows");
for(var i=0;i<rowsOfMatrixA;i++){
for(var j=0;j<colOfMatrixA;j++){
result[i][j]=(new CM.Sum([matrixA[i][j],(new CM.Factor([new CM.Integer(-1),matrixB[i][j]]))])).simplify();}}
return new CM.Matrix(result);};
CM.Matrix.prototype.multiply=function(){
var rowCount=0;
var tempResult=new CM.Integer(0);
var matrixA=this.terms;
var matrixB=arguments[0].terms;
var rowsOfMatrixA=matrixA.length;
var colOfMatrixA=matrixA[0].length;
var rowsOfMatrixB=matrixB.length;
var colOfMatrixB=matrixB[0].length;
var result=new Array();
if(colOfMatrixA!=rowsOfMatrixB){
throw new Error("The Matrixs has to has the same number of the columns in matrixA and the same number of the rows in matrixB");}
for(var i=0;i<rowsOfMatrixA;i++)
result[i]=new Array();
for(var i=0;i<rowsOfMatrixA;i++){
for(var j=0;j<colOfMatrixB;j++){
while(rowCount<rowsOfMatrixB){
tempResult=(new CM.Sum([tempResult,(new CM.Factor([matrixA[i][rowCount],matrixB[rowCount][j]]))])).simplify();
rowCount++;}
rowCount=0;
result[i][j]=tempResult;
tempResult=new CM.Integer(0);}}
return new CM.Matrix(new CM.Vector(result));};
CM.Matrix.prototype.square=function(){
var MatrixA=this;
var MatrixB=this;
return MatrixA.multiply(MatrixB);};
CM.Matrix.prototype.power=function(){
var exponent=arguments[0];
var binaryString=exponent.toBaseTwo();
var bLength=binaryString.length;
var returnthis=this;
for(var i=1;i<bLength;i++){
if(binaryString[i]=='1'){
returnthis=returnthis.square();
returnthis=returnthis.multiply(this);}
else{
returnthis=returnthis.square();}}
return returnthis;};
CM.Matrix.prototype.inverse=function(){
var args=this.terms;
var argsLength=args.length;
var terms=new Array();
var rows=args.length;
var cols=args[0].length;
var div;
var notInvertible=0;
var count=0;
var checkRow=0;
var inverseMatrix=new Array();
if(rows!=cols)
throw new Error("Matrix has to be square");
for(var i=0;i<rows;i++){
terms[i]=new Array();
terms[i]=args[i].slice();
inverseMatrix[i]=new Array();
for(var j=0;j<rows;j++){
if(i==j)
inverseMatrix[i][j]=new CM.Integer(1);
else
inverseMatrix[i][j]=new CM.Integer(0);}}
for(var i=0;i<cols;i++){
for(var j=0;j<rows;j++){
if(j!=i){
div=(new CM.Factor([terms[j][i],(new CM.Power([terms[i][i],new CM.Integer(-1)]))])).simplify();
while(count<cols){
terms[j][count]=new CM.Sum([terms[j][count],new CM.Factor([(new CM.Factor([div,terms[i][count]])),(new CM.Integer(-1))])]).simplify();
inverseMatrix[j][count]=new CM.Sum([inverseMatrix[j][count],new CM.Factor([(new CM.Factor([div,inverseMatrix[i][count]])),(new CM.Integer(-1))])]).simplify();
count++;}}
else if(terms[i][j]==0){
while(checkRow<rows){
if(checkRow!=j&&terms[checkRow][i]!=0)
break;
checkRow++;}
if(checkRow==rows)
throw new Error("Matrix is not invertible");
while(count<cols){
terms[j][count]=(new CM.Sum([terms[j][count],terms[checkRow][count]])).simplify();
inverseMatrix[j][count]=(new CM.Sum([inverseMatrix[j][count],inverseMatrix[checkRow][count]])).simplify();
count++;}}
checkRow=0;
count=0;}}
for(var i=0;i<rows;i++)
for(var j=0;j<cols;j++){
if(j==i){
div=(new CM.Factor([new CM.Integer(1),new CM.Power([terms[i][j],new CM.Integer(-1)])])).simplify();
while(count<cols){
terms[i][count]=(new CM.Factor([div,terms[i][count]])).simplify();
inverseMatrix[i][count]=(new CM.Factor([div,inverseMatrix[i][count]])).simplify();
count++;}}
count=0;}
return new CM.Matrix(new CM.Vector(inverseMatrix));};
CM.Matrix.prototype.transpose=function(){
var args=this.terms;
var rows=args.length;
var cols=args[0].length;
var terms=new Array();
for(var i=0;i<cols;i++){
terms[i]=new Array();
for(var j=0;j<rows;j++)
terms[i][j]=args[j][i];}
return new CM.Matrix(new CM.Vector(terms));};
CM.Matrix.prototype.scalar=function(){
var c=arguments[0];
var args=this.terms;
var rows=args.length;
var cols=args[0].length;
var terms=new Array();
var primeNumber=new Array();
for(var i=0;i<rows;i++){
terms[i]=new Array();
for(var j=0;j<cols;j++)
terms[i][j]=(new CM.Factor([c,args[i][j]])).simplify();}
return new CM.Matrix(new CM.Vector(terms));};
CM.Matrix.prototype.determinant=function(){
var args=this.terms;
var rows=args.length;
var cols=args[0].length;
var temp=1;
var primeNumber=new Array();
var determinant=new Array();
var tempTerms=new Array();
var count=0;
var temp1=0;
var sign=0;
var div;
var div1=new CM.Integer(1);
var temp2;
var B=0;
var C;
var r;
var n;
if(rows!=cols)
throw new Error("Matrix has to be square");
n=new CM.Integer(rows);
for(var i=0;i<rows;i++){
tempTerms[i]=new Array();
for(var j=0;j<cols;j++){
if(args[i][j]>B)
B=args[i][j];}}
C=Math.pow(n,n/2)*Math.pow(B,n);
r=Math.ceil((Math.log((2*C)+1))/(Math.log(2)));
for(var i=0;i<r;i++){
primeNumber[i]=new CM.Integer(CM.Integer.NativeHundredPrimeArray[i]);
for(var j=0;j<rows;j++){
for(var k=0;k<cols;k++){
tempTerms[j][k]=1*(args[j][k].mod(primeNumber[i]));}}
for(var l=0;l<cols;l++){
if(tempTerms[l][l]==0){
sign++;
count=l+1;
while(count<cols&&tempTerms[count][l]==0)
count++;
while(count<cols&&temp1<cols){
temp2=tempTerms[l][temp1];
tempTerms[l][temp1]=tempTerms[count][temp1];
tempTerms[count][temp1]=temp2;
temp1++;}
count=0;
temp1=0;}
div1=new CM.Factor([div1,tempTerms[l][l]]).simplify();
if(tempTerms[l][l].cm_instanceof=="Integer")
temp2=new CM.Integer(tempTerms[l][l]);
else if(tempTerms[l][l].cm_instanceof=="Rational")
temp2=new CM.Rational(tempTerms[l][l]);
for(var d=0;d<cols;d++)
tempTerms[l][d]=new CM.Factor([tempTerms[l][d],new CM.Power([temp2,new CM.Integer(-1)])]).simplify();
for(var j=l+1;j<rows;j++){
div=(new CM.Factor([tempTerms[j][l],(new CM.Power([tempTerms[l][l],new CM.Integer(-1)]))])).simplify();
while(count<cols){
tempTerms[j][count]=new CM.Sum([tempTerms[j][count],new CM.Factor([(new CM.Factor([div,tempTerms[l][count]])),(new CM.Integer(-1))])]).simplify();
count++;}
count=0;}}
if(sign%2!=0)
div1=new CM.Factor([div1,new CM.Integer(-1)]).simplify();
sign=0;
determinant[i]=div1;
div1=new CM.Integer(1);}
return CM.Integer.ChineseRemainder(primeNumber,determinant);};
CM.Matrix.prototype.simple_determinant=function(){
var args=this.terms;
var rows=args.length;
var cols=args[0].length;
var tempTerms=new Array();
var count=0;
var temp1=0;
var temp2;
var sign=0;
var div;
var determinant=new CM.Integer(1);
if(rows!=cols)
throw new Error("Matrix has to be square");
n=new CM.Integer(rows);
for(var i=0;i<rows;i++){
tempTerms[i]=new Array();
tempTerms[i]=args[i].slice();}
for(var l=0;l<cols;l++){
if(tempTerms[l][l]==0){
sign++;
count=l+1;
while(count<cols&&tempTerms[count][l]==0)
count++;
while(count<cols&&temp1<cols){
temp2=tempTerms[l][temp1];
tempTerms[l][temp1]=tempTerms[count][temp1];
tempTerms[count][temp1]=temp2;
temp1++;}
count=0;
temp1=0;}
determinant=new CM.Factor([determinant,tempTerms[l][l]]).simplify();
if(tempTerms[l][l].cm_instanceof=="Integer")
temp2=new CM.Integer(tempTerms[l][l]);
else if(tempTerms[l][l].cm_instanceof=="Rational")
temp2=new CM.Rational(tempTerms[l][l]);
for(var d=0;d<cols;d++)
tempTerms[l][d]=new CM.Factor([tempTerms[l][d],new CM.Power([temp2,new CM.Integer(-1)])]).simplify();
for(var j=l+1;j<rows;j++){
div=(new CM.Factor([tempTerms[j][l],(new CM.Power([tempTerms[l][l],new CM.Integer(-1)]))])).simplify();
while(count<cols){
tempTerms[j][count]=new CM.Sum([tempTerms[j][count],new CM.Factor([(new CM.Factor([div,tempTerms[l][count]])),(new CM.Integer(-1))])]).simplify();
count++;}
count=0;}}
if(sign%2!=0)
determinant=new CM.Factor([determinant,new CM.Integer(-1)]).simplify();
return determinant;}

