
CM.Sin=function(){
this.terms=arguments[0];
this.hasDerivative=new Object();};
CM.Sin.prototype=new CM.StandardFunction("sin",["x"]);
CM.Sin.prototype.constructor=CM.Sin;
CM.Sin.prototype.name="sin";
CM.Sin.prototype.constructorName="Sin";
CM.Sin.prototype.argumentsLength=1;
CM.Sin.prototype.simplify=function(){
var thissimplified=this.simplified;
if(thissimplified!=null){
return thissimplified;}
var term0=this.terms[0];
if(term0.cm_instanceof=="Expression"){
term0=term0.terms[0];}
if(term0.cm_instanceof=="Sum"){
term0=term0.expand();}
else{
term0=term0.simplify();}
if(term0.isNumber===true){
var term0simplified=term0.simplify();
if(term0simplified.equalTo(CM.Integer.zero)){
var tempreturn=CM.Integer.zero;
this.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=new CM.Sin([term0simplified]);
tempreturn.simplified=tempreturn;
return tempreturn;}}
var temptest=new CM.Factor([term0,new CM.Power([CM.Definitions.Constants.Standard["pi"],CM.Integer.minusOne])]).expand();
if(temptest.cm_instanceof=="Integer"){
var tempreturn=CM.Integer.zero;
this.simplified=tempreturn;
return tempreturn;}
var temptest1=new CM.Sum([temptest,new CM.Factor([CM.Integer.minusOne,CM.Rational.half])]).expand();
if(temptest1.cm_instanceof=="Integer"){
if(temptest1.mod(CM.Integer.two).equalTo(CM.Integer.zero)){
var tempreturn=CM.Integer.one;
this.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=CM.Integer.minusOne;
this.simplified=tempreturn;
return tempreturn;}}
var temptest1=new CM.Factor([CM.Integer.two,new CM.Sum([temptest,new CM.Factor([CM.Integer.minusOne,CM.Rational.fourth])])]).expand();
if(temptest1.cm_instanceof=="Integer"){
var mod4=temptest1.mod(CM.Integer.four);
if(mod4.equalTo(CM.Integer.zero)||mod4.equalTo(CM.Integer.one)){
var tempreturn=CM.Definitions.Constants.Standard["Sq2O2"];
this.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=CM.Definitions.Constants.Standard["MSq2O2"];
this.simplified=tempreturn;
return tempreturn;}}
var temptest1=new CM.Sum([temptest,new CM.Factor([CM.Integer.minusOne,CM.Rational.sixth])]).expand();
if(temptest1.cm_instanceof=="Integer"){
var mod2=temptest1.mod(CM.Integer.two);
if(mod2.equalTo(CM.Integer.zero)){
var tempreturn=CM.Rational.half;
this.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=new CM.Factor([CM.Integer.minusOne,CM.Rational.half]).simplify();
this.simplified=tempreturn;
return tempreturn;}}
var temptest1=new CM.Sum([temptest,CM.Rational.sixth]).expand();
if(temptest1.cm_instanceof=="Integer"){
var mod2=temptest1.mod(CM.Integer.two);
if(mod2.equalTo(CM.Integer.one)){
var tempreturn=CM.Rational.half;
this.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=new CM.Factor([CM.Integer.minusOne,CM.Rational.half]).simplify();
this.simplified=tempreturn;
return tempreturn;}}
var temptest1=new CM.Sum([temptest,new CM.Factor([CM.Integer.minusOne,CM.Rational.third])]).expand();
if(temptest1.cm_instanceof=="Integer"){
var mod2=temptest1.mod(CM.Integer.two);
if(mod2.equalTo(CM.Integer.zero)){
var tempreturn=CM.Definitions.Constants.Standard["Sq3O2"];
this.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=CM.Definitions.Constants.Standard["MSq3O2"];
this.simplified=tempreturn;
return tempreturn;}}
var temptest1=new CM.Sum([temptest,CM.Rational.third]).expand();
if(temptest1.cm_instanceof=="Integer"){
var mod2=temptest1.mod(CM.Integer.two);
if(mod2.equalTo(CM.Integer.one)){
var tempreturn=CM.Definitions.Constants.Standard["Sq3O2"];
this.simplified=tempreturn;
return tempreturn;}
else{
var tempreturn=CM.Definitions.Constants.Standard["MSq3O2"];
this.simplified=tempreturn;
return tempreturn;}}
else{
var tempreturn=new CM.Sin([term0]);
this.simplified=tempreturn;
tempreturn.simplified=tempreturn;
return tempreturn;}};
CM.Sin.prototype.evaluateTaylorSeries=function(){
var Floating=CM.Floating;
var minusOne=Floating.minusOne;
var numberofterms=Math.ceil(1*arguments[0].toString());
var precision=arguments[1];
var type=arguments[2];
if(precision==null){
precision=Floating.precision;}
precision=1*precision.toString();
if(type==null){
type="s";}
var exponent=this.terms[0].round(precision,type);
var previousterm=exponent;
var tempreturn=exponent;
for(var i=2;i<numberofterms;i++){
previousterm=minusOne.multiply(previousterm,precision,type).multiply(exponent,precision,type).multiply(exponent,precision,type).divide(new CM.Floating(new CM.Integer(2*i-1)).multiply(new CM.Floating(new CM.Integer(2*i-2)),precision,type),precision,type);
tempreturn=tempreturn.add(previousterm,precision,type);}
return tempreturn;};
