
Function.prototype.cm_constructorname="Function";
Function.prototype.cm_objecttype="Function";
Function.prototype.cm_getLinearPlotCoordinates=function(){
return this.cm_linearplotcoordinates;};
Function.prototype.cm_setLinearPlotCoordinates=function(){
return this.cm_linearplotcoordinates=arguments[0];};
Function.prototype.cm_getDefinedFunction=function(){
return this.cm_definedfunction;};
Function.prototype.cm_getDomain=function(){
return this.cm_domain;};
Function.prototype.cm_getNotWelldefined=function(){
return this.cm_notwelldefined;};
Function.prototype.cm_getPointsArray=function(){
return this.cm_pointsarray;};
Function.prototype.cm_getPointsArrayWithDuplicates=function(){
return this.cm_pointsarraywithduplicates;};
Function.prototype.cm_getIsAFunction=function(){
return this.cm_isafunction;};
Function.prototype.cm_getRange=function(){
return this.cm_range;};
Function.prototype.cm_getDuplicatePoints=function(){
return this.cm_getduplicatepoints;};
Function.prototype.cm_computemax=function(cm_start,cm_end){
var cm_start=arguments[0];
var cm_end=arguments[1];
var max="cm_fail";
var min="cm_fail";
var numberofpoints=100;
if(arguments.length==3){
numberofpoints=arguments[2];}
var distance=(cm_end-cm_start)/numberofpoints;
var i=0;
var currentvalue=this(cm_start+i*distance);
while((isNaN(currentvalue)||currentvalue==null||currentvalue==Infinity||currentvalue==-Infinity)&&i<=numberofpoints){
i=i+1;
var currentvalue=this(cm_start+i*distance);}
if(i<=numberofpoints){
max=currentvalue;
min=currentvalue;}
var j=i;
for(i=j;i<=numberofpoints;i++){
var currentvalue=this(cm_start+i*distance);
if(currentvalue!=Infinity&&currentvalue>max){
max=currentvalue;}
if(currentvalue!=-Infinity&&currentvalue<min){
min=currentvalue;}}
return[min,max];};
Function.prototype.cm_nearestzero=function(){
var xvalue=arguments[0];
var yvalue=arguments[1];
var cm_start=arguments[2];
var cm_end=arguments[3];
if(arguments.length==5){
var n=arguments[4];}
else{
var n=20;}
if(xvalue<cm_start||xvalue>cm_end){
return "cm_fail";}
var f=this;
if(f(xvalue)==yvalue){
return xvalue;}
else if(isFinite(f(xvalue))){
var sign=yvalue-f(xvalue);
var delta=Math.abs(cm_end-cm_start)/n;}
else{
var yvalueundefined="yes";
var realxvalue=xvalue;
var runningvalue1=xvalue
var delta=Math.abs(cm_end-cm_start)/n;
while(runningvalue1>cm_start&&!isFinite(f(runningvalue1))){
var runningvalue1=runningvalue1-delta;}
xvalue=runningvalue1;
var beginningvalue1=runningvalue1;
var sign=yvalue-f(xvalue);
var sign1=yvalue-f(xvalue);
if(f(xvalue)==yvalue){
return xvalue;}}
var runningvalue1=xvalue;
while(runningvalue1>cm_start&&(yvalue-f(runningvalue1))*sign>0){
runningvalue1=runningvalue1-delta;}
if(yvalueundefined=="yes"){
var runningvalue2=realxvalue;
while(runningvalue2<cm_end&&!isFinite(f(runningvalue2))){
runningvalue2=runningvalue2+delta;}
xvalue=runningvalue2;
var beginningvalue2=runningvalue2;
var sign=yvalue-f(xvalue);
var sign2=yvalue-f(xvalue);
if(f(xvalue)==yvalue){
return xvalue;}}
var runningvalue2=xvalue;
while(runningvalue2<cm_end&&(yvalue-f(runningvalue2))*sign>0){
runningvalue2=runningvalue2+delta;}
var potential2=yvalue-f(runningvalue2);
var potential1=yvalue-f(runningvalue1);
if(yvalueundefined!="yes"){
if(potential2*sign<0&&potential1*sign<0){
if(Math.abs(runningvalue2-xvalue)<=Math.abs(runningvalue1-xvalue)){
return runningvalue2;}
else{
return runningvalue1;}}
else if(potential2*sign<0){
return runningvalue2;}
else if(potential1*sign<0){
return runningvalue1;}
else{
if(arguments.length==4){
return this.cm_nearestzero(arguments[0],arguments[1],arguments[2],arguments[3],200);}
else{
return "cm_fail";}}}
else{
var fbeginningvalue1=f(beginningvalue1);
var fbeginningvalue2=f(beginningvalue2);
if(isFinite(fbeginningvalue1)&&((!isFinite(f(runningvalue1))||(Math.abs(fbeginningvalue1-yvalue)<Math.abs(f(runningvalue1)-yvalue)))&&(!isFinite(f(runningvalue2))||(Math.abs(fbeginningvalue1-yvalue)<Math.abs(f(runningvalue2)-yvalue)))&&(!isFinite(fbeginningvalue2)||(Math.abs(fbeginningvalue1-yvalue)<Math.abs(fbeginningvalue2-yvalue))))){
return beginningvalue1;}
if(isFinite(fbeginningvalue2)&&((!isFinite(f(runningvalue1))||(Math.abs(fbeginningvalue2-yvalue)<Math.abs(f(runningvalue1)-yvalue)))&&(!isFinite(f(runningvalue2))||(Math.abs(fbeginningvalue2-yvalue)<Math.abs(f(runningvalue2)-yvalue)))&&(!isFinite(fbeginningvalue1)||(Math.abs(fbeginningvalue2-yvalue)<Math.abs(fbeginningvalue1-yvalue))))){
return beginningvalue2;}
else if(potential2*sign2<0&&potential1*sign1<0){
if(Math.abs(runningvalue2-realxvalue)<=Math.abs(runningvalue1-realxvalue)){
return runningvalue2;}
else{
return runningvalue1;}}
else if(potential2*sign2<0){
return runningvalue2;}
else if(potential1*sign1<0){
return runningvalue1;}
else{
if(arguments.length==4){
return this.cm_nearestzero(arguments[0],arguments[1],arguments[2],arguments[3],200);}
else{
return "cm_fail";}}}};
Function.prototype.cm_lhs=function(){
var definedfunction=this.cm_definedfunction;
try{
if(definedfunction==null){
return alert("You are trying to used cm_lhs on a function that is not a CaluMath.Html.DefinedFunction. The function that invoked this method is "+this+".");}
var args=CaluMath.Html.ArgumentsToArray(arguments);
if(args[0].cm_constructorname=="Array"){
args=args[0].concat(args.slice(1));}
var definedfunctionvariablelength=definedfunction.cm_variable.length
var type=args[definedfunctionvariablelength];
if(type!=null){
if(type.cm_constructorname!="String"||type.replace(/\s*/g,"").length!=1){
return alert("Function.prototypeIn cm_lhs, after the "+definedfunctionvariablelength+" variables, you should have the type. Instead you have "+type+" for the type.")}
else{
type.replace(/\s*/g,"");}}
else{
type="e";}
var cm_precision=args[definedfunctionvariablelength+1];
if(cm_precision==null){
cm_precision=this.cm_definedfunction.cm_precision;}
if(cm_precision==null){
cm_precision=CaluMath.Html.DefinedFunction.prototype.cm_displayprecision;}
if(type!="e"){
if(this.cm_definedfunction.cm_donotround==false){
var args=CaluMath.Html.ArgumentsToArray(args).slice(0,definedfunctionvariablelength).cm_round(cm_precision).concat("f").concat(cm_precision);}
else{
var args=CaluMath.Html.ArgumentsToArray(args).slice(0,definedfunctionvariablelength).concat("f");}
return this.cm_coordinates.apply(this,args)[1];}
else{
if(this.cm_definedfunction.cm_donotround==false){
var args=CaluMath.Html.ArgumentsToArray(args).slice(0,definedfunctionvariablelength).cm_roundmath(cm_precision).concat("f").concat(cm_precision);}
else{
var args=CaluMath.Html.ArgumentsToArray(args).slice(0,definedfunctionvariablelength).concat("f");}
return this.cm_coordinates.apply(this,args)[1];}}
catch(e){
cm_catch(e,["cm_lhs",definedfunction.cm_mathversion],arguments);}};
Function.prototype.cm_display=function(){
var definedfunction=this.cm_definedfunction;
if(definedfunction==null){
return alert("You are trying to used cm_display on a function that is not a CaluMath.Html.DefinedFunction");};
var args=CaluMath.Html.ArgumentsToArray(arguments);
if(args[0].cm_constructorname=="Array"){
args=args[0].concat(args.slice(1));};
var definedfunctionvariablelength=definedfunction.cm_variable.length;
var type=args[definedfunctionvariablelength];
if(type!=null){
if(type.cm_constructorname!="String"||type.replace(/\s*/g,"").length>2){
return alert("In cm_display, after the "+definedfunctionvariablelength+" variables, you should have the type. Instead you have "+type+" for the type.")}
else{
type.replace(/\s*/g,"");};}
else{
type="ee";};
if(type.length==1){
type=type+type;};
var leftargs=args.slice(0);
var rightargs=args.slice(0);
leftargs[definedfunctionvariablelength]=type.charAt(0);
rightargs[definedfunctionvariablelength]=type.charAt(1);
var tempreturncaslocalvariable=this.cm_lhs.apply(this,leftargs)+" = "+this.cm_coordinates.apply(this,rightargs)[1];
return tempreturncaslocalvariable;};
Function.prototype.cm_rhs=function(){
var definedfunction=this.cm_definedfunction;
if(definedfunction==null){
return alert("You are trying to used cm_rhs on a function that is not a CaluMath.Html.DefinedFunction");};
var args=CaluMath.Html.ArgumentsToArray(arguments);
return this.cm_coordinates.apply(this,args)[1];};
Function.prototype.cm_coordinates=function(){
var variableinput1=arguments[0];
var definedfunction=this.cm_definedfunction;
if(definedfunction==null){
return alert("You are trying to used Function.prototype.cm_coordinates on a function that is not a CaluMath.Html.DefinedFunction. You invoked it on "+this);}
var definedfunctionvariablelength=definedfunction.cm_getVariables().length;
if(arguments[0].cm_constructorname=="Array"){
var variableinput1=arguments[0];
var type=arguments[1];
var cm_precision=arguments[2];}
else{
var variableinput1=CaluMath.Html.ArgumentsToArray(arguments).slice(0,definedfunctionvariablelength);
var type=arguments[definedfunctionvariablelength];
var cm_precision=arguments[definedfunctionvariablelength+1];}
if(cm_precision==null){
cm_precision=this.cm_definedfunction.cm_getDisplayPrecision();}
if(type!=null&&(type.charAt(0)=="s"||type.charAt(0)=="f"||type.charAt(0)=="l")){
var cm_variable=variableinput1.cm_round(cm_precision).cm_unicode();
newvariable=new Array;
newleftvariable=new Array;
var variablelength=cm_variable.length;
for(var i=0;i<variablelength;i++){
if(cm_variable[i].match(/\//)||cm_variable[i].match(/\+/)||cm_variable[i].match(/\-/)||cm_variable[i].match(/\*/)||cm_variable[i].match(/\^/)||cm_variable[i].match(/\(/)){
newvariable[i]="("+cm_variable[i]+")";}
else{
newvariable[i]=cm_variable[i];}
newleftvariable[i]=cm_variable[i];
newleftvariable[i]=newleftvariable[i].replace(/([a-zA-Z0-9_\'\"\,])\s+([a-zA-Z0-9_\'\"\,])/g,"$1CM_SPACE$2");
newleftvariable[i]=newleftvariable[i].replace(/\s*/g,"");
newleftvariable[i]=newleftvariable[i].replace(/CM_SPACE/g," ");
newleftvariable[i]=newleftvariable[i].replace(/([^0-9])\*([^0-9])/g,"$1"+"$2");
newleftvariable[i]=newleftvariable[i].replace(/([^0-9])\*([0-9])/g,"$1"+"$2");
newleftvariable[i]=newleftvariable[i].replace(/([0-9])\*([^0-9])/g,"$1"+"$2");
newleftvariable[i]=newleftvariable[i].replace(/\"\s*\+/g,"");
newleftvariable[i]=newleftvariable[i].replace(/\+\s*\"/g,"");
newleftvariable[i]=newleftvariable[i].replace(/\'\s*\+/g,"");
newleftvariable[i]=newleftvariable[i].replace(/\+\s*\'/g,"");
newleftvariable[i]=newleftvariable[i].replace(/^1\*/,"");}
if(type.charAt(0)=="f"){
var tempreturncaslocalvariable=[newleftvariable,definedfunction.cm_alternatename+"("+newleftvariable+")"];}
else{
if(type.charAt(0)=="l"){
var cm_rightside=" "+definedfunction.cm_originalrightside+" ";}
else{
var cm_rightside=" "+definedfunction.cm_rightside+" ";}
var definedfunctionvariablelength=definedfunction.cm_variable.length;
for(var i=0;i<definedfunctionvariablelength;i++){
var newstring=new RegExp("(\\W)"+definedfunction.cm_variable[i]+"(\\W)","g");
cm_rightside=cm_rightside.replace(/\</g,"&lt;").replace(/\>/g,"&gt;");
cm_rightside=cm_rightside.replace(/\^/g," \^ ");
cm_rightside=cm_rightside.replace(newstring,"$1"+(" "+newvariable[i])+"$2");}
cm_rightside=cm_rightside.replace(/([a-zA-Z0-9_\'\"\,\\])\s+([a-zA-Z0-9_\'\"\,\\])/g,"$1CM_SPACE$2");
cm_rightside=cm_rightside.replace(/([a-zA-Z0-9_\'\"\,\\])\s+([a-zA-Z0-9_\'\"\,\\])/g,"$1CM_SPACE$2");
cm_rightside=cm_rightside.replace(/\s*/g,"");
cm_rightside=cm_rightside.replace(/CM_SPACE/g," ");
cm_rightside=cm_rightside.replace(/([^0-9])\*([^0-9])/g,"$1"+"$2");
cm_rightside=cm_rightside.replace(/([^0-9])\*([0-9])/g,"$1"+"$2");
cm_rightside=cm_rightside.replace(/([0-9])\*([^0-9])/g,"$1"+"$2");
cm_rightside=cm_rightside.replace(/\"\s*\+/g,"");
cm_rightside=cm_rightside.replace(/\+\s*\"/g,"");
cm_rightside=cm_rightside.replace(/\'\s*\+/g,"");
cm_rightside=cm_rightside.replace(/\+\s*\'/g,"");
cm_rightside=cm_rightside.replace(/^\s*\"/," ");
cm_rightside=cm_rightside.replace(/^\s*\'/," ");
cm_rightside=cm_rightside.replace(/\"/,"");
cm_rightside=cm_rightside.replace(/\'/,"");
cm_rightside=cm_rightside.replace(/\*/g,"\u2219");
cm_rightside=cm_rightside.replace(/^1\*/,"");
if(cm_variable.length!=1){
tempreturncaslocalvariable=[cm_variable,cm_rightside];}
else{
tempreturncaslocalvariable=[cm_variable[0],cm_rightside];}}
tempreturncaslocalvariable.toString=Function.prototype.cm_coordinatestoString;}
else{
var variableinput1length=variableinput1.length;
var cm_variable=new Array();
var cm_donotround=this.cm_definedfunction.cm_donotround;
for(var i=0;i<variableinput1length;i++){
if(variableinput1[i].cm_constructorname=="String"){
if(cm_donotround!=true){
variableinput1[i]=CaluMath.Html.EvalMath(variableinput1[i]);
cm_variable[i]=CaluMath.Html.Round(variableinput1[i],cm_precision);}
else{
cm_variable[i]=variableinput1[i];}}
else{
cm_variable[i]=CaluMath.Html.Round(variableinput1[i],cm_precision);}}
if(cm_donotround!=true){
if(cm_variable.length==1){
var tempreturncaslocalvariable=[cm_variable[0],CaluMath.Html.Round(this.apply(null,cm_variable),cm_precision)];}
else{
var tempreturncaslocalvariable=[cm_variable,CaluMath.Html.Round(this.apply(null,cm_variable),cm_precision)];}}
else{
var tempreturncaslocalvariable=[cm_variable,this.apply(null,variableinput1)];}
if(definedfunctionvariablelength!=1){
var tempfirstentry=tempreturncaslocalvariable[0];
tempfirstentry.toString=function(){
var tempcaslocalvariable=tempfirstentry.slice(0);
return "("+tempcaslocalvariable+")";};
tempreturncaslocalvariable.toString=function(){
return this[0].toString().replace(/\)\s*$/,"")+" , "+this[1]+")";}}
else{
tempreturncaslocalvariable.toString=function(){
if(cm_donotround==false){
var tempx=CaluMath.Html.Round(this[0],cm_precision);
var tempy=CaluMath.Html.Round(definedfunction.cm_map(tempx),cm_precision);}
else{
var tempx=this[0];
var tempy=definedfunction.cm_map(tempx);}
return "("+tempx+" , "+tempy+")";}}}
return tempreturncaslocalvariable;};
Function.prototype.cm_coordinatestoString=function(){
var tempcaslocalvariable=this.slice(0);
return "("+tempcaslocalvariable+")";};
Function.prototype.cm_htmlversion=function(){
if(this.cm_definedfunction==null){
return '';};
var mathversion=this.cm_definedfunction.cm_mathversion;
if(mathversion.match(/splitfunction/)==null){
return mathversion;}
else{
var bothsides=mathversion.split(/splitfunction\(/);
if(arguments[0]=="single"){
var rightside=bothsides[1].replace(/\&\&/g," and ").replace(/\|\|/g," or ").replace(/\<=/g,"Unicode(le)").replace(/\>=/g,"Unicode(ge)").replace(/\</g,"&lt;").replace(/\>/g,"&gt;").replace(/\'/g,"").split(/\,/);;}
else if(arguments[0]=="double"){
var rightside=bothsides[1].replace(/\&\&/g," and ").replace(/\|\|/g," or ").replace(/\<=/g,"Unicode(le)").replace(/\>=/g,"Unicode(ge)").replace(/\</g,"&lt;").replace(/\>/g,"&gt;").replace(/\"/g,"").split(/\,/);;}
else if(arguments[0]=="both"){
var rightside=bothsides[1].replace(/\&\&/g," and ").replace(/\|\|/g," or ").replace(/\<=/g,"Unicode(le)").replace(/\>=/g,"Unicode(ge)").replace(/\</g,"&lt;").replace(/\>/g,"&gt;").replace(/\"/g,"").replace(/\'/g,"").split(/\,/);;}
else{
var rightside=bothsides[1].replace(/\&\&/g," and ").replace(/\|\|/g," or ").replace(/\<=/g,"Unicode(le)").replace(/\>=/g,"Unicode(ge)").replace(/\</g,"&lt;").replace(/\>/g,"&gt;").split(/\,/);};
var rightsidelength=rightside.length/2;
var temparray=['<table><tbody><tr><td style="vertical-align:middle">'+bothsides[0].replace(/\:\s*\=/,"=")+'</td><td><span style="font-size:'+2*rightsidelength+'em">{</span></td><td><table><tbody>'];
for(var i=0;i<rightsidelength;i++){
temparray.push('<tr><td>'+rightside[2*i]+',</td><td style="width:2em; text-align:center"> if </td><td>'+rightside[2*i+1]+'</td></tr>');};
temparray[temparray.length-1]=temparray[temparray.length-1].replace(/\)\<\/td\>\<\/tr\>$/,"</td></tr>");
temparray.push('</tbody></table></td></tr></tbody></table>');
return temparray.join('');};};
Function.prototype.cm_execute=function(){
var args=CaluMath.Html.ArgumentsToArray(arguments);
return this.apply(this,args);};
Function.prototype.cm_executelater=function(){
var args=CaluMath.Html.ArgumentsToArray(arguments);
var passedargs=args.slice(1);
var tempfunction=this;
var actingon=args[0];
return function(){
return tempfunction.apply(actingon,passedargs);};};
Function.prototype.cm_nearestpoint=function(){
var givenpoint=arguments[0];
var givenpointx=arguments[0][0];
var givenpointy=arguments[0][1];
var leftboundary=arguments[1];
var rightboundary=arguments[2];
var numberofintervals=arguments[3];
if(numberofintervals==null){
numberofintervals=100;};
var tempfunction=this;
var distancefunction=function(x,y){return Math.pow(Math.pow(x-givenpointx,2)+Math.pow(tempfunction(x)-givenpointy,2),1/2);};
if(rightboundary<=leftboundary){
return alert("In cm_nearestpoint, your rightboundary point is greater than or equal to your left boundary point.");};
var delta=(rightboundary-leftboundary)/numberofintervals;
var mindistance=Infinity;
var xcoordinatearray=new Array();
for(var i=0;i<=numberofintervals;i++){
var tempdistance=distancefunction(leftboundary+i*delta);
if(isFinite(tempdistance)){
if(tempdistance<mindistance){
mindistance=tempdistance;
xcoordinatearray=[leftboundary+i*delta];}
else if(tempdistance==mindistance){
xcoordinatearray=xcoordinatearray.concat([leftboundary+i*delta]);};};};
tempreturn=new Number(mindistance);
tempreturn.cm_xcoordinatearray=xcoordinatearray;
return tempreturn;};
Function.prototype.cm_returnGetAndSetArrays=function(){
return this.toString().cm_returnGetAndSetArrays();};
